﻿class BioActorBehavior extends BioBaseComponent
    config(Game)
    native
    editinlinenew;

struct native BioVOSettings
{
    var Color cSubtitleColour;

    var byte nSubtitleMode;

    var bool bSuppressSubtitlesIfVO;

    var bool bAlert;

}

struct native BioDamageReporter
{
    var float fShieldDamage;

    var float fShieldDamageCapacity;

    var float fHealthDamage;

    var float fToxicDamage;

    var float fStabilityDamage;

    var float fDamageResistance;

    var float fToxicResistance;

}

var const native Map_Mirror m_mLatentSequenceDataStore;

var transient array<???> m_aPowerText;

var transient float m_fPhysicsSoundLastTimePlayed;

var transient bool m_bPhysicsDamageIgnored;

var float m_fPhysicsDamageTimerMax;

var float m_fPhysicsDamageTimer;

var config float m_fPhysicsDamageImpulsePerRelVel;

var config float m_fPhysicsDamagePerRelVel;

// m_nTargetTipTextOverridden: StringRefProperty[44]
var int m_nMaxTargetTipStrings;

var config array<???> m_aTargetTipDefaults;

var(Selection) int m_nRequiredScanLevel;

var(Selection) float m_fUseRange;

// m_srStasisPowerText: StringRefProperty[44]
var int m_nInvulnerabilityCount;

var /* 00000008 */ BioDamageType m_pPhysicsDamage;

var /* 00000008 */ BioDamageType m_pBumpDamage;

var int m_nLeaveActionStation;

var /* 00000008 */ BioCameraShakeInterface m_cameraShakeInterface;

var float m_fPowerAffectingActorTime;

var Name m_nmPowerAffectingActor;

var transient BioActive m_InstantPowerActive;

var transient int m_nPreviousSuperMode;

var transient array<BioReactive> m_aActivatedReactive;

var transient array<BioReactive> m_aPendingReactive;

var transient array<BioReactive> m_aRegisteredReactive;

var transient array<BioActive> m_aRegisteredActive;

var transient BioActive m_oCurrentModalActive;

var transient BioSuperMode m_oCurrentActiveSuperMode;

var transient array<BioSuperMode> m_lSuperModeList;

var transient config float m_fMaxHenchAimDist;

var transient config float m_fHenchAimLagFactor;

var BioCombatLog m_oCombatLog;

var float m_fInteractionRange;

var(Designer) /* 00000008 */ BioInterface_Appearance m_oAppearanceType;

var(Designer) Color ActorGameNameColor;

var BioActorType m_oActorType;

// ActorGameNameStrRef: StringRefProperty[44]
var(Designer) String ActorGameName;

var(Designer) bool m_bSuppressDisintegrationOverride;

var(Designer) bool m_bSuppressDisintegration;

var(Designer) bool m_bPlotProtectedOverride;

var(Designer) bool m_bPlotProtected;

var config bool m_bPhysicsDamageLoggingEnabled;

var config bool m_bPhysicsDamageEnabled;

var bool m_bDefaultActionPossible;

var(TargetTip) bool m_bDefaultActionPossibleOverridden;

var(TargetTip) bool m_bTargetTipTextOverride;

var(Selection) bool m_bRequiredScanLevelOverride;

var(Selection) bool m_bUseRangeOverride;

var(Selection) bool m_bCombatTargetableOverride;

var(Selection) bool m_bCombatTargetable;

var(Selection) bool m_bTargetableOverride;

var(Selection) bool m_bTargetable;

var /* 00000008 */ bool m_bAllowDamageInCombatStasis;

var bool m_bInActionStation;

var bool m_bIsBusy;

var(Placeable) bool AllowFall;

var(Placeable) bool Mountable;

var config bool bDisableFacefx;

var config bool bUseStringRefActorGameName;

var(Designer) bool m_bMin1Health;

var(Designer) bool m_bMin1HealthOverride;

var(Designer) bool bActive;

var(Designer) bool ActorGameNameOverride;

var config bool m_bAreShieldsDisabled;

native function TickBehavior(float DeltaTime);

native function EBioSuperModes GetPreviousSuperMode();

native function bool SetSuperMode(EBioSuperModes nSuperMode, bool bActivate, bool bReturnToSuperMode);

native function BioSuperMode FindSuperMode(class<BioSuperMode> clsSuperMode);

native function GetTargetTipText(Pawn pSourcePawn, out String strTip);

native function bool IsSuperModeCurrentAndActive(EBioSuperModes eSuperMode);

native function bool GetScanable(int nInstigatorScanLevel);

native final function float GetUseRange();

native function bool IsWithinUseRange(Vector vRefLocation);

native function bool IsDefaultActionPossible();

native function EnableCollision(bool bState);

function PostBeginPlay()
{
    if (bActive == false)
    {
        if (Owner != None)
        {
            Owner.SetActive(false);
        }
    }
}

native function RegisterActive(class<BioActive> clsActive, BioActive oActive);

native function RegisterReactive(class<BioReactive> clsReactive, BioReactive oReactive);

native function BioActive AcquireActive(class<BioActive> clsActive, optional bool bAutoStartActive);

native function BioActive SearchForActive(class<BioActive> clsActive);

native function BioReactive AcquireReactive(class<BioReactive> clsReactive, Actor oInstigator);

native function bool ReleaseActive();

native function bool ReleaseActiveByClass(class<Object> oActiveToRelease);

native function ReleasePendingReactive(BioReactive oReactive);

native function HardResetActionAndAnimationState();

native function SoftResetMovementAndAnimationState();

native function BioBaseSquad GetSquad();

native function int AbilityEnable(bool bEnable, EDisableType eEnableType, Name nmSubType);

native function bool IsAbilityEnabled(EDisableType eEnableType, Name nmSubType);

event bool IsMin1Health()
{
    if (m_bMin1HealthOverride)
    {
        return m_bMin1Health;
    }
    return BioActorType(Owner.ActorType).m_bMin1Health;
}

event String GetActorGameName()
{
    if (ActorGameNameOverride)
    {
        if (bUseStringRefActorGameName)
        {
            return ActorGameNameStrRef;
        }
        return ActorGameName;
    }
    else
    {
        if (bUseStringRefActorGameName)
        {
            return BioActorType(Owner.ActorType).ActorGameNameStrRef;
        }
        return BioActorType(Owner.ActorType).ActorGameName;
    }
}

function SetActorGameName()
{
    ActorGameNameOverride = true;
    ActorGameNameStrRef = newActorGameName;
    ActorGameName = newActorGameName;
}

function RemoveFromActionStationOnDamage(Controller InstigatedBy)
{
    local BioEpicPawnBehavior pEPBehavior;
    local BioArtPlaceableBehavior pAPBehavior;
    local BioPawn Pawn;
    pEPBehavior = None;
    if (BioEpicPawnBehavior(self) != None)
    {
        pEPBehavior = BioEpicPawnBehavior(self);
    }
    else
    {
        if (BioArtPlaceableBehavior(self) != None)
        {
            pAPBehavior = BioArtPlaceableBehavior(self);
            if (BioArtPlaceable(pAPBehavior.Owner) != None && BioArtPlaceable(pAPBehavior.Owner).m_oLastInstigator != None && BioArtPlaceable(pAPBehavior.Owner).m_oLastInstigator.oBioComponent != None)
            {
                if (BioEpicPawnBehavior(BioArtPlaceable(pAPBehavior.Owner).m_oLastInstigator.oBioComponent) != None)
                {
                    pEPBehavior = BioEpicPawnBehavior(BioArtPlaceable(pAPBehavior.Owner).m_oLastInstigator.oBioComponent);
                }
            }
        }
    }
    Pawn = BioPawn(pEPBehavior.Owner);
    if (Pawn != None && Pawn.IsHostile(InstigatedBy.Pawn))
    {
        m_nLeaveActionStation = 2;
    }
}

event HurtRadius(float BaseDamage, float DamageRadius, class<DamageType> DamageType, float Momentum, Vector HurtOrigin, optional Actor oDirectlyHitActor, optional DamageType pDamage)
{
    local bool bDoFullDamage_FALSE;
    local Controller pInstigatorController;
    local Pawn pPawn;
    local Actor pDamageCausingActor_Owner;
    bDoFullDamage_FALSE = false;
    pPawn = Pawn(Owner);
    if (pPawn != None)
    {
        pInstigatorController = pPawn.Controller;
    }
    if (oDirectlyHitActor != None)
    {
        pDamageCausingActor_Owner = Owner;
        oDirectlyHitActor.TakeRadiusDamage(Pawn(Owner).Controller, BaseDamage, DamageRadius, DamageType, Momentum, HurtOrigin, true, pDamageCausingActor_Owner);
    }
    Owner.HurtRadius(BaseDamage, DamageRadius, DamageType, Momentum, HurtOrigin, oDirectlyHitActor, pInstigatorController, bDoFullDamage_FALSE);
}

function AmplifyDamage(out float Damage);

event OnAnimEnd(AnimNodeSequence oAnimation, float PlayedTime, float ExcessTime);

native function SetBusyState(bool bSetBusy);

native function bool GetBusyState();

native function OnGPEvent(EBioGamePropertyEvent eEvent, Object pTarget);

static function bool AttachMeshToClosestBone(SkeletalMeshComponent Mesh, float fMeshDrawScale, SkeletalMeshComponent subMesh, Vector subMeshPosition, Rotator subMeshRotation)
{
    local Name BoneName;
    local Vector boneRelativeLocation;
    local Rotator boneRelativeRotation;
    local float fMeshDrawScaledInverted;
    local Vector vBoneRelativeScale;
    BoneName = Mesh.FindClosestBone(subMeshPosition);
    if (BoneName != 'None')
    {
        Mesh.TransformToBoneSpace(BoneName, subMeshPosition, subMeshRotation, boneRelativeLocation, boneRelativeRotation);
        fMeshDrawScaledInverted = 1 / fMeshDrawScale;
        vBoneRelativeScale.X = fMeshDrawScaledInverted;
        vBoneRelativeScale.Y = fMeshDrawScaledInverted;
        vBoneRelativeScale.Z = fMeshDrawScaledInverted;
        Mesh.AttachComponent(subMesh, BoneName, boneRelativeLocation, boneRelativeRotation, vBoneRelativeScale);
        return true;
    }
    return false;
}

static function bool DetachMesh(SkeletalMeshComponent Mesh, SkeletalMeshComponent subMesh)
{
    if (Mesh.IsComponentAttached(subMesh))
    {
        Mesh.DetachComponent(subMesh);
        return true;
    }
    return false;
}

native function BioBaseAppearance GetAppearanceTemplate();

native static function Actor SpawnActorFromType(String sActorResource, Vector vLocation, Rotator rRotation, optional float fLifeSpan, optional Actor oOwner);

native function bool MoveActorToFloor(Actor oActor);

native function bool EnterCombatStasis(float fDuration, bool bAllowDamage);

native function bool ExitCombatStasis();

static function class<BioBaseSaveObject> GetSaveObjectClass()
{
    return Class'BioActorBehaviorSaveObject';
}

native final function bool IsPlotProtected();

native final function bool IsDisintegrationSuppressed();

native function bool GetPowerText(out String sPowerText);

final function SetActive(bool bSetActive)
{
    if (Owner != None)
    {
        Owner.SetActive(bSetActive);
    }
}

defaultproperties
{
    bActive=true
    bUseStringRefActorGameName=true
    m_bAllowDamageInCombatStasis=true
    m_bDefaultActionPossibleOverridden=true
    m_bPhysicsDamageEnabled=true
    ActorGameName="Actor"
    ActorGameNameColor=(B=1,G=168,R=255,A=255)
    m_fInteractionRange=50000
    m_fHenchAimLagFactor=0,25
    m_fMaxHenchAimDist=300
    m_nPreviousSuperMode=-1
    m_fUseRange=500
    m_nRequiredScanLevel=-1
    m_nMaxTargetTipStrings=1
    m_fPhysicsDamagePerRelVel=0,02
    m_fPhysicsDamageImpulsePerRelVel=0,01
    m_fPhysicsDamageTimerMax=1
}
