﻿class BioAnimNodeBlendByWeaponEquip extends AnimNodeBlendList
    hidecategories(Object,Object,Object)
    native;

enum EBioAnimNodeBlendByWeaponEquip
{
    eBioAnimNodeBlendByWeaponEquip_Idle,
    eBioAnimNodeBlendByWeaponEquip_Draw,
    eBioAnimNodeBlendByWeaponEquip_Holster,
};

var transient float SliderPosition;

var transient bool bDisabledIK;

var() float HolsterToIdleBlendDuration;

var() float HolsterToDrawBlendDuration;

var() float IdleToHolsterBlendDuration;

var() float IdleToDrawBlendDuration;

event HolsterAnimEnd()
{
    local BioPawn P;
    local SFXWeapon Weapon;
    P = BioPawn(SkelComponent.Owner);
    if (P != None && P.Weapon != None)
    {
        Weapon = SFXWeapon(P.Weapon);
        if (Weapon != None)
        {
            Weapon.UnEquipFinished();
        }
    }
}

event DrawAnimEnd()
{
    local Pawn P;
    local SFXWeapon Weapon;
    P = Pawn(SkelComponent.Owner);
    if (P != None && P.Weapon != None)
    {
        Weapon = SFXWeapon(P.Weapon);
        if (Weapon != None)
        {
            Weapon.EquipFinished();
        }
    }
}

defaultproperties
{
    IdleToDrawBlendDuration=0,1
    IdleToHolsterBlendDuration=0,1
    HolsterToDrawBlendDuration=0,3
    HolsterToIdleBlendDuration=0,7
    Children=None
}
