﻿class BioAnimNodeBlendStateMovementBehavior extends BioAnimNodeBlendStateBehavior
    hidecategories(Object)
    native
    editinlinenew;

enum EBioAnimNodeBlendStateMovementBehavior
{
    BSMove_None,
    BSMove_SpeedVelocity,
    BSMove_SpeedTacticalVelocity,
    BSMove_ScaleRate,
    BSMove_ScaleRateByWalkSpeed,
    BSMove_ScaleRateByRunSpeed,
    BSMove_ScaleRateBySprintSpeed,
    BSMove_ScaleRateByTacticalWalkSpeed,
    BSMove_ScaleRateByTacticalRunSpeed,
    BSMove_LookAtTurning,
    BSMove_TurningDirection,
    BSMove_AxisDirection,
    BSMove_FlyingState,
    BSMove_StopSwitch,
    BSMove_StopOnFoot,
    BSMove_StartSwitch,
    BSMove_ScaleRateByWalkRunRatio,
    BSMove_SkidTurnSwitch,
};

enum EBioMovementSpeedStates
{
    MSS_Idle,
    MSS_Walk,
    MSS_Run,
    MSS_Sprint,
};

enum EBioAnimNodeBlendStateMoveAxisDir
{
    BSMoveAxisDir_X,
    BSMoveAxisDir_Y,
    BSMoveAxisDir_Z,
};

enum EBioAnimNodeBlendStateMoveAxisDirMode
{
    BSMoveAxisDirMode_WorldRotation,
    BSMoveAxisDirMode_WorldVelDir,
    BSMoveAxisDirMode_WorldAccelDir,
    BSMoveAxisDirMode_LocalVelDir,
    BSMoveAxisDirMode_LocalAccelDir,
};

var int m_nLastPhys;

var float m_fStartCheckTime;

var() float BlendResetWeight;

var(Scale) float RunRate;

var(Scale) float WalkRate;

var(Scale) float ScaleByValue;

var bool m_bRootMotionOn;

var bool m_bPlayedAnim;

var bool m_bInLanding;

var bool m_bInTakeoff;

var bool m_bIsStarted;

var(Start) bool bUseDirStartControl;

var(Speed) bool bUseSnapshotStartSpeed;

var(Speed) bool bUseSnapshotSpeed;

var(Speed) bool bUseSprint;

var(Speed) float BlendDownPerc;

var(AxisDir) EBioAnimNodeBlendStateMoveAxisDirMode AxisDirMode;

var(AxisDir) EBioAnimNodeBlendStateMoveAxisDir AxisDir;

var(Movement) EBioAnimNodeBlendStateMovementBehavior MovementBehavior;

defaultproperties
{
    AxisDirMode=BSMoveAxisDirMode_LocalVelDir
    BlendDownPerc=0,2
    ScaleByValue=1
    WalkRate=1
    RunRate=1,5
    BlendResetWeight=0,75
    m_aNodeDefinitions=System.Byte[]
}
