﻿class BioCameraBehaviorConversation extends BioCameraBehavior
    config(Game)
    native;

var config Name m_nProceduralCameraClass;

var class<BioProceduralCameraBasic> pProceduralCamera;

var int m_idleCamAnimIndex;

var float m_fIdleCamTimeIndex;

var AnimSet m_pIdleCamAnimSet;

var BioStageDOFData m_tPrevDOFData;

var config bool m_bIdleCamEnabled;

var bool m_bSavedData;

var float m_fPrevNearPlane;

var float m_fPrevCamFOV;

var Rotator m_rPrevFixedCamRot;

var Vector m_vPrevFixedCamPos;

var float m_fLateralOffset;

var Rotator m_rRotationOffset;

var float CAMERA_FOV;

var transient bool m_bDOFSettingDisabled;

var BioStageDOFData m_tDOFData;

var float m_fNearPlane;

var Rotator m_rProceduralCamRotation;

var Vector m_vProceduralCamPosition;

var Rotator m_rFixedCamRotation;

var Vector m_vFixedCamPosition;

var Actor Target;

var Actor ViewSource;

const DEFAULT_CAMERA_FOV = 52.9f;
const DEFAULT_NEAR_CLIP_PLANE = 10.0f;
native function Tick(float TimeDelta);

native function ShutDown();

native function ForcePOV();

function Initialize(BioPlayerController NewOwner)
{
    Initialize(NewOwner);
    m_fIdleCamTimeIndex = 0;
}

function MakeInactive()
{
    BioWorldInfo(Owner.WorldInfo).SetRenderStateOfPlayerToDefault(0);
    ShutDown();
}

function Reset()
{
    ForcePOV();
}

native function InitProceduralCameraClass();

native function BlendIdleCameraAnimation();

event GetProceduralCam(out Vector vCamLocation, out Rotator rCamRotation, bool bInvert)
{
    local BioPawn pBioCameraTarget;
    local ActorInfo stActorInfo;
    local CameraInfo stCameraInfo;
    local Bio_Appr_Character Appearance;
    pBioCameraTarget = BioPawn(Target);
    InitProceduralCameraClass();
    if (pBioCameraTarget == None || pProceduralCamera == None)
    {
        return;
    }
    Appearance = BioPawnType(pBioCameraTarget.ActorType).m_oAppearance;
    stActorInfo.myPosition = pBioCameraTarget.Location;
    stActorInfo.myPosition.Z = stActorInfo.myPosition.Z + pBioCameraTarget.Mesh.Translation.Z;
    stActorInfo.myRotation = pBioCameraTarget.Rotation;
    stActorInfo.headBaseBonePosition = pBioCameraTarget.Mesh.GetBoneLocation('headBase');
    stActorInfo.headBonePosition = pBioCameraTarget.Mesh.GetBoneLocation('Head');
    stActorInfo.vCameraFocusPoint = Appearance.vCameraFocusPoint;
    stCameraInfo.vPosition = Appearance.vProceduralCameraPosition;
    stCameraInfo.rRotation = Appearance.rProceduralCameraRotation;
    pProceduralCamera.FixedCamera(stActorInfo, stCameraInfo, bInvert);
    vCamLocation = stCameraInfo.vPosition;
    rCamRotation = stCameraInfo.rRotation;
    stCameraInfo.fFov = Appearance.fFov;
    stCameraInfo.fNearPlane = Appearance.fNearClip;
    if (stCameraInfo.fFov != 0)
    {
        CAMERA_FOV = stCameraInfo.fFov;
    }
    else
    {
        CAMERA_FOV = 52,9;
    }
    if (stCameraInfo.fNearPlane != 0)
    {
        m_fNearPlane = stCameraInfo.fNearPlane;
    }
    else
    {
        m_fNearPlane = 10;
    }
    if (Appearance.fDOFFocusInnerRadius != 0 && Appearance.fDOFFocusDistance != 0)
    {
        m_tDOFData.bEnable = true;
        m_tDOFData.fFocusInnerRadius = Appearance.fDOFFocusInnerRadius;
        m_tDOFData.fFocusDistance = Appearance.fDOFFocusDistance;
    }
    else
    {
        m_tDOFData.bEnable = false;
    }
}

function DrawHUD(BioCheatManager M)
{
    M.DrawProfileText("Owner:" @ Owner);
    M.DrawProfileText("Target:" @ Target);
    M.DrawProfileText("Input:" @ Input);
    M.DrawProfileText("Follow Hook:" @ HookName @ HookOffset);
    M.DrawProfileText("Last collision with:" @ LastCameraCollisionActor);
}

native function InternalModifyPostProcessSettings(out PostProcessSettings PPSettings);

event ModifyPostProcessSettings(out PostProcessSettings PPSettings)
{
    ModifyPostProcessSettings(PPSettings);
    InternalModifyPostProcessSettings(PPSettings);
}

defaultproperties
{
    m_fNearPlane=10
    CAMERA_FOV=52,9
    m_rRotationOffset=(Pitch=0,Yaw=-3700,Roll=0)
    m_fLateralOffset=25
    m_pIdleCamAnimSet=AnimSet'CAM_FX_Dialog'
    m_idleCamAnimIndex=1
    bIsCameraShakeEnabled=false
    bCollisionEnabled=false
    m_bConstrainAspectRatio=true
}
