﻿class BioCameraBehaviorSpectator extends BioCameraBehavior
    native;

var transient int m_nSpectateCurrentLocation;

var transient array<PlayerStart> m_aSpectateSpawnLocation;

var Actor Target;

var Actor ViewSource;

var bool m_bSuppliedLocalizedParams;

var float m_fLockYaw;

var float m_fLockPitch;

var float m_fLockHeight;

var float m_fLockRange;

native function GetTargetLocalizedCameraParams(out Vector vPosition, out Rotator rRotation, out Rotator rLockRotation);

native function SetTargetLocalizedCameraParams(Vector vPosition, Rotator rRotation, Rotator rLockRotation);

native function Reset();

function MakeInactive()
{
    m_bSuppliedLocalizedParams = false;
}

function SetTarget(Actor NewTarget)
{
    local Vector vDir;
    local Rotator rDir;
    Target = NewTarget;
    if (NewTarget != None)
    {
        vDir = Target.Location - m_pov.Location;
        rDir = vDir;
        m_fLockRange = VSize(vDir);
        m_fLockHeight = 0;
        m_fLockYaw = rDir.Yaw;
        m_fLockPitch = rDir.Pitch;
    }
    else
    {
        m_bSuppliedLocalizedParams = false;
        m_fLockRange = 0;
        m_fLockHeight = 0;
        m_fLockYaw = 0;
        m_fLockPitch = 0;
    }
}

native function Tick(float TimeDelta);

defaultproperties
{
    m_nSpectateCurrentLocation=-1
}
