﻿class BioConversation extends Object
    config(Game)
    native;

const BIOCONV_REPLY_NONE = -1;
const MIN_DEFAULT_INTIMACY = 250;
const MAX_DEFAULT_INTIMACY = 750;
const DEBUG_CAMERAS = FALSE;
const VERY_SMALL_TIME = 0.00001f;
enum EReplyTypes
{
    REPLY_STANDARD,
    REPLY_AUTOCONTINUE,
    REPLY_DIALOGEND,
};

enum EReplyCategory
{
    REPLY_CATEGORY_DEFAULT,
    REPLY_CATEGORY_AGREE,
    REPLY_CATEGORY_DISAGREE,
    REPLY_CATEGORY_FRIENDLY,
    REPLY_CATEGORY_HOSTILE,
    REPLY_CATEGORY_INVESTIGATE,
    REPLY_CATEGORY_RENEGADE_INTERRUPT,
    REPLY_CATEGORY_PARAGON_INTERRUPT,
};

enum EConvGUIStyles
{
    GUI_STYLE_NONE,
    GUI_STYLE_CHARM,
    GUI_STYLE_INTIMIDATE,
    GUI_STYLE_PLAYER_ALERT,
    GUI_STYLE_ILLEGAL,
};

enum EInterruptionType
{
    INTERRUPTION_RENEGADE,
    INTERRUPTION_PARAGON,
};

struct native BioDialogReplyListDetails
{
    var() int nIndex;

// srParaphrase: StringRefProperty[44]
    var() String sParaphrase;

    var() EReplyCategory Category;

}

struct native BioDialogNode
{
// srText: StringRefProperty[44]
    var() String sText;

    var() bool bFireConditional;

    var() int nConditionalFunc;

    var() int nConditionalParam;

    var() int nStateTransition;

    var() int nStateTransitionParam;

    var() int nExportID;

    var() int nScriptIndex;

    var() bool bAmbient;

    var() bool bNonTextLine;

    var transient WwiseBaseSoundObject pCue;

    var transient bool bSoundLoaded;

    var() EConvGUIStyles eGUIStyle;

    var() int nCameraIntimacy;

    var() bool bIgnoreBodyGestures;

}

struct native BioDialogEntryNode extends BioDialogNode
{
    var() array<BioDialogReplyListDetails> ReplyListNew;

    var() int nSpeakerIndex;

    var() int nListenerIndex;

    var() bool bSkippable;

    var() array<int> aSpeakerList;

}

struct native BioDialogReplyNode extends BioDialogNode
{
    var() array<int> EntryList;

    var() EReplyTypes ReplyType;

    var() int nListenerIndex;

    var() bool bUnskippable;

    var transient bool bIllegal;

}

struct native BioDialogSpeaker
{
    var() Name sSpeakerTag;

    var transient Actor aSpeaker;

}

struct native BioDialogLookat
{
    var transient Actor pActor;

    var transient float fLookAtDelay;

    var transient Actor pLookAtTarget;

}

struct native BioDialogScript
{
    var() Name sScriptTag;

}

struct native BioNextCamData
{
    var() float fFov;

    var() Vector vPos;

    var() Rotator rRot;

    var() bool bUseThis;

    var() float fNearPlane;

    var() Name sCameraName;

    var() BioStageDOFData tDOFData;

}

struct native BioSavedActorPos
{
    var Actor pActor;

    var Vector vPos;

    var Rotator rRot;

}

struct native BioInterruptReplyInfo
{
    var EInterruptionType eInterruptType;

    var bool bEnabled;

    var int nReplyListIndex;

    var float fWindowStartTimeRemaining;

    var float fWindowTimeRemaining;

    var bool bActivated;

}

enum EConvLightingType
{
    ConvLighting_Cinematic,
    ConvLighting_Exploration,
    ConvLighting_Dynamic,
};

struct native BioConvLightingData
{
    var(KeyLight) float KeyLight_Scale_Red;

    var(KeyLight) float KeyLight_Scale_Green;

    var(KeyLight) float KeyLight_Scale_Blue;

    var(FillLight) float FillLight_Scale_Red;

    var(FillLight) float FillLight_Scale_Green;

    var(FillLight) float FillLight_Scale_Blue;

    var(RimLight) Color RimLightColor;

    var(RimLight) float RimLightScale;

    var(RimLight) float RimLightYaw;

    var(RimLight) float RimLightPitch;

    var(RimLight) ERimLightControlType RimLightControl;

    var() EConvLightingType LightingType;

    var() Name TargetBoneName;

    var() float BouncedLightingIntensity;

    var() float BouncedKeyLightingIntensity;

    var() float BouncedKeyLightingDesaturation;

    var() bool bLockEnvironment;

    var() bool bTriggerFullUpdate;

    var() bool bUseForNextCamera;

}

struct native BioNextLightingData
{
    var() BioConvLightingData tData;

    var() Actor pActor;

    var() bool bUseThis;

}

var transient float m_fTeleAverageSkipTime;

var transient int m_nTeleLinesSkipped;

var transient int m_nTeleLinesHit;

var config float m_fDefaultInterruptWindowStart;

var config float m_fDefaultInterruptWindowDuration;

// m_CachedLightingState: MapProperty[52]
var transient array<BioPawn> m_aExtraParticipants;

// m_srPreLoadedStrRef: StringRefProperty[44]
var transient float m_fPreLoadStartDelay;

var transient array<int> m_aPreLoadNodesVisited;

var transient float m_fPreLoadTimer;

var transient WwiseBaseSoundObject m_pPreLoadingSoundCue;

var transient float m_fAudioHitchBuffer;

var transient config Color m_colSubtitleColor;

var array<WwiseBaseSoundObject> m_aFemaleSoundObjects;

var array<WwiseBaseSoundObject> m_aMaleSoundObjects;

var FaceFXAnimSet m_pNonSpeakerFaceFXSet;

var const array<FaceFXAnimSet> m_aFemaleFaceSets;

var const array<FaceFXAnimSet> m_aMaleFaceSets;

var() const FaceFXAnimSet FaceFXSet;

var const transient Sequence m_pPIEEvtSysSeq;

var() const Sequence MatineeSequence;

var const BioTlkSet TalkTables;

var native transient Map_Mirror m_mapPawnProps;

var transient int m_nDelayedReplyChoice;

var transient float m_fRemainingLastLineSubtitleDelay;

var transient float m_fRemainingVOLength;

var transient String m_sCurrentFaceFXAnim;

var transient WwiseBaseSoundObject m_pCurrentSound;

var transient String m_sCurrentSubTitle;

var transient int m_nNodeStateFlags;

var transient config float m_fVOPreloadDelayTime;

var transient config float m_fSubtitleTimingMinimum;

var transient config float m_fSubtitleTimingModifier;

var transient array<BioSavedActorPos> m_aFSPrevPositions;

var transient BioNextLightingData m_tNextLightingOverride;

var transient BioNextCamData m_tNextCamOverride;

var transient float m_fInterruptRange;

var transient BioInterruptReplyInfo m_tInterruptInfo;

var transient float m_fNodePlayTimer;

var transient config float m_fShowLastLineOffset;

var transient config float m_fShowRepliesOffset;

var transient String m_sAreaCode;

var transient BioStage m_stage;

var transient int m_intimacy;

var transient config bool m_bAutoAdvanceSkippableLinesWithNoVO;

var transient config bool m_bVerifyPreLoadingCorrectness;

var transient bool m_bPlayerSexIsValid;

var transient config bool m_bNextLinePreLoadEnabled;

var transient bool m_bPlayingNonTextLine;

var transient config bool m_bRemoveWeapons;

var transient bool m_bEarlyTermination;

var transient bool m_bCleanupNeeded;

var transient bool m_bForceShowReplies;

var transient bool m_bNoGestures;

var transient bool m_bPlayerIsFemale;

var transient config bool m_bEnableLookAtWithStage;

var transient bool m_bConversationOver;

var transient bool m_bKismetInitiated;

var transient bool m_bInterrupted;

var transient bool m_bFailed;

var transient bool m_bSkippable;

var transient bool m_bDisableTargeting;

var transient bool m_bPutPlayerIntoCombat;

var transient bool m_bAmbient;

var transient bool m_bSkipProtectionDisabled;

var transient config bool m_bDisplayNonAmbientName;

var transient bool m_bForceUnskippable;

var transient bool m_bSkipRequested;

var transient bool m_bHasAttachedDOFTrack;

var transient bool m_bHasAttachedCameraTrack;

var transient bool m_bConversationEnded;

var transient int m_nCurrentReply;

var transient BioSeqAct_StartConversation m_pKismetStart;

var transient int m_nSelectedReply;

var transient Vector vLineOfAction;

var transient Actor m_pListener;

var transient Actor m_oPreviousSpeaker;

var transient Actor m_pSpeaker;

var transient Actor m_pConversationPlayer;

var transient Actor m_pConversationOwner;

var transient array<int> m_lstCurrentReplyIndices;

var transient float m_fStartTime;

var transient int m_nCurrentEntry;

var() int m_nResRefID;

var() bool bUseFixedCameras;

var() bool m_bOneLinerConversation;

var() array<BioDialogScript> m_ScriptList;

var transient array<BioDialogLookat> m_LookAtList;

var() array<BioDialogSpeaker> m_SpeakerList;

var() array<BioDialogReplyNode> m_ReplyList;

var() array<BioDialogEntryNode> m_EntryList;

var() array<int> m_StartingList;

struct native BioConvPawnPropData
{
    var native Map_Mirror mapMeshPropData;

    var native Map_Mirror mapWeaponPropData;

}

native function SetPositionRotator(Actor pActor, Vector Position, Rotator facing);

native function Actor GetConversationObject(int nObjectIndex, optional bool bNoisyErrors);

native function bool StartConversation(Actor aOwner, Actor aPlayer);

native function EndConversation();

native function bool UpdateConversation(float fDeltaT);

native function bool SelectReply(int nReply);

native function bool QueueReply(int nReply);

native function bool FinishSelectedReply();

native function bool SkipNode();

native function bool WaitingForReply();

native function bool IsAmbient();

native function switchToAmbient(bool bWasNonAmbient);

native function UpdateLookAtList(BioPawn pBioPawn);

native function UpdateLookAtTargets(float fDeltaT);

native function UpdateFacing();

native function Actor GetSpeaker(int nIndex);

native function String GetEntryText(optional bool bParse);

native function String GetReplyText(int nIndex, optional bool bParse);

native function String GetReplyParaphraseText(int nIndex);

native function int GetReplyCategory(int nIndex);

native function int GetReplyExportID(int nIndex);

native function StopScript(String Script);

native function bool NeedToDisplayReplies();

native function bool FinishEntryNode(int nEntryIndex);

native function EConvGUIStyles GetReplyGUIStyle(int nIndex);

native function MissingVO();

native function MissingLipSync();

native function bool TickInterruptionData(float fDelta);

native function EnableCustomInterruptWindow();

native function SetCustomInterruptWindow(float fStart, optional float fDuraton);

native function bool NeedToDisplayInterrupt();

native function bool SelectInterruption();

event DisableCamera(bool bDisableCamera)
{
    local Pawn Pawn;
    Pawn = Pawn(m_pConversationPlayer);
    if (Pawn != None && PlayerController(Pawn.Controller) != None)
    {
        SFXPlayerCamera(PlayerController(Pawn.Controller).PlayerCamera).bDisabled = bDisableCamera;
    }
}

defaultproperties
{
    m_bDisplayNonAmbientName=true
    m_bEnableLookAtWithStage=true
    m_bRemoveWeapons=true
    m_bNextLinePreLoadEnabled=true
    m_fShowRepliesOffset=2
    m_fShowLastLineOffset=5
    m_fSubtitleTimingModifier=0,5
    m_fSubtitleTimingMinimum=2
    m_fVOPreloadDelayTime=1
    m_colSubtitleColor=(B=255,G=255,R=204,A=255)
    m_fDefaultInterruptWindowDuration=2
    m_fDefaultInterruptWindowStart=1
}
