﻿class BioEventNotifier extends Object
    config(UI)
    native;

enum BioNoticeDisplayTypes
{
    NOTICE_TYPE_DELTA,
    NOTICE_TYPE_TEXT,
    NOTICE_TYPE_QUANTITY,
    NOTICE_TYPE_QUANTITY_TEXT,
};

enum BioNoticeIcons
{
    NOTICE_ICON_UNASSIGNED,
    NOTICE_ICON_QUEST_UPDATE,
    NOTICE_ICON_LEVELUP,
    NOTICE_ICON_DEFICIENCY,
    NOTICE_ICON_XP,
    NOTICE_ICON_PARAGON,
    NOTICE_ICON_RENEGADE,
    NOTICE_ICON_OMNITOOL,
    NOTICE_ICON_BIOAMP,
    NOTICE_ICON_XMOD,
    NOTICE_ICON_CODEX_ADDED,
    NOTICE_ICON_COIN,
    NOTICE_ICON_MEDIGEL,
    NOTICE_ICON_SALVAGE,
    NOTICE_ICON_PISTOL,
    NOTICE_ICON_SHOTGUN,
    NOTICE_ICON_ASSAULT_RIFLE,
    NOTICE_ICON_SNIPER_RIFLE,
    NOTICE_ICON_ARMOR,
    NOTICE_ICON_GRENADE,
    NOTICE_ICON_QUEST_ADDED,
    NOTICE_ICON_AREAMAPNODE,
};

enum BioNoticeContexts
{
    NOTICE_CONTEXT_JOURNAL,
    NOTICE_CONTEXT_CODEX,
    NOTICE_CONTEXT_INVENTORY,
    NOTICE_CONTEXT_PARTYLEVEL,
    NOTICE_CONTEXT_XP,
    NOTICE_CONTEXT_MEDIGEL,
    NOTICE_CONTEXT_SALVAGE,
    NOTICE_CONTEXT_CREDITS,
    NOTICE_CONTEXT_GRENADES,
    NOTICE_CONTEXT_PARAGON,
    NOTICE_CONTEXT_RENEGADE,
    NOTICE_CONTEXT_AREAMAP,
    NOTICE_CONTEXT_ABILITY,
};

struct native BioDisplayNotice
{
    var int nEventType;

    var int nTimeToLive;

    var int nIconIndex;

    var int nContext;

// srTitle: StringRefProperty[44]
    var String strTitle;

    var int nQuantity;

    var int nQuantMin;

    var int nQuantMax;

}

var Bio2DA oPlotIntTalent2DA;

var config bool bDissableTallentNotifications;

var config String sWwiseParaReneRTPCName;

var config float fPassivePopupDisplayTime;

var config String sWwiseMusicVolumeRTPCName;

var config int nWwiseMusicVolumeRTPCPlotVar;

var config int nRenegadePlotVar;

var config int nParagonPlotVar;

// srAbility: StringRefProperty[44]
// srMap: StringRefProperty[44]
// srSalvage: StringRefProperty[44]
// srMedigel: StringRefProperty[44]
// srRenegadeReceived: StringRefProperty[44]
// srParagonReceived: StringRefProperty[44]
// srCodexEntry: StringRefProperty[44]
// srQuestCompleted: StringRefProperty[44]
// srQuestUpdated: StringRefProperty[44]
// srQuestAdded: StringRefProperty[44]
// srLevelUp: StringRefProperty[44]
// srTalentSkipRemainder: StringRefProperty[44]
// srTalentOk: StringRefProperty[44]
var transient BioSFHandler_MessageBox m_oTalentNotifyBoxHandler;

var transient array<BioTalentNotice> m_lstTalentNotices;

var transient bool m_bHUDAcknowledgedTalentNotify;

var transient bool m_bTalentNoticeReady;

var transient bool m_bEnabled;

var transient bool m_bNoticesNotarized;

var transient array<BioDisplayNotice> m_lstNotices;

struct native BioTalentNotice
{
    var int nIcon;

    var String sName;

    var BioPawn oCharacter;

}

enum BioQuestEventTypes
{
    QET_New,
    QET_Updated,
    QET_Completed,
};

native function RetrieveNotices(out array<BioDisplayNotice> lstNotices);

native function HasListChanged();

native function NotarizeNotices();

native final function AddNotice(int nType, int nContext, int nTimeToLive, int nIconIndex, String strTitle, optional int nQuantity, optional int nQuantMin, optional int nQuantMax);

native final function ShowTalentNotify(BioPawn oCharacter);

native final function bool PendingTalentNotify(BioPawn oCharacter);

native final function OnTalentNoticeInput(bool bAPressed, int nContext);

native final function AddTalentNotifyString(int nTalentIcon, String sTalentName, BioPawn pPawn);

native final function AddTalentNotifyStringRef(int nTalentIcon, BioPawn pPawn);

native final function RemoveTalentNotify(BioPawn oCharacter);

defaultproperties
{
    m_bEnabled=true
    m_bHUDAcknowledgedTalentNotify=true
    srTalentOk=System.Byte[]
    srTalentSkipRemainder=System.Byte[]
    srLevelUp=System.Byte[]
    srQuestAdded=System.Byte[]
    srQuestUpdated=System.Byte[]
    srQuestCompleted=System.Byte[]
    srCodexEntry=System.Byte[]
    srParagonReceived=System.Byte[]
    srRenegadeReceived=System.Byte[]
    srMedigel=System.Byte[]
    srSalvage=System.Byte[]
    srMap=System.Byte[]
    srAbility=System.Byte[]
    nParagonPlotVar=2
    nRenegadePlotVar=3
    nWwiseMusicVolumeRTPCPlotVar=9
    sWwiseMusicVolumeRTPCName="Current_Music_Plot_State"
    fPassivePopupDisplayTime=3
    sWwiseParaReneRTPCName="Para_Rene_State"
    bDissableTallentNotifications=true
}
