﻿class BioEvtSysTrackGesture extends SFXGameActorInterpTrack
    hidecategories(Object)
    native
    collapsecategories;

enum EBioGestureAllPoses
{
    GestPose_Unset,
};

enum EBioGestureOverrideType
{
    DEFAULT_TRACK,
    FEMALE_PLAYER_TRACK,
};

struct native BioGestTrackPriority
{
    var int nTrackIndex;

    var int nPriority;

}

struct native BioGestureRenameData
{
    var Name nmOldAnim;

    var Name nmNewSet;

    var Name nmNewAnim;

}

enum EBioGestureValidPoses
{
    GestValidPoses_Unset,
};

enum EBioGestureValidGestures
{
    GestValidGest_Unset,
};

enum EBioGestureGroups
{
    GestGroups_Unset,
};

enum EBioValidPoseGroups
{
    ValidPoseGroups_Unset,
};

enum EBioTrackAllPoseGroups
{
    AllPoseGroups_Unset,
};

struct native BioGestureData
{
    var() EBioValidPoseGroups ePoseFilter;

    var() EBioGestureValidPoses ePose;

    var() EBioGestureGroups eGestureFilter;

    var() EBioGestureValidGestures eGesture;

    var Name nmPoseSet;

    var Name nmPoseAnim;

    var Name nmGestureSet;

    var Name nmGestureAnim;

    var Name nmTransitionSet;

    var Name nmTransitionAnim;

    var() float fPlayRate;

    var() float fStartOffset;

    var() float fEndOffset;

    var bool bInvalidData;

    var bool bOneShotAnim;

    var() float fStartBlendDuration;

    var() float fEndBlendDuration;

    var() float fWeight;

    var() bool bChainToPrevious;

    var() bool bPlayUntilNext;

    var array<int> aChainedGestures;

    var bool bUseDynAnimSets;

    var() bool bSnapToPose;

    var() float fTransBlendTime;

}

struct native BioGesturePinScrubData
{
    var Name nmAnimSet;

    var Name nmAnimSeq;

    var float fTime;

    var float fWeight;

}

struct native BioGestureScrubData extends BioGestureData
{
    var Name nmNextPoseSet;

    var Name nmNextPoseAnim;

    var float fCurPoseTime;

    var float fNextPoseTime;

    var float fTransitionTime;

    var float fCurPoseWeight;

    var float fTransitionWeight;

    var float fNextPoseWeight;

    var array<BioGesturePinScrubData> aGestPins;

}

var() float m_fStartPoseOffset;

var transient BioEvtSysTrackGestureAudHelper m_pGestAudHelper;

var bool m_bUseDynamicAnimsets;

var bool m_bAutoGenFemaleTrack;

var bool m_bARPUGenerated;

var Name nmStartingPoseAnim;

var Name nmStartingPoseSet;

var() EBioGestureOverrideType eOverrideType;

var() EBioGestureAllPoses eStartingPose;

var() EBioTrackAllPoseGroups ePoseFilter;

var() array<BioGestureData> m_aGestures;

static event bool AllowKeyNaming()
{
    return false;
}

static event String NewKeyDefaultName()
{
    return "Gesture";
}

static event String KeyDataArrayName()
{
    return "m_aGestures";
}

static event String KeyDataDisplayName()
{
    return "Gesture Data";
}

static event String GetNewTrackSubMenuName()
{
    return "Bio Conversation";
}

defaultproperties
{
    m_bUseDynamicAnimsets=true
    m_fStartPoseOffset=-1
    TrackInstClass=None
    TrackTitle="Gesture"
}
