﻿class BioFSMComponent extends Object
    hidecategories(Object)
    native
    editinlinenew
    collapsecategories;

enum eBioPendingStateChange
{
    BIO_PST_Done,
    BIO_PST_Pending,
    BIO_PST_Started,
};

var delegate<OnTransitionDelegate> OnTransition;

var() eBioPendingStateChange PendingStateChange;

var() BioTransition PendingTransition;

var() BioState PendingState;

var() BioState CurrentState;

var() BioFSM FSMData;

delegate OnTransitionDelegate(Name FromState, Name ToState, bool bCallCPP);

native function TransitionComplete();

event BioTransition GetTransition(Name ToState, optional Name NamedTransition)
{
    if (FSMData != None && CurrentState != None)
    {
        return CurrentState.GetTransition(ToState, NamedTransition);
    }
    return None;
}

native function BioState SetState(Name ToState, optional Name NamedTransition, optional bool IgnoreTransition, optional bool bForceStateNow);

event bool HasState(Name ToState)
{
    if (FSMData == None || FSMData.GetState(ToState) == None)
    {
        return false;
    }
    else
    {
        return true;
    }
}

event TransitionStarted();

event CallTransitionDelegate(Name From, Name To)
{
    OnTransition.OnTransitionDelegate(From, To, true);
}

event bool IsTransitioning()
{
    return PendingStateChange != 0 && CurrentState != None;
}

defaultproperties
{
}
