﻿class BioGUIBox extends Object
    abstract
    native;

struct native CanvasProperties
{
    var Font m_font;

    var int m_nCurX;

    var int m_nCurY;

    var int m_nOrgX;

    var int m_nOrgY;

    var int m_nClipX;

    var int m_nClipY;

    var Color m_color;

}

const MAX_SIZE_PERCENT = 0.75;
var bool m_bComputeDrawParameters;

var Font m_font;

var float m_fHeight;

var float m_fWidth;

var float m_fY;

var float m_fX;

var int m_nCanvasHeight;

var int m_nCanvasWidth;

var CanvasProperties m_canvasProperties;

var() Color m_colorForeground;

var() Color m_colorBackground;

protected function bool ShouldRender();

protected function ComputeDrawParameters(Canvas oCanvas);

protected function RenderContent(Canvas oCanvas);

final private function PushCanvasProperties(Canvas oCanvas)
{
    m_canvasProperties.m_font = oCanvas.Font;
    m_canvasProperties.m_nOrgX = oCanvas.OrgX;
    m_canvasProperties.m_nCurX = oCanvas.CurX;
    m_canvasProperties.m_nClipX = oCanvas.ClipX;
    m_canvasProperties.m_nOrgY = oCanvas.OrgY;
    m_canvasProperties.m_nCurY = oCanvas.CurY;
    m_canvasProperties.m_nClipY = oCanvas.ClipY;
    m_canvasProperties.m_color = oCanvas.DrawColor;
}

final private function PopCanvasProperties(Canvas oCanvas)
{
    oCanvas.Font = m_canvasProperties.m_font;
    oCanvas.OrgX = m_canvasProperties.m_nOrgX;
    oCanvas.CurX = m_canvasProperties.m_nCurX;
    oCanvas.ClipX = m_canvasProperties.m_nClipX;
    oCanvas.OrgY = m_canvasProperties.m_nOrgY;
    oCanvas.CurY = m_canvasProperties.m_nCurY;
    oCanvas.ClipY = m_canvasProperties.m_nClipY;
    oCanvas.DrawColor = m_canvasProperties.m_color;
}

native function SetFont(Font Font);

function Draw(Canvas oCanvas)
{
    if (oCanvas == None)
    {
        return;
    }
    if (!ShouldRender())
    {
        return;
    }
    if (oCanvas.SizeX != m_nCanvasWidth || oCanvas.SizeY != m_nCanvasHeight)
    {
        m_bComputeDrawParameters = true;
    }
    PushCanvasProperties(oCanvas);
    oCanvas.Font = m_font;
    ComputeDrawParameters(oCanvas);
    oCanvas.OrgX = 0;
    oCanvas.OrgY = 0;
    oCanvas.ClipX = oCanvas.SizeX;
    oCanvas.CurY = m_fY;
    oCanvas.ClipY = oCanvas.SizeY;
    oCanvas.SetPos(m_fX, m_fY);
    oCanvas.DrawColor = m_colorBackground;
    oCanvas.DrawRect(m_fWidth, m_fHeight);
    RenderContent(oCanvas);
    PopCanvasProperties(oCanvas);
}

defaultproperties
{
    m_colorBackground=(B=0,G=0,R=0,A=255)
    m_colorForeground=(B=255,G=255,R=255,A=255)
    m_font=Font'LargeFont'
    m_bComputeDrawParameters=true
}
