﻿class BioGamePropertyEventSet extends Object
    native;

enum EBioGamePropertyEvent
{
    GAMEPROP_EVENT_EQUIPMENT_CHANGE,
    GAMEPROP_EVENT_XMOD_CHANGE,
    GAMEPROP_EVENT_WEAPON_IMPACT,
    GAMEPROP_EVENT_VEHICLE_EQUIPMENT_CHANGE,
    GAMEPROP_EVENT_DEATH,
    GAMEPROP_EVENT_WEAPON_FIRED,
    GAMEPROP_EVENT_WEAPON_POWER_USED,
};

var array<EBioGamePropertyEvent> m_aEvents;

function Clear()
{
    m_aEvents.Length = 0;
}

native function AddEvent(EBioGamePropertyEvent eEvent);

native function AddEvents(array<EBioGamePropertyEvent> aEvents);

native function AddEventSet(BioGamePropertyEventSet oEvents);

native function RemoveEvent(EBioGamePropertyEvent eEvent);

native function RemoveEvents(array<EBioGamePropertyEvent> aEvents);

native function RemoveEventSet(BioGamePropertyEventSet oEvents);

native function bool CheckForEvent(EBioGamePropertyEvent eEvent);

native function bool CheckForAllEvents(BioGamePropertyEventSet oEvents);

native function bool CheckForAnyEvents(BioGamePropertyEventSet oEvents);

static event BioGamePropertyEventSet Create1(EBioGamePropertyEvent eEvent1, optional Object oSource)
{
    local BioGamePropertyEventSet oEventSet;
    oEventSet = new(Class'BioGamePropertyEventSet');
    oEventSet.AddEvent(eEvent1);
    return oEventSet;
}

static event BioGamePropertyEventSet Create2(EBioGamePropertyEvent eEvent1, EBioGamePropertyEvent eEvent2, optional Object oSource)
{
    local BioGamePropertyEventSet oEventSet;
    oEventSet = new(Class'BioGamePropertyEventSet');
    oEventSet.AddEvent(eEvent1);
    oEventSet.AddEvent(eEvent2);
    return oEventSet;
}

static event BioGamePropertyEventSet Create3(EBioGamePropertyEvent eEvent1, EBioGamePropertyEvent eEvent2, EBioGamePropertyEvent eEvent3, optional Object oSource)
{
    local BioGamePropertyEventSet oEventSet;
    oEventSet = new(Class'BioGamePropertyEventSet');
    oEventSet.AddEvent(eEvent1);
    oEventSet.AddEvent(eEvent2);
    oEventSet.AddEvent(eEvent3);
    return oEventSet;
}

defaultproperties
{
}
