﻿class BioGamePropertyManager extends SFXModule
    hidecategories(Object)
    native;

// m_mapActiveGamePropertyGroups: MapProperty[52]
var Object m_oOwner;

var array<BioGamePropertyManagerTimedOutTicked> m_aTimedOutTicked;

var array<BioGameProperty> m_apPendingUnapply;

var /* 00000008 */ BioGamePropertyTimer m_oRegisteredGPs;

struct native BioGamePropertyManagerTimedOutTicked
{
    var BioGameProperty m_pGP;

    var float m_fTimeRemaining;

}

native final function EvaluateGameProperty(BioGameProperty pGP, Object pTarget);

native final private function ApplyGameProperty(BioGameProperty pGP, Object pTarget);

native final private function UnapplyGameProperty(BioGameProperty pGP, Object pTarget);

final private function OnGPTimeOut(BioGameProperty pGameProperty, EBioGPTimingType eTimingType, float fDeltaTimeRemaining)
{
    if (eTimingType == 2)
    {
        m_aTimedOutTicked.Length = m_aTimedOutTicked.Length + 1;
        m_aTimedOutTicked[m_aTimedOutTicked.Length - 1].m_pGP = pGameProperty;
        m_aTimedOutTicked[m_aTimedOutTicked.Length - 1].m_fTimeRemaining = fDeltaTimeRemaining;
    }
    else
    {
        m_apPendingUnapply.AddItem(pGameProperty);
    }
}

final private event TickInternal(float fDelta)
{
    m_oRegisteredGPs.Tick(fDelta, OnGPTimeOut);
}

native function Tick(float fDelta);

native final function Object GetOwnerObject();

native final function bool FindGamePropertyByName(Name nmName, int nGamePropertyGroup, out array<BioGameProperty> aProperties);

native final function bool FindGamePropertyByOwner(Actor oOwner, int nGamePropertyGroup, out array<BioGameProperty> aProperties);

native final function bool FindGamePropertyByGroup(int nGamePropertyGroup, out array<BioGameProperty> aProperties);

native final function bool FindGamePropertyByEffectType(class<Object> GameEffectClass, int nGamePropertyGroup, out array<BioGameProperty> aProperties);

native final function bool IsGameEffectApplied(class<Object> GameEffectClass);

event String ToString(optional String sIndent)
{
    local String sOutput;
    sOutput $= sIndent $ m_oRegisteredGPs.ToString(sIndent $ "  ");
    return sOutput;
}

defaultproperties
{
    m_oRegisteredGPs=BioGamePropertyTimer'timertemp'
    // child object timertemp of type BioGamePropertyTimer
}
