﻿class BioGamePropertyTimer extends Object
    native;

enum EBioGPTimeAction
{
    GP_TA_REMOVE,
    GP_TA_CONTINUE,
    GP_TA_BREAK,
};

struct native BioGPTimingData
{
    var float fTime;

    var BioGameProperty oGP;

    var EBioGPTimingType eTimingType;

    var bool bFrameTicked;

}

var bool m_bMutex;

var array<BioGameProperty> m_aFrameTickGPs;

var array<BioGPTimingData> m_aTimedGPs;

delegate OnRemoveGameProperty(BioGameProperty pGP, EBioGPTimingType eTimingType, float fDeltaTimeRemaining);

native final function InsertGameProperty(BioGameProperty oGP, float fTime, EBioGPTimingType eTimingType, optional bool bFrameTicked);

native final function bool RemoveGameProperty(BioGameProperty oGP);

native final function RemoveGamePropertyAtIndex(int nIndex);

native final function int FindGamePropertyIndex(BioGameProperty oGP, EBioGPTimingType eTimingType);

native final function AppendStaticGameProperty(BioGameProperty oGP);

native function Tick(float fDeltaTime, delegate<OnRemoveGameProperty> oOnRemoveGameProperty);

native function float GetTimeForGameProperty(BioGameProperty oGameProp, EBioGPTimingType eTimingType);

native function float GetTimeForGamePropertyByName(Name nmGamePropertyName, EBioGPTimingType eTimingType, out BioGameProperty oGameProperty);

native function RemoveAllNonStatic(delegate<OnRemoveGameProperty> pDelegate);

final private event InvokeDelegate(delegate<OnRemoveGameProperty> pDelegate, BioGameProperty pGP, EBioGPTimingType eTimingType, float fDeltaTimeRemaining)
{
    local bool bBogus;
    bBogus = true;
    if (bBogus == false)
    {
    }
    pDelegate.OnRemoveGameProperty(pGP, eTimingType, fDeltaTimeRemaining);
}

event String ToString(optional String sIndent)
{
    local String sOutput;
    local int I;
    local String sGameProperty;
    I = 0;
    while (I != m_aTimedGPs.Length)
    {
        sGameProperty = m_aTimedGPs[I].oGP.ToLine();
        if (sGameProperty != "")
        {
            sOutput $= sIndent $ "Game Property[" $ I $ "]," $ sGameProperty $ ",";
        }
        ++I;
    }
    return sOutput;
}

const GP_NEVER_TIMEOUT = 9999999999.0f;
enum EBioGPTimingType
{
    GP_TIMING_STATIC,
    GP_TIMING_TIMEOUT,
    GP_TIMING_TICK,
    GP_TIMING_COOLDOWN,
};

defaultproperties
{
}
