﻿class BioMorphUtility extends Object
    hidecategories(Object,Advanced,Collision,Movement,Debug)
    native;

enum EBioMorphUtilityComponentType
{
    BMU_Component_Unknown,
    BMU_Component_Picker,
    BMU_Component_Slider,
    BMU_Component_Combo,
    BMU_Component_RGBA,
    BMU_Component_Compound,
};

enum EBioMorphUtilityHairComponentType
{
    BMU_HairComponent_Hair,
    BMU_HairComponent_Other,
};

struct native TextureData
{
    var Name m_nParamName;

    var Texture m_oTexture;

}

struct native ScalarData
{
    var Name m_nParamName;

    var float m_fScalarValue;

}

struct native HairComponent
{
    var String StyleName;

    var String MeshName;

    var SkeletalMesh HairMesh;

    var String ScalpMorphName;

    var float ScalpMorphWeight;

    var EBioMorphUtilityHairComponentType HairType;

    var array<TextureData> m_aHairTextures;

    var array<ScalarData> m_aHairScalars;

}

struct native HairData
{
    var String PackageName;

    var String HairMorphSpecMaskName;

    var array<HairComponent> HairComponents;

}

struct native MaterialComponent
{
    var String Label;

    var EBioMorphUtilityComponentType Type;

    var String Name;

    var String Panel;

    var String ParameterName;

    var array<String> Params;

}

struct native MaterialGroup
{
    var String Name;

    var array<MaterialComponent> Components;

}

struct native MaterialPanel
{
    var String Name;

    var array<MaterialGroup> Groups;

}

struct native MaterialData
{
    var array<MaterialPanel> Panels;

}

struct native AdditionalData
{
    var HairData Hair;

}

defaultproperties
{
}
