﻿class BioMoviePlayer extends Object
    native;

var TextureMovie m_textureMovie;

var Material m_material;

delegate OnMovieFinished(TextureMovie TextureMovie);

final private function InitializeMovie()
{
    m_textureMovie.Stop();
    m_textureMovie.Play();
}

function SetTextureMovie(TextureMovie TextureMovie)
{
    local MaterialExpressionTextureSample textureSample;
    if (TextureMovie == None)
    {
        return;
    }
    m_textureMovie = TextureMovie(BioDuplicate(TextureMovie));
    m_material = new(self,Class'Material');
    textureSample = new(m_material,Class'MaterialExpressionTextureSample');
    textureSample.Texture = m_textureMovie;
    m_material.EmissiveColor.Expression = textureSample;
    InitializeMovie();
}

function SetMaterial(Material Material)
{
    local MaterialExpressionTextureSample textureSample;
    if (Material == None)
    {
        return;
    }
    m_material = Material;
    textureSample = MaterialExpressionTextureSample(m_material.DiffuseColor.Expression);
    if (textureSample != None)
    {
        m_textureMovie = TextureMovie(textureSample.Texture);
    }
    if (m_textureMovie == None)
    {
        textureSample = MaterialExpressionTextureSample(m_material.EmissiveColor.Expression);
        if (textureSample != None)
        {
            m_textureMovie = TextureMovie(textureSample.Texture);
        }
    }
    if (m_textureMovie == None)
    {
        textureSample = MaterialExpressionTextureSample(m_material.SpecularColor.Expression);
        if (textureSample != None)
        {
            m_textureMovie = TextureMovie(textureSample.Texture);
        }
    }
    if (m_textureMovie == None)
    {
        textureSample = MaterialExpressionTextureSample(m_material.TwoSidedLightingColor.Expression);
        if (textureSample != None)
        {
            m_textureMovie = TextureMovie(textureSample.Texture);
        }
    }
    InitializeMovie();
}

function Draw(Canvas Canvas)
{
    if (m_material == None)
    {
        return;
    }
    if (m_textureMovie != None && m_textureMovie.Stopped)
    {
        ShutdownMovie();
        return;
    }
    Canvas.SetPos(0, 0);
    Canvas.DrawMaterialTile(m_material, Canvas.SizeX, Canvas.SizeY);
}

event ShutdownMovie()
{
    m_material = None;
    if (m_textureMovie != None)
    {
        m_textureMovie.Stop();
        OnMovieFinished(m_textureMovie);
        m_textureMovie = None;
    }
}

defaultproperties
{
}
