﻿class BioParticleModuleCollisionDecal extends ParticleModuleCollision
    hidecategories(Object,Object,Object,Object)
    native
    editinlinenew
    collapsecategories;

var ParticleSystem CollisionEmitterTemplate;

var(Parameters) /* 00000008 */ array<Name> ColorParams;

var(Collision) bool bEnableMultiHitDecal;

var(Collision) /* 00000008 */ String CollisionEmitter;

var(Collision) /* 00000008 */ BioDecalComponent DecalTemplate;

event CreateDecal(ParticleSystemComponent PSC, PrimitiveComponent HitComponent, Vector HitLocation, Vector HitNormal)
{
    local MaterialInstanceTimeVarying MITV;
    local MaterialInterface DecalMaterial;
    local Name Param;
    local ParticleSysParam PSParam;
    local LinearColor C;
    if (ColorParams.Length > 0)
    {
        MITV = new(PSC,Class'MaterialInstanceTimeVarying');
        MITV.SetParent(DecalTemplate.DecalMaterial);
        foreach ColorParams(Param)
        {
            foreach PSC.InstanceParameters(PSParam)
            {
                if (PSParam.Name == Param)
                {
                    C.R = PSParam.Color.R;
                    C.G = PSParam.Color.G;
                    C.B = PSParam.Color.B;
                    C.A = PSParam.Color.A;
                    MITV.SetVectorParameterValue(Param, C);
                }
            }
        }
        foreach Class'SFXWeapon'.Default.FadingParameters(Param)
        {
            MITV.SetScalarStartTime(Param, 0);
        }
        DecalMaterial = MITV;
    }
    else
    {
        DecalMaterial = DecalTemplate.DecalMaterial;
    }
    if (bEnableMultiHitDecal)
    {
        HitComponent = None;
    }
    Class'Engine'.GetCurrentWorldInfo().MyDecalManager.SpawnDecal(DecalMaterial, HitLocation + HitNormal, -HitNormal, DecalTemplate.Width, DecalTemplate.Height, DecalTemplate.Thickness, DecalTemplate.bNoClip, FRand() * 360, HitComponent);
}

defaultproperties
{
    // child object DistributionDelayAmount of type DistributionFloatConstant
    // child object DistributionParticleMass of type DistributionFloatConstant
    // child object DistributionMaxCollisions of type DistributionFloatUniform
    // child object DistributionDampingFactorRotation of type DistributionVectorConstant
    // child object DistributionDampingFactor of type DistributionVectorUniform
}
