﻿class BioPawnBehaviorSaveObject extends BioEpicPawnBehaviorSaveObject
    native;

var int m_TalentPoints;

var bool m_bHeadGearVisiblePreference;

var float m_DamageDurationMult;

var int m_ResourcesMedigel;

var int m_ResourcesCredits;

var float m_SkillHaggle;

var float m_SkillIntimidate;

var float m_SkillCharm;

var int m_SpecializationBonusID;

var int m_AutoLevelUpTemplateID;

// m_LocalizedClassName: StringRefProperty[44]
var int m_TalentPoolPoints;

var int m_Experience;

var array<BioComplexTalentSave> m_aComplexTalents;

var array<BioSimpleTalentSave> m_aSimpleTalents;

var BioBaseSaveObject m_Squad;

var EBioPlayerCharacterBackgroundNotoriety m_BackgroundNotoriety;

var EBioPlayerCharacterBackgroundOrigin m_BackgroundOrigin;

var EBioPlayerCharacterSpectreRank m_SpectreRank;

var EBioPartyMemberClassBase m_ClassBase;

var EBioAttributePawnRace m_Race;

var EBioAttributePawnGender m_Gender;

var int m_XPLevel;

function SaveObject(Object O)
{
    local BioPawnBehavior oBehave;
    local BioAttributesPawn PawnAttributes;
    local BioAttributesPawnParty PawnPartyAttributes;
    local BioAttributesPawnPlayer PawnPlayerAttributes;
    oBehave = BioPawnBehavior(O);
    PawnAttributes = BioAttributesPawn(oBehave.m_PawnAttributes);
    if (PawnAttributes != None)
    {
        m_Race = PawnAttributes.m_Race;
        m_DamageDurationMult = Class'BioAttributes'.GetBaseFloatValue(PawnAttributes.m_DamageDurationMult);
    }
    PawnPartyAttributes = BioAttributesPawnParty(oBehave.m_PawnAttributes);
    if (PawnPartyAttributes != None)
    {
        m_ClassBase = PawnPartyAttributes.m_ClassBase;
        m_LocalizedClassName = PawnPartyAttributes.m_LocalizedClassName;
        m_TalentPoolPoints = PawnPartyAttributes.m_TalentPoolPoints;
        m_Experience = PawnPartyAttributes.m_Experience;
        m_AutoLevelUpTemplateID = PawnPartyAttributes.m_AutoLevelUpTemplateID;
    }
    PawnPlayerAttributes = BioAttributesPawnPlayer(oBehave.m_PawnAttributes);
    if (PawnPlayerAttributes != None)
    {
        m_SpectreRank = PawnPlayerAttributes.m_SpectreRank;
        m_BackgroundOrigin = PawnPlayerAttributes.m_BackgroundOrigin;
        m_BackgroundNotoriety = PawnPlayerAttributes.m_BackgroundNotoriety;
        m_SkillCharm = Class'BioAttributes'.GetBaseFloatValue(PawnPlayerAttributes.m_SkillCharm);
        m_SkillIntimidate = Class'BioAttributes'.GetBaseFloatValue(PawnPlayerAttributes.m_SkillIntimidate);
        m_SkillHaggle = Class'BioAttributes'.GetBaseFloatValue(PawnPlayerAttributes.m_SkillHaggle);
        m_SpecializationBonusID = PawnPlayerAttributes.m_SpecializationBonusID;
        if (SFXInventoryManager(BioPawn(oBehave.Owner).InvManager) != None)
        {
            m_ResourcesCredits = SFXInventoryManager(BioPawn(oBehave.Owner).InvManager).GetResource(0);
            m_ResourcesMedigel = SFXInventoryManager(BioPawn(oBehave.Owner).InvManager).GetResource(1);
        }
        else
        {
            m_ResourcesCredits = 0;
            m_ResourcesMedigel = 0;
        }
    }
    m_bHeadGearVisiblePreference = BioPawn(oBehave.Owner).GetHeadGearVisiblePreference();
    SaveObject(O);
}

function LoadObject(Object O)
{
    local BioPawnBehavior oBehave;
    local BioAttributesPawn PawnAttributes;
    local BioAttributesPawnParty PawnPartyAttributes;
    local BioAttributesPawnPlayer PawnPlayerAttributes;
    local int nAmtIncrease;
    local SFXInventoryManager oInventory;
    oBehave = BioPawnBehavior(O);
    LoadObject(O);
    PawnAttributes = BioAttributesPawn(oBehave.m_PawnAttributes);
    if (PawnAttributes != None)
    {
        PawnAttributes.SetByteAttribute('m_Race', m_Race);
        PawnAttributes.SetFloatAttribute('m_DamageDurationMult', m_DamageDurationMult);
    }
    PawnPartyAttributes = BioAttributesPawnParty(oBehave.m_PawnAttributes);
    if (PawnPartyAttributes != None)
    {
        PawnPartyAttributes.m_ClassBase = m_ClassBase;
        PawnPartyAttributes.m_LocalizedClassName = m_LocalizedClassName;
        PawnPartyAttributes.m_TalentPoolPoints = m_TalentPoolPoints;
        PawnPartyAttributes.m_Experience = m_Experience;
        PawnPartyAttributes.m_AutoLevelUpTemplateID = m_AutoLevelUpTemplateID;
    }
    PawnPlayerAttributes = BioAttributesPawnPlayer(oBehave.m_PawnAttributes);
    if (PawnPlayerAttributes != None)
    {
        PawnPlayerAttributes.m_SpectreRank = m_SpectreRank;
        PawnPlayerAttributes.m_BackgroundOrigin = m_BackgroundOrigin;
        PawnPlayerAttributes.m_BackgroundNotoriety = m_BackgroundNotoriety;
        PawnPlayerAttributes.SetFloatAttribute('m_SkillCharm', m_SkillCharm);
        PawnPlayerAttributes.SetFloatAttribute('m_SkillIntimidate', m_SkillIntimidate);
        PawnPlayerAttributes.SetFloatAttribute('m_SkillHaggle', m_SkillHaggle);
        PawnPlayerAttributes.m_SpecializationBonusID = m_SpecializationBonusID;
        oInventory = SFXInventoryManager(BioPawn(oBehave.Owner).InvManager);
        if (oInventory != None)
        {
            nAmtIncrease = m_ResourcesCredits - oInventory.GetResource(0);
            oInventory.AdjustResource(0, nAmtIncrease);
            nAmtIncrease = m_ResourcesMedigel - oInventory.GetResource(1);
            oInventory.AdjustResource(1, nAmtIncrease);
        }
    }
    if (m_Squad != None)
    {
        oBehave.Squad.ReadSaveObject(m_Squad);
    }
    BioPawn(oBehave.Owner).SetHeadGearVisiblePreference(m_bHeadGearVisiblePreference);
}

defaultproperties
{
}
