﻿class BioPawnType extends BioInteractiveActorType
    hidecategories(Object)
    native;

enum eDefaultAIBehaviour
{
    DAIB_NONE,
};

var Color CharacterBloodColor[23];

var(SoundSet) WwiseBaseSoundObject m_oRollingStartMoving;

var(SoundSet) WwiseBaseSoundObject m_oRollingIdle;

var(SoundSet) FaceFXAnimSet m_pSndSetFaceFXPkg;

var(Damage) float m_fPhysicsThresholdRegenerationRate;

var(Damage) float m_fPhysicsThreshold;

var(Damage) float m_fDeathAnimationMagnitudeThreshold;

var(Damage) float m_fPhysicsSettleDownTime;

var(Damage) float m_fPhysicsRecoverSpeedThreshold;

var(Appearance) int m_nMinAutoLODLevel;

var(Appearance) BioMorphFace m_oMorphFace;

var(Appearance) /* 00000008 */ BioMaterialOverride m_oMaterialOverrides;

var(Appearance) /* 00000008 */ Bio_Appr_Character_Settings m_oAppearanceSettings;

var(Appearance) Bio_Appr_Character m_oAppearance;

var(AI) BioVFXTemplate DeathCrust;

var(AI) BioVFXTemplate EliteCrust;

var(AI) SFXLoadoutData Loadout;

var Name m_nmDefaultAIBehaviour;

var(Classification) EChallengeType ChallengeType;

var(Classification) EAffiliationType AffiliationType;

var(Classification) ECharacterType CharacterType;

var(Classification) ERaceType RaceType;

var(SoundSet) EPhysics m_eUseRollingInPhysicsMode;

var(Appearance) EBioPawnClassification m_eDefaultClassification;

var(Appearance) EBioBaseAppearanceReportMethod m_eReportMethod;

var(AI) eDefaultAIBehaviour m_eDefaultAIBehaviour;

var(AI) class<BioAiController> AIController;

var(Physics) bool m_bCanBePhysicsImpacted;

var(Combat) bool m_bTerminateRagdollOnDeath;

var(Combat) bool m_bCanBeBumped;

var(Appearance) bool m_bIsArmorOverridden;

var(AI) bool bIsFemale;

var(AI) class<BioPawn> PawnClass;

var(AI) float m_fPowerUsePercent;

enum ERaceType
{
    RaceType_None,
    RaceType_Humanoid,
    RaceType_Machine,
    RaceType_Animal,
};

enum ECharacterType
{
    CharacterType_None,
    CharacterType_Human,
    CharacterType_Turian,
    CharacterType_Asari,
    CharacterType_Krogan,
    CharacterType_Quarian,
    CharacterType_Salarian,
    CharacterType_Vorcha,
    CharacterType_LightMech,
    CharacterType_HeavyMech,
    CharacterType_MechDog,
    CharacterType_Batarian,
    CharacterType_GethInfantry,
    CharacterType_GethColossus,
    CharacterType_GethDestroyer,
    CharacterType_Husk,
    CharacterType_Scion,
    CharacterType_Praetorian,
    CharacterType_Collector,
    CharacterType_Oculus,
    CharacterType_Gunship,
    CharacterType_Animal,
    CharacterType_Other,
};

enum EAffiliationType
{
    AffiliationType_None,
    AffiliationType_GenericMerc,
    AffiliationType_BloodPack,
    AffiliationType_BlueSuns,
    AffiliationType_Eclipse,
};

enum EChallengeType
{
    ChallengeType_None,
    ChallengeType_Minion,
    ChallengeType_Elite,
    ChallengeType_SubBoss,
    ChallengeType_Boss,
};

defaultproperties
{
    m_fPowerUsePercent=1
    PawnClass=class'BioPawn'
    m_bCanBeBumped=true
    m_bTerminateRagdollOnDeath=true
    m_bCanBePhysicsImpacted=true
    AIController=class'BioAiController'
    RaceType=RaceType_Humanoid
    CharacterType=CharacterType_Human
    ChallengeType=ChallengeType_Minion
    m_oAppearanceSettings=Bio_Appr_Character_Settings'oAppearanceSettings'
    m_nMinAutoLODLevel=1
    m_fPhysicsRecoverSpeedThreshold=4
    m_fPhysicsSettleDownTime=0,5
    m_fPhysicsThreshold=400
    m_fPhysicsThresholdRegenerationRate=200
    CharacterBloodColor=(B=0,G=0,R=10,A=255)
    CharacterBloodColor=(B=0,G=0,R=10,A=255)
    CharacterBloodColor=(B=5,G=2,R=2,A=255)
    CharacterBloodColor=(B=8,G=3,R=10,A=255)
    CharacterBloodColor=(B=0,G=10,R=20,A=255)
    CharacterBloodColor=(B=0,G=2,R=10,A=255)
    CharacterBloodColor=(B=1,G=7,R=5,A=255)
    CharacterBloodColor=(B=0,G=0,R=20,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=0,G=0,R=10,A=255)
    CharacterBloodColor=(B=170,G=180,R=200,A=255)
    CharacterBloodColor=(B=170,G=180,R=200,A=255)
    CharacterBloodColor=(B=170,G=180,R=200,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=0,G=0,R=0,A=255)
    CharacterBloodColor=(B=20,G=100,R=255,A=255)
    CharacterBloodColor=(B=0,G=0,R=255,A=255)
    CharacterBloodColor=(B=0,G=0,R=10,A=255)
    CharacterBloodColor=(B=0,G=0,R=255,A=255)
    m_bCombatTargetable=true
    m_nRequiredScanLevel=0
    // child object oAppearanceSettings of type Bio_Appr_Character_Settings
}
