﻿class BioPhysicsActor extends SFXKActor
    native
    placeable;

var(Combat) bool m_bToughPlaceable;

var float m_fCurrentHealth;

var(Combat) float m_fHealth;

native function ChangeMaterialParameters();

simulated function TakeRadiusDamage(Controller InstigatedBy, float BaseDamage, float DamageRadius, class<DamageType> DamageType, float Momentum, Vector HurtOrigin, bool bFullDamage, Actor DamageCauser)
{
    TakeRadiusDamage(InstigatedBy, BaseDamage, DamageRadius, DamageType, Momentum, HurtOrigin, bFullDamage, DamageCauser);
    if (m_fCurrentHealth > 0)
    {
        m_fCurrentHealth -= BaseDamage;
        ChangeMaterialParameters();
    }
}

event TakeDamage(float Damage, Controller InstigatedBy, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
{
    TakeDamage(Damage, InstigatedBy, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
    if (m_fCurrentHealth > 0)
    {
        m_fCurrentHealth -= Damage;
        ChangeMaterialParameters();
    }
}

defaultproperties
{
    m_fHealth=1000
    m_fCurrentHealth=1000
    StaticMeshComponent=None
    LightEnvironment=None
    Components=None
    // child object MyLightEnvironment of type DynamicLightEnvironmentComponent
    // child object StaticMeshComponent0 of type StaticMeshComponent
}
