﻿class BioPlaypenVolumeAdditive extends BioPlaypenVolume
    hidecategories(Navigation,Display)
    placeable;

event Touch(Actor Other, PrimitiveComponent OtherComp, Vector HitLocation, Vector HitNormal)
{
    local BioPawn Pawn;
    local BioAiController Controller;
    local int I;
    local bool bPreviouslyInPlaypen;
    local BioPlaypenVolume oPlaypen;
    bPreviouslyInPlaypen = false;
    Pawn = BioPawn(Other);
    if (Pawn != None && Pawn.Squad != None)
    {
        if (Pawn.Squad.IsVolumeInPlaypen(self))
        {
            I = 0;
            while (I < Pawn.Squad.PlaypenVolumes.Length && !bPreviouslyInPlaypen)
            {
                oPlaypen = Pawn.Squad.PlaypenVolumes[I];
                if (oPlaypen != None && oPlaypen != self)
                {
                    if (oPlaypen.Encompasses(Pawn))
                    {
                        bPreviouslyInPlaypen = true;
                    }
                }
                I++;
            }
            if (!bPreviouslyInPlaypen)
            {
                Controller = BioAiController(Pawn.Controller);
                if (Controller != None)
                {
                    Controller.OnEnteredPlaypen();
                }
            }
        }
    }
}

event UnTouch(Actor Other)
{
    local BioPawn Pawn;
    local BioAiController Controller;
    Pawn = BioPawn(Other);
    if (Pawn != None && Pawn.Squad != None)
    {
        if (Pawn.Squad.IsVolumeInPlaypen(self) && Pawn.Squad.IsPositionInPlaypen(Pawn.Location) == false)
        {
            Controller = BioAiController(Pawn.Controller);
            if (Controller != None)
            {
                Controller.OnLeftPlaypen();
            }
        }
    }
}

defaultproperties
{
    bColored=true
    BrushComponent=None
    Components=None
    // child object BrushComponent0 of type BrushComponent
}
