﻿class BioPowerManager extends Object
    native;

struct native PowerReservation
{
    var int nID;

    var float fTimeUntilExpiry;

}

var transient int m_nCurrentReservationID;

var transient array<PowerReservation> m_aReservations;

var native transient Map_Mirror m_mapGlobalCooldowns;

native function GetStartLocationForLOSCheck(Pawn Caster, out Vector vStartLocation);

native function bool CheckLOSToActor(Actor oSourceActor, Actor oDestinationActor, Vector vStartLocation, float fMaxRange, bool bIgnoreFriendlies, bool bIgnorePawns, out Actor oHitActor, out Vector vHitLocation, out Vector vHitNormal);

native function bool CheckLOSToLocation(Actor oSourceActor, Vector vStartLocation, Vector vEndLocation, float fMaxRange, bool bIgnoreFriendlies, out Actor oHitActor, out Vector vHitLocation, out Vector vHitNormal);

native function bool AreActorsFriendly(Actor oFirstActor, Actor oSecondActor);

native function ChooseTargetForPlayer(BioPower oPower, out Actor oTarget, out Vector vTargetLocation);

native function Tick(float fDeltaTime);

native function SetGlobalCooldown(Name nmPower, float fCooldown);

native function float GetGlobalCooldown(Name nmPower);

native function TickGlobalCooldowns(float fDeltaTime);

native function int MakeReservation(BioPower oPower, Pawn oPawn, optional bool bForceSuccess);

native function ClearReservation(int nReservationID);

native function bool StartReservation(int nReservationID);

native function TickReservations(float fDeltaTime);

event bool CanImpactActor(Actor oActor)
{
    if (oActor == None)
    {
        return false;
    }
    if (oActor.bWorldGeometry)
    {
        return true;
    }
    if (oActor.IsA('Pawn') || oActor.IsA('BioArtPlaceable') || oActor.IsA('KActor') || oActor.IsA('StaticMeshActor') || oActor.IsA('KAsset') || oActor.IsA('InterpActor'))
    {
        if (oActor.CollisionComponent != None && oActor.CollisionType != 1)
        {
            return true;
        }
    }
    else
    {
        if (oActor.IsA('SFXPointOfInterest'))
        {
            return true;
        }
    }
    return false;
}

defaultproperties
{
}
