﻿class BioProceduralCameraBasic extends Object
    hidecategories(Object)
    native;

struct native ActorInfo
{
    var Vector myPosition;

    var Rotator myRotation;

    var Vector headBaseBonePosition;

    var Vector headBonePosition;

    var Vector vCameraFocusPoint;

    var Vector vProceduralCameraPosition;

    var Rotator rProceduralCameraRotation;

}

struct native CameraInfo
{
    var Vector vPosition;

    var Rotator rRotation;

    var float fFov;

    var float fNearPlane;

}

static function FixedCamera(ActorInfo stActorInfo, out CameraInfo stCameraInfo, bool bInvert)
{
    local Rotator rTmpRotator;
    local Vector vTmpVector;
    vTmpVector.X = -1 * stCameraInfo.vPosition.Y;
    vTmpVector.Y = -1 * stCameraInfo.vPosition.X;
    vTmpVector.Z = stCameraInfo.vPosition.Z;
    stActorInfo.vProceduralCameraPosition = vTmpVector;
    vTmpVector.X = -1 * stActorInfo.vCameraFocusPoint.Y;
    vTmpVector.Y = -1 * stActorInfo.vCameraFocusPoint.X;
    vTmpVector.Z = stActorInfo.vCameraFocusPoint.Z;
    stActorInfo.vCameraFocusPoint = vTmpVector;
    stCameraInfo.rRotation.Pitch = stCameraInfo.rRotation.Pitch - 90 * 182,0444;
    stCameraInfo.rRotation.Yaw = -1 * stCameraInfo.rRotation.Yaw;
    if (stActorInfo.vProceduralCameraPosition != vect(0,0,0))
    {
        stCameraInfo.vPosition = stActorInfo.vProceduralCameraPosition;
        if (bInvert)
        {
            stCameraInfo.vPosition.Y = -1 * stCameraInfo.vPosition.Y;
            stCameraInfo.rRotation.Yaw = -1 * stCameraInfo.rRotation.Yaw;
        }
        stCameraInfo.vPosition.Z = 0;
        rTmpRotator = stCameraInfo.vPosition;
        rTmpRotator = rTmpRotator + stActorInfo.myRotation;
        rTmpRotator.Roll = 0;
        rTmpRotator.Pitch = 0;
        stCameraInfo.vPosition = Normal(rTmpRotator) * VSize(stCameraInfo.vPosition);
        stCameraInfo.vPosition.Z = stActorInfo.vProceduralCameraPosition.Z;
        stCameraInfo.vPosition = stCameraInfo.vPosition + stActorInfo.myPosition;
        stCameraInfo.rRotation.Yaw = stCameraInfo.rRotation.Yaw + stActorInfo.myRotation.Yaw + 180 * 182,0444;
    }
    else
    {
        stCameraInfo.vPosition = stActorInfo.headBaseBonePosition;
        stCameraInfo.rRotation = stActorInfo.myRotation;
        if (stCameraInfo.vPosition == vect(0,0,0))
        {
            stCameraInfo.vPosition = stActorInfo.headBonePosition;
        }
        stCameraInfo.vPosition = stCameraInfo.vPosition + Normal(stCameraInfo.rRotation) * 100;
        stCameraInfo.rRotation = rot(0,0,0);
        stCameraInfo.rRotation.Yaw = stActorInfo.myRotation.Yaw + 180 * 182,0444;
    }
}

defaultproperties
{
}
