﻿class BioSFHandler_ChoiceGUI extends BioSFHandler
    config(UI)
    transient
    native;

enum EChoiceGUIHandlerID
{
    CHOICEHANDLER_NONE,
    CHOICEHANDLER_SELECTED,
    CHOICEHANDLER_EXIT,
    CHOICEHANDLER_UPDATE_IMAGE,
    CHOICEHANDLER_SHOW_CREDITS,
};

var transient bool m_bStopScroll;

var config int m_nInfoScrollSpeed;

var config String m_sResourceCostColorHTML_CantAfford;

var config String m_sResourceCostColorHTML_CanAfford;

// m_srResourceAvailFormat: StringRefProperty[44]
// m_srResourceCostFormat: StringRefProperty[44]
// m_srResourceTextProbes: StringRefProperty[44]
// m_srResourceTextPlatinum: StringRefProperty[44]
// m_srResourceTextPalladium: StringRefProperty[44]
// m_srResourceTextIridium: StringRefProperty[44]
// m_srResourceTextEzo: StringRefProperty[44]
// m_srResourceTextCredits: StringRefProperty[44]
var int nInputCallbackContext;

var SFXGameChoiceGUIData m_ChoiceData;

delegate InputCallback(bool bAPressed, int nContext);

delegate UpdateCallback(float fDeltaT, BioSFHandler_ChoiceGUI oChoiceGUI);

delegate UpdateCallbackEx(float fDeltaT, Object oChoiceGUI);

native final function SetInputDelegate(delegate<InputCallback> pDelegate, optional int nContext);

native final function SetUpdateDelegate(delegate<UpdateCallback> pDelegate);

native function ShowChoiceGUI();

native final function HideChoiceGUI(optional bool bRemove);

native final function Initialize(SFXGameChoiceGUIData ChoiceData);

native function String GetResourceText(EInventoryResourceTypes eResource);

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 5:
            ScrollText(-fValue);
            break;
        default:
            HandleInputEvent(Event, fValue);
            return;
    }
}

function ScrollText(float fValue)
{
    local array<ASParams> lstParams;
    local ASParams aParam;
    if (Abs(fValue) <= 0,0001)
    {
        if (m_bStopScroll == true)
        {
            oPanel.InvokeMethod("ChoiceGuiInstance.StopInfoScroll");
            m_bStopScroll = false;
        }
        return;
    }
    aParam.Type = 1;
    aParam.fVar = fValue * m_nInfoScrollSpeed;
    lstParams.AddItem(aParam);
    oPanel.InvokeMethodArgs("ChoiceGuiInstance.ScrollInfoText", lstParams);
    m_bStopScroll = true;
}

event OnPanelAdded()
{
    OnPanelAdded();
    oPanel.SetExternalInterface(self);
    if (oPanel.nmTag == 'MissionCompletion')
    {
        PlayGuiSound('MissionCompletionEnter');
    }
    else
    {
        PlayGuiSound('ConsoleEnter');
    }
}

event OnPanelRemoved()
{
    if (oPanel.nmTag == 'MissionCompletion')
    {
        PlayGuiSound('MissionCompletionExit');
    }
    else
    {
        PlayGuiSound('ConsoleExit');
    }
    CleanUpDelegateReferences();
    OnPanelRemoved();
}

event onExIntUpdateOptionValues(int nResource)
{
    local array<ASParams> lstParams;
    local int nResourceCount;
    local EInventoryResourceTypes eResource;
    if (nResource == -1)
    {
        nResource = m_ChoiceData.m_eOptionalPaneResourceType;
    }
    eResource = nResource;
    nResourceCount = GetResourceCount(nResource);
    lstParams.Length = 1;
    lstParams[0].Type = 2;
    ClearCustomTokens();
    SetCustomToken(0, GetResourceText(eResource));
    SetCustomToken(1, nResourceCount);
    lstParams[0].sVar = Class'SFXGame'.GetSimpleString(m_srResourceAvailFormat, true);
    ClearCustomTokens();
    oPanel.InvokeMethodArgs("ChoiceGuiInstance.UpdateInventoryValues", lstParams);
}

event int GetResourceCount(int nResource)
{
    local BioPlayerController PC;
    local BioPawn pPawn;
    local EInventoryResourceTypes eResource;
    local int nValue;
    nValue = 0;
    if (nResource == -1)
    {
        nResource = m_ChoiceData.m_eOptionalPaneResourceType;
    }
    eResource = nResource;
    if (oWorldInfo != None)
    {
        PC = BioWorldInfo(oWorldInfo).GetLocalPlayerController();
        pPawn = BioPawn(PC.Pawn);
        nValue = SFXInventoryManager(pPawn.InvManager).GetResource(eResource);
    }
    return nValue;
}

function GameSessionEnded()
{
    CleanUpDelegateReferences();
    GameSessionEnded();
}

native function CleanUpDelegateReferences();

defaultproperties
{
    m_srResourceTextCredits=System.Byte[]
    m_srResourceTextEzo=System.Byte[]
    m_srResourceTextIridium=System.Byte[]
    m_srResourceTextPalladium=System.Byte[]
    m_srResourceTextPlatinum=System.Byte[]
    m_srResourceCostFormat=System.Byte[]
    m_srResourceAvailFormat=System.Byte[]
    m_sResourceCostColorHTML_CanAfford="<font color='#00FF00'>"
    m_sResourceCostColorHTML_CantAfford="<font color='#FF0000'>"
    m_nInfoScrollSpeed=20
    nHandlerID=38
    bSetGameMode=false
}
