﻿class BioSFHandler_Credits extends BioSFHandler
    config(Credits)
    transient
    native;

const InitializeCredits = 1;
const GetNextCredit = 2;
const CreditScrollComplete = 3;
const CreditsCancel = 4;
struct native BioCreditsDetails
{
// srHeading: StringRefProperty[44]
// srTitle: StringRefProperty[44]
// srNames: StringRefProperty[44]
}

var bool bFromKismet;

var bool bFromPRCChoiceGUI;

var bool bFromAdditionalContent;

var bool bFromMainMenu;

var int nCreditIndex;

var config array<BioCreditsDetails> lstDLCScrollingCredits;

var config array<BioCreditsDetails> lstScrollingCredits;

var config array<BioCreditsDetails> lstFlashingCredits;

// srExitNo: StringRefProperty[44]
// srExitYes: StringRefProperty[44]
// srConfirmExitMessage: StringRefProperty[44]
var config float fScrollTime;

var config float fHoldTime;

var config float fFadeTime;

function OnPanelAdded()
{
    OnPanelAdded();
    Class'WwiseAudioComponent'.SetGlobalRTPCFromScript("FX_Volume", 0);
}

function OnPanelRemoved()
{
    local float fFXVolume;
    local BioWorldInfo WorldInfo;
    local BioPlayerController PC;
    local SFXProfileSettings Profile;
    fFXVolume = 100;
    WorldInfo = BioWorldInfo(oWorldInfo);
    if (WorldInfo != None)
    {
        PC = WorldInfo.GetLocalPlayerController();
        if (PC != None)
        {
            Profile = PC.ProfileSettings;
            if (Profile != None)
            {
                fFXVolume = Profile.GetFXVolume();
            }
        }
    }
    Class'WwiseAudioComponent'.SetGlobalRTPCFromScript("FX_Volume", fFXVolume * 0,01);
    OnPanelRemoved();
}

delegate OnCloseCallback();

function SetOnCloseCallback(delegate<OnCloseCallback> fn_OnCloseDelegate)
{
    __OnCloseCallback__Delegate = fn_OnCloseDelegate;
}

native function bool SetDataFromIniFile(String a_sSection);

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    switch (nCommand)
    {
        case 2:
            nCreditIndex++;
            if (nCreditIndex < lstFlashingCredits.Length)
            {
                SendFlashingCredit();
            }
            else
            {
                PopulateScrollingCredits();
            }
            break;
        case 1:
            SetupCreditDetails();
            StopGuiMusic();
            PlayGuiMusic('Credits');
            if (lstFlashingCredits.Length == 0)
            {
                PopulateScrollingCredits();
            }
            else
            {
                nCreditIndex = 0;
                SendFlashingCredit();
            }
            break;
        case 4:
            OnCancel();
            break;
        case 3:
            EndCredits();
            break;
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 13:
            OnCancel();
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function Pause(bool B);

function OnCancel()
{
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    Pause(true);
    oMsgBox = MassEffectGuiManager(oPanel.oParentManager).CreateMessageBox();
    oMsgBox.SetInputDelegate(ConfirmButtonPressed);
    stParams.srAText = srExitYes;
    stParams.srBText = srExitNo;
    oMsgBox.DisplayMessageBox(srConfirmExitMessage, stParams);
}

function ConfirmButtonPressed(bool bAPressed, int nContext)
{
    Pause(false);
    if (bAPressed)
    {
        EndCredits();
    }
}

function EndCredits()
{
    local BioSFPanel oNewPanel;
    StopGuiMusic();
    if (__OnCloseCallback__Delegate != None)
    {
        OnCloseCallback();
    }
    __OnCloseCallback__Delegate = None;
    if (bFromMainMenu)
    {
        MassEffectGuiManager(oPanel.oParentManager).ShowMainMenu(10);
    }
    else
    {
        if (bFromAdditionalContent)
        {
            oNewPanel = oPanel.oParentManager.CreatePanel('AdditionalContent', true);
            oNewPanel.bFullScreen = true;
            oPanel.oParentManager.RemovePanel(oPanel, true);
        }
        else
        {
            if (bFromPRCChoiceGUI)
            {
                oPanel.oParentManager.RemovePanel(oPanel, true);
            }
            else
            {
                oWorldInfo.bPlayersOnly = false;
            }
        }
    }
    if (!bFromKismet)
    {
        oPanel.oParentManager.RemovePanel(oPanel);
    }
}

final function SetupCreditDetails()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 1;
    stParam.fVar = fFadeTime;
    lstParams.AddItem(stParam);
    stParam.fVar = fHoldTime;
    lstParams.AddItem(stParam);
    stParam.fVar = fScrollTime;
    lstParams.AddItem(stParam);
    stParam.Type = 0;
    stParam.nVar = ScreenLayout;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("credits.setCreditParameters", lstParams);
}

final function SendFlashingCredit()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 2;
    stParam.sVar = lstFlashingCredits[nCreditIndex].srTitle;
    lstParams.AddItem(stParam);
    stParam.sVar = lstFlashingCredits[nCreditIndex].srNames;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("credits.setFlashingCredit", lstParams);
}

final function PopulateScrollingCredits()
{
    local int I;
    local ASParams stParam;
    local array<ASParams> lstParams;
    oPanel.InvokeMethod("credits.initScrollingCredits");
    stParam.Type = 2;
    lstParams.AddItem(stParam);
    lstParams.AddItem(stParam);
    lstParams.AddItem(stParam);
    lstParams.AddItem(stParam);
    I = 0;
    while (I < lstScrollingCredits.Length)
    {
        lstParams[0].sVar = lstScrollingCredits[I].srTitle;
        lstParams[1].sVar = lstScrollingCredits[I].srNames;
        if (lstScrollingCredits[I].srHeading == 0)
        {
            lstParams[2].Type = 4;
        }
        else
        {
            lstParams[2].Type = 2;
            lstParams[2].sVar = lstScrollingCredits[I].srHeading;
        }
        lstParams[3].Type = 3;
        lstParams[3].bVar = true;
        oPanel.InvokeMethodArgs("credits.addScrollingCreditSection", lstParams);
        I++;
    }
    I = 0;
    while (I < lstDLCScrollingCredits.Length)
    {
        lstParams[0].sVar = lstDLCScrollingCredits[I].srTitle;
        lstParams[1].sVar = lstDLCScrollingCredits[I].srNames;
        if (lstDLCScrollingCredits[I].srHeading == 0)
        {
            lstParams[2].Type = 4;
        }
        else
        {
            lstParams[2].Type = 2;
            lstParams[2].sVar = lstDLCScrollingCredits[I].srHeading;
        }
        lstParams[3].Type = 3;
        lstParams[3].bVar = false;
        oPanel.InvokeMethodArgs("credits.addScrollingCreditSection", lstParams);
        I++;
    }
    oPanel.InvokeMethod("credits.startScrollingCredits");
}

function SetFromMainMenu()
{
    bFromMainMenu = true;
}

event SetFromAdditionalContent()
{
    bFromAdditionalContent = true;
}

event SetFromPRCChoiceGUI()
{
    bFromPRCChoiceGUI = true;
}

defaultproperties
{
    fFadeTime=2,397
    fScrollTime=252,401
    srConfirmExitMessage=System.Byte[]
    srExitYes=System.Byte[]
    srExitNo=System.Byte[]
    lstFlashingCredits=System.Byte[]
    lstScrollingCredits=System.Byte[]
    nHandlerID=27
}
