﻿class BioSFHandler_GalaxyMap extends BioSFHandler
    config(UI)
    transient
    native;

const Close = 1;
const Initialize = 2;
const Select = 3;
const back = 4;
const Scan = 5;
const ClosePlanet = 6;
const CloseScan = 7;
const EnableMouseMovement = 8;
const DisableMouseMovement = 9;
var Bio2DA m_pGalaxyMapImages2DA;

var transient bool m_bWaitingForMsgBox;

var transient bool m_bClosingScan;

var transient bool m_bClosingPlanet;

var transient float m_fLeftStickY;

var transient float m_fLeftStickX;

var float m_fScrollValue;

native final function TravelConfirm(bool bAPressed, int nContext);

function UpdateScanResources(array<float> Resources)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local float Resource;
    foreach Resources(Resource)
    {
        stParam.Type = 1;
        stParam.fVar = Resource;
        lstParams.AddItem(stParam);
    }
    oPanel.InvokeMethodArgs("updateScanResources", lstParams);
}

function UpdateInventoryDisplay(int nResourceIndex, int nAmount)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 0;
    stParam.nVar = nResourceIndex;
    lstParams.AddItem(stParam);
    stParam.Type = 0;
    stParam.nVar = nAmount;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("updateInventoryDisplay", lstParams);
}

native function CloseGalaxyMap();

function HandleInputEvent(BioGuiEvents nEvent, optional float fValue = 1)
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeOrbital OrbitalGame;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (Manager != None)
    {
        OrbitalGame = SFXGameModeOrbital(Manager.HACK_GetOrbitalMode());
    }
    switch (nEvent)
    {
        case 2:
            if (OrbitalGame != None)
            {
                OrbitalGame.RingReticleLeftRight(fValue);
            }
            m_fLeftStickX = fValue;
            break;
        case 3:
            if (OrbitalGame != None)
            {
                OrbitalGame.RingReticleUpDown(fValue);
            }
            m_fLeftStickY = fValue;
            break;
        case 4:
            if (OrbitalGame != None)
            {
                OrbitalGame.PlanetLeftRight(fValue);
            }
            break;
        case 5:
            m_fScrollValue = fValue;
            break;
        default:
            HandleInputEvent(nEvent, fValue);
    }
}

event BuyFuel();

event BuyProbes();

defaultproperties
{
    m_pGalaxyMapImages2DA=Bio2DA'Default2DA'
    nHandlerID=7
}
