﻿class BioSFHandler_GameOver extends BioSFHandler
    config(UI)
    transient
    native;

const InitializeGameOver = 1;
const LoadLastSave = 3;
const QuitToMainMenu = 4;
const ShowLoadScreen = 5;
// AcceptBadResumeGameText: StringRefProperty[44]
// BadResumeGameText: StringRefProperty[44]
// GameOverStringOverride: StringRefProperty[44]
// GameOverString: StringRefProperty[44]
function Callback_GotoMainMenu(bool bAPressed, int Context)
{
    GotoMainMenu();
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local MassEffectGuiManager GuiMan;
    local SFXEngine Engine;
    local PlayerController PC;
    local SFXSFHandler_Load Handler;
    local BioSFPanel NewPanel;
    local BioSFHandler_MessageBox MessageBox;
    local BioMessageBoxOptionalParams Params;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None && GuiMan.Player != None)
    {
        PC = GuiMan.GetPlayerController();
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
        }
    }
    switch (nCommand)
    {
        case 1:
            stParam.Type = 0;
            stParam.nVar = ScreenLayout;
            lstParams.AddItem(stParam);
            if (GameOverStringOverride != 0)
            {
                stParam.Type = 2;
                stParam.sVar = Class'SFXGame'.GetSimpleString(GameOverStringOverride);
                lstParams.AddItem(stParam);
            }
            else
            {
                stParam.Type = 2;
                stParam.sVar = Class'SFXGame'.GetSimpleString(GameOverString);
                lstParams.AddItem(stParam);
            }
            oPanel.InvokeMethodArgs("Initialize", lstParams);
            break;
        case 3:
            if (Engine != None && Engine.CurrentSaveGame != None && Engine.CurrentSaveGame.bIsValid)
            {
                Engine.PendingSaveGameAction = 4;
                PlayGuiSound('GameOverResume');
                GuiMan.HideGameOverGui();
            }
            else
            {
                MessageBox = GuiMan.CreateMessageBox();
                MessageBox.SetInputDelegate(Callback_GotoMainMenu);
                Params.srAText = AcceptBadResumeGameText;
                Params.bNoFade = true;
                Params.bModal = true;
                MessageBox.DisplayMessageBox(BadResumeGameText, Params);
            }
            break;
        case 4:
            PlayGuiSound('GameOverMainMenu');
            oPanel.oParentManager.ClearAll();
            GotoMainMenu();
            break;
        case 5:
            PlayGuiSound('GameOverLoadScreen');
            oPanel.oParentManager.ClearAll();
            GuiMan.SetupBackground();
            NewPanel = oPanel.oParentManager.CreatePanel('Load', true);
            NewPanel.bFullScreen = true;
            Handler = SFXSFHandler_Load(NewPanel.GetDefaultHandler());
            Handler.GuiMode = 2;
            GuiMan.RemovePanel(oPanel, true);
            break;
    }
}

function OnPanelAdded()
{
    oPanel.bUseThumbstickAsDPad = false;
}

native function GotoMainMenu();

defaultproperties
{
    GameOverString=System.Byte[]
    BadResumeGameText=System.Byte[]
    AcceptBadResumeGameText=System.Byte[]
    nHandlerID=22
}
