﻿class BioSFHandler_MainMenu extends BioSFHandler
    config(UI)
    transient
    native;

const StartNewGame = 1;
const ShowHonors = 2;
const ShowCredits = 3;
const InitializeMainMenu = 4;
const ResumeGame = 5;
const ShowLoadGui = 6;
const ShowLiveContent = 8;
const ShowOptions = 9;
const ExitGame = 10;
const ShowLoadGuiForImport = 13;
const CerberusStateExecuteAction = 14;
const StartNewGameFemale = 15;
const CerberusDLCAvailable = 16;
const OpenMarketPlace = 17;
const ShowLoadGuiForME2Import = 18;
// ConfirmImportME1: StringRefProperty[44]
// srCancel: StringRefProperty[44]
// srConfirm: StringRefProperty[44]
// srExitConfirm: StringRefProperty[44]
// srPRCStore_BBtn: StringRefProperty[44]
// srPRCStore_ABtn: StringRefProperty[44]
// srPRCStore_Subtitle: StringRefProperty[44]
// srPRCStore_Title: StringRefProperty[44]
// srPRCStore_PurchasedNo: StringRefProperty[44]
// srPRCStore_PurchasedYes: StringRefProperty[44]
// srPRCStore_DescFormat: StringRefProperty[44]
// srCerb_ConnectedToCerb: StringRefProperty[44]
// srCerb_ConnectingToCerb: StringRefProperty[44]
// srCerb_ConnectTo: StringRefProperty[44]
// srCerb_ActivateCerb: StringRefProperty[44]
// AVAIL_CERB_DLC_Title: StringRefProperty[44]
// UPCOMING_CERB_DLC_Title: StringRefProperty[44]
// AVAIL_DLC_Title: StringRefProperty[44]
// UPCOMING_DLC_Title: StringRefProperty[44]
// MOTD_Title: StringRefProperty[44]
// Calander_Title: StringRefProperty[44]
// ConfirmNetworkLoss: StringRefProperty[44]
// LostNetworkConnection: StringRefProperty[44]
// CancelNoLoginStart: StringRefProperty[44]
// ConfirmNoLoginStart: StringRefProperty[44]
// NoLoginStart: StringRefProperty[44]
var transient SFXSFHandler_PRCShop m_PCRStore;

var transient SFXOnlineConnectionState m_CerbConnectState;

var transient bool m_bIsConnecting;

var transient SFXOnlineComponentUI m_BlazeUI;

var() byte PendingCommand;

var Cerberus3DState nCurrent3DState;

var MainMenuEntries nSelectedEntry;

var config bool bUseCerberusBackGroundForSubScreens;

var config bool bDisplayForNewContentOnly;

var config float fPCRMessageDispTime;

// srPRCAvailableMessage: StringRefProperty[44]
function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    local BioSFHandler_Options oOptions;
    local BioSFHandler_Credits oCredits;
    local BioSFHandler_Achievement oAchievement;
    local BioSFPanel oNewPanel;
    local SFXEngine Engine;
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    local MassEffectGuiManager oManager;
    Engine = SFXEngine(GetPlayerController().Player.Outer);
    PendingCommand = nCommand;
    switch (nCommand)
    {
        case 1:
            if (CheckLogin())
            {
                BioWorldInfo(oWorldInfo).CurrentGame.bNewPlayer = false;
                BioWorldInfo(oWorldInfo).RequestStartNewGame();
            }
            break;
        case 15:
            if (CheckLogin())
            {
                BioWorldInfo(oWorldInfo).CurrentGame.bNewPlayer = false;
                BioWorldInfo(oWorldInfo).RequestStartNewGame(true);
            }
            break;
        case 2:
            oNewPanel = oPanel.oParentManager.CreatePanel('Achievement', true);
            oNewPanel.bFullScreen = !bUseCerberusBackGroundForSubScreens;
            oAchievement = BioSFHandler_Achievement(oNewPanel.GetDefaultHandler());
            oAchievement.SetFromMainMenu();
            SetEnabledAndVisible(false);
            break;
        case 5:
            if (Engine != None)
            {
                Engine.PendingSaveGameAction = 4;
            }
            break;
        case 13:
            if (oWorldInfo.IsConsoleBuild(1))
            {
                stParams.srAText = srConfirm;
                stParams.srBText = srCancel;
                MassEffectGuiManager(oPanel.oParentManager).QueueNamedMessageBox('ImportME1Prompt', 3, ConfirmImportME1, stParams, Callback_ImportME1Prompt);
            }
            else
            {
                BioWorldInfo(oWorldInfo).CurrentGame.ImportedDataManager.m_bImportAllowed = true;
                MoveToLoadGui(1);
            }
            break;
        case 18:
            MoveToLoadGui(2);
            break;
        case 6:
            MoveToLoadGui(0);
            break;
        case 9:
            oNewPanel = oPanel.oParentManager.CreatePanel('Options', true);
            oNewPanel.bFullScreen = !bUseCerberusBackGroundForSubScreens;
            oOptions = BioSFHandler_Options(oNewPanel.GetDefaultHandler());
            oOptions.GuiMode = 1;
            SetEnabledAndVisible(false);
            break;
        case 8:
            Buy(1);
            break;
        case 4:
            BioWorldInfo(oWorldInfo).CurrentGame.ImportedDataManager.ClearCurrentData();
            if (Engine != None)
            {
                Engine.ME2ImportSaveGame = None;
            }
            BioWorldInfo(oWorldInfo).CurrentGame.ImportedDataManager.m_bImportedData = false;
            BioWorldInfo(oWorldInfo).CurrentGame.ImportedDataManager.m_bImportAllowed = false;
            SetupMainMenu();
            break;
        case 3:
            oNewPanel = oPanel.oParentManager.CreatePanel('Credits', true);
            oNewPanel.bFullScreen = !bUseCerberusBackGroundForSubScreens;
            oCredits = BioSFHandler_Credits(oNewPanel.GetDefaultHandler());
            oCredits.SetFromMainMenu();
            SetEnabledAndVisible(false);
            break;
        case 14:
            if (!m_bIsConnecting)
            {
                CerberusConnect(2);
            }
            break;
        case 16:
            OnExecuteCerberusDLCAvailable();
            break;
        case 17:
            OnExecuteOpenMarketPlace();
            break;
        case 10:
            oManager = MassEffectGuiManager(oPanel.oParentManager);
            oMsgBox = oManager.CreateMessageBox();
            oMsgBox.SetInputDelegate(ExitConfirm);
            stParams.srAText = srConfirm;
            stParams.srBText = srCancel;
            oMsgBox.DisplayMessageBox(srExitConfirm, stParams);
            break;
    }
}

function ExitConfirm(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        oWorldInfo.ConsoleCommand("Exit");
    }
}

function Callback_NoLoginStart(bool bAPressed, int Context)
{
    local PlayerController PC;
    local SFXEngine Engine;
    local array<String> Empty;
    if (bAPressed)
    {
        PC = GetPlayerController();
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
            if (Engine != None)
            {
                Engine.bCanWriteSaveToStorage = false;
                HandleEvent(PendingCommand, Empty);
            }
        }
    }
}

function Callback_ImportME1Prompt(bool bAPressed, int Context)
{
    local PlayerController PC;
    local SFXEngine Engine;
    if (bAPressed)
    {
        PC = GetPlayerController();
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
            if (Engine != None)
            {
                Engine.LaunchUnreaperWithDiscCheck();
            }
        }
    }
}

function bool IsReadyForLegacyImport()
{
    local PlayerController PC;
    local int ControllerId;
    local OnlineSubsystem OnlineSub;
    if (Class'WorldInfo'.IsConsoleBuild() == false)
    {
        return true;
    }
    PC = GetPlayerController();
    if (PC != None)
    {
        ControllerId = LocalPlayer(PC.Player).ControllerId;
        OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
        if (OnlineSub != None)
        {
            PlayerInt = OnlineSub.PlayerInterface;
            if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)) && NotEqual_InterfaceInterface(OnlineSub.SystemInterface, OnlineSystemInterface(None)) && PlayerInt.GetLoginStatus(ControllerId) != 0)
            {
                return true;
            }
        }
    }
    return false;
}

function bool CheckLogin()
{
    local PlayerController PC;
    local int ControllerId;
    local OnlineSubsystem OnlineSub;
    local SFXEngine Engine;
    local BioSFHandler_MessageBox MessageBox;
    local BioMessageBoxOptionalParams Params;
    if (Class'WorldInfo'.IsConsoleBuild() == false)
    {
        return true;
    }
    PC = GetPlayerController();
    if (PC != None)
    {
        Engine = SFXEngine(PC.Player.Outer);
        if (Engine != None && Engine.bCanWriteSaveToStorage == false)
        {
            return true;
        }
        ControllerId = LocalPlayer(PC.Player).ControllerId;
        OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
        if (OnlineSub != None)
        {
            PlayerInt = OnlineSub.PlayerInterface;
            if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)) && NotEqual_InterfaceInterface(OnlineSub.SystemInterface, OnlineSystemInterface(None)))
            {
                if (PlayerInt.GetLoginStatus(ControllerId) == 0)
                {
                    MessageBox = MassEffectGuiManager(oPanel.oParentManager).CreateMessageBox();
                    MessageBox.SetInputDelegate(Callback_NoLoginStart);
                    Params.srAText = ConfirmNoLoginStart;
                    Params.srBText = CancelNoLoginStart;
                    Params.bNoFade = true;
                    MessageBox.DisplayMessageBox(NoLoginStart, Params);
                    return false;
                }
            }
        }
    }
    return true;
}

function MoveToLoadGui(ELoadGuiMode LoadMode)
{
    local SFXSFHandler_Load oLGHandler;
    local BioSFPanel oNewPanel;
    oNewPanel = oPanel.oParentManager.CreatePanel('Load', true);
    oNewPanel.bFullScreen = !bUseCerberusBackGroundForSubScreens;
    oLGHandler = SFXSFHandler_Load(oNewPanel.GetDefaultHandler());
    oLGHandler.bFromMainMenu = true;
    oLGHandler.GuiMode = 1;
    oLGHandler.LoadMode = LoadMode;
    SetEnabledAndVisible(false);
}

function SetEnabledAndVisible(bool bVal)
{
    oPanel.SetInputDisabled(!bVal);
    oPanel.IsVisible = bVal;
}

function OnPanelAdded()
{
    local OnlineSubsystem OnlineSub;
    OnPanelAdded();
    oPanel.SetExternalInterface(self);
    PlayGuiMusic('MainMenu');
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSub != None)
    {
        SystemInterface = OnlineSub.SystemInterface;
        if (NotEqual_InterfaceInterface(SystemInterface, OnlineSystemInterface(None)))
        {
            SystemInterface.AddLinkStatusChangeDelegate(NotifyLinkStatusChange);
        }
    }
}

function OnPanelRemoved()
{
    local OnlineSubsystem OnlineSub;
    if (m_BlazeUI != None)
    {
        m_BlazeUI.ClearDelegates();
        m_BlazeUI.ClearGui();
        m_BlazeUI = None;
    }
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSub != None)
    {
        SystemInterface = OnlineSub.SystemInterface;
        if (NotEqual_InterfaceInterface(SystemInterface, OnlineSystemInterface(None)))
        {
            SystemInterface.ClearLinkStatusChangeDelegate(NotifyLinkStatusChange);
        }
    }
}

function NotifyLinkStatusChange(bool bIsConnected);

function SetupMainMenu()
{
    local SFXEngine Engine;
    local BioPlayerController PC;
    local LocalPlayer LP;
    local ASParams stParam;
    local array<ASParams> lstParams;
    PC = BioPlayerController(GetPlayerController());
    LP = LocalPlayer(PC.Player);
    Engine = SFXEngine(LP.Outer);
    stParam.Type = 3;
    if (Engine != None && Engine.SavesExistInCurrentCareer())
    {
        stParam.bVar = true;
    }
    else
    {
        stParam.bVar = false;
    }
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    if (Engine != None && Engine.SavesExist())
    {
        stParam.bVar = true;
    }
    else
    {
        stParam.bVar = false;
    }
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    if (Engine != None && Engine.NGSavesExist())
    {
        stParam.bVar = true;
    }
    else
    {
        stParam.bVar = false;
    }
    lstParams.AddItem(stParam);
    stParam.Type = 0;
    stParam.nVar = nSelectedEntry;
    lstParams.AddItem(stParam);
    stParam.Type = 0;
    stParam.nVar = ScreenLayout;
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    stParam.bVar = IsReadyForLegacyImport();
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("InitializeMainMenu", lstParams);
    InitCerberus();
}

function InitCerberus()
{
    local SFXGame oGame;
    local SFXOnlineSubsystem oOnline;
    local BioWorldInfo oBioWorldInfo;
    oBioWorldInfo = BioWorldInfo(oWorldInfo);
    if (m_BlazeUI == None)
    {
        if (oBioWorldInfo != None)
        {
            oGame = SFXGame(oBioWorldInfo.Game);
            if (oGame != None)
            {
                oOnline = oGame.SFXOnlineSubsystem;
                if (oOnline != None)
                {
                    m_BlazeUI = oOnline.GetComponentUserInterface();
                }
            }
        }
        CerberusConnect(1);
    }
}

function NextCerberusItem()
{
    if (oPanel != None && nCurrent3DState == 1)
    {
        oPanel.InvokeMethod("NextCerberusItem");
    }
}

function PrevCerberusItem()
{
    if (oPanel != None && nCurrent3DState == 1)
    {
        oPanel.InvokeMethod("PrevCerberusItem");
    }
}

function AddCerberusItem(String i_sTitle, String i_sInfo, String i_sImage)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 2;
    stParam.sVar = i_sTitle;
    lstParams.AddItem(stParam);
    stParam.Type = 2;
    stParam.sVar = i_sInfo;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("AddCerberusItem", lstParams);
}

function ClearNotifications()
{
    oPanel.InvokeMethod("ClearCerberusData");
}

function CloseEANetworking()
{
    local MassEffectGuiManager oManager;
    if (oPanel != None)
    {
        oManager = MassEffectGuiManager(oPanel.oParentManager);
        if (oManager != None && m_BlazeUI != None)
        {
            m_BlazeUI.ClearGui();
            oManager.DestroyNetworkGUI(m_BlazeUI.HandlerId);
        }
    }
}

function OnDisplayNotification(SFXOnlineConnection_MessageType Type, String MessageData, String Title, String Image)
{
    switch (Type)
    {
        case 1:
            Class'BioTelemetry'.SendEventString('CATALOGUE_NOTIFICATION', MessageData);
            SetMarqueeRepeatText(MessageData);
            return;
        default:
            AddCerberusItem(Title, MessageData, Image);
            return;
            return;
    }
}

function SetMarqueeRepeatText(String MessageData)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 2;
    stParam.sVar = MessageData;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("SetRepeatingText", lstParams);
}

function SetOnlineState(SFXOnlineConnectionState eState)
{
    local bool bHasAction;
    local bool bIsVisible;
    local bool bAltView;
    local String sMessage;
    if (m_CerbConnectState == eState)
    {
        return;
    }
    bHasAction = false;
    bIsVisible = true;
    bAltView = 1 == nCurrent3DState;
    m_CerbConnectState = eState;
    switch (m_CerbConnectState)
    {
        case 4:
            m_bIsConnecting = false;
            bHasAction = true;
            sMessage = srCerb_ConnectTo;
            break;
        case 5:
            m_bIsConnecting = false;
            bIsVisible = false;
            sMessage = srCerb_ConnectedToCerb;
            bHasAction = false;
            if (nCurrent3DState != 1 && nCurrent3DState != 3)
            {
                BioWorldInfo(oWorldInfo).GetLocalPlayerController().CauseEvent('OpenRightComputer');
                nCurrent3DState = 3;
            }
            else
            {
                bIsVisible = true;
            }
            break;
        case 2:
            bHasAction = true;
            m_bIsConnecting = false;
            sMessage = srCerb_ActivateCerb;
            break;
        case 1:
        case 3:
            m_bIsConnecting = true;
            sMessage = srCerb_ConnectingToCerb;
            break;
        case 0:
        default:
            bHasAction = true;
            m_bIsConnecting = false;
            sMessage = srCerb_ConnectTo;
            break;
    }
    SetCerberusConnectState(bHasAction, sMessage, bAltView, bIsVisible);
}

function CerberusConnect(SFXOnlineConnectMode connectMode)
{
    local SFXSFHandler_EANetworking oHandler;
    local MassEffectGuiManager oManager;
    if (m_BlazeUI != None)
    {
        if (m_BlazeUI.m_oGUI == None)
        {
            if (oPanel != None)
            {
                oManager = MassEffectGuiManager(oPanel.oParentManager);
                if (oManager != None)
                {
                    oHandler = oManager.CreateNetworkGUI(m_BlazeUI.HandlerId);
                    m_BlazeUI.SetGui(oHandler);
                    m_BlazeUI.__ExternalCallback_OnDisplayNotification__Delegate = OnDisplayNotification;
                    m_BlazeUI.__ExternalCallback_ClearNotifications__Delegate = ClearNotifications;
                    m_BlazeUI.__ExternalCallback_SetState__Delegate = SetOnlineState;
                    m_BlazeUI.__ExternalCallback_CloseEANetworking__Delegate = CloseEANetworking;
                    m_BlazeUI.__ExternalCallback_HasCerberusDLC__Delegate = HasCerberusDLC;
                    m_BlazeUI.__ExternalCallback_ShowStore__Delegate = OpenMarketplaceGui;
                }
            }
        }
        if (m_BlazeUI.m_oGUI != None)
        {
            m_BlazeUI.Connect(connectMode);
        }
    }
}

function SetCerberusConnectState(bool bHasAction, String sMessage, optional bool bAltView = false, optional bool bVisible = true)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 3;
    stParam.bVar = bHasAction;
    lstParams.AddItem(stParam);
    stParam.Type = 2;
    stParam.sVar = sMessage;
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    stParam.bVar = bAltView;
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    stParam.bVar = bVisible;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("SetCerberusConnectionState", lstParams);
}

function CerberusScreenStateChange(Cerberus3DState eNewState)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    switch (eNewState)
    {
        case 1:
            stParam.Type = 3;
            stParam.bVar = true;
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("SetCerberusElementVisible", lstParams);
            SetCerberusConnectState(false, srCerb_ConnectedToCerb, true, true);
            break;
        case 2:
            stParam.Type = 3;
            stParam.bVar = false;
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("SetCerberusElementVisible", lstParams);
            break;
    }
    nCurrent3DState = eNewState;
}

function HasCerberusDLC(bool bVal)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 3;
    stParam.bVar = bVal;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("HasCerberusDLC", lstParams);
}

function OnExecuteCerberusDLCAvailable()
{
    Buy(2);
}

function OnExecuteOpenMarketPlace()
{
    Buy(3);
}

function Buy(SFXOnlinePurchaseSource nSource)
{
    local SFXGame oGame;
    local SFXOnlineSubsystem oOnline;
    local SFXOnlineComponentBlazeLogin oLogin;
    local BioWorldInfo oBioWorldInfo;
    oBioWorldInfo = BioWorldInfo(oWorldInfo);
    if (oBioWorldInfo != None)
    {
        oGame = SFXGame(oBioWorldInfo.Game);
        if (oGame != None)
        {
            oOnline = oGame.SFXOnlineSubsystem;
            if (oOnline != None)
            {
                oLogin = oOnline.GetComponentLogin();
                if (oLogin != None)
                {
                    oLogin.Buy(nSource);
                }
            }
        }
    }
}

function OpenMarketplaceGui(array<SFXOfferDescriptor> aOffers)
{
    if (oPanel != None)
    {
        SetEnabledAndVisible(false);
        if (m_BlazeUI.m_oGUI != None)
        {
            m_BlazeUI.m_oGUI.oPanel.SetInputDisabled(true);
            m_BlazeUI.m_oGUI.oPanel.IsVisible = false;
        }
        m_PCRStore = MassEffectGuiManager(oPanel.oParentManager).CreatePCRStore();
        if (m_PCRStore != None)
        {
            m_PCRStore.m_ChoiceDataNoStrRef = new(Class'SFXGameChoiceGUIData_PRCShop');
            m_PCRStore.m_ChoiceDataNoStrRef.m_srTitle = srPRCStore_Title;
            m_PCRStore.m_ChoiceDataNoStrRef.m_srSubTitle = srPRCStore_Subtitle;
            m_PCRStore.m_ChoiceDataNoStrRef.m_srAText = srPRCStore_ABtn;
            m_PCRStore.m_ChoiceDataNoStrRef.m_srBText = srPRCStore_BBtn;
            AddPRCChoices(m_PCRStore.m_ChoiceDataNoStrRef, aOffers);
            m_PCRStore.__InputCallback__Delegate = PRCStoreGUIInputPressed;
            m_PCRStore.ShowChoiceGUI();
        }
    }
}

function AddPRCChoices(SFXGameChoiceGUIData_PRCShop oData, array<SFXOfferDescriptor> aOffers)
{
    local SFXChoiceEntryNoStrRef ChoiceParams;
    local SFXOfferDescriptor oOffer;
    local int nIndex;
    local String sFinalDescription;
    nIndex = 0;
    foreach aOffers(oOffer)
    {
        ClearCustomTokens();
        SetCustomToken(0, oOffer.Price);
        SetCustomToken(1, oOffer.Description);
        srYesNo = oOffer.UserHasIt ? srPRCStore_PurchasedYes : srPRCStore_PurchasedNo;
        SetCustomToken(2, srYesNo);
        sFinalDescription = Class'SFXGame'.GetSimpleString(srPRCStore_DescFormat, true);
        ClearCustomTokens();
        ChoiceParams.sChoiceName = oOffer.Name;
        ChoiceParams.sChoiceTitle = oOffer.Name;
        ChoiceParams.sChoiceDescription = sFinalDescription;
        ChoiceParams.nChoiceID = oOffer.internalId;
        ChoiceParams.bDefaultSelection = nIndex == 0;
        ChoiceParams.bDisabled = false;
        ChoiceParams.bNested = oOffer.UserHasIt;
        oData.AddChoiceNoStrRef(ChoiceParams);
        nIndex++;
    }
}

final function PRCStoreGUIInputPressed(bool bAPressed, int nContext)
{
    local SFXGameChoiceGUIData_PRCShop oData;
    local array<int> aChoices;
    oData = m_PCRStore.m_ChoiceDataNoStrRef;
    if (oData != None)
    {
        if (nContext >= 0 && nContext < oData.lstChoicesNoStrRef.Length)
        {
            aChoices.AddItem(nContext);
        }
    }
    m_PCRStore = None;
    MassEffectGuiManager(oPanel.oParentManager).DestroyPCRStore();
    SetEnabledAndVisible(true);
    if (m_BlazeUI != None)
    {
        if (m_BlazeUI.m_oGUI != None)
        {
            m_BlazeUI.m_oGUI.oPanel.SetInputDisabled(false);
            m_BlazeUI.m_oGUI.oPanel.IsVisible = true;
        }
        m_BlazeUI.SubmitStore(aChoices);
    }
}

function RefreshCerberusState()
{
    local SFXGame oGame;
    local SFXOnlineSubsystem oOnline;
    local SFXOnlineComponentBlazeLogin oLogin;
    local BioWorldInfo oBioWorldInfo;
    local SFXOnlineConnectionState eConnectionState;
    if (m_BlazeUI == None)
    {
        return;
    }
    eConnectionState = m_CerbConnectState;
    oBioWorldInfo = BioWorldInfo(oWorldInfo);
    if (oBioWorldInfo != None)
    {
        oGame = SFXGame(oBioWorldInfo.Game);
        if (oGame != None)
        {
            oOnline = oGame.SFXOnlineSubsystem;
            if (oOnline != None)
            {
                oLogin = oOnline.GetComponentLogin();
                if (oLogin != None)
                {
                    eConnectionState = oLogin.GetConnectionState();
                }
            }
        }
    }
    SetOnlineState(eConnectionState);
}

event OnInputFocusRecieved()
{
    RefreshCerberusState();
}

native function String GetLocalizedNewsItemCount(int nCurrent, int nTotal);

defaultproperties
{
    srPRCAvailableMessage=System.Byte[]
    fPCRMessageDispTime=5
    bDisplayForNewContentOnly=true
    m_CerbConnectState=None
    NoLoginStart=System.Byte[]
    ConfirmNoLoginStart=System.Byte[]
    CancelNoLoginStart=System.Byte[]
    LostNetworkConnection=System.Byte[]
    ConfirmNetworkLoss=System.Byte[]
    Calander_Title=System.Byte[]
    MOTD_Title=System.Byte[]
    UPCOMING_DLC_Title=System.Byte[]
    AVAIL_DLC_Title=System.Byte[]
    UPCOMING_CERB_DLC_Title=System.Byte[]
    AVAIL_CERB_DLC_Title=System.Byte[]
    srCerb_ActivateCerb=System.Byte[]
    srCerb_ConnectTo=System.Byte[]
    srCerb_ConnectingToCerb=System.Byte[]
    srCerb_ConnectedToCerb=System.Byte[]
    srPRCStore_DescFormat=System.Byte[]
    srPRCStore_PurchasedYes=System.Byte[]
    srPRCStore_PurchasedNo=System.Byte[]
    srPRCStore_Title=System.Byte[]
    srPRCStore_Subtitle=System.Byte[]
    srPRCStore_ABtn=System.Byte[]
    srPRCStore_BBtn=System.Byte[]
    srExitConfirm=System.Byte[]
    srConfirm=System.Byte[]
    srCancel=System.Byte[]
    ConfirmImportME1=System.Byte[]
    nHandlerID=8
}
