﻿class BioSFHandler_NewCharacter extends BioSFHandler
    config(UI)
    transient
    native;

const NextGeneratedHead = 1;
const SliderValueChanged = 2;
const StartGameWithIconic = 3;
const InitializeNC = 4;
const StartGameWithCustom = 5;
const ExitNewCharacter = 6;
const ShowNameKeyboard = 7;
const ConfirmCharCreate = 8;
const ClassChange = 9;
const SelectPreviousChar = 10;
const Hide3DModel = 11;
const StartCustom = 12;
const Show3DModel = 13;
const ZoomInOnFace = 14;
const ZoomOutFromFace = 15;
const ResetCategory = 16;
const Set3DModelState = 17;
const UpdateBonusTalents = 18;
const ShowCodeKeyboard = 20;
const SetCode = 21;
const SelectStorageDevice = 24;
const MAX_CLASS_CHOICES = 6;
var const config array<String> FemalePregeneratedHeadCodes;

var const config array<String> MalePregeneratedHeadCodes;

var transient int CurrentPregeneratedHeadIndex;

var transient array<BonusTalentData> UnlockedBonusTalents;

var const config array<BonusTalentData> BonusTalents;

var transient Name lstCurrentClass[3];

var transient BioMorphFaceFrontEnd m_oBioMorphFrontEnd;

var BioSFHandler_Keyboard oKeyboard;

var AnimSet SchematicAnimSet;

var BioVFXTemplate SchematicVisualEffect;

var Name lstStoredVarNames[3];

var Name lstTemplateNames[3];

var BioPawn lstTemplates[3];

var SFXMorphFaceFrontEndDataSource FemaleDataSource;

var SFXMorphFaceFrontEndDataSource MaleDataSource;

var array<class<SFXPawn_Player> > lstSpawnableClasses;

var array<class<SFXCharacterClass> > lstCharacterClasses;

var array<AnimSet> lstClassAnimSetRefs;

var Name m_nmClassAnimSet;

// CancelSelectDevice: StringRefProperty[44]
// ConfirmSelectDevice: StringRefProperty[44]
// NoSaveDevice: StringRefProperty[44]
var transient bool m_bStopScroll;

var transient bool m_bEnteringCode;

var String m_sCode;

var config int m_nInfoScrollSpeed;

var config int nMaxCodeLength;

// srCodeTitle: StringRefProperty[44]
var config int nMaxNameLength;

// srNameTitle: StringRefProperty[44]
var int m_nDefaultClass;

var int m_nDefaultNotoriety;

var int m_nDefaultOrigin;

var NewCharacterLookAtTarget NextLookAtTarget;

var NewCharacterLookAtTarget CurrentLookAtTarget;

var BioNewCharacterTemplates m_nLastInitializedTemplate;

var BioNewCharacterTemplates m_nCurrentTemplate;

var EDataOrigin m_nDataOrigin;

var String m_sFemaleName;

var String m_sMaleName;

var Name m_nmAllianceComputerPleaseLogin;

// srConfirm: StringRefProperty[44]
// srFacialCategoryDescription: StringRefProperty[44]
// srNewCharQuestion: StringRefProperty[44]
// srNewCharCancel: StringRefProperty[44]
// srNewCharConfirm: StringRefProperty[44]
// srCustomFemaleName: StringRefProperty[44]
// srCustomMaleName: StringRefProperty[44]
var config String sStartMap;

var bool m_bMaleSelected;

var bool bImportingCharacter;

var bool bOpenedFromMainMenu;

var bool bZoomedInOnFace;

var bool bLookAtUpDownNulling;

var bool bLookAtLeftRightNulling;

var float fLookAtLeftRightValue;

var float fLookAtUpDownValue;

enum EDataOrigin
{
    DataOrigin_NewGame,
    DataOrigin_ME1,
    DataOrigin_ME2,
};

enum BioNewCharacterTemplates
{
    BNCT_ICONIC,
    BNCT_CUSTOM,
    BNCT_IMPORTED,
};

struct native BonusTalentData
{
    var String PowerClassName;

    var int AchievementId;

// srChoiceName: StringRefProperty[44]
// srChoiceTitle: StringRefProperty[44]
    var Texture2D oChoiceImage;

// srChoiceDescription: StringRefProperty[44]
    var bool bMorinthSpecialCase;

}

enum NewCharacterLookAtTarget
{
    NCLAT_Ahead,
    NCLAT_Left,
    NCLAT_Right,
    NCLAT_Up,
    NCLAT_Down,
};

delegate OnCloseCallback();

function SetOnCloseCallback(delegate<OnCloseCallback> fn_OnCloseDelegate)
{
    __OnCloseCallback__Delegate = fn_OnCloseDelegate;
}

native function Setup3DModel();

native function Update3DModelByClass(Name nmClass, BioPawn pTemplate, BioNewCharacterTemplates nTemplate, bool bUpdate, optional bool bForce, optional bool bAttachVFXandUpdatePose);

native function ClearEffects();

event class<Object> GetCharacterClassByName(Name nmClass)
{
    local class<SFXCharacterClass> CharClass;
    local int nClassIdx;
    nClassIdx = 0;
    while (nClassIdx < lstCharacterClasses.Length)
    {
        CharClass = lstCharacterClasses[nClassIdx];
        if (CharClass.Default.ClassName ~= nmClass)
        {
            return CharClass;
        }
        ++nClassIdx;
    }
    return None;
}

function SetMaleSelected(bool bSelected)
{
    local BioUIWorld oUIWorld;
    oUIWorld = BioWorldInfo(oWorldInfo).m_UIWorld;
    if (oUIWorld != None)
    {
        oUIWorld.SetBoolVariable('bIsMaleCharacterCreation', bSelected);
    }
    m_bMaleSelected = bSelected;
}

function AddKismetNamedObject(Name KismetVariableName, Object ObjectValue)
{
    local BioUIWorld oUIWorld;
    oUIWorld = BioWorldInfo(oWorldInfo).m_UIWorld;
    if (oUIWorld != None)
    {
        oUIWorld.SetObjectVariable(KismetVariableName, ObjectValue);
    }
}

function SetClassVFXTemplates(BioVFXTemplate FullBioticEffectTemplate, BioVFXTemplate HalfBioticEffectTemplate, BioVFXTemplate TechToolEffectTemplate)
{
    local BioUIWorld oUIWorld;
    oUIWorld = BioWorldInfo(oWorldInfo).m_UIWorld;
    if (oUIWorld != None)
    {
        oUIWorld.m_pFullBioticEffectTemplate = FullBioticEffectTemplate;
        oUIWorld.m_pHalfBioticEffectTemplate = HalfBioticEffectTemplate;
        oUIWorld.m_pTechToolEffectTemplate = TechToolEffectTemplate;
    }
}

function SetSchematicResources(BioVFXTemplate in_SchematicEffectTemplate, AnimSet in_SchematicAnimSet)
{
    local BioUIWorld oUIWorld;
    oUIWorld = BioWorldInfo(oWorldInfo).m_UIWorld;
    if (oUIWorld != None)
    {
        SchematicVisualEffect = in_SchematicEffectTemplate;
        SchematicAnimSet = in_SchematicAnimSet;
    }
}

function SetBackgroundMaterial(MaterialInterface Material)
{
    local BioUIWorld oUIWorld;
    oUIWorld = BioWorldInfo(oWorldInfo).m_UIWorld;
    if (oUIWorld != None)
    {
        if (Material != None)
        {
            oUIWorld.SetObjectVariable('BackgroundMaterial', Material);
            oUIWorld.TriggerEvent('UpdateBackgroundMaterial', oWorldInfo);
        }
        else
        {
            oUIWorld.TriggerEvent('ClearBackgroundMaterial', oWorldInfo);
        }
    }
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    local BioSFPanel oNewPanel;
    local Name nmNewClass;
    local PlayerController PC;
    switch (nCommand);
    case 2;
    HandleSliderChange(lstArguments[0], lstArguments[1], lstArguments[2]);
    UpdateCode();
    jump 1804;
    case 9;
    Update3DModelByClass(lstArguments[0], lstTemplates[m_nCurrentTemplate], m_nCurrentTemplate, false);
    jump 1804;
    case 17;
    nmNewClass = lstCurrentClass[m_nCurrentTemplate];
    if (!bZoomedInOnFace) jump 187;
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateLookReset', oWorldInfo);
    Update3DModelState(lstArguments[0]);
    Update3DModelByClass(nmNewClass, lstTemplates[lstArguments[0]], lstArguments[0], true, false, !bZoomedInOnFace);
    jump 1804;
    case 1;
    SelectNextPregeneratedHead();
    UpdateCode();
    jump 1804;
    case 16;
    DoCategoryReset(lstArguments[0]);
    UpdateCode();
    jump 1804;
    case 3;
    SetupIconicCharacter(lstArguments);
    m_oBioMorphFrontEnd.CleanUp();
    StartNewGame();
    jump 1804;
    case 5;
    SetPlayerCharacter(lstArguments);
    m_oBioMorphFrontEnd.CleanUp();
    StartNewGame();
    jump 1804;
    case 8;
    ConfirmComplete();
    jump 1804;
    case 14;
    bZoomedInOnFace = true;
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateZoomIn', oWorldInfo);
    jump 1804;
    case 15;
    Update3DModelByClass(lstCurrentClass[m_nCurrentTemplate], lstTemplates[m_nCurrentTemplate], m_nCurrentTemplate, true, true);
    bZoomedInOnFace = false;
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateZoomOut', oWorldInfo);
    ResetLookAt();
    jump 1804;
    case 11;
    BioWorldInfo(oWorldInfo).m_UIWorld.HidePawn(lstTemplates[m_nCurrentTemplate]);
    jump 1804;
    case 13;
    BioWorldInfo(oWorldInfo).m_UIWorld.HidePawn(lstTemplates[m_nCurrentTemplate], false);
    jump 1804;
    case 10;
    oNewPanel = oPanel.oParentManager.CreatePanel('ReplayCharacterSelect', true);
    oNewPanel.bFullScreen = true;
    oPanel.oParentManager.RemovePanel(oPanel, true);
    jump 1804;
    case 18;
    UpdateBonusTalentList();
    jump 1804;
    case 4;
    m_oBioMorphFrontEnd = new(Class'BioMorphFaceFrontEnd');
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateInitCamera', oWorldInfo);
    ProcessExternalStates(BioWorldInfo(oWorldInfo));
    SetCustomName(m_sMaleName, m_sFemaleName);
    UpdateCustomClassList();
    SetupSummary();
    SetUIPawnCasual(true);
    BioWorldInfo(oWorldInfo).m_UIWorld.SetObjectVariable('ZoomInCompleteEffect', SchematicVisualEffect);
    BioWorldInfo(oWorldInfo).m_UIWorld.HidePawn(lstTemplates[m_nCurrentTemplate], false);
    Update3DModelByClass('Soldier', lstTemplates[m_nCurrentTemplate], m_nCurrentTemplate, true, true);
    bZoomedInOnFace = true;
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateForcedZoomIn', oWorldInfo);
    jump 1804;
    case 12;
    m_oBioMorphFrontEnd.SetPlayerName(m_bMaleSelected ? m_sMaleName : m_sFemaleName);
    SetCustomModel();
    PopulateCustomFaceList();
    SetSliderPositions();
    UpdateCode();
    jump 1804;
    case 6;
    SetBackgroundMaterial(None);
    oNewPanel = oPanel.oParentManager.CreatePanel(bOpenedFromMainMenu ? 'MainMenu' : 'SelectCharacter', true);
    oNewPanel.bFullScreen = true;
    StopGuiVoice();
    oPanel.oParentManager.RemovePanel(oPanel, true);
    jump 1804;
    case 7;
    if (!Class'WorldInfo'.IsConsoleBuild(1)) jump 1484;
    m_bEnteringCode = false;
    oKeyboard = BioSFHandler_Keyboard(oPanel.AttachHandler(Class'BioSFHandler_Keyboard'));
    oKeyboard.DisplayKeyboard(srNameTitle// unknown bytecode 4F ;
}

function SetUIPawnCasual(bool bCasual)
{
    local BioWorldInfo oWI;
    local BioPlayerController PC;
    local SFXPawn_Player oPlayerPawn;
    if (oWorldInfo != None)
    {
        oWI = BioWorldInfo(oWorldInfo);
        if (oWI != None)
        {
            PC = oWI.GetLocalPlayerController();
            if (PC != None)
            {
                oPlayerPawn = SFXPawn_Player(PC.Pawn);
                if (oPlayerPawn != None)
                {
                    oPlayerPawn = SFXPawn_Player(oWI.m_UIWorld.GetSpawnedPawn(oPlayerPawn));
                    if (oPlayerPawn != None)
                    {
                        oPlayerPawn.bUseCasualAppearance = bCasual;
                    }
                }
            }
        }
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 5:
            HandleLookAtUpDown(fValue);
            ScrollText(-fValue);
            break;
        case 4:
            HandleLookAtLeftRight(fValue);
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function ScrollText(float fValue)
{
    local array<ASParams> lstParams;
    local ASParams aParam;
    if (Abs(fValue) <= 0,0001)
    {
        if (m_bStopScroll == true)
        {
            oPanel.InvokeMethod("StopInfoScroll");
            m_bStopScroll = false;
        }
        return;
    }
    aParam.Type = 1;
    aParam.fVar = fValue * m_nInfoScrollSpeed;
    lstParams.AddItem(aParam);
    oPanel.InvokeMethodArgs("ScrollInfoText", lstParams);
    m_bStopScroll = true;
}

function HandleRotate(float fValue)
{
    if (fValue > 0,5)
    {
        BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateInitRotation', oWorldInfo);
    }
    else
    {
        if (fValue < -0,5)
        {
            BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateReverseRotation', oWorldInfo);
        }
        else
        {
            BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('CharCreateStopRotation', oWorldInfo);
        }
    }
}

function HandleLookAtUpDown(float fValue)
{
    local float LookThreshold;
    if (!bZoomedInOnFace)
    {
        return;
    }
    LookThreshold = 0,5;
    if (fLookAtUpDownValue > LookThreshold)
    {
        if (fValue < -LookThreshold)
        {
            ResetLookAt();
        }
    }
    else
    {
        if (fLookAtUpDownValue < -LookThreshold)
        {
            if (fValue > LookThreshold)
            {
                ResetLookAt();
            }
        }
        else
        {
            if (fValue > LookThreshold)
            {
                if (!bLookAtUpDownNulling)
                {
                    NextLookAtTarget = 4;
                    fLookAtUpDownValue = fValue;
                    bLookAtLeftRightNulling = false;
                    fLookAtLeftRightValue = 0;
                }
            }
            else
            {
                if (fValue < -LookThreshold)
                {
                    if (!bLookAtUpDownNulling)
                    {
                        NextLookAtTarget = 3;
                        fLookAtUpDownValue = fValue;
                        bLookAtLeftRightNulling = false;
                        fLookAtLeftRightValue = 0;
                    }
                }
                else
                {
                    bLookAtUpDownNulling = false;
                }
            }
        }
    }
}

function HandleLookAtLeftRight(float fValue)
{
    local float LookThreshold;
    if (!bZoomedInOnFace)
    {
        return;
    }
    LookThreshold = 0,5;
    if (fLookAtLeftRightValue > LookThreshold)
    {
        if (fValue < -LookThreshold)
        {
            ResetLookAt();
        }
    }
    else
    {
        if (fLookAtLeftRightValue < -LookThreshold)
        {
            if (fValue > LookThreshold)
            {
                ResetLookAt();
            }
        }
        else
        {
            if (fValue > LookThreshold)
            {
                if (!bLookAtLeftRightNulling)
                {
                    NextLookAtTarget = 2;
                    fLookAtLeftRightValue = fValue;
                    fLookAtUpDownValue = 0;
                    bLookAtUpDownNulling = false;
                }
            }
            else
            {
                if (fValue < -LookThreshold)
                {
                    if (!bLookAtLeftRightNulling)
                    {
                        NextLookAtTarget = 1;
                        fLookAtLeftRightValue = fValue;
                        fLookAtUpDownValue = 0;
                        bLookAtUpDownNulling = false;
                    }
                }
                else
                {
                    bLookAtLeftRightNulling = false;
                }
            }
        }
    }
}

function ResetLookAt()
{
    NextLookAtTarget = 0;
    fLookAtUpDownValue = 0;
    bLookAtUpDownNulling = true;
    fLookAtLeftRightValue = 0;
    bLookAtLeftRightNulling = true;
}

function Update(float fDeltaT)
{
    local PlayerController PC;
    local int ControllerId;
    local bool bCanWriteSave;
    if (oKeyboard != None && oKeyboard.bKeyboardVisible == false)
    {
        if (m_bEnteringCode)
        {
            if (oKeyboard.bKeyboardEntrySucceeded)
            {
                ApplyNewCode(oKeyboard.sInputValue);
                SetSliderPositions();
                UpdateCode();
            }
            oPanel.RemoveScriptHandler(oKeyboard);
            oKeyboard = None;
        }
        else
        {
            if (oKeyboard.bKeyboardEntrySucceeded)
            {
                if (oKeyboard.sInputValue == "")
                {
                    oKeyboard.DisplayKeyboard(srNameTitle// unknown bytecode 4F ;
                }
            }
        }
    }
}

function ApplyNewCode(String sInputCode)
{
    local int nNumCategories;
    local int nNumSliders;
    local int I;
    local int J;
    local int nIndex;
    local int nValue;
    local BioWorldInfo oBWI;
    oBWI = BioWorldInfo(oWorldInfo);
    nIndex = 0;
    nNumCategories = m_oBioMorphFrontEnd.GetNumberOfFeatureCategories();
    I = 0;
    while (I < nNumCategories)
    {
        nNumSliders = m_oBioMorphFrontEnd.GetNumSlidersInCategory(I);
        J = 0;
        while (J < nNumSliders)
        {
            nValue = Asc(".");
            while (nIndex < Len(sInputCode) && nValue == Asc("."))
            {
                nValue = Asc(Mid(sInputCode, nIndex, 1));
                nIndex++;
            }
            if (nValue >= Asc("1") && nValue <= Asc("9"))
            {
                nValue -= Asc("1");
            }
            else
            {
                if (nValue >= Asc("a") && nValue <= Asc("z"))
                {
                    if (nValue >= Asc("o"))
                    {
                        nValue--;
                    }
                    nValue += 9 - Asc("a");
                }
                else
                {
                    if (nValue >= Asc("A") && nValue <= Asc("Z"))
                    {
                        if (nValue > Asc("O"))
                        {
                            nValue--;
                        }
                        nValue += 9 - Asc("A");
                    }
                    else
                    {
                        nValue = 0;
                    }
                }
            }
            nValue += m_oBioMorphFrontEnd.GetSliderMin(I, J);
            if (nValue > m_oBioMorphFrontEnd.GetSliderMax(I, J))
            {
                nValue = m_oBioMorphFrontEnd.GetSliderMax(I, J);
            }
            m_oBioMorphFrontEnd.HandleSliderChange(I, J, nValue, false);
            ++J;
        }
        ++I;
    }
    m_oBioMorphFrontEnd.HandleSliderChange(0, 0, m_oBioMorphFrontEnd.GetSliderValue(0, 0), true);
    oBWI.m_UIWorld.UpdateAppearance(lstTemplates[m_nCurrentTemplate], SchematicAnimSet, 2);
}

function UpdateCode()
{
    local int nNumCategories;
    local int nNumSliders;
    local int I;
    local int J;
    local int nIndex;
    local int nValue;
    local ASParams stParam;
    local array<ASParams> lstParams;
    m_sCode = "";
    nIndex = 0;
    nNumCategories = m_oBioMorphFrontEnd.GetNumberOfFeatureCategories();
    I = 0;
    while (I < nNumCategories)
    {
        nNumSliders = m_oBioMorphFrontEnd.GetNumSlidersInCategory(I);
        J = 0;
        while (J < nNumSliders)
        {
            if (nIndex > 0 && nIndex % 3 == 0)
            {
                m_sCode = m_sCode $ ".";
            }
            nValue = m_oBioMorphFrontEnd.GetSliderValue(I, J);
            if (nValue < 9)
            {
                nValue += Asc("1");
            }
            else
            {
                if (nValue < 34)
                {
                    nValue += Asc("A") - 9;
                    if (nValue >= Asc("O"))
                    {
                        nValue++;
                    }
                }
                else
                {
                    nValue = Asc("!");
                }
            }
            m_sCode = m_sCode $ Chr(nValue);
            nIndex = nIndex + 1;
            ++J;
        }
        ++I;
    }
    stParam.Type = 2;
    stParam.sVar = m_sCode;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("setFaceCode", lstParams);
}

final function SetCustomName(String sMaleName, String sFemaleName)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local String sConfirmNameString;
    m_sMaleName = sMaleName;
    m_sFemaleName = sFemaleName;
    ClearCustomTokens();
    SetCustomToken(0, m_bMaleSelected ? sMaleName : sFemaleName);
    sConfirmNameString = Class'SFXGame'.GetSimpleString(srConfirm, true);
    ClearCustomTokens();
    stParam.Type = 2;
    stParam.sVar = sMaleName;
    lstParams.AddItem(stParam);
    stParam.sVar = sFemaleName;
    lstParams.AddItem(stParam);
    stParam.sVar = sConfirmNameString;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("setCustomName", lstParams);
}

final function SetupSummary()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 0;
    stParam.nVar = m_nDataOrigin;
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    stParam.bVar = m_bMaleSelected == false;
    lstParams.AddItem(stParam);
    stParam.Type = 0;
    stParam.nVar = m_nDefaultOrigin;
    lstParams.AddItem(stParam);
    stParam.nVar = m_nDefaultNotoriety;
    lstParams.AddItem(stParam);
    stParam.nVar = m_nDefaultClass;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("initializeSequenceDetails", lstParams);
}

final function UpdatePreviousCharacterList();

function UpdateCustomClassList()
{
    local ASParams CurrentParameter;
    local array<ASParams> Parameters;
    local int nClassIdx;
    CurrentParameter.Type = 0;
    CurrentParameter.nVar = 6;
    Parameters.AddItem(CurrentParameter);
    oPanel.InvokeMethodArgs("createClassList", Parameters);
    nClassIdx = 0;
    while (nClassIdx < lstCharacterClasses.Length)
    {
        UpdateCustomClassChoice(lstCharacterClasses[nClassIdx], nClassIdx);
        ++nClassIdx;
    }
}

final function UpdateCustomClassChoice(class<SFXCharacterClass> PlayerClass, int Row)
{
    local ASParams CurrentParameter;
    local array<ASParams> Parameters;
    CurrentParameter.Type = 0;
    CurrentParameter.nVar = Row;
    Parameters.AddItem(CurrentParameter);
    CurrentParameter.Type = 2;
    CurrentParameter.sVar = PlayerClass.Default.ClassName;
    Parameters.AddItem(CurrentParameter);
    CurrentParameter.Type = 0;
    CurrentParameter.nVar = PlayerClass.Default.srClassName;
    Parameters.AddItem(CurrentParameter);
    CurrentParameter.nVar = PlayerClass.Default.srClassDesc;
    Parameters.AddItem(CurrentParameter);
    CurrentParameter.nVar = PlayerClass.Default.srClassPrimaryDesc;
    Parameters.AddItem(CurrentParameter);
    CurrentParameter.nVar = PlayerClass.Default.srClassSecondaryDesc;
    Parameters.AddItem(CurrentParameter);
    oPanel.InvokeMethodArgs("populateClassChoice", Parameters);
}

final function SetupIconicCharacter(const out array<String> lstSettings)
{
    local BioSaveGame CurrentGame;
    CurrentGame = BioWorldInfo(oWorldInfo).CurrentGame;
    CurrentGame.DefaultPlayer.bIsFemale = !m_bMaleSelected;
    CurrentGame.DefaultPlayer.FirstName = m_bMaleSelected ? m_sMaleName : m_sFemaleName;
    CurrentGame.DefaultPlayer.CharacterClass = lstSpawnableClasses[m_nDefaultClass];
    CurrentGame.DefaultPlayer.Origin = m_nDefaultOrigin + 1;
    CurrentGame.DefaultPlayer.Notoriety = m_nDefaultNotoriety + 1;
    CurrentGame.DefaultPlayer.BonusTalentClass = UnlockedBonusTalents[lstSettings[1]].PowerClassName;
    CurrentGame.DefaultPlayer.FaceCode = m_sCode;
    CurrentGame.bNewPlayer = false;
    Class'BioTelemetry'.SendEventBool('CUSTOM_SHEPARD', false);
}

final function SetPlayerCharacter(const out array<String> PlayerSettings)
{
    local BioPawn Pawn;
    local BioMorphFace MorphHead;
    local BioSaveGame CurrentGame;
    if (m_nCurrentTemplate == 1)
    {
        Pawn = lstTemplates[1];
        MorphHead = Pawn.MorphHead;
        Class'BioTelemetry'.SendEventBool('CUSTOM_SHEPARD', true);
    }
    else
    {
        if (m_nCurrentTemplate == 2)
        {
            Pawn = lstTemplates[2];
            MorphHead = Pawn.MorphHead;
            Class'BioTelemetry'.SendEventBool('CUSTOM_SHEPARD', true);
        }
        else
        {
            Pawn = lstTemplates[0];
            MorphHead = Pawn.MorphHead;
            Class'BioTelemetry'.SendEventBool('CUSTOM_SHEPARD', false);
        }
    }
    CurrentGame = BioWorldInfo(oWorldInfo).CurrentGame;
    CurrentGame.bNewPlayer = true;
    CurrentGame.NewPlayer.CharacterClass = SFXGame(oWorldInfo.Game).GetCharacterClassByName(PlayerSettings[0]);
    CurrentGame.NewPlayer.bIsFemale = !m_bMaleSelected;
    CurrentGame.NewPlayer.FirstName = m_bMaleSelected ? m_sMaleName : m_sFemaleName;
    CurrentGame.NewPlayer.Origin = PlayerSettings[2];
    CurrentGame.NewPlayer.Notoriety = PlayerSettings[3];
    CurrentGame.NewPlayer.MorphHead = MorphHead;
    if (PlayerSettings[4] > -1 && PlayerSettings[4] < UnlockedBonusTalents.Length)
    {
        CurrentGame.NewPlayer.BonusTalentClass = UnlockedBonusTalents[PlayerSettings[4]].PowerClassName;
    }
    else
    {
        CurrentGame.NewPlayer.BonusTalentClass = "";
    }
    CurrentGame.NewPlayer.FaceCode = m_sCode;
}

final function UpdateBonusTalentList()
{
    local int I;
    local ASParams CurrentParameter;
    local array<ASParams> Parameters;
    GetAllUnlockedBonusTalentInfo(UnlockedBonusTalents);
    CurrentParameter.Type = 0;
    CurrentParameter.nVar = UnlockedBonusTalents.Length;
    Parameters.AddItem(CurrentParameter);
    oPanel.InvokeMethodArgs("createTalentList", Parameters);
    Parameters.Length = 0;
    CurrentParameter.Type = 0;
    Parameters.AddItem(CurrentParameter);
    Parameters.AddItem(CurrentParameter);
    Parameters.AddItem(CurrentParameter);
    Parameters.AddItem(CurrentParameter);
    I = 0;
    while (I < UnlockedBonusTalents.Length)
    {
        Parameters[0].nVar = I;
        Parameters[1].nVar = I;
        Parameters[2].nVar = UnlockedBonusTalents[I].srChoiceTitle;
        Parameters[3].nVar = UnlockedBonusTalents[I].srChoiceDescription;
        oPanel.InvokeMethodArgs("populateTalentChoice", Parameters);
        ++I;
    }
}

final function GetAllUnlockedBonusTalentInfo(out array<BonusTalentData> aUnlockedBonusTalentInfo)
{
    local BonusTalentData UnlockableTalent;
    local SFXProfileSettings Profile;
    local BioPlayerController PC;
    PC = BioPlayerController(GetPlayerController());
    if (PC != None)
    {
        Profile = PC.ProfileSettings;
    }
    aUnlockedBonusTalentInfo.Length = 0;
    foreach BonusTalents(UnlockableTalent)
    {
        if (Profile != None && Profile.HasCompletedAchievement(UnlockableTalent.AchievementId) == true)
        {
            if (UnlockableTalent.bMorinthSpecialCase && Profile.GetChoseMorinthNotSamara() == false)
            {
                continue;
            }
            aUnlockedBonusTalentInfo.AddItem(UnlockableTalent);
        }
    }
}

function RefitBonusTalent(String BonusTalent)
{
    local int idx;
    local SFXPower Power;
    local PlayerController PC;
    local BioPawn ResultPawn;
    local bool bLastBonusHadRanks;
    local int Rank1Cost;
    local int Refund;
    local float Rank;
    local bool bHadBonusPower;
    PC = GetPlayerController();
    ResultPawn = BioPawn(PC.Pawn);
    bHadBonusPower = false;
    idx = ResultPawn.PowerManager.Powers.Length - 1;
    while (idx >= 0)
    {
        Power = ResultPawn.PowerManager.Powers[idx];
        if (Power != None)
        {
            if (Power.IsHenchmenUnique)
            {
                bHadBonusPower = true;
                if (Power.Rank > Rank)
                {
                    bHadBonusPower = true;
                    bLastBonusHadRanks = true;
                    Rank = Power.Rank;
                    Refund = Class'SFXPowerManager'.GetRefundAmount2(Power.Class, Power.Rank);
                    if (Power.RankCosts.Length > 0)
                    {
                        Rank1Cost = Power.RankCosts[0];
                    }
                    else
                    {
                        Rank1Cost = 1;
                    }
                    Refund -= Rank1Cost;
                }
                ResultPawn.PowerManager.RemovePower(Power.Class);
            }
        }
        idx--;
    }
    Power = ResultPawn.PowerManager.AddPowerByClassName(BonusTalent);
    if (Power != None)
    {
        if (Refund > 0)
        {
            ResultPawn.AddTalentPoints(Refund);
        }
        if (bHadBonusPower)
        {
            if (bLastBonusHadRanks)
            {
                Power.Rank = 1;
            }
        }
        else
        {
            Power.Rank = 1;
        }
    }
}

final function StartNewGame()
{
    local PlayerInfoEx NewPlayer;
    local BioSaveGame CurrentGame;
    local PlayerController PC;
    local SFXPawn_Player oPlayerPawn;
    local SFXEngine Engine;
    local class<SFXCharacterClass> CharacterClass;
    CurrentGame = BioWorldInfo(oWorldInfo).CurrentGame;
    if (CurrentGame != None)
    {
        if (CurrentGame.bNewPlayer)
        {
            NewPlayer = CurrentGame.NewPlayer;
        }
        else
        {
            NewPlayer = CurrentGame.DefaultPlayer;
        }
        PC = GetPlayerController();
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
            CurrentGame.bStartedGame = false;
            if (Engine != None)
            {
                CharacterClass = Class<SFXCharacterClass>(Engine.LoadSeekFreeObject(NewPlayer.CharacterClass.Default.PlayerClassName, Class'Class'));
                Class'SFXEngine'.ReleaseSeekFreeObject(NewPlayer.CharacterClass.Default.PlayerClassName);
                Engine.ClearSaveCache();
                Engine.CreateCareer(NewPlayer.FirstName, CharacterClass.Default.srClassName, NewPlayer.Origin, NewPlayer.Notoriety);
                if (Engine.ME2ImportSaveGame != None)
                {
                    Engine.ME2ImportSaveGame = None;
                    RefitBonusTalent(NewPlayer.BonusTalentClass);
                    CurrentGame.bStartedGame = true;
                    oPlayerPawn = SFXPawn_Player(PC.Pawn);
                    if (oPlayerPawn != None)
                    {
                        oPlayerPawn.MorphHead = NewPlayer.MorphHead;
                        oPlayerPawn.FaceCode = NewPlayer.FaceCode;
                    }
                }
            }
        }
    }
    m_oBioMorphFrontEnd = None;
    MaleDataSource = None;
    FemaleDataSource = None;
    StartNewGameEx();
}

final event StartNewGameEx()
{
    local SeqEvent_RemoteEvent reStartNewGame;
    oWorldInfo.bPlayersOnly = false;
    reStartNewGame = Class'SeqEvent_RemoteEvent'.FindRemoteEvent("re_StartNewGame");
    if (reStartNewGame != None)
    {
        reStartNewGame.CheckActivate(oWorldInfo, oWorldInfo);
        jump 103;
    }
    StopGuiMusic();
    m_oBioMorphFrontEnd = None;
    if (__OnCloseCallback__Delegate != None)
    {
        OnCloseCallback();
    }
    return;
}

final function Update3DModelState(BioNewCharacterTemplates nTemplate)
{
    if (nTemplate == m_nCurrentTemplate)
    {
        return;
    }
    BioWorldInfo(oWorldInfo).SetGlobalTlk(m_bMaleSelected, false);
    Update3DModel(nTemplate);
}

final function Update3DModel(BioNewCharacterTemplates nTemplate)
{
    local BioWorldInfo oBWI;
    if (nTemplate == m_nCurrentTemplate)
    {
        return;
    }
    oBWI = BioWorldInfo(oWorldInfo);
    oBWI.m_UIWorld.SwapPawn(lstTemplates[m_nCurrentTemplate], 'CharCreatePawn', lstTemplates[nTemplate], lstStoredVarNames[nTemplate]);
    lstStoredVarNames[m_nCurrentTemplate] = lstStoredVarNames[nTemplate];
    m_nCurrentTemplate = nTemplate;
    BioWorldInfo(oWorldInfo).m_UIWorld.SetAnimSet(lstTemplates[m_nCurrentTemplate], SchematicAnimSet);
}

final function SetCustomModel()
{
    local BioWorldInfo oBWI;
    local bool bForceFullReset;
    oBWI = BioWorldInfo(oWorldInfo);
    bForceFullReset = m_nLastInitializedTemplate != m_nCurrentTemplate;
    if (bForceFullReset)
    {
        m_oBioMorphFrontEnd.Initialize(m_bMaleSelected ? MaleDataSource : FemaleDataSource, lstTemplates[m_nCurrentTemplate], m_bMaleSelected, bForceFullReset);
        SelectNextPregeneratedHead();
    }
    oBWI.m_UIWorld.UpdateAppearance(lstTemplates[m_nCurrentTemplate], SchematicAnimSet, 2);
    m_nLastInitializedTemplate = m_nCurrentTemplate;
}

final function SetSliderPositions()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local int nNumCategories;
    local int nNumSliders;
    local int I;
    local int J;
    stParam.Type = 0;
    lstParams.AddItem(stParam);
    lstParams.AddItem(stParam);
    lstParams.AddItem(stParam);
    nNumCategories = m_oBioMorphFrontEnd.GetNumberOfFeatureCategories();
    I = 0;
    while (I < nNumCategories)
    {
        nNumSliders = m_oBioMorphFrontEnd.GetNumSlidersInCategory(I);
        J = 0;
        while (J < nNumSliders)
        {
            lstParams[0].nVar = I + 1;
            lstParams[1].nVar = J;
            lstParams[2].nVar = m_oBioMorphFrontEnd.GetSliderValue(I, J);
            oPanel.InvokeMethodArgs("SetSliderValue", lstParams);
            ++J;
        }
        ++I;
    }
}

final function DoCategoryReset(int nCategory)
{
    local BioWorldInfo oBWI;
    oBWI = BioWorldInfo(oWorldInfo);
    if (nCategory == 0)
    {
        m_oBioMorphFrontEnd.ResetAll();
    }
    else
    {
        m_oBioMorphFrontEnd.ResetCategory(nCategory - 1);
    }
    SetSliderPositions();
    oBWI.m_UIWorld.UpdateAppearance(lstTemplates[m_nCurrentTemplate], SchematicAnimSet, 2);
}

final function HandleSliderChange(int nCategory, int nSlider, int nValue)
{
    local BioWorldInfo oBWI;
    oBWI = BioWorldInfo(oWorldInfo);
    m_oBioMorphFrontEnd.HandleSliderChange(nCategory, nSlider, nValue);
    oBWI.m_UIWorld.UpdateAppearance(lstTemplates[m_nCurrentTemplate], SchematicAnimSet, 2);
}

final function PopulateCustomFaceList()
{
    local int I;
    local int J;
    local int nNumCategories;
    local int nNumSliders;
    local ASParams stParam;
    local array<ASParams> lstCategoryParams;
    local array<ASParams> lstSliderParams;
    stParam.Type = 0;
    lstCategoryParams.AddItem(stParam);
    lstCategoryParams.AddItem(stParam);
    lstCategoryParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    lstSliderParams.AddItem(stParam);
    stParam.Type = 3;
    lstSliderParams.AddItem(stParam);
    nNumCategories = m_oBioMorphFrontEnd.GetNumberOfFeatureCategories();
    oPanel.InvokeMethod("clearSliderData");
    I = 0;
    while (I < nNumCategories)
    {
        lstCategoryParams[0].nVar = I;
        lstCategoryParams[1].nVar = m_oBioMorphFrontEnd.GetCategoryString(I);
        lstCategoryParams[2].nVar = srFacialCategoryDescription;
        oPanel.InvokeMethodArgs("populateFaceTitleChoice", lstCategoryParams);
        nNumSliders = m_oBioMorphFrontEnd.GetNumSlidersInCategory(I);
        lstSliderParams[0].nVar = I;
        J = 0;
        while (J < nNumSliders)
        {
            lstSliderParams[1].nVar = m_oBioMorphFrontEnd.GetSliderLabel(I, J);
            lstSliderParams[2].nVar = m_oBioMorphFrontEnd.GetSliderDesc(I, J);
            lstSliderParams[3].nVar = m_oBioMorphFrontEnd.GetSliderMin(I, J);
            lstSliderParams[4].nVar = m_oBioMorphFrontEnd.GetSliderMax(I, J);
            lstSliderParams[5].nVar = m_oBioMorphFrontEnd.GetSliderStep(I, J);
            lstSliderParams[6].bVar = m_oBioMorphFrontEnd.GetSliderNotched(I, J);
            oPanel.InvokeMethodArgs("AddCategorySlider", lstSliderParams);
            J++;
        }
        I++;
    }
}

function OnPanelAdded()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    OnPanelAdded();
    PlayGuiMusic('CharacterCreation');
    oPanel.bApplyRightThumbstickDeadzone = true;
    stParam.Type = 1;
    stParam.fVar = ScreenLayout;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("SetPlatformLayout", lstParams);
    SetMaleSelected(m_bMaleSelected);
    oPanel.SetExternalInterface(self);
}

function OnPanelRemoved()
{
    OnPanelRemoved();
    BioWorldInfo(oWorldInfo).m_UIWorld.HidePawn(lstTemplates[m_nCurrentTemplate]);
    BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent('LightsOff', oWorldInfo);
}

final function ClearModels()
{
    local int I;
    I = 0;
    while (I < 3)
    {
        BioWorldInfo(oWorldInfo).m_UIWorld.DestroyPawn(lstTemplates[I]);
        lstTemplates[I] = None;
        I++;
    }
}

final function ConfirmComplete()
{
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    oMsgBox = MassEffectGuiManager(oPanel.oParentManager).CreateMessageBox();
    oMsgBox.SetInputDelegate(ConfirmButtonPressed);
    stParams.srAText = srNewCharConfirm;
    stParams.srBText = srNewCharCancel;
    oMsgBox.DisplayMessageBox(srNewCharQuestion, stParams);
}

final function ConfirmButtonPressed(bool bAPressed, int nContext)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 3;
    stParam.bVar = bAPressed;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("HandleConfirmInput", lstParams);
}

final function SelectNextPregeneratedHead()
{
    local int NumPregeneratedHeads;
    NumPregeneratedHeads = m_bMaleSelected ? MalePregeneratedHeadCodes.Length : FemalePregeneratedHeadCodes.Length;
    ++CurrentPregeneratedHeadIndex;
    if (CurrentPregeneratedHeadIndex >= NumPregeneratedHeads)
    {
        CurrentPregeneratedHeadIndex = NumPregeneratedHeads != 0 ? 0 : -1;
    }
    if (CurrentPregeneratedHeadIndex >= 0)
    {
        ApplyNewCode(m_bMaleSelected ? MalePregeneratedHeadCodes[CurrentPregeneratedHeadIndex] : FemalePregeneratedHeadCodes[CurrentPregeneratedHeadIndex]);
        SetSliderPositions();
        UpdateCode();
    }
}

final function SelectPreviousPregeneratedHead()
{
    local int NumPregeneratedHeads;
    NumPregeneratedHeads = m_bMaleSelected ? MalePregeneratedHeadCodes.Length : FemalePregeneratedHeadCodes.Length;
    --CurrentPregeneratedHeadIndex;
    if (CurrentPregeneratedHeadIndex < 0)
    {
        CurrentPregeneratedHeadIndex = NumPregeneratedHeads - 1;
    }
    if (CurrentPregeneratedHeadIndex >= 0)
    {
        ApplyNewCode(m_bMaleSelected ? MalePregeneratedHeadCodes[CurrentPregeneratedHeadIndex] : FemalePregeneratedHeadCodes[CurrentPregeneratedHeadIndex]);
        SetSliderPositions();
        UpdateCode();
    }
}

final event TriggerClassOverlay()
{
    oPanel.InvokeMethod("TriggerClassOverlay");
}

event ProcessExternalStates(BioWorldInfo BWI)
{
    local BioPlayerController PC;
    local SFXEngine Engine;
    local PlayerSaveRecord PlayerRecord;
    PC = BioPlayerController(GetPlayerController());
    Engine = SFXEngine(PC.Player.Outer);
    if (BWI != None && BWI.CurrentGame != None && BWI.CurrentGame.ImportedDataManager != None && BWI.CurrentGame.ImportedDataManager.m_bImportedData == true)
    {
        m_nDataOrigin = 1;
        SetMaleSelected(BWI.CurrentGame.ImportedDataManager.GetImportedPlayerGender() == 0);
        m_sMaleName = BWI.CurrentGame.ImportedDataManager.GetImportedPlayerName();
        m_sFemaleName = m_sMaleName;
        m_nDefaultOrigin = BWI.CurrentGame.ImportedDataManager.GetImportedPlayerOrigin() - 1;
        m_nDefaultNotoriety = BWI.CurrentGame.ImportedDataManager.GetImportedPlayerNotoriety() - 1;
        switch (BWI.CurrentGame.ImportedDataManager.GetImportedPlayerClass())
        {
            case 1:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerEngineer');
                break;
            case 2:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerAdept');
                break;
            case 3:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerInfiltrator');
                break;
            case 4:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerSentinel');
                break;
            case 5:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerVanguard');
                break;
            case 0:
            default:
                m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerSoldier');
                break;
        }
        m_nDefaultClass = lstSpawnableClasses.Find(BWI.CurrentGame.NewPlayer.CharacterClass);
    }
    else
    {
        if (Engine != None && Engine.ME2ImportSaveGame != None)
        {
            m_nDataOrigin = 2;
            Engine.ME2ImportSaveGame.GetPlayerRecord(PlayerRecord);
            SetMaleSelected(!PlayerRecord.bIsFemale);
            m_sMaleName = PlayerRecord.FirstName;
            m_sFemaleName = m_sMaleName;
            m_nDefaultOrigin = PlayerRecord.Origin - 1;
            m_nDefaultNotoriety = PlayerRecord.Notoriety - 1;
            m_nDefaultClass = lstSpawnableClasses.Find(PlayerRecord.PlayerClass);
        }
        else
        {
            m_nDataOrigin = 0;
            SetMaleSelected(BWI == None || BWI.CurrentGame == None || BWI.CurrentGame.DefaultPlayer.bIsFemale == false);
            m_sMaleName = srCustomMaleName;
            m_sFemaleName = srCustomFemaleName;
            m_nDefaultOrigin = 3 - 1;
            m_nDefaultNotoriety = 1 - 1;
            m_nDefaultClass = lstSpawnableClasses.Find(Class'SFXPawn_PlayerSoldier');
        }
    }
    if (m_nDefaultClass < 0 || m_nDefaultClass >= lstCharacterClasses.Length)
    {
        m_nDefaultClass = 0;
    }
    if (m_nDataOrigin == 1 || m_nDataOrigin == 2)
    {
        m_nCurrentTemplate = 2;
    }
    else
    {
        m_nCurrentTemplate = 0;
    }
    if (m_bMaleSelected == true)
    {
        lstTemplateNames[0] = 'Iconic_Male_Template';
        lstTemplateNames[1] = 'Custom_Male_Template';
    }
    else
    {
        lstTemplateNames[0] = 'Iconic_Female_Template';
        lstTemplateNames[1] = 'Custom_Female_Template';
    }
}

function ChooseStorageDevice()
{
    local PlayerController PC;
    local OnlineSubsystem OnlineSub;
    local int ControllerId;
    PC = GetPlayerController();
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (PC != None && OnlineSub != None)
    {
        ControllerId = LocalPlayer(PC.Player).ControllerId;
        PlayerIntEx = OnlineSub.PlayerInterfaceEx;
        if (NotEqual_InterfaceInterface(PlayerIntEx, OnlinePlayerInterfaceEx(None)))
        {
            PlayerIntEx.AddDeviceSelectionDoneDelegate(ControllerId, OnDeviceSelectionComplete);
            if (PlayerIntEx.ShowDeviceSelectionUI(ControllerId, 1048576, true) == false)
            {
                PlayerIntEx.ClearDeviceSelectionDoneDelegate(ControllerId, OnDeviceSelectionComplete);
            }
        }
    }
}

function OnDeviceSelectionComplete(bool bWasSuccessful)
{
    local OnlineSubsystem OnlineSub;
    local PlayerController PC;
    local SFXEngine Engine;
    local int ControllerId;
    local BioSFHandler_MessageBox MessageBox;
    local BioMessageBoxOptionalParams Params;
    local int DeviceID;
    local String DeviceName;
    PC = GetPlayerController();
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSub != None && PC != None)
    {
        ControllerId = LocalPlayer(PC.Player).ControllerId;
        PlayerIntEx = OnlineSub.PlayerInterfaceEx;
        if (NotEqual_InterfaceInterface(PlayerIntEx, OnlinePlayerInterfaceEx(None)))
        {
            PlayerIntEx.ClearDeviceSelectionDoneDelegate(ControllerId, OnDeviceSelectionComplete);
            if (bWasSuccessful)
            {
                DeviceID = PlayerIntEx.GetDeviceSelectionResults(LocalPlayer(PC.Player).ControllerId, DeviceName);
                BioPlayerController(PC).SetDeviceID(DeviceID);
            }
        }
    }
    if (bWasSuccessful)
    {
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
        }
        if (Engine != None)
        {
            Engine.bCanWriteSaveToStorage = true;
            if (Class'WorldInfo'.IsConsoleBuild(1))
            {
                SoldierStringRef = // unknown bytecode 4F ;
            }
        }
    }
}

function Callback_NoDevice(bool bAPressed, int Context)
{
    local PlayerController PC;
    local SFXEngine Engine;
    if (bAPressed)
    {
        ChooseStorageDevice();
    }
    else
    {
        PC = GetPlayerController();
        if (PC != None)
        {
            Engine = SFXEngine(PC.Player.Outer);
            if (Engine != None)
            {
                Engine.bCanWriteSaveToStorage = false;
                Engine.CurrentCareerName = "";
                BioPlayerController(PC).SetDeviceID(-1);
                if (!bImportingCharacter)
                {
                    oPanel.InvokeMethod("nameEntryComplete");
                }
            }
        }
    }
}

function UpdateLookAtTarget()
{
    local Name LookAtTarget;
    if (CurrentLookAtTarget != NextLookAtTarget)
    {
        fLookAtUpDownValue = 0;
        fLookAtLeftRightValue = 0;
        LookAtTarget = 'None';
        switch (NextLookAtTarget)
        {
            case 0:
                LookAtTarget = 'CharCreateLookNull';
                break;
            case 1:
                LookAtTarget = 'CharCreateLookLeft';
                break;
            case 2:
                LookAtTarget = 'CharCreateLookRight';
                break;
            case 3:
                LookAtTarget = 'CharCreateLookUp';
                break;
            case 4:
                LookAtTarget = 'CharCreateLookDown';
                break;
        }
        if (LookAtTarget != 'None')
        {
            BioWorldInfo(oWorldInfo).m_UIWorld.TriggerEvent(LookAtTarget, oWorldInfo);
        }
        CurrentLookAtTarget = NextLookAtTarget;
    }
}

defaultproperties
{
    m_bMaleSelected=true
    sStartMap="BioP_ProCer"
    srCustomMaleName=System.Byte[]
    srCustomFemaleName=System.Byte[]
    srNewCharConfirm=System.Byte[]
    srNewCharCancel=System.Byte[]
    srNewCharQuestion=System.Byte[]
    srFacialCategoryDescription=System.Byte[]
    srConfirm=System.Byte[]
    m_nmAllianceComputerPleaseLogin=AllianceComputerPleaseLogin
    m_nCurrentTemplate=None
    m_nLastInitializedTemplate=None
    CurrentLookAtTarget=None
    srNameTitle=System.Byte[]
    nMaxNameLength=11
    srCodeTitle=System.Byte[]
    nMaxCodeLength=47
    m_nInfoScrollSpeed=20
    NoSaveDevice=System.Byte[]
    ConfirmSelectDevice=System.Byte[]
    CancelSelectDevice=System.Byte[]
    lstSpawnableClasses(0)=class'SFXPawn_PlayerSoldier'
    lstSpawnableClasses(1)=class'SFXPawn_PlayerInfiltrator'
    lstSpawnableClasses(2)=class'SFXPawn_PlayerVanguard'
    lstSpawnableClasses(3)=class'SFXPawn_PlayerSentinel'
    lstSpawnableClasses(4)=class'SFXPawn_PlayerAdept'
    lstSpawnableClasses(5)=class'SFXPawn_PlayerEngineer'
    lstTemplateNames=Iconic_Male_Template
    lstTemplateNames=Custom_Male_Template
    lstTemplateNames=Custom_Male_Template
    BonusTalents=System.Byte[]
    CurrentPregeneratedHeadIndex=-1
    MalePregeneratedHeadCodes(0)="541DJDLTFA3GAAVJBDMDJ6PGG72AG16454"
    MalePregeneratedHeadCodes(1)="313WDMRG8H1CGMPCBBN1J2RNJ84AU2A376"
    MalePregeneratedHeadCodes(2)="122FRCUJME7DFHNS9D7F8381FK7U183766"
    MalePregeneratedHeadCodes(3)="333SSDL18171D6UW9UW8W6MJ6D8AK68465"
    MalePregeneratedHeadCodes(4)="5211VBB41M81PLNSBBED733F1G18915765"
    MalePregeneratedHeadCodes(5)="332RFFJH9D2IJJ9C9C1NF13FPB38945745"
    MalePregeneratedHeadCodes(6)="122WSDRGIS31MANE9BSLG7HLJ874R88335"
    FemalePregeneratedHeadCodes(0)="743Q9GM17F8AJDQ62Q1DA7119664146G6177"
    FemalePregeneratedHeadCodes(1)="233LPIK9E46IQCJ79J1DW419C719I72G7316"
    FemalePregeneratedHeadCodes(2)="722W89Q9E417FMAA5LCFD7C9C7C9K29G6315"
    FemalePregeneratedHeadCodes(3)="9413IIIR1M9HFPK28Q6RG1D1G179B23B4317"
    FemalePregeneratedHeadCodes(4)="13116BII1731JL66BM9MG71BD66417637176"
    FemalePregeneratedHeadCodes(5)="552ELIHAE425CLHE26PDH2G1L426L6426573"
    nHandlerID=9
}
