﻿class BioSFHandler_PCConversation extends BioSFHandler_Conversation
    config(UI)
    transient;

var transient bool m_bEnforce16x9;

var config float AccumulationDivisor;

var Vector vMouseInput;

function OnPanelAdded()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    OnPanelAdded();
    oPanel.bUseThumbstickAsDPad = true;
    SetMouseShown(false);
    vMouseInput = vect(1,0,0);
    stParam.nVar = 0;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("setArrowPosition", lstParams);
    oPanel.UpdateAspectRatio(true);
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 2:
        case 3:
            break;
        case 6:
            vInput.X = fValue;
            break;
        case 7:
            vInput.Y = fValue;
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function HighlightDefaultConvSegment()
{
    vMouseInput = vect(1,0,0);
}

function CalculateArrowPosition(out ASParams stParam, out array<ASParams> lstParams)
{
    local Vector vMouseAngle;
    local Rotator R;
    vMouseInput += vInput / Class'PlayerInput'.Default.MouseSensitivity * AccumulationDivisor;
    vInput.X = 0;
    vInput.Y = 0;
    vInput.Z = 0;
    if (VSize(vMouseInput) > 1)
    {
        vMouseInput = Normal(vMouseInput);
    }
    if (VSize(vMouseInput) < 0,3)
    {
        vMouseInput = Normal(vMouseInput) * 0,3;
    }
    vMouseAngle = Normal(vMouseInput);
    R = vMouseAngle;
    stParam.nVar = R.Yaw * 0,005493164;
    if (stParam.nVar < 0)
    {
        stParam.nVar += 360;
    }
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("setArrowPosition", lstParams);
}

function Update(float fDeltaT)
{
    local BioPlayerController PC;
    PC = BioPlayerController(GetPlayerController());
    if (PC != None && PC.GameModeManager2 != None)
    {
        Enforce16x9(PC.GameModeManager2.ShouldEnforce16x9Subtitiles());
    }
    Update(fDeltaT);
}

function Enforce16x9(bool bVal)
{
    if (bVal)
    {
        if (!m_bEnforce16x9 && oPanel != None)
        {
            oPanel.InvokeMethod("Enforce16x9");
            m_bEnforce16x9 = true;
        }
    }
    else
    {
        if (m_bEnforce16x9 && oPanel != None)
        {
            oPanel.UpdateAspectRatio(true);
            m_bEnforce16x9 = false;
        }
    }
}

defaultproperties
{
    AccumulationDivisor=100
    ScreenLayout=System.Byte[]
}
