﻿class BioSFHandler_PCGalaxyMap extends BioSFHandler_GalaxyMap
    config(UI)
    transient
    native;

var transient bool bMouseMovementEnabled;

var transient bool bMoveToMouse;

function HandleInputEvent(BioGuiEvents nEvent, optional float fValue = 1)
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeOrbital OrbitalGame;
    local BioCameraBehaviorGalaxy GalaxyCam;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (Manager != None)
    {
        OrbitalGame = SFXGameModeOrbital(Manager.HACK_GetOrbitalMode());
    }
    if (Manager != None)
    {
        GalaxyCam = BioCameraBehaviorGalaxy(Manager.HACK_GetCameraMode(9));
    }
    if (!IsMouseShown())
    {
        switch (nEvent);
        case 12;
        oPanel.InvokeMethod("fakeLeftClick");
        jump 404;
        case 50;
        oPanel.InvokeMethod("fakeLeftClick");
        jump 404;
        case 34;
        jump 404;
        case 6;
        if (!OrbitalGame != None) jump 331;
        OrbitalGame.RingReticleLeftRight(fValue);
        m_fLeftStickX = fValue;
        jump 404;
        case 7;
        if (!OrbitalGame != None) jump 385;
        OrbitalGame.RingReticleUpDown(fValue);
        m_fLeftStickY = -fValue;
        jump 404;
        default;
    }
    else
    {
        switch (nEvent)
        {
            case 48:
                if (bMouseMovementEnabled && GalaxyCam.m_nCurrentState == 3 || GalaxyCam.m_nCurrentState == 2)
                {
                    bMoveToMouse = true;
                }
                break;
            case 50:
                if (GalaxyCam.m_nCurrentState == 3 || GalaxyCam.m_nCurrentState == 2)
                {
                    bMoveToMouse = false;
                }
                EndRefuelNoise();
                PC.ClearTimer('RepeatBuyFuel', self);
                break;
            case 34:
                if (GalaxyCam.m_nCurrentState == 3 || GalaxyCam.m_nCurrentState == 2 || GalaxyCam.m_nCurrentState == 4)
                {
                    oPanel.InvokeMethod("fakeRightClick");
                }
                break;
        }
        m_fLeftStickX = 0;
        m_fLeftStickY = 0;
    }
    HandleInputEvent(nEvent, fValue);
    return;
}

event BuyFuel()
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeGalaxy GalaxyMap;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (Manager != None)
    {
        GalaxyMap = SFXGameModeGalaxy(Manager.GameModes[9]);
    }
    if (GalaxyMap != None)
    {
        GalaxyMap.StartFuel();
        GalaxyMap.BuyFuel();
    }
    PC.SetTimer(0,1, true, 'RepeatBuyFuel', self);
}

function RepeatBuyFuel()
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeGalaxy GalaxyMap;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (Manager != None)
    {
        GalaxyMap = SFXGameModeGalaxy(Manager.GameModes[9]);
    }
    if (GalaxyMap != None)
    {
        GalaxyMap.BuyFuel();
    }
}

function EndRefuelNoise()
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeGalaxy GalaxyMap;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (PC.IsTimerActive('RepeatBuyFuel', self) == false)
    {
        return;
    }
    if (Manager != None)
    {
        GalaxyMap = SFXGameModeGalaxy(Manager.GameModes[9]);
    }
    if (GalaxyMap != None)
    {
        GalaxyMap.StopFuel();
    }
}

event BuyProbes()
{
    local SFXGameModeManager Manager;
    local MassEffectGuiManager GuiMan;
    local BioPlayerController PC;
    local SFXGameModeGalaxy GalaxyMap;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        PC = BioPlayerController(GuiMan.Player);
    }
    if (PC != None)
    {
        Manager = PC.GameModeManager2;
    }
    if (Manager != None)
    {
        GalaxyMap = SFXGameModeGalaxy(Manager.GameModes[9]);
    }
    if (GalaxyMap != None)
    {
        GalaxyMap.BuyProbes();
    }
}

defaultproperties
{
    bMouseMovementEnabled=true
    ScreenLayout=System.Byte[]
}
