﻿class BioSFHandler_PCPauseMenu extends BioSFHandler_BrowserWheel
    config(UI)
    transient
    native;

var bool bWaitForNextFrame;

event OnPanelAdded()
{
    OnPanelAdded();
    bWaitForNextFrame = true;
    oPanel.bUseThumbstickAsDPad = true;
    SetMouseShown(true);
}

function OnPanelRemoved()
{
    SetMouseShown(false);
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    if (oWorldInfo == None)
    {
        SetWorld();
    }
    if (bWaitForNextFrame)
    {
        return;
    }
    HandleEvent(nCommand, lstArguments);
}

function ExitGame()
{
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    local MassEffectGuiManager oManager;
    oManager = MassEffectGuiManager(oPanel.oParentManager);
    oMsgBox = oManager.CreateMessageBox();
    oMsgBox.SetInputDelegate(ExitConfirm);
    stParams.srAText = // unknown bytecode 4F ;
}

function ExitConfirm(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        oWorldInfo.ConsoleCommand("Exit");
    }
    else
    {
        oPanel.InvokeMethod("finishCancel");
        SendMouseToScaleForm(5);
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 2:
            vInput.X = fValue;
            break;
        case 3:
            vInput.Y = fValue;
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

function MainMenuConfirm(bool bAPressed, int nContext)
{
    if (bAPressed)
    {
        MassEffectGuiManager(oPanel.oParentManager).HackReloadMainMenu();
    }
    else
    {
        oPanel.InvokeMethod("finishCancel");
        SendMouseToScaleForm(5);
    }
}

event Update(float fDeltaT)
{
    if (bWaitForNextFrame)
    {
        bWaitForNextFrame = false;
    }
    Update(fDeltaT);
}

defaultproperties
{
    m_Helper=SFXPowerLevelUpHelper'oHelper'
    // child object oHelper of type SFXPowerLevelUpHelper
}
