﻿class BioSFHandler_PartySelection extends BioSFHandler
    config(UI)
    transient;

const InitializeParty = 1;
const SelectParty = 2;
const SetAppearance = 3;
const Conflict = 4;
const GetInfo = 5;
const THIEF_DOWNLOADED = 2288;
const VETERAN_DOWNLOADED = 2289;
var int m_nPartyMember2;

var int m_nPartyMember1;

var Name nmForcedHenchman;

var array<PartySelectDynamicInfo> lstDynamicInfo;

var config int m_nStrMorinthName;

var config Name m_nmMorinthPlotState;

var config Name nmSpecialistLabel;

var config Name nmFireTeamLeaderLabel;

// srPartyQuestion: StringRefProperty[44]
// srPartyCancel: StringRefProperty[44]
// srPartyConfirm: StringRefProperty[44]
var config array<AdditionalAppearanceInfo> lstAppearances;

var config array<PartySelectMemberInfo> lstMemberInfo;

var transient bool m_bSFScreenInitialized;

var transient bool m_bNoSelectMode;

enum CharacterSelectState
{
    CharSel_Unknown,
    CharSel_Discovered,
    CharSel_Available,
    CharSel_InParty,
    CharSel_Forced,
    CharSel_Dead,
    CharSel_FireTeam,
    CharSel_Specialist,
};

struct PartySelectMemberInfo
{
    var Name Tag;

    var Name LoadoutTag;

    var int StrName;

    var int ImageIndex;

    var int KismetIndex;

    var Name DiscoveredLabel;

    var Name AvailableLabel;

    var Name InPartyLabel;

    var Name IsLoyalLabel;

    var Name IsSpecializedLabel;

    var Name OldLoyaltyLabel;

    var Name AppearanceLabel;

    var int DeadIndex;

    var int StrDossierText;

    var int StrSpecialty;

}

struct AdditionalAppearanceInfo
{
    var Name Tag;

    var int AddAppearance;

    var int PlotFlag;

}

struct PartySelectDynamicInfo
{
    var int Abilities[5];

    var int Ranks[5];

    var int Weapons[3];

}

delegate ExternalCallback_OnComplete();

function SetExternalCallback_OnComplete(delegate<ExternalCallback_OnComplete> pDelegate)
{
    __ExternalCallback_OnComplete__Delegate = pDelegate;
}

function ClearDelegates()
{
    __ExternalCallback_OnComplete__Delegate = None;
}

function OnPanelAdded()
{
    OnPanelAdded();
    PlayGuiSound('PartySelectOpen');
}

function OnPanelRemoved()
{
    PlayGuiSound('PartySelectClose');
    OnPanelRemoved();
    ClearDelegates();
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    local SFXEngine Engine;
    local BioPlayerController PC;
    PC = BioPlayerController(GetPlayerController());
    if (PC != None)
    {
        Engine = SFXEngine(PC.Player.Outer);
    }
    switch (nCommand)
    {
        case 1:
            if (Engine != None)
            {
                Engine.CurrentSaveGame.SaveHenchmen(Engine.CurrentUserID);
            }
            DoInitialization();
            break;
        case 2:
            if (m_bNoSelectMode)
            {
                ExitScreen();
            }
            else
            {
                PlayGuiSound('SelectParty');
                switch (lstArguments.Length)
                {
                    case 2:
                        m_nPartyMember1 = lstArguments[0];
                        m_nPartyMember2 = lstArguments[1];
                        break;
                    case 1:
                        m_nPartyMember1 = lstArguments[0];
                        m_nPartyMember2 = -1;
                        break;
                    default:
                        m_nPartyMember1 = -1;
                        m_nPartyMember2 = -1;
                }
                ConfirmParty();
            }
            break;
        case 3:
            if (lstArguments.Length >= 2)
            {
                SetCharacterAppearance(lstArguments[0], lstArguments[1]);
            }
            break;
        case 4:
            if (lstArguments.Length >= 2)
            {
                PlayConflict(lstArguments[0], lstArguments[1]);
            }
            break;
        case 5:
            if (lstArguments.Length >= 1)
            {
            }
            break;
    }
}

function SetCharacterAppearance(int nChar, int nAppearance)
{
    local BioGlobalVariableTable oGV;
    oGV = BioWorldInfo(oWorldInfo).GetGlobalVariables();
    if (nChar >= 0 && nChar < lstMemberInfo.Length)
    {
        oGV.SetIntByName(lstMemberInfo[nChar].AppearanceLabel, nAppearance);
    }
    else
    {
        PlayGuiSound('GuiError');
    }
}

function PlayConflict(int nChar1, int nChar2)
{
    if (nChar1 >= 0 && nChar1 < lstMemberInfo.Length && nChar2 >= 0 && nChar2 < lstMemberInfo.Length)
    {
    }
}

function SetInfo(Name nmTag, SFXPlayerSquadLoadoutData oLoadout)
{
    local int nChar;
    local int nSlot;
    local int nPower;
    local int nLoadoutPower;
    local int nExistingPower;
    local class<SFXPower> cPower;
    local class<SFXPower> cEvolvedPower;
    local BioPlayerController PC;
    local SFXEngine Engine;
    local int idx;
    local HenchmanSaveRecord oHenchData;
    nChar = lstMemberInfo.Find('Tag', nmTag);
    if (nChar == -1)
    {
        return;
    }
    if (lstDynamicInfo.Length < lstMemberInfo.Length)
    {
        // unknown bytecode 54 ;
    }
}

function SendInfo(int nChar)
{
    local array<ASParams> lstParams;
    local ASParams stParam;
    local int I;
    if (nChar < 0 || nChar >= lstDynamicInfo.Length)
    {
        return;
    }
    stParam.Type = 0;
    stParam.nVar = nChar;
    lstParams.AddItem(stParam);
    I = 0;
    while (I < 5)
    {
        stParam.nVar = lstDynamicInfo[nChar].Abilities[I];
        lstParams.AddItem(stParam);
        stParam.nVar = lstDynamicInfo[nChar].Ranks[I];
        lstParams.AddItem(stParam);
        I++;
    }
    I = 0;
    while (I < 3)
    {
        stParam.nVar = lstDynamicInfo[nChar].Weapons[I];
        lstParams.AddItem(stParam);
        I++;
    }
    oPanel.InvokeMethodArgs("SetInfo", lstParams);
}

function DoInitialization()
{
    local array<ASParams> lstParams;
    local ASParams stParam;
    local BioGlobalVariableTable oGV;
    local BioWorldInfo oBioWorld;
    local bool bNeed12Henchmen;
    local int nHench;
    local bool bSelected;
    local bool bDiscovered;
    local bool bAvailable;
    local bool bRequired;
    local bool bRequiredByScript;
    local bool bRequiredByPlot;
    local bool bLoyal;
    local bool bWasLoyal;
    local bool bDead;
    local bool bInFireTeam;
    local bool bIsSpecialist;
    local bool bIsNotDownloaded;
    local int nAppearanceMask;
    local int nAppearance;
    local int nState;
    local int nConflictMask;
    local int nStrName;
    oBioWorld = BioWorldInfo(oWorldInfo);
    oGV = oBioWorld.GetGlobalVariables();
    stParam.Type = 0;
    stParam.nVar = ScreenLayout;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("UpdatePlatformLayout", lstParams);
    lstParams.Length = 0;
    bNeed12Henchmen = false;
    nHench = 0;
    while (nHench < lstMemberInfo.Length)
    {
        if (lstMemberInfo[nHench].Tag == 'hench_veteran' || lstMemberInfo[nHench].Tag == 'hench_thief')
        {
            if (nmForcedHenchman == lstMemberInfo[nHench].Tag || oGV.GetBoolByName(lstMemberInfo[nHench].AvailableLabel) || oGV.GetBoolByName(lstMemberInfo[nHench].InPartyLabel) || lstMemberInfo[nHench].DiscoveredLabel == 'None' || oGV.GetBoolByName(lstMemberInfo[nHench].DiscoveredLabel))
            {
                bNeed12Henchmen = true;
                break;
            }
        }
        nHench++;
    }
    stParam.Type = 0;
    stParam.nVar = bNeed12Henchmen ? 2 : 1;
    lstParams.AddItem(stParam);
    stParam.Type = 3;
    stParam.bVar = m_bNoSelectMode;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("ResetState", lstParams);
    lstParams.Length = 0;
    nHench = 0;
    while (nHench < lstMemberInfo.Length)
    {
        nAppearanceMask = 1;
        nAppearance = 0;
        while (nAppearance < lstAppearances.Length)
        {
            if (lstAppearances[nAppearance].Tag == lstMemberInfo[nHench].Tag)
            {
                if (lstAppearances[nAppearance].PlotFlag >= 0)
                {
                    if (!BioWorldInfo(oWorldInfo).GetGlobalVariables().GetBool(lstAppearances[nAppearance].PlotFlag))
                    {
                    }
                }
                else
                {
                    nAppearanceMask = nAppearanceMask | 1 << lstAppearances[nAppearance].AddAppearance;
                }
            }
            nAppearance++;
        }
        bSelected = oGV.GetBoolByName(lstMemberInfo[nHench].InPartyLabel);
        bRequiredByScript = nmForcedHenchman == lstMemberInfo[nHench].Tag;
        bRequiredByPlot = !oGV.GetBoolByName(lstMemberInfo[nHench].AvailableLabel) && bSelected;
        bRequired = bRequiredByPlot || bRequiredByScript;
        bDiscovered = bRequired || lstMemberInfo[nHench].DiscoveredLabel == 'None' || oGV.GetBoolByName(lstMemberInfo[nHench].DiscoveredLabel);
        bAvailable = bRequired || oGV.GetBoolByName(lstMemberInfo[nHench].AvailableLabel);
        bIsNotDownloaded = lstMemberInfo[nHench].Tag == 'hench_thief' && !oGV.GetBool(2288) || lstMemberInfo[nHench].Tag == 'hench_veteran' && !oGV.GetBool(2289);
        bLoyal = oGV.GetBoolByName(lstMemberInfo[nHench].IsLoyalLabel);
        bWasLoyal = oGV.GetBoolByName(lstMemberInfo[nHench].OldLoyaltyLabel);
        bDead = oGV.GetBool(lstMemberInfo[nHench].DeadIndex);
        nAppearance = oGV.GetIntByName(lstMemberInfo[nHench].AppearanceLabel);
        bInFireTeam = oGV.GetIntByName(nmFireTeamLeaderLabel) - 1 == lstMemberInfo[nHench].KismetIndex;
        bIsSpecialist = oGV.GetIntByName(nmSpecialistLabel) - 1 == lstMemberInfo[nHench].KismetIndex;
        nConflictMask = 0;
        if (bRequired)
        {
            nState = 4;
        }
        else
        {
            if (bDead)
            {
                nState = 5;
            }
            else
            {
                if (bInFireTeam)
                {
                    nState = 6;
                }
                else
                {
                    if (bIsSpecialist)
                    {
                        nState = 7;
                    }
                    else
                    {
                        if (!bAvailable && !bDiscovered)
                        {
                            nState = 0;
                        }
                        else
                        {
                            if (!bAvailable)
                            {
                                nState = 1;
                            }
                            else
                            {
                                nState = 2;
                            }
                        }
                    }
                }
            }
        }
        stParam.Type = 0;
        stParam.nVar = nHench;
        lstParams.AddItem(stParam);
        stParam.nVar = lstMemberInfo[nHench].ImageIndex;
        lstParams.AddItem(stParam);
        nStrName = lstMemberInfo[nHench].StrName;
        if (lstMemberInfo[nHench].Tag == 'hench_mystic' && oGV.GetBoolByName(m_nmMorinthPlotState))
        {
            nStrName = m_nStrMorinthName;
        }
        stParam.Type = 2;
        stParam.sVar = Class'SFXGame'.GetSimpleString(nStrName);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = nState;
        lstParams.AddItem(stParam);
        stParam.Type = 3;
        stParam.bVar = bLoyal;
        lstParams.AddItem(stParam);
        stParam.bVar = bIsNotDownloaded;
        lstParams.AddItem(stParam);
        stParam.bVar = bWasLoyal;
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = nAppearanceMask;
        lstParams.AddItem(stParam);
        stParam.nVar = nAppearance;
        lstParams.AddItem(stParam);
        stParam.nVar = nConflictMask;
        lstParams.AddItem(stParam);
        stParam.nVar = lstMemberInfo[nHench].StrDossierText;
        lstParams.AddItem(stParam);
        stParam.nVar = 0;
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("InitializePartyMember", lstParams);
        lstParams.Length = 0;
        if (lstDynamicInfo[nHench].Abilities[0] != 0)
        {
            SendInfo(nHench);
        }
        oGV.SetBoolByName(lstMemberInfo[nHench].InPartyLabel, false);
        oGV.SetBoolByName(lstMemberInfo[nHench].OldLoyaltyLabel, bLoyal);
        nHench++;
    }
    m_bSFScreenInitialized = true;
    oPanel.InvokeMethod("FinishInitialize");
}

function ConfirmParty()
{
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    oMsgBox = MassEffectGuiManager(oPanel.oParentManager).CreateMessageBox();
    oMsgBox.SetInputDelegate(FinalizeParty);
    stParams.srAText = srPartyConfirm;
    stParams.srBText = srPartyCancel;
    oMsgBox.DisplayMessageBox(srPartyQuestion, stParams);
}

function FinalizeParty(bool bAPressed, int nContext)
{
    local BioGlobalVariableTable oGV;
    if (bAPressed)
    {
        oGV = BioWorldInfo(oWorldInfo).GetGlobalVariables();
        if (m_nPartyMember1 != -1)
        {
            oGV.SetBoolByName(lstMemberInfo[m_nPartyMember1].InPartyLabel, true);
            Class'BioTelemetry'.SendEventName('PLAYER_SELECT_HENCHMAN', lstMemberInfo[m_nPartyMember1].Tag);
        }
        if (m_nPartyMember2 != -1)
        {
            oGV.SetBoolByName(lstMemberInfo[m_nPartyMember2].InPartyLabel, true);
            Class'BioTelemetry'.SendEventName('PLAYER_SELECT_HENCHMAN', lstMemberInfo[m_nPartyMember2].Tag);
        }
        ExitScreen();
    }
    else
    {
        oPanel.InvokeMethod("CancelSelection");
    }
}

function ExitScreen()
{
    if (__ExternalCallback_OnComplete__Delegate == None)
    {
        MassEffectGuiManager(oPanel.oParentManager).HidePartySelect();
    }
    else
    {
        ExternalCallback_OnComplete();
    }
}

defaultproperties
{
    lstMemberInfo=System.Byte[]
    lstAppearances=System.Byte[]
    srPartyConfirm=System.Byte[]
    srPartyCancel=System.Byte[]
    srPartyQuestion=System.Byte[]
    nmFireTeamLeaderLabel=FireTeamLeader
    nmSpecialistLabel=Specialist
    m_nmMorinthPlotState=Morinth_not_Samara
    m_nStrMorinthName=191150
    nHandlerID=13
}
