﻿class BioSFHandler_Splash extends BioSFHandler
    config(UI)
    transient
    native;

const FadeoutComplete = 1;
const FadeinComplete = 2;
const AnyKeyPressed = 3;
const Init = 4;
// srCancelNoLoginStart: StringRefProperty[44]
// srConfirmNoLoginStart: StringRefProperty[44]
// srNoLoginStart: StringRefProperty[44]
var bool bPressedStart;

var config bool bSuppressAttractMode;

var config float fShowLegalTime;

var config float fAttractModeDelay;

var float fLegalTimeout;

var float fAttractModeTimeout;

function CheckLogin()
{
    local MassEffectGuiManager GuiMan;
    local int ControllerId;
    local OnlineSubsystem OnlineSub;
    local LocalPlayer LP;
    if (Class'WorldInfo'.IsConsoleBuild() == false)
    {
        AdvanceScreen();
        return;
    }
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        LP = LocalPlayer(GuiMan.Player.Player);
        ControllerId = LP.ControllerId;
    }
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSub != None)
    {
        PlayerInt = OnlineSub.PlayerInterface;
        SystemInt = OnlineSub.SystemInterface;
        if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)) && NotEqual_InterfaceInterface(SystemInt, OnlineSystemInterface(None)))
        {
            if (PlayerInt.GetLoginStatus(ControllerId) == 0)
            {
                SystemInt.AddExternalUIChangeDelegate(Callback_LoginComplete);
                if (!PlayerInt.ShowLoginUI())
                {
                    SystemInt.ClearExternalUIChangeDelegate(Callback_LoginComplete);
                    AdvanceScreen();
                }
                return;
            }
        }
    }
    AdvanceScreen();
}

function Callback_LoginComplete(bool bIsOpening)
{
    local OnlineSubsystem OnlineSub;
    local MassEffectGuiManager GuiMan;
    local int ControllerId;
    if (!bIsOpening)
    {
        OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
        if (OnlineSub != None)
        {
            SystemInt = OnlineSub.SystemInterface;
            PlayerInt = OnlineSub.PlayerInterface;
            GuiMan = MassEffectGuiManager(oPanel.oParentManager);
            if (NotEqual_InterfaceInterface(SystemInt, OnlineSystemInterface(None)))
            {
                SystemInt.ClearExternalUIChangeDelegate(Callback_LoginComplete);
            }
            if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)) && GuiMan != None)
            {
                ControllerId = LocalPlayer(GuiMan.Player.Player).ControllerId;
                if (PlayerInt.GetLoginStatus(ControllerId) != 0)
                {
                    AdvanceScreen();
                }
                else
                {
                    DisplayNoProfileConfirmation();
                }
            }
        }
    }
}

function DisplayNoProfileConfirmation()
{
    local MassEffectGuiManager GuiMan;
    local BioMessageBoxOptionalParams Params;
    GuiMan = MassEffectGuiManager(oPanel.oParentManager);
    if (GuiMan != None)
    {
        Params.srAText = srConfirmNoLoginStart;
        Params.srBText = srCancelNoLoginStart;
        Params.bModal = true;
        Params.bNoFade = true;
        GuiMan.QueueNamedMessageBox('ConfirmNoProfile', 2, srNoLoginStart, Params, Callback_NoLoginStart);
    }
    else
    {
        AdvanceScreen();
    }
}

function Callback_NoLoginStart(bool bAPressed, int Context)
{
    if (bAPressed)
    {
        AdvanceScreen();
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 21:
            CheckLogin();
            break;
    }
}

event AdvanceScreen()
{
    local BioPlayerController PC;
    local OnlineSubsystem OnlineSub;
    local SFXEngine Engine;
    PC = BioPlayerController(oPanel.oParentManager.GetPlayerController());
    OnlineSub = Class'GameEngine'.GetOnlineSubsystem();
    if (PC != None && PC.Player != None && OnlineSub != None)
    {
        PlayerInt = OnlineSub.PlayerInterface;
        Engine = SFXEngine(PC.Player.Outer);
        if (NotEqual_InterfaceInterface(PlayerInt, OnlinePlayerInterface(None)) && Engine != None)
        {
            PlayerInt.GetUniquePlayerId(LocalPlayer(PC.Player).ControllerId, Engine.m_oInitialPlayerID);
        }
    }
    bPressedStart = true;
    oPanel.SetInputDisabled(true);
    fAttractModeTimeout = 0;
    oPanel.InvokeMethod("DoTransition");
    BioWorldInfo(oWorldInfo).GetLocalPlayerController().CauseEvent('startpressed');
    PlayGuiSound('SplashStart');
}

function HandleEvent(byte nCommand, const out array<String> lstArguments)
{
    switch (nCommand)
    {
        case 1:
            oPanel.oParentManager.RemovePanel(oPanel);
            break;
        case 2:
            oPanel.SetInputDisabled(false);
            break;
        case 4:
            Initialize();
            break;
    }
}

function Initialize()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    local BioPlayerController PC;
    stParam.Type = 0;
    stParam.nVar = ScreenLayout;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("Initialize", lstParams);
    PC = BioPlayerController(GetPlayerController());
    if (PC != None)
    {
        PC.GameModeManager2.DisableMode(8);
    }
}

function Update(float fDeltaT)
{
    if (fAttractModeTimeout > 0)
    {
        fAttractModeTimeout -= fDeltaT;
        if (fAttractModeTimeout <= 0 && !bSuppressAttractMode)
        {
            oWorldInfo.SetLockInputToControllerOnNextInput(false, 'XboxTypeS_Start');
            StopGuiMusic();
            BioWorldInfo(oWorldInfo).GetLocalPlayerController().CauseEvent('startattractmode');
            oPanel.oParentManager.RemovePanel(oPanel);
            MassEffectGuiManager(oPanel.oParentManager).RemoveNamedMessageBox('ConfirmNoProfile');
        }
        else
        {
            if (fLegalTimeout > 0)
            {
                fLegalTimeout -= fDeltaT;
                if (fLegalTimeout <= 0)
                {
                    oPanel.InvokeMethod("FadeLegal");
                }
            }
        }
    }
}

function StartTimeout(bool bShowLegal)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    fAttractModeTimeout = fAttractModeDelay;
    fLegalTimeout = bShowLegal ? fShowLegalTime : -1;
    stParam.Type = 3;
    stParam.bVar = bShowLegal;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("FadeIn", lstParams);
}

function OnPanelAdded()
{
    local WorldInfo oWorld;
    oWorld = Class'Engine'.GetCurrentWorldInfo();
    oWorld.SetLockInputToControllerOnNextInput(true, 'XboxTypeS_Start');
    PlayGuiMusic('MainMenu');
    oPanel.SetInputDisabled(true);
    fAttractModeTimeout = 0;
    if (BioWorldInfo(oWorld).m_playerSquad != None && BioWorldInfo(oWorld).m_playerSquad.m_playerPawn != None)
    {
        BioWorldInfo(oWorld).m_playerSquad.m_playerPawn.SetRichPresence();
    }
    OnPanelAdded();
}

defaultproperties
{
    fAttractModeDelay=60
    fShowLegalTime=15
    srNoLoginStart=System.Byte[]
    srConfirmNoLoginStart=System.Byte[]
    srCancelNoLoginStart=System.Byte[]
    nHandlerID=31
}
