﻿class BioSPGame extends SFXGame
    hidecategories(Navigation,Movement,Collision)
    config(Game)
    native;

// srGameOverString: StringRefProperty[44]
var TextureMovie m_oTextureMovie;

var /* 00000008 */ transient AudioComponent m_oLogoMovieAudioComponent;

function StartMatch()
{
    StartMatch();
    BioWorldInfo(WorldInfo).StartMatch();
}

native function ExtractLogoMovieSettings(out int nShouldPlay, out int nIsInterruptable);

native function SetupPartyMemberAttributes(BioPawnBehavior Behavior, class<Object> attributesClass);

event PostLogin(PlayerController NewPlayer)
{
    local int nShouldPlay;
    local int nIsInterruptable;
    PostLogin(NewPlayer);
    ExtractLogoMovieSettings(nShouldPlay, nIsInterruptable);
    if (nShouldPlay != 0)
    {
        BioHUD(NewPlayer.myHUD).m_moviePlayer.SetTextureMovie(m_oTextureMovie);
        BioHUD(NewPlayer.myHUD).m_moviePlayer.__OnMovieFinished__Delegate = OnMovieFinished;
    }
}

function OnMovieFinished(TextureMovie TextureMovie)
{
    m_oLogoMovieAudioComponent.Stop();
}

function Reset()
{
    Reset();
    GotoState('PendingMatch');
}

state PendingMatch
{
    StartMatch();
    jump 0;
    // unresolved reference 0 ;
}

final function SpawnGameOverGUI()
{
    local BioPlayerController pController;
    pController = BioWorldInfo(WorldInfo).GetLocalPlayerController();
    MassEffectGuiManager(pController.GetScaleFormManager()).ShowGameOverGui(srGameOverString);
    MassEffectGuiManager(pController.GetScaleFormManager()).CancelHint();
}

defaultproperties
{
    BonusList=SFXBonusList'Bonus'
    // child object Bonus of type SFXBonusList
}
