﻿class BioSaveGame extends Object
    config(Game)
    native;

struct native PlayerInfoEx
{
    var class<SFXPawn_Player> CharacterClass;

    var bool bIsFemale;

    var String FirstName;

    var EOriginType Origin;

    var ENotorietyType Notoriety;

    var BioMorphFace MorphHead;

    var String BonusTalentClass;

    var String FaceCode;

}

struct native BioSimpleTalentSave
{
    var int m_TalentID;

    var int m_Ranks;

}

struct native BioComplexTalentSave
{
    var int m_TalentID;

    var int m_Ranks;

    var int m_MaxRank;

    var int m_LevelOffset;

    var int m_LevelsPerRank;

    var int m_VisualOrder;

    var array<int> m_PrereqTalentIDArray;

    var array<int> m_PrereqTalentRankArray;

}

var array<String> m_DependentPackages;

var array<int> m_DependentDLC;

var transient Vector m_DesiredPosition;

var transient Name m_DesiredStartPoint;

var transient Package m_PlayerPackage;

var bool m_bInvalidSaveFileCreator;

var bool bStartedGame;

var transient bool m_UseDesiredStartPoint;

var transient bool bNewPlayer;

var transient config PlayerInfoEx DefaultPlayer;

var transient PlayerInfoEx NewPlayer;

var BioBaseSaveObject MorphHead;

var BioBaseSaveObject m_PlayerController;

var BioBaseSaveObject m_Player;

var String m_sMapName;

var transient SFXLegacyData ImportedDataManager;

struct native SaveGameRecord
{
    var String m_filename;

    var String m_saveName;

    var String m_saveNameShort;

    var int m_sec;

    var int m_Min;

    var int m_hr;

    var int m_day;

    var int m_mo;

    var int m_year;

    var int m_secPlayed;

    var int m_minPlayed;

    var int m_hrPlayed;

    var String m_charId;

    var int m_ClassId;

    var int m_CharcterLevel;

    var bool m_bCanDelete;

    var int m_DeviceId;

    var int m_SaveGameNumber;

    var bool m_bIsAutoSave;

    var bool m_bIsQuickSave;

}

native function Package GetPlayerPackage();

function ResetToDefaults()
{
    bStartedGame = Default.bStartedGame;
    m_sMapName = Default.m_sMapName;
    m_DesiredStartPoint = Default.m_DesiredStartPoint;
    m_DesiredPosition = Default.m_DesiredPosition;
    m_UseDesiredStartPoint = Default.m_UseDesiredStartPoint;
    m_PlayerPackage = Default.m_PlayerPackage;
    m_Player = Default.m_Player;
    m_PlayerController = Default.m_PlayerController;
    MorphHead = Default.MorphHead;
    m_DependentDLC.Length = 0;
}

function BioPawnBehaviorSaveObject GetPlayerSaveObject()
{
    return BioPawnBehaviorSaveObject(m_Player);
}

final private function LoadObjectPosition(BioBaseSaveObject Save, Actor Obj)
{
    local BioActorBehaviorSaveObject savedBehavior;
    local BioActorSaveObject SaveObject;
    savedBehavior = BioActorBehaviorSaveObject(Save);
    SaveObject = BioActorSaveObject(savedBehavior.Owner);
    SaveObject.LoadPositionAndOrientation(Obj);
}

event SavePlayerParty(BioPlayerController PlayerController, optional Package savePackage)
{
    local BioPawnBehavior playerBehavior;
    if (savePackage == None)
    {
        savePackage = GetPlayerPackage();
    }
    playerBehavior = BioPawn(PlayerController.Pawn).m_oBehavior;
    m_PlayerController = PlayerController.WriteSaveObject(savePackage);
    m_Player = playerBehavior.WriteSaveObject(savePackage);
    MorphHead = BioPawn(PlayerController.Pawn).MorphHead.WriteSaveObject(savePackage);
}

function bool LoadPlayer(BioPawn Player)
{
    if (m_Player != None)
    {
        Player.m_oBehavior.ReadSaveObject(m_Player);
        Player.Controller.ReadSaveObject(m_PlayerController);
        Player.MorphHead.ReadSaveObject(MorphHead);
        m_Player = None;
        m_PlayerController = None;
        MorphHead = None;
        return true;
    }
    return false;
}

defaultproperties
{
    ImportedDataManager=SFXLegacyData'ImportedDataManager0'
    // child object ImportedDataManager0 of type SFXLegacyData
}
