﻿class BioSeqAct_ActionStation extends BioSequenceLatentAction
    hidecategories(Object)
    native;

enum EBioActionStationExitCondition
{
    BIO_AS_NONE,
    BIO_AS_EXIT,
    BIO_AS_COMBAT_EXIT,
    BIO_AS_INTERRUPT,
    BIO_AS_FAIL,
    BIO_AS_ABORT_TWITCHES,
};

enum EBioActionStationEntrancePose
{
    BIO_AS_ENTRANCEPOSE_UNSET,
};

enum EBioActionStationExitPose
{
    BIO_AS_EXITPOSE_UNSET,
};

enum EBioActionStationCombatPose
{
    BIO_AS_COMBATPOSE_UNSET,
};

struct native BioActionStationGestureData
{
    var Name nmPoseSet;

    var Name nmPoseAnim;

    var Name nmTransitionSet;

    var Name nmTransitionAnim;

    var Name nmEnumName;

}

struct native ActionStationOffsetData
{
    var() Name nmAnimSet;

    var() Vector vOffset;

    var() Rotator rRotation;

}

var transient bool m_bTwitchesAborted;

var transient bool m_bFireFailedPin;

var transient bool m_bStartedSuccessfully;

var transient bool m_bInEntranceTransition;

var transient int m_nTwitchStartIndex;

var transient BioGestureRulesData m_RulesData;

var BioActionStationGestureData m_CombatExitTransition;

var BioActionStationGestureData m_ExitTransition;

var BioActionStationGestureData m_EntranceTransition;

var float m_fTimeToSpend;

var float m_fTimeSpent;

var float m_fDelayBeforeTwitch;

var(Animations) float m_fExitBlendTime;

var(Animations) float m_fEntranceBlendTime;

var EBioActionStationExitCondition m_nExitCondition;

var(Animations) EBioActionStationCombatPose m_PawnCombatExitTransition;

var(Animations) EBioActionStationExitPose m_PawnExitTransition;

var(Animations) EBioActionStationEntrancePose m_PawnEntranceTransition;

var(Duration) int m_nNumOutputTwitches;

var(Duration) RawDistributionFloat m_TimeToSpend;

var(PathNode) Vector m_vPathNodeOffset;

var bool m_bResourcesReferenced;

var bool m_bActionStationComplete;

var bool m_bPawnInConversation;

var(Duration) bool m_bPlayTwitchesInOrder;

var(PathNode) bool m_bDontMovePathnode;

var(Inputs) bool m_bSnapToPose;

var(Inputs) BioPathPoint m_oPathNode;

var(Inputs) BioArtPlaceable m_oArtPlaceable;

var(Inputs) BioPawn m_oPawn;

defaultproperties
{
    m_nNumOutputTwitches=1
    m_fEntranceBlendTime=0,1
    m_fExitBlendTime=0,1
    m_fTimeToSpend=-1
    InputLinks=None
    // child object Dist of type DistributionFloatUniform
}
