﻿class BioSeqAct_AddToParty extends SequenceAction
    hidecategories(Object);

var() float TeleportOffsetSide;

var() float TeleportOffsetRear;

var() bool TeleportToLeader;

function Activated()
{
    local array<Object> aLeaderObjects;
    local array<Object> aFollowerObjects;
    local BioPawn leader;
    local BioPawn follower;
    local BioBaseSquad oSquad;
    local int I;
    local int J;
    local Vector TargetLocation;
    local Vector vCross;
    local Vector vTeleportLocation;
    local bool bIsPlayerSquad;
    local SFXPawn_Henchman Henchman;
    local SFXAI_Henchman oHenchAI;
    bIsPlayerSquad = false;
    GetObjectVars(aLeaderObjects, "Leader");
    GetObjectVars(aFollowerObjects, "Follower");
    I = 0;
    while (I < aFollowerObjects.Length)
    {
        if (BioPlayerController(Pawn(aFollowerObjects[I]).Controller) != None)
        {
            OutputLinks[0].bHasImpulse = false;
            OutputLinks[1].bHasImpulse = true;
            return;
        }
        ++I;
    }
    I = 0;
    while (I < aLeaderObjects.Length)
    {
        if (BioPlayerController(aLeaderObjects[I]) != None)
        {
            leader = BioPawn(BioPlayerController(aLeaderObjects[I]).Pawn);
            bIsPlayerSquad = true;
        }
        else
        {
            leader = BioPawn(aLeaderObjects[I]);
        }
        oSquad = None;
        if (leader != None)
        {
            oSquad = leader.m_oBehavior.Squad;
        }
        if (oSquad == None)
        {
            oSquad = BioBaseSquad(aLeaderObjects[I]);
        }
        if (oSquad == None)
        {
        }
        else
        {
            J = 0;
            while (J < aFollowerObjects.Length)
            {
                follower = BioPawn(aFollowerObjects[J]);
                if (follower == None || BioAiController(follower.Controller) == None || oSquad.GetMemberIndex(follower) != -1)
                {
                }
                else
                {
                    if (TeleportToLeader)
                    {
                        TargetLocation = leader.Location - leader.Rotation * TeleportOffsetRear;
                        vCross = leader.Rotation Cross vect(0,0,1);
                        if (oSquad.GetSquadSize() < 2)
                        {
                            TargetLocation -= vCross * TeleportOffsetSide;
                        }
                        else
                        {
                            TargetLocation += vCross * TeleportOffsetSide;
                        }
                        oHenchAI = SFXAI_Henchman(follower.Controller);
                        if (bIsPlayerSquad && oHenchAI != None)
                        {
                            if (oHenchAI.FindNearestOpenLocation(TargetLocation, vTeleportLocation, leader))
                            {
                                follower.SafeSetLocation(vTeleportLocation);
                            }
                            else
                            {
                                TargetLocation = leader.Location + leader.Rotation * TeleportOffsetRear;
                                if (oHenchAI.FindNearestOpenLocation(TargetLocation, vTeleportLocation, leader))
                                {
                                    follower.SafeSetLocation(vTeleportLocation);
                                    jump 872;
                                }
                            }
                        }
                        else
                        {
                            follower.SetLocation(TargetLocation);
                        }
                    }
                    oSquad.AddMember(follower);
                    Henchman = SFXPawn_Henchman(follower);
                    if (bIsPlayerSquad && Henchman != None)
                    {
                        Henchman.InitializeHenchman(leader.CharacterLevel);
                    }
                }
                J++;
            }
            break;
        }
        I++;
    }
    OutputLinks[0].bHasImpulse = true;
    OutputLinks[1].bHasImpulse = false;
    return;
}

defaultproperties
{
    TeleportOffsetRear=60
    TeleportOffsetSide=60
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
