﻿class BioSeqAct_BlackScreen extends BioSequenceLatentAction
    hidecategories(Object)
    native;

enum BlackScreenActionSet
{
    BlackScreenAction_TurnBlackOn,
    BlackScreenAction_TurnBlackOff,
    BlackScreenAction_FadeToBlack,
    BlackScreenAction_FadeFromBlack,
};

var() float fTimeDelay;

var transient float fTimeExpired;

var() BlackScreenActionSet m_eBlackScreenAction;

event Activated()
{
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    fTimeExpired = 0;
    if (oController != None)
    {
        switch (m_eBlackScreenAction);
        case 0;
        MassEffectGuiManager(oController.GetScaleFormManager()).ShowBlackScreen(false);
        jump 233;
        case 1;
        MassEffectGuiManager(oController.GetScaleFormManager()).HideBlackScreen(false);
        jump 233;
        case 3;
        MassEffectGuiManager(oController.GetScaleFormManager()).HideBlackScreen(true);
        jump 233;
        case 2;
        MassEffectGuiManager(oController.GetScaleFormManager()).ShowBlackScreen(true);
        jump 233;
        default;
        jump 233;
    }
    OutputLinks[0].bHasImpulse = false;
    OutputLinks[1].bHasImpulse = false;
    OutputLinks[2].bHasImpulse = false;
    return;
}

function bool UpdateOp(float fDeltaT)
{
    local bool bFinished;
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    oWorldInfo = BioWorldInfo(GetWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    bFinished = false;
    fTimeExpired += fDeltaT;
    if (oController != None)
    {
        switch (m_eBlackScreenAction);
        case 0;
        if (!fTimeDelay > 0) jump 126;
        if (!fTimeExpired >= fTimeDelay) jump 123;
        bFinished = true;
        jump 134;
        bFinished = true;
        jump 209;
        case 1;
        bFinished = true;
        jump 209;
        case 3;
        case 2;
        bFinished = MassEffectGuiManager(oController.GetScaleFormManager()).BlackScreenFadeFinished();
        jump 209;
        default;
        jump 209;
    }
    OutputLinks[0].bHasImpulse = bFinished;
    OutputLinks[1].bHasImpulse = false;
    OutputLinks[2].bHasImpulse = false;
    return bFinished;
}

defaultproperties
{
    bHasTargets=false
    bManualHandleOutputs=true
    VariableLinks=None
}
