﻿class BioSeqAct_PlotTreasureTester extends SequenceAction
    hidecategories(Object);

function Activated()
{
    local BioWorldInfo oWorldInfo;
    local SFXPlotTreasure oTreasure;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    oTreasure = oWorldInfo.m_oTreasure;
    Validate(oTreasure);
}

static function Validate(SFXPlotTreasure oTreasure)
{
    ValidateResourcesSheet(oTreasure);
    ValidateTreasureSheet(oTreasure);
    ValidateTechSheet(oTreasure);
}

static function ValidateResourcesSheet(SFXPlotTreasure oTreasure)
{
    local SResourceBudget stResource;
    local Name nmLevel;
    local int I;
    local int nCredits;
    local int Eezo;
    local int Palladium;
    local int Platinum;
    local int Iridium;
    local int Id;
    if (oTreasure.oPlotTreasureResources2DA.GetNumRows() < 2)
    {
    }
    I = 0;
    while (I != oTreasure.oPlotTreasureResources2DA.GetNumRows())
    {
        nmLevel = oTreasure.oPlotTreasureResources2DA.GetRowName(I);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Credits', nCredits);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Eezo', Eezo);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Palladium', Palladium);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Platinum', Platinum);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Iridium', Iridium);
        oTreasure.oPlotTreasureResources2DA.GetIntEntryIN(I, 'Id', Id);
        if (nmLevel == 'None')
        {
        }
        if (nCredits < 100 && Eezo < 100 && Palladium < 100 && Iridium < 100)
        {
        }
        stResource = oTreasure.Budget(nmLevel);
        if (stResource.nCredits != nCredits)
        {
        }
        if (stResource.nEezo != Eezo)
        {
        }
        if (stResource.nPalladium != Palladium)
        {
        }
        if (stResource.nPlatinum != Platinum)
        {
        }
        if (stResource.nIridium != Iridium)
        {
        }
        if (stResource.nID != Id)
        {
        }
        ++I;
    }
}

static function ValidateTreasureSheet(SFXPlotTreasure oTreasure)
{
    local int I;
    local STreasure stTreasure;
    local STech stTech;
    local Name nmLevel;
    local Name nmTreasure;
    local Name nmTech;
    local Name nmResource;
    local Name nmRequiredTech;
    local int nTreasureId;
    local int nPrice;
    local int nRequiredTechLevel;
    if (oTreasure.oPlotTreasureTreasure2DA.GetNumRows() < 2)
    {
    }
    I = 0;
    while (I != oTreasure.oPlotTreasureTreasure2DA.GetNumRows())
    {
        nTreasureId = oTreasure.oPlotTreasureTreasure2DA.GetRowNumber(I);
        oTreasure.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmLevel', nmLevel);
        oTreasure.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTreasure', nmTreasure);
        oTreasure.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmTech', nmTech);
        oTreasure.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmResource', nmResource);
        oTreasure.oPlotTreasureTreasure2DA.GetIntEntryIN(I, 'nPrice', nPrice);
        oTreasure.oPlotTreasureTreasure2DA.GetNameEntryIN(I, 'nmRequiredTech', nmRequiredTech);
        oTreasure.oPlotTreasureTreasure2DA.GetIntEntryIN(I, 'nRequiredTechLevel', nRequiredTechLevel);
        if (nmLevel == 'None')
        {
        }
        if (nmTreasure == 'None')
        {
        }
        if (nmTech == 'None')
        {
        }
        stTech = oTreasure.tech(nmTech);
        if (stTech.nmTech == 'None')
        {
        }
        switch (nmResource)
        {
            case 'None':
            case 'Credits':
            case 'Eezo':
            case 'Iridium':
            case 'Palladium':
            case 'Platinum':
            case 'Probes':
                break;
        }
        if (nmResource == 'None' && nPrice != 0)
        {
        }
        if (nmResource != 'None' && nPrice == 0)
        {
        }
        stTech = oTreasure.tech(nmRequiredTech);
        if (nmRequiredTech != 'None' && stTech.nmTech != nmRequiredTech)
        {
        }
        if (nmRequiredTech != 'None' && nRequiredTechLevel <= 0)
        {
        }
        if (nmRequiredTech == 'None' && nRequiredTechLevel != 0)
        {
        }
        stTreasure = oTreasure.TREASURE(nTreasureId);
        if (stTreasure.nmLevel != nmLevel)
        {
        }
        if (stTreasure.nmRequiredTech != nmRequiredTech)
        {
        }
        if (stTreasure.nmTech != nmTech)
        {
        }
        if (stTreasure.nmTreasure != nmTreasure)
        {
        }
        if (stTreasure.nTreasureId != nTreasureId)
        {
        }
        if (stTreasure.RequiredTechLevel != nRequiredTechLevel)
        {
        }
        if (stTreasure.ResourcePrice != nPrice)
        {
        }
        ++I;
    }
}

static function ValidateTechSheet(SFXPlotTreasure oTreasure)
{
    local Name nmTech;
    local STech stTech;
    local int I;
    local int nSrTitle;
    local int nSrName;
    local int nSrMessage;
    local int nSrDescription;
    local int nLevels;
    if (oTreasure.oPlotTreasureTech2DA.GetNumRows() < 2)
    {
    }
    I = 0;
    while (I != oTreasure.oPlotTreasureTech2DA.GetNumRows())
    {
        oTreasure.oPlotTreasureTech2DA.GetNameEntryIN(I, 'nmTech', nmTech);
        oTreasure.GetPlotTreasureTechInt(nmTech, 'nmTech', 'srTitle', nSrTitle);
        oTreasure.GetPlotTreasureTechInt(nmTech, 'nmTech', 'srName', nSrName);
        oTreasure.GetPlotTreasureTechInt(nmTech, 'nmTech', 'srMessage', nSrMessage);
        oTreasure.GetPlotTreasureTechInt(nmTech, 'nmTech', 'srDescription', nSrDescription);
        oTreasure.GetPlotTreasureTechInt(nmTech, 'nmTech', 'nLevels', nLevels);
        if (nmTech == 'None')
        {
        }
        stTech = oTreasure.tech(nmTech);
        if (stTech.nmTech == 'None')
        {
        }
        if (stTech.nmTech != nmTech)
        {
        }
        if (stTech.srName != nSrName)
        {
        }
        if (stTech.srTitle != nSrTitle)
        {
        }
        if (stTech.srMessage != nSrMessage)
        {
        }
        if (stTech.srDescription != nSrDescription)
        {
        }
        if (stTech.nLevels != nLevels)
        {
        }
        ++I;
    }
}

defaultproperties
{
    ObjName="Test Plot Treasure"
}
