﻿class BioSeqAct_ShowChoiceGUI extends BioSequenceLatentAction
    hidecategories(Object)
    native;

var EInventoryResourceTypes m_eResource;

var Name m_nmResource;

var Name m_nmTag;

var transient int m_nInitialSelectionID;

var transient int m_nSelectionID;

var transient BioSFHandler_ChoiceGUI m_ChoiceGUIHandler;

var transient int m_nSelectionIndex;

var transient bool m_bWasPaused;

var transient bool m_bAPressed;

var transient bool m_bAborted;

var transient bool m_bFinished;

var int m_nOptionalPaneValue;

// m_srOptionalPaneValuePrefixText: StringRefProperty[44]
// m_srOptionalPaneItemValuePrefixText: StringRefProperty[44]
// m_srOptionalPaneTitleText: StringRefProperty[44]
// m_srBButton: StringRefProperty[44]
// m_srAButton: StringRefProperty[44]
// m_srSubTitle: StringRefProperty[44]
// m_srTitle: StringRefProperty[44]
var() bool m_bAutoClose;

var bool m_ShowOptionalPane;

var bool m_OverrideExistingChoiceData;

function bool UpdateOp(float fDeltaT)
{
    local BioPlayerController PC;
    local BioWorldInfo WorldInfo;
    if (m_bAborted != false)
    {
        m_bFinished = false;
        if (OutputLinks.Length > 2)
        {
            OutputLinks[2].bHasImpulse = true;
        }
        m_bAborted = false;
        return true;
    }
    if (m_bFinished)
    {
        m_bFinished = false;
        if (m_ChoiceGUIHandler != None)
        {
            if (m_bAutoClose != false)
            {
                m_ChoiceGUIHandler.HideChoiceGUI(true);
                WorldInfo = BioWorldInfo(GetWorldInfo());
                if (WorldInfo != None)
                {
                    PC = WorldInfo.GetLocalPlayerController();
                    if (PC != None)
                    {
                        PC.GameModeManager2.DisableMode(7, 'ChoiceGUI');
                    }
                }
            }
            m_ChoiceGUIHandler = None;
        }
        if (m_bAPressed)
        {
            OutputLinks[0].bHasImpulse = true;
        }
        else
        {
            OutputLinks[1].bHasImpulse = true;
        }
        return true;
    }
    return false;
}

final function ChoiceGUIInputPressed(bool bAPressed, int nContext)
{
    local SFXGameChoiceGUIData oData;
    local int nChoiceID;
    m_bFinished = true;
    m_bAPressed = bAPressed;
    m_nSelectionIndex = nContext;
    SetIntVars("SelectionIndex", nContext);
    nChoiceID = -1;
    if (VariableLinks[0].LinkedVariables.Length > 0)
    {
        oData = BioSeqVar_ChoiceGUIData(VariableLinks[0].LinkedVariables[0]).m_ChoiceData;
        if (oData != None)
        {
            if (nContext >= 0 && nContext < oData.lstChoices.Length)
            {
                nChoiceID = oData.lstChoices[nContext].nChoiceID;
            }
        }
    }
    SetIntVars("SelectionID", nChoiceID);
    GetWorldInfo().bPlayersOnly = m_bWasPaused;
}

defaultproperties
{
    m_bAutoClose=true
    m_nmTag=ChoiceGUI
    bHasTargets=false
    bCallHandler=false
    bManualHandleOutputs=true
    OutputLinks=None
}
