﻿class BioSkillGame extends BioBaseComponent
    native;

enum EBioSkillGame
{
    SKILL_GAME_DECRYPTION,
    SKILL_GAME_ELECTRONICS,
    SKILL_GAME_CUSTOM,
};

enum EBioSkillGameDifficulty
{
    SKILL_GAME_DIFFICULTY_EASY,
    SKILL_GAME_DIFFICULTY_MEDIUM,
    SKILL_GAME_DIFFICULTY_HARD,
};

// m_preGameButtonXText: StringRefProperty[44]
// m_preGameButtonBText: StringRefProperty[44]
// m_preGameButtonAText: StringRefProperty[44]
// m_GameMessageDuringGame: StringRefProperty[44]
// m_GameMessageFailure: StringRefProperty[44]
// m_GameMessageSuccess: StringRefProperty[44]
var transient float m_fButtonDelayTime;

var transient float m_fButtonTimeout;

var transient int m_nTotalButtonsToDisplay;

var transient int m_nMaxSalvage;

var transient int m_nMinSalvage;

var transient EBioSkillGame m_nSkillGameType;

var transient Object m_oDependent;

var transient BioPawn m_oUsingPawn;

var transient bool m_bSalvageCheckParam;

var transient bool m_bDefault2DAsLoaded;

var Bio2DA m_SkillGame2DA;

var Name m_nmSkillGame2DAName;

var Name m_nmSkillGamePackageName;

native function Pawn GetBestSkillMember(EBioSkillGame eSkillGameType, BioBaseSquad oInputSquad, out int nBestSkillLevel);

native function bool InitializeSkillGame(BioPawn oUsingPawn, Object oDependent, byte nSkillGameType, int nTotalButtonsToDisplay, float fButtonTimeout, float fButtonDelayTime);

native function bool InitializeSkillGameCustom(BioPawn oUsingPawn, Object oDependent, byte nSkillGameType, int nTotalButtonsToDisplay, float fButtonTimeout, float fButtonDelayTime, Name nmFunctionSuccessCallback, Name nmFunctionFailureCallback, Name nmFunctionCancelCallback, bool i_bDoNotUseSalvage);

native function CallbackSkillGame();

event InitializeSkillGameStringReferences()
{
    m_GameMessageSuccess = i_GameMessageSuccess;
    m_GameMessageFailure = i_GameMessageFailure;
    m_GameMessageDuringGame = i_GameMessageDuringGame;
    m_preGameButtonAText = i_preGameButtonAText;
    m_preGameButtonBText = i_preGameButtonBText;
    m_preGameButtonXText = i_preGameButtonXText;
}

native final function InitializeObject();

defaultproperties
{
    m_nmSkillGamePackageName=BIOG_2DA_Talents_X
    m_nmSkillGame2DAName=Skills_SkillCost
    m_SkillGame2DA=Bio2DA'Default2DA'
}
