﻿class BioSpectator extends BioBaseComponent;

var transient BioWorldInfo m_WorldInfo;

var transient array<BioSpectatorMode> m_modes;

var transient int m_nSelectedMode;

function InitializeModes(BioWorldInfo WorldInfo)
{
    local Actor Target;
    Target = WorldInfo.GetLocalPlayerController().PlayerCamera.ViewTarget.Target;
    m_modes.Length = 0;
    if (BioArtPlaceable(Target) != None)
    {
        m_modes[0] = new(self,Class'BioSpectatorModeState');
        m_modes[0].m_desc = "States";
    }
    else
    {
        m_modes[0] = new(self,Class'BioSpectatorModeAnim');
        m_modes[0].m_desc = "Animations";
    }
    m_modes[1] = new(self,Class'BioSpectatorModeAnimSpeed');
    m_modes[1].m_desc = "Animation Speed";
    m_modes[2] = new(self,Class'BioSpectatorModeLOD');
    m_modes[2].m_desc = "Level of Detail";
    if (BioPawn(Target) != None)
    {
        m_modes[4] = new(self,Class'BioSpectatorModeCamera');
        m_modes[4].m_desc = "Camera";
    }
    m_nSelectedMode = 0;
    m_WorldInfo = WorldInfo;
    m_modes[m_nSelectedMode].InitializeOptions(m_WorldInfo);
}

function PrevMode()
{
    if (m_modes.Length == 0)
    {
        return;
    }
    if (m_nSelectedMode <= 0)
    {
        m_nSelectedMode = m_modes.Length - 1;
    }
    else
    {
        m_nSelectedMode--;
    }
    m_modes[m_nSelectedMode].InitializeOptions(m_WorldInfo);
}

function NextMode()
{
    if (m_modes.Length == 0)
    {
        return;
    }
    if (m_nSelectedMode >= m_modes.Length - 1)
    {
        m_nSelectedMode = 0;
    }
    else
    {
        m_nSelectedMode++;
    }
    m_modes[m_nSelectedMode].InitializeOptions(m_WorldInfo);
}

defaultproperties
{
}
