﻿class BioSpectatorMode extends BioBaseComponent
    abstract;

var transient array<String> m_subOptions;

var transient int m_nSelectedSubOption;

var transient array<String> m_options;

var transient int m_nSelectedOption;

var transient int m_nCurrentLevel;

var transient String m_desc;

function InitializeOptions(BioWorldInfo WorldInfo);

function ActivateOption(BioWorldInfo WorldInfo);

function DeactivateOption(BioWorldInfo WorldInfo)
{
    if (m_nCurrentLevel > 0)
    {
        m_nCurrentLevel--;
    }
}

function String GetAboveOptionText(int Level)
{
    if (Level == 1)
    {
        if (m_subOptions.Length >= 3)
        {
            if (m_nSelectedSubOption == 0)
            {
                return m_subOptions[m_subOptions.Length - 1];
            }
            else
            {
                return m_subOptions[m_nSelectedSubOption - 1];
            }
        }
    }
    if (Level == 0)
    {
        if (m_options.Length >= 3)
        {
            if (m_nSelectedOption == 0)
            {
                return m_options[m_options.Length - 1];
            }
            else
            {
                return m_options[m_nSelectedOption - 1];
            }
        }
    }
    return "";
}

function String GetSelectedOptionText(int Level)
{
    if (Level == 1)
    {
        return m_subOptions[m_nSelectedSubOption];
    }
    if (Level == 0)
    {
        if (m_nCurrentLevel > 0)
        {
            return m_options[m_nSelectedOption] $ " -->";
        }
        else
        {
            return m_options[m_nSelectedOption];
        }
    }
    return "";
}

function String GetBelowOptionText(int Level)
{
    if (Level == 1)
    {
        if (m_subOptions.Length >= 2)
        {
            if (m_nSelectedSubOption == m_subOptions.Length - 1)
            {
                return m_subOptions[0];
            }
            else
            {
                return m_subOptions[m_nSelectedSubOption + 1];
            }
        }
    }
    if (Level == 0)
    {
        if (m_options.Length >= 2)
        {
            if (m_nSelectedOption == m_options.Length - 1)
            {
                return m_options[0];
            }
            else
            {
                return m_options[m_nSelectedOption + 1];
            }
        }
    }
    return "";
}

function PrevOption()
{
    if (m_nCurrentLevel == 1)
    {
        if (m_subOptions.Length == 0)
        {
            return;
        }
        if (m_nSelectedSubOption <= 0)
        {
            m_nSelectedSubOption = m_subOptions.Length - 1;
        }
        else
        {
            m_nSelectedSubOption--;
        }
        return;
    }
    if (m_nCurrentLevel == 0)
    {
        if (m_options.Length == 0)
        {
            return;
        }
        if (m_nSelectedOption <= 0)
        {
            m_nSelectedOption = m_options.Length - 1;
        }
        else
        {
            m_nSelectedOption--;
        }
    }
}

function NextOption()
{
    if (m_nCurrentLevel == 1)
    {
        if (m_subOptions.Length == 0)
        {
            return;
        }
        if (m_nSelectedSubOption >= m_subOptions.Length - 1)
        {
            m_nSelectedSubOption = 0;
        }
        else
        {
            m_nSelectedSubOption++;
        }
        return;
    }
    if (m_nCurrentLevel == 0)
    {
        if (m_options.Length == 0)
        {
            return;
        }
        if (m_nSelectedOption >= m_options.Length - 1)
        {
            m_nSelectedOption = 0;
        }
        else
        {
            m_nSelectedOption++;
        }
    }
}

defaultproperties
{
}
