﻿class BioSpectatorModeLOD extends BioSpectatorMode;

function InitializeOptions(BioWorldInfo WorldInfo)
{
    local Actor Target;
    local int I;
    InitializeOptions(WorldInfo);
    Target = WorldInfo.GetLocalPlayerController().PlayerCamera.ViewTarget.Target;
    if (BioPawn(Target) != None)
    {
        m_options.Length = 0;
        m_options[0] = "Automatic";
        I = 0;
        while (I < BioPawn(Target).Mesh.SkeletalMesh.LODInfo.Length)
        {
            m_options[m_options.Length] = "Level" @ I;
            I++;
        }
        m_nSelectedOption = BioPawn(Target).Mesh.ForcedLodModel;
    }
    else
    {
        if (BioArtPlaceable(Target) != None)
        {
            if (SkeletalMeshComponent(BioArtPlaceable(Target).PlaceableMesh) != None)
            {
                m_options.Length = 0;
                m_options[0] = "Automatic";
                I = 0;
                while (I < SkeletalMeshComponent(BioArtPlaceable(Target).PlaceableMesh).SkeletalMesh.LODInfo.Length)
                {
                    m_options[m_options.Length] = "Level" @ I;
                    I++;
                }
                m_nSelectedOption = SkeletalMeshComponent(BioArtPlaceable(Target).PlaceableMesh).ForcedLodModel;
            }
        }
    }
}

function ActivateOption(BioWorldInfo WorldInfo)
{
    local Actor Target;
    Target = WorldInfo.GetLocalPlayerController().PlayerCamera.ViewTarget.Target;
    if (BioPawn(Target) != None)
    {
        BioPawn(Target).Mesh.ForcedLodModel = m_nSelectedOption;
    }
    else
    {
        if (BioArtPlaceable(Target) != None)
        {
            if (SkeletalMeshComponent(BioArtPlaceable(Target).PlaceableMesh) != None)
            {
                SkeletalMeshComponent(BioArtPlaceable(Target).PlaceableMesh).ForcedLodModel = m_nSelectedOption;
            }
        }
    }
}

defaultproperties
{
}
