﻿class BioTierManager extends Object
    config(Engine)
    native;

struct native TierDetails_t
{
    var Name TierName;

    var Color Color;

    var bool IsEnabled;

    var bool IsGlobal;

    var bool IsFloor;

    var int Priority;

}

var transient bool bReevaluateStreaming;

var transient byte DefaultTierIndex;

var transient BioTierInfo FloorTier;

var transient array<BioTierInfo> TierInfo;

var config Name DefaultTier;

var config array<TierDetails_t> TierDetails;

native static function byte GetNumTiers();

native static function Name GetTierName(byte Index);

native static function ClearCurrentTriggers();

native static function Retouch(bool bForce);

native function BioTierInfo GetTier(byte Index);

native function BioTierInfo GetFloorTier();

native function BioTierInfo GetDefaultTier();

native static function byte GetTierIndex(Name TierNameIn);

native static function SetTierByName(Name TierNameIn, BioTriggerStream TriggerIn);

native static function SetTierByIndex(byte TierIndex, BioTriggerStream TriggerIn);

native static function RemoveTrigger(BioTriggerStream TriggerIn);

native static function BackgroundStreamingDone(array<Sequence> Sequences, Pawn PlayerPawn);

native static function ForegroundStreamingDone(array<Sequence> Sequences, Pawn PlayerPawn);

native static function ReevaluateStreaming(bool bForce);

native static function RegisterPlotStreaming(array<PlotStreamingSet> PlotStreaming);

native static function UnregisterPlotStreaming(array<PlotStreamingSet> PlotStreaming);

native static function ConvertPlotStreaming(Name fnVirtualChunk, out array<PlotStreamingElement> aRealChunks);

defaultproperties
{
    TierDetails=System.Byte[]
    DefaultTier=TIER_Art
}
