﻿class BioTimerList extends Object;

struct BioTimer
{
    var delegate<BioTimerDelegate> OnTimer;

    var Object Params;

    var float fTickTime;

    var String sTimerName;

}

var array<BioTimer> lstTimers;

delegate BioTimerDelegate(Object Params);

function AddTimer(delegate<BioTimerDelegate> TimerDelegate, Object Params, float fTime, optional String i_sTimerName)
{
    local float fAccumulatedTime;
    local BioTimer Timer;
    local bool bInserted;
    local int I;
    Timer.OnTimer = TimerDelegate;
    Timer.Params = Params;
    Timer.fTickTime = fTime;
    Timer.sTimerName = i_sTimerName;
    if (lstTimers.Length == 0)
    {
        lstTimers[0] = Timer;
    }
    else
    {
        bInserted = false;
        fAccumulatedTime = 0;
        I = 0;
        while (I < lstTimers.Length && bInserted == false)
        {
            if (fAccumulatedTime + lstTimers[I].fTickTime > fTime)
            {
                lstTimers.Insert(I, 1);
                lstTimers[I] = Timer;
                lstTimers[I + 1].fTickTime = fAccumulatedTime + lstTimers[I + 1].fTickTime - fTime;
                lstTimers[I].fTickTime -= fAccumulatedTime;
                bInserted = true;
            }
            fAccumulatedTime += lstTimers[I].fTickTime;
            I++;
        }
        if (bInserted == false)
        {
            lstTimers[lstTimers.Length] = Timer;
            lstTimers[lstTimers.Length - 1].fTickTime -= fAccumulatedTime;
        }
    }
}

function bool KillTimer(String i_sTimerName)
{
    local int nIndex;
    local BioTimer Timer;
    nIndex = 0;
    while (nIndex < lstTimers.Length)
    {
        Timer = lstTimers[nIndex];
        if (Timer.sTimerName == i_sTimerName)
        {
            lstTimers.Remove(nIndex, 1);
            return true;
        }
        nIndex++;
    }
    return false;
}

function Tick(float fDeltaT)
{
    local bool bProcessTick;
    local BioTimer Timer;
    local float fTickTime;
    bProcessTick = lstTimers.Length > 0;
    fTickTime = fDeltaT;
    while (bProcessTick)
    {
        if (lstTimers[0].fTickTime <= fTickTime)
        {
            Timer = lstTimers[0];
            lstTimers.Remove(0, 1);
            __BioTimerDelegate__Delegate = Timer.OnTimer;
            BioTimerDelegate(Timer.Params);
            fTickTime -= Timer.fTickTime;
        }
        else
        {
            lstTimers[0].fTickTime -= fTickTime;
            fTickTime = 0;
        }
        bProcessTick = lstTimers.Length > 0 && fTickTime > 0;
    }
}

defaultproperties
{
}
