﻿class BioTriggerStream extends TriggerVolume
    hidecategories(Navigation,Display,Collision)
    config(Engine)
    native
    placeable;

struct native BioStreamingState
{
    var() Name StateName;

    var() String StateDescription;

    var() Name InChunkName;

    var() transient bool ColorChunks;

    var() array<Name> VisibleChunkNames;

    var() array<Name> VisibleSoonChunkNames;

    var() array<Name> LoadChunkNames;

    var() float DesignFudget;

    var() float ArtFudget;

}

var transient int bInPlotStreaming;

var(Streaming) bool m_bIgnoreForStreamingCoverage;

var() GFxMovieInfo m_oAreaMapOverride;

var transient bool bErrorsLogged;

var native BioTierInfo TierInfo;

var Name TierName;

var(Streaming) transient EBioAutoSet Tier;

var(Streaming) array<BioStreamingState> StreamingStates;

var(Streaming) int m_nPriorityLevel;

var transient int m_StoredStateIndex;

native function DoTouch();

native function DoUntouch(Actor Other);

native function DoStasis(Actor Touched, bool bTouched);

native function Retouch(bool bForce);

native function BackgroundStreamingDone(array<Sequence> Sequences, Pawn PlayerPawn);

native function ForegroundStreamingDone(array<Sequence> Sequences, Pawn PlayerPawn);

event Touch(Actor Other, PrimitiveComponent OtherComp, Vector HitLocation, Vector HitNormal)
{
    local Pawn P;
    P = Pawn(Other);
    if (P != None && !TierInfo.IsGlobal && TierInfo.Enabled)
    {
        if (P.IsPlayerPawn())
        {
            DoTouch();
        }
        DoStasis(Other, true);
    }
    Touch(Other, OtherComp, HitLocation, HitNormal);
}

event UnTouch(Actor Other)
{
    local BioPawn oBioPawn;
    local Pawn P;
    P = Pawn(Other);
    if (P != None && !TierInfo.IsGlobal && TierInfo.Enabled)
    {
        if (P.IsPlayerPawn())
        {
            DoUntouch(Other);
        }
        oBioPawn = BioPawn(P);
        if (oBioPawn == None || !oBioPawn.IsDead())
        {
            DoStasis(Other, false);
        }
    }
    UnTouch(Other);
}

defaultproperties
{
    m_StoredStateIndex=-1
    BrushComponent=None
    Components=None
    // child object BrushComponent0 of type BrushComponent
}
