﻿class BioVisualEffect extends PrefabInstance
    hidecategories(Navigation,Actor,Object)
    native
    placeable;

struct native InterpPropertyInfo
{
    var Object Outer;

    var int Offset;

}

struct native CachedInstanceParameter
{
    var Name ParameterName;

    var float fCurrentValue;

    var array<InterpPropertyInfo> OffsetInfo;

    var bool bInited;

}

var const native MultiMap_Mirror m_mTrackMaterialVectorMap;

var const native MultiMap_Mirror m_mObjectVectorPropertyMap;

var const native MultiMap_Mirror m_mTrackMaterialFloatMap;

var const native MultiMap_Mirror m_mObjectFloatPropertyMap;

var const native transient array<CachedInstanceParameter> m_CachedInstanceParameters;

var Object m_pInstigator;

var int m_nAttachedToBoneCount;

var array<Actor> m_cameraShakenActors;

var BioCameraShake m_cameraShake;

var WwiseEventPairObject oCurrentWwisePair;

var /* 00000008 */ AudioComponent oAudioComponent;

var() WwiseBaseSoundObject oSoundCue;

var /* 00000008 */ transient BioDecalComponent pLastDecal;

var /* 00000008 */ transient BioDecalComponent aDecalList[3];

var transient int nLastDecal;

var const int nMaxDecals;

var transient bool bCancelSpawn;

var float fCurrentTime;

var float fStateEndTimes[3];

var float fStateStartTimes[3];

var float fStateDurations[3];

var String sStateNames[3];

var SeqAct_Interp Matinee;

var BioVFXTemplate pTemplate;

var float fTotalDuration;

var float m_accruedTime;

var(VisualEffect) float fLifeDuration;

var(VisualEffect) EBioVFXState eCurrentState;

var bool bHideBaseOnComplete;

var bool bIsComponentOnly;

var(VisualEffect) bool bPauseOnDeath;

var(VisualEffect) bool bLoopLife;

var(VisualEffect) bool bActive;

var bool bPaused;

var bool bDeleteSelf;

enum EBioVFXState
{
    BVFX_SPAWN,
    BVFX_LIFE,
    BVFX_DEATH,
    BVFX_ENUM_SIZE,
};

function LoopDuration(bool bLoop)
{
    bLoopLife = bLoop;
}

function PauseOnDeath(bool bPause)
{
    bPauseOnDeath = bPause;
}

native function bool SetPaused(bool bPause, optional bool bForceRefresh);

native function bool SetState(EBioVFXState eState, optional bool bForceSetState, optional bool bPlayAudio, optional bool bForceKill);

native function bool SetBasePrefab(Prefab pBase);

native function bool IsAttached();

native function DestroyInstance();

native function float GetEffectDuration();

native function float GetStateDuration(EBioVFXState eState);

native function SetScalarParameter(Name sParameter, float fValue);

native function SetVectorParameter(Name sParameter, Vector vValue);

native function SetLifeTime(float fLife);

native static function BioVisualEffect CreateCrustEffect(BioVFXTemplate a_pTemplate, Actor Target, optional float fLifeTime, optional bool bUseVFXPool);

native static function BioVisualEffect CreateVFXOnMesh(BioVFXTemplate a_pTemplate, Actor Target, Name sBoneName, optional float fLifeTime, optional SkeletalMeshComponent mTargetMesh, optional bool bUseVFXPool);

native static function BioVisualEffect CreateVFXOnPosition(BioVFXTemplate a_pTemplate, Vector vPosition, Rotator rOrientation, optional float fLifeTime, optional bool bUseVFXPool);

native function bool SetSound(int nIndexInSoundArray);

event OnComplete()
{
    if (bHideBaseOnComplete && Base != None)
    {
        Base.SetHidden(true);
    }
}

defaultproperties
{
    bDeleteSelf=true
    sStateNames="Impact"
    sStateNames="Duration"
    sStateNames="Cessation"
    nMaxDecals=3
    Components=None
    ***Deleted***=System.Byte[]
}
