﻿class BioWp_DoorMarker extends BioPathPoint
    hidecategories(Navigation,Lighting,LightColor,Force)
    native
    placeable;

var() Name m_nmGotoStateToOpen;

var() array<Name> m_nmOpenedStates;

var() array<Name> m_nmClosedStates;

var const transient bool bTempDisabledCollision;

var() bool bAICanOpenDoor;

var() bool bWaitUntilCompletelyOpened;

var() BioDoor oMyDoor;

native function bool IsDoorOpen();

native function bool IsDoorClosed();

event Actor SpecialHandling(Pawn Other)
{
    if (IsDoorOpen() == false && bAICanOpenDoor != false && oMyDoor != None)
    {
        oMyDoor.m_oBehavior.SetState(m_nmGotoStateToOpen);
    }
    return self;
}

function bool ProceedWithMove(Pawn Other)
{
    if (IsDoorOpen())
    {
        return true;
    }
    if (bWaitUntilCompletelyOpened)
    {
        Other.Controller.WaitForDoor(oMyDoor, m_nmGotoStateToOpen);
    }
    return false;
}

event bool SuggestMovePreparation(Pawn Other)
{
    if (IsDoorOpen() || oMyDoor == None)
    {
        return false;
    }
    else
    {
        if (oMyDoor.m_oBehavior.IsTransitioning())
        {
            Other.Controller.WaitForDoor(oMyDoor, m_nmGotoStateToOpen);
            return true;
        }
        else
        {
            Other.Controller.bPreparingMove = true;
            return false;
        }
    }
    return None;
}

defaultproperties
{
    m_nmClosedStates(0)=Closed
    m_nmOpenedStates(0)=Opened
    m_nmGotoStateToOpen=Opened
    bSpecialMove=true
    ExtraCost=100
    CylinderComponent=None
    Components=None
    2=System.Byte[]
    // child object CollisionCylinder of type CylinderComponent
}
