﻿class Bio_Appr_Character_Body extends BioBaseAppearance
    hidecategories(Object,Advanced,Collision,Movement,Debug,Physics,Targeting,Death)
    native;

struct native ModelVariation
{
    var() int NumVariations;

    var() int MaterialsPerVariation;

    var() bool m_bHasHeadGear;

}

struct native ArmorTypes
{
    var() const EBioArmorType ArmorType;

    var() Name m_meshPackageName;

    var() Name m_materialPackageName;

    var() array<ModelVariation> Variations;

    var() PhysicsAsset ArmorPhysicsAsset;

}

var(Technical) array<WeaponAnimSpec> WeaponAnimSpecs;

var WeaponAnimSpec m_weaponAnimSpecs[9];

var(IKSettings) float ManualMeshAdj;

var(IKSettings) float MeshAdjRate;

var(Ragdoll) Name RagdollRecoverDirSwapBone;

var(Ragdoll) float RagdollRecoverPhysBlendTime;

var(Ragdoll) EAxis RagdollRecoverDirSwapBoneAxis;

var(Ragdoll) EAxis RagdollRecoverBoneAxis;

var(Ragdoll) Name RagdollRecoverBone;

var(animation) float LookAtSpeedDEBUG;

var(animation) float LookAtRotationMaxHoldAngle;

var(animation) float LookAtRotationMaxHoldTime;

var(animation) float LookAtRotationMinHoldTime;

var(animation) float PawnMoveStopDecelTime;

var(animation) float SkidTurnThreshold;

var(animation) float InclineDownMoveMod;

var(animation) float InclineUpMoveMod;

var(Flyer) bool m_bSuppressPitch;

var(Flyer) bool m_bCanLand;

var(Flyer) bool m_bCanFly;

var(Combat) bool m_bCanWalk;

var(Combat) bool m_bCanCrouch;

var(Combat) bool m_bCanPortArms;

var(IKSettings) bool bUseManualAdj;

var(IKSettings) bool bEnableMeshAdj;

var(Ragdoll) bool bInvertRagdollRecoverDirSwapBoneAxis;

var(Ragdoll) bool bRecoverDirSwap;

var(Ragdoll) bool bInvertRagdollRecoverBoneAxis;

var(Ragdoll) bool bEnableRagdollRecovery;

var(Movement) bool bUseWallSlideSpeedAdjust;

var(animation) bool bEnableLookAtTargeting;

var(animation) bool bEnableStopRootMotion;

var(animation) bool bEnableStartRootMotion;

var(animation) bool bEnableMountRootMotion;

var(animation) bool bAllowStopAnimInCombat;

var(animation) bool bAllowSkidAnimInCombat;

var(animation) bool bAllowStartAnimInCombat;

var(animation) bool bEnableStopAnims;

var(animation) bool bEnableSkidAnims;

var(animation) bool bEnableStartAnims;

var(Technical) float Scale;

var(Technical) float CollisionReadyHeight;

var(Technical) float CollisionCrouchHeight;

var(Technical) float CollisionRadius;

var(Technical) float CollisionHeight;

var(Technical) OverrideAnimTreeTemplate AnimTreeTemplates[7];

var(Technical) array<AnimSet> AnimSets;

var(Preview) /* 00000008 */ transient Bio_Appr_Character_Body_Settings m_oSettings;

var(Visual) Bio_Appr_Character_HeadGear m_oHeadGearAppearance;

var(Visual) String AppearancePrefix;

var(Visual) array<ArmorTypes> Armor;

var(Visual) Bio2DA m_oMaterialVariationTranslationTable;

struct native OverrideAnimTreeTemplate
{
    var() EBioPawnClassification eClassification;

    var() AnimTree AnimTreeTemplate;

}

struct native WeaponAnimSpec
{
    var() const String AnimType;

    var() array<AnimSet> m_animSets;

    var() AnimSet m_drawAnimSet;

}

native function SkeletalMesh GetModel(int ArmorType, int ModelVar);

native function String GetPhysics_Name(int ArmorType, int ModelVar);

native function PhysicsAsset GetPhysics(int ArmorType, int ModelVar);

native function bool IsValidVariation(int ArmorType, int ModelVar, int MaterialVar);

native function bool GetMaterial(int ArmorType, int ModelVar, int MaterialVar, out array<MaterialInterface> Materials);

defaultproperties
{
    Armor=System.Byte[]
    m_oSettings=Bio_Appr_Character_Body_Settings'oSettings'
    CollisionHeight=78
    CollisionRadius=32
    CollisionCrouchHeight=39
    CollisionReadyHeight=78
    Scale=1
    bRecoverDirSwap=true
    m_bCanCrouch=true
    m_bCanWalk=true
    InclineUpMoveMod=-0,2
    InclineDownMoveMod=0,2
    SkidTurnThreshold=135
    PawnMoveStopDecelTime=0,65
    LookAtRotationMinHoldTime=0,5
    LookAtRotationMaxHoldTime=2
    LookAtRotationMaxHoldAngle=90
    LookAtSpeedDEBUG=2,5
    RagdollRecoverBone=root
    RagdollRecoverBoneAxis=AXIS_Z
    RagdollRecoverDirSwapBoneAxis=AXIS_Y
    RagdollRecoverPhysBlendTime=0,333
    RagdollRecoverDirSwapBone=Chest1
    MeshAdjRate=120
    WeaponAnimSpecs=System.Byte[]
    // child object oSettings of type Bio_Appr_Character_Body_Settings
}
