﻿class Goal_AtCover extends PathGoalEvaluator
    native;

var transient bool MoveTowardsGoalActor;

var /* 00000008 */ array<CoverGoalConstraint> CoverGoalConstraints;

var Actor TetherActor;

var int NumMarkersTested;

var() int MaxToRate;

var int BestRating;

var CoverSlotMarker BestMarker;

var SFXAI_NativeBase AI;

final function Init(SFXAI_NativeBase oAI, Actor GoalActor)
{
    local int I;
    if (oAI.MyBP != None)
    {
        BestMarker = None;
        BestRating = 10000000;
        NumMarkersTested = 0;
        AI = oAI;
        TetherActor = GoalActor;
        I = 0;
        while (I < CoverGoalConstraints.Length)
        {
            CoverGoalConstraints[I].Init(self);
            I++;
        }
        InitNative();
        oAI.Pawn.AddGoalEvaluator(self);
        jump 164;
    }
    return;
}

native final private function InitNative();

native final function RateSlotMarker(CoverSlotMarker Marker, Pawn Pawn, int BaseRating);

event AddCoverGoalConstraint(CoverGoalConstraint Constraint)
{
    CoverGoalConstraints[CoverGoalConstraints.Length] = Constraint;
}

event String GetDumpString()
{
    local int idx;
    local String Str;
    if (CoverGoalConstraints.Length == 0)
    {
        return "Empty Cov Goal Constraints";
    }
    idx = 0;
    while (idx < CoverGoalConstraints.Length)
    {
        Str = Str @ CoverGoalConstraints[idx].GetDumpString() @ "\n";
        idx++;
    }
    return Str;
}

defaultproperties
{
    MaxToRate=40
    MoveTowardsGoalActor=true
    MaxPathVisits=500
}
