﻿class SFXAI_TechDrone_NPC extends SFXAI_Core
    hidecategories(Navigation)
    config(AI)
    placeable;

var bool bHasWarned;

var bool bHasTaunted;

var bool bHasFlanked;

var bool bHasHowled;

state Combat_TechDrone_NPC
{
    while (true)
    {
        while (SelectTarget() == false)
        {
            Sleep(0,2);
        }
        if (Enemy != None && Pawn != None)
        {
            Focus = Enemy;
        }
        ATTACK();
        if (VSize(Enemy.Location - MyBP.Location) > 300)
        {
            SFXGame(WorldInfo.Game).TriggerVocalizationEvent(13, MyBP, BioPawn(FireTarget));
            MoveToGoal(Enemy, 250);
        }
        Sleep(0,2);
    }
    // invalid native function 205 ;
}

function SetMovementSpeed()
{
    local float fDistanceSquared;
    if (MyBP == None || FireTarget == None)
    {
        return;
    }
    fDistanceSquared = VSizeSq(FireTarget.Location - MyBP.Location);
    if (fDistanceSquared < 640000 && bHasTaunted == false)
    {
        bHasTaunted = true;
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(39, MyBP, BioPawn(FireTarget));
    }
    if (fDistanceSquared < 1000000 && bHasWarned == false)
    {
        bHasWarned = true;
        SFXGame(WorldInfo.Game).TriggerVocalizationEvent(39, MyBP, BioPawn(FireTarget));
    }
}

state MovingToGoal
{
    function PeriodicMoveCheck()
    {
        local float fTimeOfHit;
        local Name nmPowerName;
        local SFXWeapon oWeapon;
        local int nRequiresAttackTicket;
        local Vector AttackOrigin;
        PeriodicMoveCheck();
        if (FRand() <= GetPowerUsePercent())
        {
            ChooseAttackPower(FireTarget, nmPowerName, nRequiresAttackTicket, AttackOrigin);
        }
        if (nmPowerName == 'None')
        {
            oWeapon = SFXWeapon(MyBP.Weapon);
            if (oWeapon == None)
            {
                return;
            }
            nRequiresAttackTicket = 1;
        }
        if (!HasLOSToTarget(FireTarget, fTimeOfHit))
        {
            return;
        }
        if (nRequiresAttackTicket > 0 && AcquireTicket(FireTarget, 2) == false)
        {
            return;
        }
        Focus = FireTarget;
        MoveTarget = None;
        bReachedMoveGoal = true;
    }

}

defaultproperties
{
    m_nmCurrentBehavior=Combat_TechDrone_NPC
    BehaviourList(0)=Combat_TechDrone_NPC
    AtCover_WeaponRange=Goal_AtCover'AtCov_EvalWeaponRange'
    AtCover_Defensive=Goal_AtCover'AtCov_EvalDefensive'
    AtCover_Aggressive=Goal_AtCover'AtCov_EvalAggressive'
    AtCover_NearMoveGoal=Goal_AtCover'AtCov_EvalNearGoal'
    AtCover_AIGoHere=Goal_AtGoHereCover'AtCov_EvalGoHere'
    CustomActionClasses(0)=None
    CustomActionClasses(1)=None
    CustomActionClasses(2)=None
    CustomActionClasses(3)=None
    CustomActionClasses(4)=class'SFXCustomAction_Frozen'
    CustomActionClasses(5)=None
    CustomActionClasses(6)=None
    CustomActionClasses(7)=None
    CustomActionClasses(8)=class'BioCustomAction_CombatActivate'
    CustomActionClasses(9)=None
    CustomActionClasses(10)=None
    CustomActionClasses(11)=class'BioCustomAction_WaypointAnimation'
    // child object AtCov_EvalAggressive of type Goal_AtCover
    // child object AtCov_EvalDefensive of type Goal_AtCover
    // child object AtCov_EvalNearGoal of type Goal_AtCover
    // child object AtCov_EvalWeaponRange of type Goal_AtCover
    // child object AtCov_EvalGoHere of type Goal_AtGoHereCover
}
