﻿class SFXArmor_Base extends Inventory
    hidecategories(Navigation)
    config(Weapon)
    abstract;

const MAXARMORLEVEL = 100.f;
var() config Vector2D PenetrationHeavy;

var() config Vector2D PenetrationMedium;

var() config Vector2D PenetrationLight;

var() config Vector2D PenetrationVeryLight;

var() config Vector2D PenetrationDefault;

var() config float FortifiedThreshold;

var() config Vector2D DamageResistance;

var() config Name ScalePlotId;

var float ArmorLevel;

var() bool bShowFortifyOnGUI;

simulated function float GetLevelRatio()
{
    return ArmorLevel / 100;
}

simulated function float GetDamageResistance(class<SFXDamageType> DamageType)
{
    local float Resistance;
    local SFXModule_GameEffectManager GEModule;
    local float DamageReduction;
    if (DamageType == None)
    {
        return 1;
    }
    Resistance = 1;
    Resistance = Resistance + DamageType.Default.ArmorBonus;
    if (Owner != None)
    {
        GEModule = Owner.GetModule(Class'SFXModule_GameEffectManager');
        if (GEModule != None)
        {
            DamageReduction = GEModule.GetEffectValue(Class'SFXGameEffect_ArmorBonus');
            Resistance = Resistance - Resistance * DamageReduction;
        }
    }
    return FClamp(Resistance, 0,2, 2);
}

simulated function ApplyDamage(out float Damage, out TraceHitInfo HitInfo, out Vector HitLocation, out Vector Momentum, class<SFXDamageType> DamageType, Controller InstigatedBy, Actor DamageCauser)
{
    if (DamageType.Default.bIgnoreArmor)
    {
        return;
    }
    Damage = Damage * GetDamageResistance(DamageType);
}

defaultproperties
{
    Components=None
    ***Deleted***=System.Byte[]
    !_Dup=System.Byte[]
}
