﻿class SFXCameraMode_SniperZoom extends SFXCameraMode;

var transient BioCameraZoom ZoomData;

function ModifyPostProcessSettings(out PostProcessSettings PPSettings)
{
    ModifyPostProcessSettings(PPSettings);
    if (Owner != None && Owner.GameModeManager2 != None && Owner.GameModeManager2.IsActive(6) == false)
    {
        ZoomData.ModifyPostProcessSettings(PPSettings);
    }
}

function DoCameraCollision(out Vector V, out Rotator R, Actor A)
{
    local int idx;
    DoCameraCollision(V, R, A);
    if (Owner.HiddenActors.Find(Owner.Pawn) == -1)
    {
        Owner.HiddenActors.AddItem(Owner.Pawn);
    }
    idx = 0;
    while (idx < Owner.Pawn.Attached.Length)
    {
        if (Owner.Pawn.Attached[idx] != None)
        {
            if (Owner.HiddenActors.Find(Owner.Pawn.Attached[idx]) == -1)
            {
                Owner.HiddenActors.AddItem(Owner.Pawn.Attached[idx]);
            }
        }
        idx++;
    }
}

function Tick(float TimeDelta)
{
    local Actor Ignored;
    local Vector HitLocation;
    local Vector HitNormal;
    Tick(TimeDelta);
    if (Owner != None && Owner.GameModeManager2 != None && Owner.GameModeManager2.IsActive(6) == false)
    {
        if (SFXWeapon(Owner.Pawn.Weapon) != None)
        {
            m_pov.FOV = SFXWeapon(Owner.Pawn.Weapon).ZoomFOV;
            SFXPlayerCamera(Owner.PlayerCamera).GetTrace(Ignored, HitLocation, HitNormal);
            ZoomData.Focus(VSize(m_pov.Location - HitLocation), BioWorldInfo(Owner.WorldInfo));
            ZoomData.Tick(TimeDelta, m_pov.FOV, 1);
        }
    }
}

defaultproperties
{
    ZoomData=BioCameraZoom'ZoomDataObj'
    bIsCameraShakeEnabled=true
    HookOffset=(X=0,Y=0,Z=79)
    Input=SFXCameraInput's_Input'
    // child object s_Input of type SFXCameraInput
    // child object ZoomDataObj of type BioCameraZoom
}
