﻿class SFXCameraNativeBase extends AnimatedCamera
    hidecategories(Navigation)
    config(Game)
    transient
    native;

var transient SFXCameraNativeBaseTraceInfo m_aTraceInfo;

var transient float AspectRatio;

var transient Rotator SubtractiveRotation;

var transient Rotator AdditiveRotation;

var transient Vector2D MovementStick;

var transient Vector2D CameraStick;

var bool m_bCameraSwitchEnabled;

var bool m_bIgnoreSlowMo;

var transient SFXCameraMode LastGoodMode;

var transient SFXCameraMode CurrentCameraMode;

var transient array<SFXCameraMode> CameraModes;

var transient SFXCameraMode_Interpolate InstantTransition;

var transient SFXCameraMode_Interpolate SlideTransition;

var transient bool bFreeCamActive;

var transient bool bDisabled;

struct native SFXCameraNativeBaseTraceInfo
{
    var Vector m_vCollVectorLocation;

    var Vector m_vCollVectorNormal;

    var Actor m_oCollVectorActor;

    var bool m_bCollDetected;

    var bool m_bCollisionDirty;

    var bool m_bDebugDraw;

    var Color m_clrDebugDraw;

}

native final function bool GetTrace(out Actor oHit, out Vector vLocation, out Vector vNormal);

native function Vector WorldToCanonicalScreen(const out Vector vWorldLoc);

native function Vector WorldToScreenSnapToEdge(const out Vector vWorldLoc, float i_fSafeZoneX, float i_fSafeZoneY);

native final function TraceCamera();

native final function ResetHiddenActors();

native final function Actor LineCheck(out TraceHitInfo HitInfo, out Vector HitLocation, out Vector HitNormal, const out Vector TraceEnd, optional bool TraceActors, optional Vector Extent, optional int ExtraTraceFlags);

function OnPossess(Pawn pPawn)
{
    if (CurrentCameraMode != None)
    {
        CurrentCameraMode.OnPossess(pPawn);
    }
}

function OnUnPossess()
{
    if (CurrentCameraMode != None)
    {
        CurrentCameraMode.OnUnPossess();
    }
}

event CreateIPECommands(BioInGamePropertyEditor IPE, BioPropertyEditorBaseNode Parent)
{
    local BioPropertyEditorPropertyNode oControlNode;
    local SFXCameraMode Mode;
    foreach CameraModes(Mode)
    {
        oControlNode = new(IPE,Class'BioPropertyEditorPropertyNode');
        oControlNode.m_sNodeDisplayName = Mode.Name;
        oControlNode.m_oParent = Parent;
        if (Mode == CurrentCameraMode)
        {
            oControlNode.m_sDeliminator = " - ";
            oControlNode.m_sValueString = "Current";
        }
        else
        {
            oControlNode.m_sDeliminator = "";
        }
        oControlNode.SetObject(Mode);
        oControlNode.MakeNodes("");
        Parent.m_aChildren.AddItem(oControlNode);
    }
}

event AddScreenShake(ScreenShakeStruct Shake);

defaultproperties
{
    m_bIgnoreSlowMo=true
}
