﻿class SFXCluster extends SFXGalaxyMapObject
    hidecategories(Object)
    native;

var transient Bio2DA m_pSystemTable;

var transient Bio2DA m_pClusterTable;

var(Label) bool ExploredCluster;

var(Appearance) float SphereSize;

var(Appearance) float SphereIntensity;

var(Appearance) float CloudTile;

var(Appearance) float NebularDensity;

var(Appearance) LinearColor StarColor2;

var(Appearance) LinearColor StarColor;

var(Appearance) Texture2D ClusterTexture;

var array<SFXCluster> RelayConnections;

var array<SFXSystem> Systems;

native function bool LoadFrom2DA();

function SFXGalaxyMapObject AddChild()
{
    local SFXSystem newSystem;
    newSystem = new(self,Class'SFXSystem');
    newSystem.NameText = "new System";
    Systems.AddItem(newSystem);
    return newSystem;
}

function GetChildren(out array<SFXGalaxyMapObject> Children)
{
    Children = Systems;
}

function RemoveChild(SFXGalaxyMapObject Child)
{
    local int Index;
    Index = Systems.Find(SFXSystem(Child));
    if (Index >= 0)
    {
        Systems[Index] = None;
    }
}

defaultproperties
{
    StarColor=(R=0,G=0,B=0,A=1)
    StarColor2=(R=0,G=0,B=0,A=1)
    m_pClusterTable=Bio2DA'Default2DA'
    m_pSystemTable=Bio2DA'Default2DA'
    Tag="Cluster"
}
