﻿class SFXCustomAction_Frozen extends SFXCustomAction_DamageReaction
    config(Game);

var() bool bWelded;

function Init(Vector HitLocation, Vector HitNormal, TraceHitInfo HitInfo, bool bPlayImpact, Controller Inst)
{
    Init(HitLocation, HitNormal, HitInfo, bPlayImpact, Inst);
    oPawn.m_oBehavior.IncrementRagdollCount();
    oPawn.InitRagdoll();
    oPawn.WeldPhysicsAssetInstance();
    bWelded = true;
    SFXGame(oPawn.WorldInfo.Game).VocManager.AddToIgnoreList(oPawn);
}

function StartCustomAction();

function UnWeldPhysicsAssetInstance()
{
    local BioAnimNodeFrame SnapshotNode;
    bWelded = false;
    if (oPawn.Mesh != None && oPawn.Mesh.Animations != None)
    {
        foreach oPawn.Mesh.AllAnimNodes(Class'BioAnimNodeFrame', SnapshotNode)
        {
            SnapshotNode.CaptureAnimFrame();
        }
    }
    oPawn.SetRigidBodyMode(2);
    oPawn.UnWeldPhysicsAssetInstance();
    SFXGame(oPawn.WorldInfo.Game).VocManager.RemoveFromIgnoreList(oPawn);
    if (oPawn.IsDead())
    {
        EndThisCustomAction();
        return;
    }
    oPawn.SetTimer(2, false, 'StartRagdollPhase', self);
}

function StartRagdollPhase()
{
    oPawn.SetTimer(0,1, true, 'CheckBeginRecovery', self);
}

function StopCustomAction()
{
    StopCustomAction();
    if (bWelded)
    {
        UnWeldPhysicsAssetInstance();
    }
}

function CheckBeginRecovery()
{
    if (oPawn.IsInState('Downed') || oPawn.IsDead() || VSize(oPawn.Velocity) < oPawn.PawnType.m_fPhysicsRecoverSpeedThreshold)
    {
        oPawn.ClearTimer('CheckBeginRecovery', self);
        oPawn.m_oBehavior.DecrementRagdollCount();
        oPawn.SetTimer(0,1, true, 'CheckEndRecovery', self);
    }
}

function CheckEndRecovery()
{
    local SFXAI_Core oAI;
    oAI = SFXAI_Core(oPawn.Controller);
    if (!oPawn.IsInState('InRagdoll', true) || oAI != None && oAI.CanCustomActionTerminateEarly())
    {
        oPawn.ClearTimer('CheckEndRecovery', self);
        EndThisCustomAction();
    }
}

defaultproperties
{
}
