﻿class SFXCustomAction_Ragdoll extends SFXCustomAction_DamageReaction
    config(Game);

var transient bool bHeldInRagdoll;

function Init(Vector HitLocation, Vector HitNormal, TraceHitInfo HitInfo, bool bPlayImpact, Controller Inst)
{
    Init(HitLocation, HitNormal, HitInfo, bPlayImpact, Inst);
    bHeldInRagdoll = true;
    oPawn.m_oBehavior.IncrementRagdollCount();
    oPawn.InitRagdoll();
}

function StartCustomAction()
{
    oPawn.SetTimer(0,1, true, 'CheckBeginRecovery', self);
    SFXGame(oPawn.WorldInfo.Game).TriggerVocalizationEvent(35, oPawn, oPawn, 0);
    oPawn.RegisterRBCallback(OnRagdollPhysicsImpact);
    oPawn.SetTimer(0,25, true, 'PlayScream', self);
}

function StopCustomAction()
{
    StopCustomAction();
    if (oPawn != None)
    {
        if (bHeldInRagdoll)
        {
            oPawn.ClearTimer('CheckBeginRecovery', self);
            oPawn.ClearTimer('PlayScream', self);
            oPawn.ClearTimer('RestartScream', self);
            oPawn.ClearRBCallbacks();
            oPawn.m_oBehavior.DecrementRagdollCount();
        }
        else
        {
            oPawn.ClearTimer('CheckEndRecovery', self);
        }
    }
}

function PlayScream()
{
    SFXGame(oPawn.WorldInfo.Game).TriggerVocalizationEvent(36, oPawn, oPawn, 0);
    oPawn.SetTimer(3, true, 'PlayScream', self);
}

function RestartScream()
{
    oPawn.SetTimer(1, true, 'PlayScream', self);
}

function OnRagdollPhysicsImpact(Pawn Pawn, Actor oImpactActor, Vector vImpactDir)
{
    SFXGame(oPawn.WorldInfo.Game).TriggerVocalizationEvent(35, oPawn, oPawn, 0);
    oPawn.ClearTimer('PlayScream', self);
    Pawn.SetTimer(1, false, 'RestartScream', self);
    oPawn.SetTimer(0,1, false, 'RegisterRagdollVocCallback', self);
}

function RegisterRagdollVocCallback()
{
    oPawn.RegisterRBCallback(OnRagdollPhysicsImpact);
}

function CheckBeginRecovery()
{
    if (oPawn.IsInState('Downed') || oPawn.IsDead() || VSize(oPawn.Velocity) < oPawn.PawnType.m_fPhysicsRecoverSpeedThreshold)
    {
        oPawn.StopVocalization();
        bHeldInRagdoll = false;
        oPawn.ClearTimer('CheckBeginRecovery', self);
        oPawn.ClearTimer('PlayScream', self);
        oPawn.ClearTimer('RestartScream', self);
        oPawn.ClearRBCallbacks();
        oPawn.m_oBehavior.DecrementRagdollCount();
        oPawn.SetTimer(0,1, true, 'CheckEndRecovery', self);
    }
}

function CheckEndRecovery()
{
    if (!oPawn.IsInState('InRagdoll', true))
    {
        oPawn.ClearTimer('CheckEndRecovery', self);
        EndThisCustomAction();
    }
}

defaultproperties
{
}
