﻿class SFXDoorMarker extends NavigationPoint
    hidecategories(Navigation,Lighting,LightColor,Force)
    native
    placeable;

var const transient int nUnblockCount;

var const transient bool bPrevBlockedState;

var const transient bool bTempDisabledCollision;

var bool bDoorOpen;

var() bool bBlockedWhenClosed;

var() bool bInitiallyClosed;

var() bool bWaitUntilCompletelyOpened;

var() SFXDoor MyDoor;

native function int UnblockDoorMarker();

native function int RestoreDoorMarkerBlockedState();

event PostBeginPlay()
{
    bBlocked = bInitiallyClosed && bBlockedWhenClosed;
    bDoorOpen = !bInitiallyClosed;
    PostBeginPlay();
}

function DoorOpened()
{
    bBlocked = !bInitiallyClosed && bBlockedWhenClosed;
    bDoorOpen = bInitiallyClosed;
    WorldInfo.Game.NotifyNavigationChanged(self);
}

function DoorClosed()
{
    bBlocked = bInitiallyClosed && bBlockedWhenClosed;
    bDoorOpen = !bInitiallyClosed;
    WorldInfo.Game.NotifyNavigationChanged(self);
}

event Actor SpecialHandling(Pawn Other)
{
    return self;
}

function bool ProceedWithMove(Pawn Other)
{
    return bDoorOpen;
}

event bool SuggestMovePreparation(Pawn Other)
{
    if (bDoorOpen || MyDoor == None)
    {
        return false;
    }
    return true;
}

defaultproperties
{
    bInitiallyClosed=true
    bBlockedWhenClosed=true
    bSpecialMove=true
    ExtraCost=100
    CylinderComponent=None
    GoodSprite=None
    BadSprite=None
    Components=None
    180Deg=System.Byte[]
    // child object CollisionCylinder of type CylinderComponent
}
