﻿class SFXDroppedPickup extends DroppedPickup
    hidecategories(Navigation);

const MAXGUNS = 4;
var /* 00000008 */ LightEnvironmentComponent LightEnvironment;

var /* 00000008 */ SkeletalMeshComponent PickupMesh;

simulated function SetPickupMesh(PrimitiveComponent NewPickupMesh)
{
    local SkeletalMeshComponent SkelMesh;
    SkelMesh = SkeletalMeshComponent(NewPickupMesh);
    if (SkelMesh != None && SkelMesh.SkeletalMesh != None)
    {
        PickupMesh.SetSkeletalMesh(SkelMesh.SkeletalMesh);
    }
}

function Landed(Vector HitNormal, Actor FloorActor);

function Used(Actor User)
{
    local SFXPawn_Player Player;
    local SFXWeapon WeaponToRemove;
    local SFXWeapon ChkWeapon;
    local SFXInventoryManager InvMan;
    local int WeaponCount;
    Player = SFXPawn_Player(User);
    if (Player != None)
    {
        InvMan = SFXInventoryManager(Player.InvManager);
        WeaponToRemove = SFXWeapon(Player.Weapon);
        if (WeaponToRemove == None)
        {
            WeaponToRemove = SFXWeapon(InvMan.FindInventoryType(InvMan.CurrentWeaponSelection, false));
        }
        if (WeaponToRemove != None)
        {
            Player.SetWeaponImmediately(None);
        }
        foreach InvMan.InventoryActors(Class'SFXWeapon', ChkWeapon)
        {
            if (SFXHeavyWeapon(ChkWeapon) == None)
            {
                WeaponCount++;
            }
        }
        if (WeaponCount >= 4 && WeaponToRemove != None)
        {
            Player.TossWeapon(WeaponToRemove);
        }
        GiveTo(Player);
        Player.SetWeaponImmediately(Class<SFXWeapon>(InventoryClass));
        InvMan.CurrentWeaponSelection = Class<SFXWeapon>(InventoryClass);
        InvMan.SetWeaponBySelected();
    }
}

function GiveTo(Pawn P)
{
    if (Inventory != None)
    {
        Inventory.AnnouncePickup(P);
        Inventory.GiveTo(P);
        Inventory = None;
    }
    PickedUpBy(P);
}

function PickedUpBy(Pawn P)
{
    Destroy();
}

state Idle
{
}

defaultproperties
{
    PickupMesh=SkeletalMeshComponent'DroppedPickupMesh0'
    LightEnvironment=DynamicLightEnvironmentComponent'DroppedPickupLightEnvironment'
    Components=None
    // child object CollisionCylinder of type CylinderComponent
    // child object DroppedPickupLightEnvironment of type DynamicLightEnvironmentComponent
    // child object SelMod0 of type SFXSimpleUseModule
    // child object DroppedPickupMesh0 of type SkeletalMeshComponent
}
