﻿class SFXEmitter extends Emitter
    hidecategories(Navigation)
    placeable;

var bool bPooled;

function Recycle()
{
    ClearTimer('Recycle');
    ParticleSystemComponent.DeactivateSystem();
    SetHidden(true);
    bStasis = true;
}

function Initialize(ParticleSystem Template)
{
    local int idx;
    SetCollision(false, false, true);
    LifeSpan = 0;
    SetTemplate(Template, false);
    if (ParticleSystemComponent != None)
    {
        ParticleSystemComponent.bAutoActivate = false;
        ParticleSystemComponent.LODMethod = 1;
        idx = 0;
        while (idx < ParticleSystemComponent.EmitterInstances.Length)
        {
            ParticleSystemComponent.SetKillOnDeactivate(idx, false);
            ParticleSystemComponent.SetKillOnCompleted(idx, false);
            ++idx;
        }
    }
}

function Reuse()
{
    bStasis = false;
    ClearTimer('Recycle');
    SetTimer(180, false, 'Recycle');
    SetHidden(false);
}

function OnParticleSystemFinished(ParticleSystemComponent FinishedComponent)
{
    if (bPooled)
    {
        Recycle();
    }
    else
    {
        Destroy();
    }
}

function SetLifeTime(float Seconds)
{
    if (bStasis == false)
    {
        ClearTimer('Recycle');
        SetTimer(Seconds, false, 'Recycle');
    }
}

defaultproperties
{
    ParticleSystemComponent=None
    bDestroyOnSystemFinish=true
    Components=None
    // child object ParticleSystemComponent0 of type ParticleSystemComponent
}
