﻿class SFXGameEffect_Crush extends SFXGameEffect
    hidecategories(Object);

var float minHeightForBodyFallSound;

var BioPawn Caster;

var() ParticleSystem SlamPS;

var float SlamDownForce;

var float UpwardForce;

var Name BoneName;

function OnApplied()
{
    OnApplied();
    if (Owner == None)
    {
        return;
    }
    Owner.Velocity.X = 0;
    Owner.Velocity.Y = 0;
    Owner.Velocity.Z = 0;
    if (Owner.CollisionComponent != None)
    {
        Owner.CollisionComponent.AddForce(vect(0,0,1) * UpwardForce, Owner.Location, BoneName);
    }
}

function OnUpdate(float DeltaSeconds)
{
    local BioPawn oBioPawn;
    OnUpdate(DeltaSeconds);
    oBioPawn = BioPawn(Owner);
    if (oBioPawn != None && oBioPawn.Location.Z - oBioPawn.m_fInitialZVal > minHeightForBodyFallSound)
    {
        oBioPawn.m_bRagdollEnteredPendingBodyFallSound = true;
    }
}

function OnRemoved()
{
    local SFXGame oGame;
    local SFXObjectPool oPool;
    local SFXEmitter oEmitter;
    local BioPawn oBioPawn;
    OnRemoved();
    if (Owner == None)
    {
        return;
    }
    oBioPawn = BioPawn(Owner);
    if (oBioPawn != None)
    {
        oBioPawn.m_bRagdollEnteredPendingBodyFallSound = true;
    }
    oGame = SFXGame(Owner.WorldInfo.Game);
    if (oGame == None)
    {
        return;
    }
    oPool = oGame.ObjectPool;
    if (oPool == None)
    {
        return;
    }
    Owner.CollisionComponent.AddForce(vect(0,0,-1) * SlamDownForce, Owner.Location, BoneName);
    oEmitter = SFXEmitter(oPool.GetImpactEmitter(SlamPS, Owner.Location, vect(0,0,-1)));
    if (oEmitter != None && oEmitter.ParticleSystemComponent != None)
    {
        oEmitter.ParticleSystemComponent.SetActive(true);
    }
}

defaultproperties
{
    SlamPS=ParticleSystem'Crush_Impact'
    minHeightForBodyFallSound=5
    bSendCompletionEvent=true
}
