﻿class SFXGameEffect_CryoFreeze extends SFXGameEffect_WeldPhysics
    hidecategories(Object);

var SFXGameEffect_PhysicsDamageMultiplier PhysicsDamageMultiplier;

var float FrozenPhysicsDamageIncrease;

var BioVisualEffect ThawCrust;

var float ThawTime;

var bool bThawStarted;

var BioVFXTemplate ThawCrustTemplate;

function OnApplied()
{
    local SFXModule_GameEffectManager Manager;
    OnApplied();
    if (Owner != None)
    {
        Manager = Owner.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            PhysicsDamageMultiplier = SFXGameEffect_PhysicsDamageMultiplier(Manager.CreateEffect(Class'SFXGameEffect_PhysicsDamageMultiplier', Category, Duration, 1, FrozenPhysicsDamageIncrease, Instigator));
            if (PhysicsDamageMultiplier != None)
            {
                PhysicsDamageMultiplier.OnApplied();
            }
        }
    }
}

function OnUpdate(float DeltaSeconds)
{
    local BioPawn oPawn;
    OnUpdate(DeltaSeconds);
    if (bThawStarted == false && CrustEffect == None || CrustEffect.Base != Owner)
    {
        CrustEffect = None;
        CurrentTime = Duration + 1;
        return;
    }
    if (!bThawStarted && Duration - CurrentTime < ThawTime)
    {
        bThawStarted = true;
        oPawn = BioPawn(Owner);
        if (oPawn != None && !oPawn.IsDead() && ThawCrustTemplate != None)
        {
            ThawCrust = Class'BioVisualEffect'.CreateCrustEffect(ThawCrustTemplate, Owner, 0, true);
            if (ThawCrust != None)
            {
                ThawCrust.SetState(0, true);
            }
        }
    }
}

function OnRemoved()
{
    OnRemoved();
    if (PhysicsDamageMultiplier != None)
    {
        PhysicsDamageMultiplier.CurrentTime = PhysicsDamageMultiplier.Duration + 1;
    }
}

defaultproperties
{
    ThawCrustTemplate=BioVFXTemplate'Cryo_Thaw_VFX'
    ThawTime=1
    FrozenPhysicsDamageIncrease=1
    DeathEffect=BioVFXTemplate'Cryo_Shatter_VFX'
    DeathSoundEffect=WwiseEvent'Play_vfx_cryo_break'
    Priority=10
}
