﻿class SFXGameEffect_DamageMultiplier extends SFXGameEffect
    hidecategories(Object);

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function ComputeEffectValue(out float Value)
{
    if (EffectValue < Value)
    {
        Value = EffectValue;
    }
}

function OnApplied()
{
    local SFXModule_Damage DmgModule;
    OnApplied();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            DmgModule.DamageMultiplier.Bonuses.AddItem(self);
            Class'SFXGame'.ReCalculate(DmgModule.DamageMultiplier);
        }
    }
}

function OnRemoved()
{
    local SFXModule_Damage DmgModule;
    OnRemoved();
    if (Owner != None)
    {
        DmgModule = Owner.GetModule(Class'SFXModule_Damage');
        if (DmgModule != None)
        {
            DmgModule.DamageMultiplier.Bonuses.RemoveItem(self);
            Class'SFXGame'.ReCalculate(DmgModule.DamageMultiplier);
        }
    }
}

defaultproperties
{
}
