﻿class SFXGameEffect_GiveShield extends SFXGameEffect
    hidecategories(Object);

var bool bForceNewShield;

var SFXShield_Base NewShield;

var class<SFXShield_Base> ShieldClass;

function ComputeEffectValue(out float Value)
{
    Value += EffectValue;
}

function OnApplied()
{
    local BioPawn oPawn;
    local float fShieldIncrease;
    local SFXShield_Base Shields;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None || EffectValue < 0)
    {
        return;
    }
    Shields = oPawn.GetShields();
    if (bForceNewShield || Shields == None || Shields.MaxShields.Value <= 0)
    {
        CreateShield();
    }
    else
    {
        fShieldIncrease = Shields.MaxShields.Value * EffectValue;
        if (SFXPawn_Player(oPawn) != None || SFXPawn_Henchman(oPawn) != None)
        {
            Shields.MaxShields.Bonuses.AddItem(self);
            Class'SFXGame'.ReCalculate(Shields.MaxShields);
        }
        Shields.CurrentShields = FClamp(Shields.CurrentShields + fShieldIncrease, 0, Shields.MaxShields.Value);
    }
}

function CreateShield()
{
    local BioPawn oPawn;
    local SFXLoadoutData ChkLoadout;
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    ChkLoadout = oPawn.GetPawnLoadout();
    if (ChkLoadout != None)
    {
        NewShield = SFXShield_Base(oPawn.CreateInventory(ShieldClass));
        if (NewShield != None)
        {
            NewShield.ShieldScale = ChkLoadout.ShieldScale;
            NewShield.ShieldOffset = ChkLoadout.ShieldOffset;
            NewShield.MaxShields.Level = 1;
            NewShield.MaxShields.X = EffectValue;
            NewShield.MaxShields.Y = EffectValue;
            Class'SFXGame'.ReCalculate(NewShield.MaxShields);
            NewShield.CurrentShields = NewShield.MaxShields.Value;
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local SFXShield_Base Shields;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (NewShield != None)
    {
        oPawn.InvManager.RemoveFromInventory(NewShield);
        NewShield.Destroy();
    }
    else
    {
        Shields = oPawn.GetShields();
        if (Shields != None)
        {
            if (SFXPawn_Player(oPawn) != None || SFXPawn_Henchman(oPawn) != None)
            {
                Shields.MaxShields.Bonuses.RemoveItem(self);
                Class'SFXGame'.ReCalculate(Shields.MaxShields);
                Shields.CurrentShields = FClamp(Shields.CurrentShields, 0, Shields.MaxShields.Value);
            }
        }
    }
}

defaultproperties
{
}
