﻿class SFXGameEffect_IgnorePlayerSquad extends SFXGameEffect
    hidecategories(Object);

function OnApplied()
{
    local BioPawn oPawn;
    local BioPlayerSquad oPlayerSquad;
    local SFXAI_Core oController;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    oPlayerSquad = BioWorldInfo(Owner.WorldInfo).m_playerSquad;
    oController = SFXAI_Core(oPawn.Controller);
    if (oController != None)
    {
        if (oController.IgnoredSquads.Find(oPlayerSquad) == -1)
        {
            oController.IgnoredSquads.AddItem(oPlayerSquad);
        }
        oController.Focus = None;
        oController.MoveTarget = None;
        oController.SelectTarget();
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local BioPlayerSquad oPlayerSquad;
    local SFXAI_Core oController;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    if (IsStillIgnoring(oPawn))
    {
        return;
    }
    oPlayerSquad = BioWorldInfo(Owner.WorldInfo).m_playerSquad;
    oPlayerSquad = BioWorldInfo(Owner.WorldInfo).m_playerSquad;
    oController = SFXAI_Core(oPawn.Controller);
    if (oController != None)
    {
        oController.IgnoredSquads.RemoveItem(oPlayerSquad);
    }
}

function bool IsStillIgnoring(BioPawn oPawn)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    if (oPawn == None)
    {
        return false;
    }
    Manager = oPawn.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class == Class'SFXGameEffect_IgnorePlayerSquad' && oEffect != self)
            {
                return true;
            }
        }
    }
    return false;
}

defaultproperties
{
}
