﻿class SFXGameEffect_PassiveHeavyAmmoBonus extends SFXGameEffect
    hidecategories(Object);

function ComputeEffectValue(out float Value)
{
    Value += EffectValue - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn oPawn;
    local SFXHeavyWeapon Weapon;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        foreach oPawn.InvManager.InventoryActors(Class'SFXHeavyWeapon', Weapon)
        {
            Weapon.MagSize.Bonuses.AddItem(self);
            Weapon.ScaleWeapon(0);
        }
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local SFXHeavyWeapon Weapon;
    OnRemoved();
    oPawn = BioPawn(Owner);
    if (oPawn != None)
    {
        foreach oPawn.InvManager.InventoryActors(Class'SFXHeavyWeapon', Weapon)
        {
            Weapon.MagSize.Bonuses.RemoveItem(self);
            Weapon.ScaleWeapon(0);
        }
    }
}

defaultproperties
{
}
