﻿class SFXGameEffect_PassiveShieldRegenBonus extends SFXGameEffect
    hidecategories(Object);

function ComputeEffectValue(out float Value)
{
    Value += EffectValue - 1;
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    OnApplied();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            Shields.ShieldRegenDelay.Bonuses.AddItem(self);
            Shields.ScaleShields();
        }
    }
}

function OnRemoved()
{
    local BioPawn OwnerPawn;
    local SFXShield_Base Shields;
    OnRemoved();
    OwnerPawn = BioPawn(Owner);
    if (OwnerPawn != None)
    {
        Shields = OwnerPawn.GetShields();
        if (Shields != None)
        {
            Shields.ShieldRegenDelay.Bonuses.RemoveItem(self);
            Shields.ScaleShields();
        }
    }
}

defaultproperties
{
}
