﻿class SFXGameEffect_PassiveWeaponDamageBonus extends SFXGameEffect
    hidecategories(Object);

var bool bRemoved;

function ComputeEffectValue(out float Value)
{
    if (!bRemoved)
    {
        Value += EffectValue;
    }
}

static function float ComputeTotalEffectValue(float baseValue, float StackingValue, float NonStackingValue)
{
    return baseValue * 1 + StackingValue + NonStackingValue;
}

function OnApplied()
{
    local BioPawn BP;
    local SFXModule_GameEffectManager Manager;
    BP = BioPawn(Owner);
    if (BP != None && BP.Controller != None && BP.Controller.PlayerReplicationInfo != None)
    {
        Manager = BP.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            SFXPRI(BP.Controller.PlayerReplicationInfo).WeaponPassiveDamageBonus = Manager.GetEffectValue(Class'SFXGameEffect_PassiveWeaponDamageBonus', 1);
        }
    }
}

function OnRemoved()
{
    local BioPawn BP;
    local SFXModule_GameEffectManager Manager;
    bRemoved = true;
    BP = BioPawn(Owner);
    if (BP != None && BP.Controller != None && BP.Controller.PlayerReplicationInfo != None)
    {
        Manager = BP.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            SFXPRI(BP.Controller.PlayerReplicationInfo).WeaponPassiveDamageBonus = Manager.GetEffectValue(Class'SFXGameEffect_PassiveWeaponDamageBonus', 1);
        }
    }
}

defaultproperties
{
}
