﻿class SFXGameEffect_Pull extends SFXGameEffect
    hidecategories(Object);

var float minHeightForBodyFallSound;

var float MinimumVelocityForceMult;

var float MinimumVelocity;

var float GravityRampUpTime;

var bool bGravityRampUp;

var BioPawn Caster;

var Name BoneName;

var Vector Direction;

var float Force;

var Vector ForceVector;

function OnApplied()
{
    OnApplied();
    if (Owner == None)
    {
        return;
    }
    Force = VSize(ForceVector);
    Direction = Normal(ForceVector);
    Owner.Velocity.X = 0;
    Owner.Velocity.Y = 0;
    Owner.Velocity.Z = 0;
    MoveActor(ForceVector);
}

function OnUpdate(float DeltaSeconds)
{
    local BioPawn oBioPawn;
    if (Owner != None)
    {
        if (VSize(Owner.Velocity) < MinimumVelocity)
        {
            MoveActor(ForceVector * MinimumVelocityForceMult);
        }
        oBioPawn = BioPawn(Owner);
        if (oBioPawn != None && oBioPawn.Location.Z - oBioPawn.m_fInitialZVal > minHeightForBodyFallSound)
        {
            oBioPawn.m_bRagdollEnteredPendingBodyFallSound = true;
        }
        if (!bGravityRampUp && Duration - CurrentTime < GravityRampUpTime)
        {
            if (oBioPawn != None)
            {
                oBioPawn.m_bRagdollEnteredPendingBodyFallSound = true;
            }
            if (!HasOtherGravityEffects())
            {
                bGravityRampUp = true;
                Owner.m_fGravityScaling = 0,5;
            }
        }
    }
}

function MoveActor(Vector vForce)
{
    if (Owner != None && Owner.CollisionComponent != None)
    {
        Owner.CollisionComponent.AddForce(vForce, Owner.Location, BoneName);
    }
}

function OnRemoved()
{
    OnRemoved();
}

function bool HasOtherGravityEffects()
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    if (Owner == None)
    {
        return false;
    }
    Manager = Owner.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class == Class'SFXGameEffect_AntiGravity' && oEffect.Category != Category)
            {
                return true;
            }
        }
    }
    return false;
}

defaultproperties
{
    minHeightForBodyFallSound=5
    bSendCompletionEvent=true
}
