﻿class SFXGameEffect_StormTimeDilation extends SFXGameEffect
    hidecategories(Object);

var BioPlayerController Controller;

var BioPawn BP;

var float TimeSinceStorm;

var float PostStormDilationTime;

var float CustomTimeDilation;

var InterpCurveFloat StormSlowDown;

function OnUpdate(float TimeDelta)
{
    local SFXModule_GameEffectManager Manager;
    local SFXGameEffect oEffect;
    OnUpdate(TimeDelta);
    if (BP == None || Controller == None)
    {
        return;
    }
    if (!BP.InCombat())
    {
        BP.CustomTimeDilation = 1;
        Controller.CustomTimeDilation = 1;
        return;
    }
    Manager = Owner.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager != None)
    {
        foreach Manager.GameEffects(oEffect)
        {
            if (oEffect.Class == Class'SFXGameEffect_TimeDilation')
            {
                return;
            }
        }
    }
    if (Controller.bStorming)
    {
        TimeSinceStorm = 0;
        SlowTime();
    }
    else
    {
        TimeSinceStorm += TimeDelta;
        if (TimeSinceStorm < PostStormDilationTime)
        {
            SlowTime();
        }
        else
        {
            BP.CustomTimeDilation = 1;
            Controller.CustomTimeDilation = 1;
        }
    }
}

function SlowTime()
{
    SFXGame(Owner.WorldInfo.Game).RequestTimeDilation(StormSlowDown, 0);
    BP.CustomTimeDilation = CustomTimeDilation;
    Controller.CustomTimeDilation = CustomTimeDilation;
}

function OnApplied()
{
    BP = BioPawn(Owner);
    Controller = BioPlayerController(BP.Controller);
    StormSlowDown.Points[0].OutVal = 1 - EffectValue;
    StormSlowDown.Points[1].OutVal = 1 - EffectValue;
    CustomTimeDilation = 1 / 1 - EffectValue;
    TimeSinceStorm = 1000;
}

function OnRemoved()
{
    OnRemoved();
    if (BP != None && Controller != None)
    {
        BP.CustomTimeDilation = 1;
        Controller.CustomTimeDilation = 1;
    }
}

defaultproperties
{
    StormSlowDown=(Points=?,InterpMethod=?)
    CustomTimeDilation=1
    PostStormDilationTime=0,25
}
