﻿class SFXGameEffect_WeldPhysics extends SFXGameEffect_DeathEffect
    hidecategories(Object);

var bool bFreezeSucceeded;

var EAICustomAction CustomActionType;

var BioVisualEffect CrustEffect;

var BioVFXTemplate CrustTemplate;

var BioPawn Caster;

function OnApplied()
{
    local BioPawn oPawn;
    local SFXAI_Core AI;
    local BioCustomAction CurrentCustomAction;
    local Vector HitLocation;
    local Vector HitNormal;
    local TraceHitInfo HitInfo;
    local SFXCustomAction_Frozen FrozenAction;
    OnApplied();
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    AI = SFXAI_Core(oPawn.Controller);
    if (AI == None)
    {
        return;
    }
    RemoveExistingWeldEffects();
    if (!AI.CanDoCustomAction(CustomActionType))
    {
        return;
    }
    if (AI.IsDoingACustomAction())
    {
        if (CustomActionType > AI.CurrentCustomAction)
        {
            return;
        }
        if (AI.GetCurrentCustomAction(CurrentCustomAction) && CurrentCustomAction != None)
        {
            CurrentCustomAction.StopCustomAction();
        }
    }
    AI.StartCustomAction(CustomActionType, 1);
    oPawn.LastAnimatedReactionTime = Owner.WorldInfo.TimeSeconds;
    if (AI.GetCurrentCustomAction(CurrentCustomAction) && CurrentCustomAction != None && CurrentCustomAction.Class == Class'SFXCustomAction_Frozen')
    {
        FrozenAction = SFXCustomAction_Frozen(CurrentCustomAction);
        if (FrozenAction != None)
        {
            FrozenAction.Init(HitLocation, HitNormal, HitInfo, false, Instigator);
            bFreezeSucceeded = true;
        }
        if (CrustTemplate != None)
        {
            CrustEffect = Class'BioVisualEffect'.CreateCrustEffect(CrustTemplate, oPawn, Duration, true);
            if (CrustEffect != None)
            {
                CrustEffect.SetState(0, true);
            }
        }
        jump 512;
    }
    return;
}

final private function RemoveExistingWeldEffects()
{
    local int idx;
    local SFXGameEffect Effect;
    local SFXModule_GameEffectManager Manager;
    if (Owner == None)
    {
        return;
    }
    Manager = Owner.GetModule(Class'SFXModule_GameEffectManager');
    if (Manager == None)
    {
        return;
    }
    idx = Manager.GameEffects.Length - 1;
    while (idx >= 0)
    {
        Effect = Manager.GameEffects[idx];
        if (ClassIsChildOf(Effect.Class, self.Class) && Effect != self)
        {
            Effect.OnRemoved();
            Manager.GameEffects.Remove(idx, 1);
        }
        idx--;
    }
}

function OnRemoved()
{
    local BioPawn oPawn;
    local SFXAI_Core AI;
    local BioCustomAction CurrentCustomAction;
    local SFXCustomAction_Frozen FrozenCustomAction;
    OnRemoved();
    if (CrustEffect != None)
    {
        CrustEffect.SetState(2, true);
    }
    if (bFreezeSucceeded == false)
    {
        return;
    }
    oPawn = BioPawn(Owner);
    if (oPawn == None)
    {
        return;
    }
    AI = SFXAI_Core(oPawn.Controller);
    if (AI == None)
    {
        return;
    }
    if (AI.GetCurrentCustomAction(CurrentCustomAction) && CurrentCustomAction != None && CurrentCustomAction.Class == Class'SFXCustomAction_Frozen')
    {
        FrozenCustomAction = SFXCustomAction_Frozen(CurrentCustomAction);
        if (FrozenCustomAction != None)
        {
            FrozenCustomAction.UnWeldPhysicsAssetInstance();
        }
    }
}

defaultproperties
{
    CustomActionType=AI_CustomAction_Frozen
    bSendCompletionEvent=true
}
