﻿class SFXGameModeBase extends Object
    within BioPlayerController
    config(Input)
    abstract
    native;

enum EGameModePriority2
{
    ModePriority_Base,
    ModePriority_CheatMenu,
    ModePriority_Conversation,
    ModePriority_Menus,
    ModePriority_Popup,
};

var() EGameModePriority2 Priority;

var array<KeyBind> LocalizedBindings;

var() bool bEnforce16x9Subtitiles;

var() bool bPlayVocalizations;

var() bool bShowReticles;

var() bool bQueueAndSuppressNotifications;

var() bool bMergeNotifications;

var() bool bMouseVisible;

var() const bool bHasMouseAuthority;

var() const bool bShowSubtitle;

var() const bool bAllowPauseMenu;

var() const bool bAllowSave;

var() const bool bAllowCameraMods;

var() const bool bAllowCamera;

var() const bool bAllowMovement;

var() const bool bAllowRotationUpdate;

var() const bool bShowRadar;

var() const bool bShowDamageIndicators;

var() const bool bShowSelection;

var() const bool bShowHUD;

var() bool bIsActive;

var bool bBindingsCollected;

var config array<KeyBind> Bindings;

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    TransitionTime = 0;
    PreserveTarget = 0;
    return OldCameraMode;
}

event SFXCameraMode HACK_GetCameraMode();

final function SetTimer(float InRate, optional bool inbLoop, optional Name inTimerFunc = 'Timer', optional Object inObj)
{
    Outer.SetTimer(InRate, inbLoop, inTimerFunc, inObj != None ? inObj : self);
}

final function ClearTimer(optional Name inTimerFunc = 'Timer', optional Object inObj)
{
    Outer.ClearTimer(inTimerFunc, inObj != None ? inObj : self);
}

function Activated()
{
    bIsActive = true;
    if (bAllowMovement == false)
    {
        Outer.IgnoreMoveInput(true);
    }
    if (bAllowCamera == false)
    {
        Outer.IgnoreLookInput(true);
    }
}

function Deactivated()
{
    bIsActive = false;
    if (bAllowMovement == false)
    {
        Outer.IgnoreMoveInput(false);
    }
    if (bAllowCamera == false)
    {
        Outer.IgnoreLookInput(false);
    }
}

function ActivateSpecifier(Name ModeSpecifier);

function DeactivateSpecifier(Name ModeSpecifier);

native function Initialize();

native function CollectBindings();

exec function FireWeapon()
{
    local BioPawn ChkPawn;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None)
    {
        if (ChkPawn.ActionState != 1)
        {
            ChkPawn.m_oBehavior.SetActionState(1);
        }
        if (ChkPawn.IsUsingPower())
        {
            BioActivePower(ChkPawn.m_oBehavior.m_oCurrentModalActive).ClearPreviousCoverAction();
        }
    }
    Outer.bFire = 1;
}

exec function SwapWeaponIfEmpty()
{
    local SFXWeapon Weapon;
    if (SFXGame(Outer.WorldInfo.Game).gameconfig.bOutOfAmmoWeaponSwap)
    {
        Weapon = SFXWeapon(Outer.Pawn.Weapon);
        if (Outer.Pawn.IsHumanControlled() && Weapon != None && Weapon.OutOfAmmo())
        {
            if (BioPawn(Outer.Pawn).IsInCover() || Outer.WorldInfo.TimeSeconds - SFXPawn_Player(Outer.Pawn).OutOfAmmoTimestamp > Class'SFXPawn_Player'.Default.OutOfAmmoSwapThreshold)
            {
                SFXPawn_Player(Outer.Pawn).SwitchToBackupWeapon();
            }
        }
    }
}

exec function StopFiringWeapon()
{
    Outer.bFire = 0;
}

exec function ShowMenu()
{
    if (bAllowPauseMenu)
    {
        Outer.bWantsToStorm = 0;
        MassEffectGuiManager(Outer.GetScaleFormManager()).ShowBrowserWheel();
    }
}

final exec function SquadCommand_Attack()
{
    local bool bSuccess;
    bSuccess = false;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled())
    {
        bSuccess = Outer.QuickCommandAttackTarget();
    }
    MassEffectGuiManager(Outer.GetScaleFormManager()).ForceSquadCommandFeedback(1, 0, bSuccess);
}

final exec function SquadCommand_Follow()
{
    local bool bSuccess;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled())
    {
        bSuccess = Outer.QuickCommandFollowPlayer();
    }
    MassEffectGuiManager(Outer.GetScaleFormManager()).ForceSquadCommandFeedback(3, 0, bSuccess);
}

final exec function SquadCommand_Move1()
{
    local bool bSuccess;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled())
    {
        bSuccess = Outer.QuickCommandMoveTo(1);
    }
    MassEffectGuiManager(Outer.GetScaleFormManager()).ForceSquadCommandFeedback(2, 1, bSuccess);
}

final exec function SquadCommand_Move2()
{
    local bool bSuccess;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled())
    {
        bSuccess = Outer.QuickCommandMoveTo(2);
    }
    MassEffectGuiManager(Outer.GetScaleFormManager()).ForceSquadCommandFeedback(2, 2, bSuccess);
}

exec function StartIngamePropertyEditor()
{
    local BioWorldInfo oBWI;
    local bool bRetval;
    if (Class'Engine'.IsShip())
    {
        return;
    }
    if (Outer.GameModeManager2.IsActive(7) && MassEffectGuiManager(Outer.GetScaleFormManager()).GetBrowserHandler() != None || Outer.GameModeManager2.IsActive(5) && MassEffectGuiManager(Outer.GetScaleFormManager()).GetConversationHandler() != None)
    {
        if (Outer.GameModeManager2.IsActive(7))
        {
            MassEffectGuiManager(Outer.GetScaleFormManager()).HideBrowserWheel();
        }
        oBWI = BioWorldInfo(Outer.WorldInfo);
        if (oBWI == None)
        {
            return;
        }
        if (oBWI.m_oPropertyEditor != None)
        {
            bRetval = oBWI.m_oPropertyEditor.ActivateSystem();
        }
        else
        {
            oBWI.m_oPropertyEditor = new(self,Class'BioInGamePropertyEditor');
            if (oBWI.m_oPropertyEditor != None)
            {
                bRetval = oBWI.m_oPropertyEditor.Initialize();
                if (bRetval)
                {
                    bRetval = oBWI.m_oPropertyEditor.ActivateSystem();
                }
            }
        }
        if (bRetval)
        {
            Outer.GameModeManager2.EnableMode(11);
        }
    }
}

exec function LeaveWorld()
{
    local SFXGame Game;
    local Sequence GameSeq;
    local array<SequenceObject> AllLeaveEvents;
    local SequenceObject Event;
    Game = SFXGame(Outer.WorldInfo.Game);
    if (Game != None && Game.InCombat() == false)
    {
        GameSeq = Outer.WorldInfo.GetGameSequence();
        if (GameSeq != None)
        {
            GameSeq.FindSeqObjectsByClass(Class'SFXSeqEvt_LeaveWorld', true, AllLeaveEvents);
            foreach AllLeaveEvents(Event)
            {
                SequenceEvent(Event).CheckActivate(Outer.Pawn, Outer.Pawn);
            }
        }
    }
}

exec function GuiKey(BioGuiEvents Event)
{
    Outer.GetScaleFormManager().HandleInputEvent(Event);
}

function RemoveTimeDilationEffects()
{
    local SFXModule_GameEffectManager Manager;
    local SFXGame Game;
    if (Outer.Pawn != None)
    {
        Manager = Outer.Pawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            Manager.RemoveEffectsByType(Class'SFXGameEffect_TimeDilation');
        }
    }
    if (Outer.WorldInfo != None)
    {
        Game = SFXGame(Outer.WorldInfo.Game);
        if (Game != None)
        {
            Game.OnTimeDilationChange(1);
        }
    }
}

function PauseTimeDilationEffects()
{
    local SFXModule_GameEffectManager Manager;
    local SFXGame Game;
    if (Outer.Pawn != None)
    {
        Manager = Outer.Pawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            Manager.PauseEffectsByType(Class'SFXGameEffect_TimeDilation');
        }
    }
    if (Outer.WorldInfo != None)
    {
        Game = SFXGame(Outer.WorldInfo.Game);
        if (Game != None)
        {
            Game.OnTimeDilationChange(1);
        }
    }
}

function UnpauseTimeDilationEffects()
{
    local SFXModule_GameEffectManager Manager;
    if (Outer.Pawn != None)
    {
        Manager = Outer.Pawn.GetModule(Class'SFXModule_GameEffectManager');
        if (Manager != None)
        {
            Manager.UnpauseEffectsByType(Class'SFXGameEffect_TimeDilation');
        }
    }
}

exec function PulseRadarDisplay(float fPulseTime)
{
    local MassEffectGuiManager GUIManager;
    GUIManager = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GUIManager != None)
    {
        if (GUIManager.m_oSFPowerWheelHandler != None)
        {
            GUIManager.m_oSFPowerWheelHandler.PulseRadar(fPulseTime);
        }
    }
}

exec function ToggleObjectiveRadarDisplay(bool bTurnOn)
{
    local MassEffectGuiManager GUIManager;
    GUIManager = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GUIManager != None)
    {
        if (GUIManager.m_oSFPowerWheelHandler != None)
        {
            GUIManager.m_oSFPowerWheelHandler.m_bObjectiveRadarOn = bTurnOn;
        }
    }
}

exec function TurnObjectiveRadarDisplayOn()
{
    ToggleObjectiveRadarDisplay(true);
}

exec function TurnObjectiveRadarDisplayOff()
{
    ToggleObjectiveRadarDisplay(false);
}

defaultproperties
{
    Bindings=System.Byte[]
}
