﻿class SFXGameModeCommand extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var bool bCameraEnabled;

function Activated()
{
    Activated();
    Outer.SetZoomed(false);
    Outer.WorldInfo.bPlayersOnly = true;
    Outer.GetScaleFormManager().PlayGuiSound('ActivateSquadCommand');
    Outer.m_oPlayerSelection.m_eCurrentSelectionMode = 1;
    bCameraEnabled = false;
    MassEffectGuiManager(Outer.GetScaleFormManager()).HideHint();
}

function Deactivated()
{
    Deactivated();
    Outer.WorldInfo.bPlayersOnly = false;
    if (BioPawn(Outer.Pawn).ActionState == 0)
    {
        BioPawn(Outer.Pawn).m_oBehavior.SetActionState(1);
    }
    else
    {
        Outer.ApplyTacticalOrders();
    }
    Outer.GetScaleFormManager().PlayGuiSound('DeactivateSquadCommand');
    MassEffectGuiManager(Outer.GetScaleFormManager()).RestoreHint();
}

exec function EnableCamera()
{
    if (!bCameraEnabled)
    {
        Outer.IgnoreLookInput(false);
        bCameraEnabled = true;
    }
}

exec function DisableCamera()
{
    if (bCameraEnabled)
    {
        Outer.IgnoreLookInput(true);
        bCameraEnabled = false;
    }
}

exec function ExitCommandMenu()
{
    Outer.GameModeManager2.DisableMode(3);
}

exec function ShowMenu()
{
    ExitCommandMenu();
    ShowMenu();
}

defaultproperties
{
    Bindings=System.Byte[]
    bShowHUD=true
    bShowSelection=true
    bShowRadar=true
    bAllowSave=true
    bAllowPauseMenu=true
    bShowSubtitle=true
    bShowReticles=true
}
