﻿class SFXGameModeConversation extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var() /* 00000008 */ SFXCameraTransition_GalaxyMap InstantTransition;

var() /* 00000008 */ BioCameraBehaviorConversation ConversationCam;

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    Transition = InstantTransition;
    TransitionTime = 0;
    PreserveTarget = 0;
    return ConversationCam;
}

function SFXCameraMode HACK_GetCameraMode()
{
    return ConversationCam;
}

function Activated()
{
    local Actor A;
    local SFXSelectionModule SelMod;
    Activated();
    Outer.m_oPlayerSelection.SelectionFlareComp.SetHidden(true);
    foreach BioWorldInfo(Outer.WorldInfo).SelectableActors(A)
    {
        SelMod = A.GetModule(Class'SFXSelectionModule');
        if (SelMod != None && SelMod.LensFlareComp != None)
        {
            SelMod.LensFlareComp.SetHidden(true);
        }
    }
    RemoveTimeDilationEffects();
}

function Deactivated()
{
    Deactivated();
    Outer.m_oPlayerSelection.m_eCurrentSelectionMode = 1;
}

exec function InterruptRenegade()
{
    local MassEffectGuiManager GuiMan;
    local BioSFHandler_Conversation ConvHandler;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        ConvHandler = GuiMan.GetConversationHandler();
        if (ConvHandler != None)
        {
            ConvHandler.InterruptRenegade();
        }
    }
}

exec function InterruptParagon()
{
    local MassEffectGuiManager GuiMan;
    local BioSFHandler_Conversation ConvHandler;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        ConvHandler = GuiMan.GetConversationHandler();
        if (ConvHandler != None)
        {
            ConvHandler.InterruptParagon();
        }
    }
}

exec function SelectResponse()
{
    local MassEffectGuiManager GuiMan;
    local BioSFHandler_Conversation ConvHandler;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        ConvHandler = GuiMan.GetConversationHandler();
        if (ConvHandler != None)
        {
            ConvHandler.SelectConversationSegment();
        }
    }
}

exec function SkipConversation()
{
    local MassEffectGuiManager GuiMan;
    local BioSFHandler_Conversation ConvHandler;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        ConvHandler = GuiMan.GetConversationHandler();
        if (ConvHandler != None)
        {
            ConvHandler.SkipConversation();
        }
    }
}

exec function HighlightDefaultResponse()
{
    local MassEffectGuiManager GuiMan;
    local BioSFHandler_Conversation ConvHandler;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        ConvHandler = GuiMan.GetConversationHandler();
        if (ConvHandler != None)
        {
            ConvHandler.HighlightDefaultConvSegment();
        }
    }
}

defaultproperties
{
    ConversationCam=BioCameraBehaviorConversation'ConversationCam0'
    InstantTransition=SFXCameraTransition_GalaxyMap'InstantTransition0'
    Bindings=System.Byte[]
    bShowSubtitle=true
    bMergeNotifications=true
    bQueueAndSuppressNotifications=true
    bEnforce16x9Subtitiles=true
    Priority=ModePriority_Conversation
    // child object ConversationCam0 of type BioCameraBehaviorConversation
    // child object InstantTransition0 of type SFXCameraTransition_GalaxyMap
}
