﻿class SFXGameModeDefault extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var() WwiseEvent UseFailed;

var() WwiseEvent UseSucceeded;

var() InterpCurveFloat ZoomSnapCurve;

var() /* 00000008 */ SFXCameraTransition_ZoomSnap ZoomSnapTransition;

var() float SniperZoomTransitionTime;

var() float CoverSlowTransitionTime;

var() float CoverTransitionTime;

var() float CoverEnter;

var() float DefaultCombatTransitionTime;

var() float DefaultAimTransitionExit;

var() float DefaultAimTransitionTime;

var() float SprintFastTransitionTime;

var() float SprintTransitionTime;

var() /* 00000008 */ SFXCameraMode_TightAimCover TightAimCover_AimBack;

var() /* 00000008 */ SFXCameraMode_SniperZoomCover SniperZoomCover_AimBack;

var() /* 00000008 */ SFXCameraMode_CoverFixed CoverPeekRightCrouch;

var() /* 00000008 */ SFXCameraMode_CoverFixed CoverPeekRightStand;

var() /* 00000008 */ SFXCameraMode_CoverFixed CoverPeekLeftCrouch;

var() /* 00000008 */ SFXCameraMode_CoverFixed CoverPeekLeftStand;

var() /* 00000008 */ SFXCameraMode_Cover CoverCrouch;

var() /* 00000008 */ SFXCameraMode_Cover CoverStand;

var() /* 00000008 */ SFXCameraMode_Cover AimBackCam;

var() /* 00000008 */ SFXCameraMode_SniperZoomCover SniperZoomCoverCam;

var() /* 00000008 */ SFXCameraMode_TightAimCover TightAimCoverPopupCam;

var() /* 00000008 */ SFXCameraMode_TightAimCover TightAimCoverCam;

var() /* 00000008 */ SFXCameraMode_SniperZoom SniperZoomCam;

var() /* 00000008 */ SFXCameraMode_TightAim TightAimCam;

var() /* 00000008 */ SFXCameraMode_ExploreStorm ExploreStormCam;

var() /* 00000008 */ SFXCameraMode_CombatStorm CombatStormCam;

var() /* 00000008 */ SFXCameraMode_Explore ExploreCam;

var() /* 00000008 */ SFXCameraMode_Combat CombatCam;

var() config float RadarMapDisplayTime;

var() config float InputDelayTightAimExit;

var() config float InputDelayStormExit;

enum ECoverCameraPosition
{
    CCP_PeekLeftCrouch,
    CCP_PeekLeftStand,
    CCP_PeekRightCrouch,
    CCP_PeekRightStand,
    CCP_Popup,
    CCP_AimBack,
};

function Initialize()
{
    bIsActive = true;
    ExploreCam.Input.m_bUseExplorationSensitivity = true;
    ZoomSnapTransition.Curve = ZoomSnapCurve;
    Initialize();
}

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    local BioPawn Player;
    local SFXCameraMode NewCameraMode;
    local SFXWeapon Weapon;
    Player = BioPawn(Outer.Pawn);
    if (Player != None)
    {
        if (Player.ActionState == 0)
        {
            if (Outer.bStorming)
            {
                NewCameraMode = ExploreStormCam;
                TransitionTime = SprintTransitionTime;
            }
            else
            {
                NewCameraMode = ExploreCam;
            }
        }
        else
        {
            if (Outer.IsInState('PlayerInAimBack'))
            {
                if (Outer.Pawn.bIsCrouched)
                {
                    if (Outer.IsZoomed())
                    {
                        if (Weapon != None && Weapon.bUseSniperCam && Player.IsUsingPower() == false)
                        {
                            NewCameraMode = SniperZoomCoverCam;
                        }
                        else
                        {
                            NewCameraMode = TightAimCoverCam;
                        }
                        SniperZoomCoverCam.SetPosition(5);
                        TightAimCoverCam.SetPosition(5);
                    }
                    else
                    {
                        NewCameraMode = AimBackCam;
                    }
                }
                else
                {
                    if (Outer.IsZoomed())
                    {
                        if (Weapon != None && Weapon.bUseSniperCam && Player.IsUsingPower() == false)
                        {
                            NewCameraMode = SniperZoomCoverCam;
                        }
                        else
                        {
                            NewCameraMode = TightAimCoverCam;
                        }
                        SniperZoomCoverCam.SetPosition(4);
                        TightAimCoverCam.SetPosition(4);
                    }
                    else
                    {
                        NewCameraMode = CoverStand;
                    }
                }
            }
            else
            {
                if (Player.IsInCover())
                {
                    if (Outer.IsZoomed() == false && Player.CoverAction == 7 || Player.CoverAction == 3 || Player.CoverAction == 4)
                    {
                        NewCameraMode = OldCameraMode;
                    }
                    if (Outer.IsZoomed() && Player.CoverAction != 0)
                    {
                        Weapon = SFXWeapon(Outer.Pawn.Weapon);
                        if (Weapon != None && Weapon.bUseSniperCam && Player.IsUsingPower() == false)
                        {
                            NewCameraMode = SniperZoomCoverCam;
                        }
                        else
                        {
                            NewCameraMode = TightAimCoverCam;
                            if (Player.CoverAction == 7)
                            {
                                NewCameraMode = TightAimCoverPopupCam;
                            }
                        }
                        if (Outer.Pawn.bIsCrouched == false)
                        {
                            switch (Player.CoverAction);
                            case 9;
                            case 3;
                            SniperZoomCoverCam.SetPosition(1);
                            TightAimCoverCam.SetPosition(1);
                            TransitionTime = DefaultAimTransitionExit;
                            jump 1049;
                            case 10;
                            case 4;
                            SniperZoomCoverCam.SetPosition(3);
                            TightAimCoverCam.SetPosition(3);
                            TransitionTime = DefaultAimTransitionExit;
                            jump 1049;
                            case 7;
                            SniperZoomCoverCam.SetPosition(4);
                            TightAimCoverPopupCam.SetPosition(4);
                            TransitionTime = CoverTransitionTime;
                            jump 1049;
                            default;
                        }
                        else
                        {
                            switch (Player.CoverAction);
                            case 9;
                            case 3;
                            SniperZoomCoverCam.SetPosition(0);
                            TightAimCoverCam.SetPosition(0);
                            TransitionTime = DefaultAimTransitionTime;
                            jump 1264;
                            case 10;
                            case 4;
                            SniperZoomCoverCam.SetPosition(2);
                            TightAimCoverCam.SetPosition(2);
                            TransitionTime = DefaultAimTransitionTime;
                            jump 1264;
                            case 7;
                            SniperZoomCoverCam.SetPosition(4);
                            TightAimCoverCam.SetPosition(4);
                            TransitionTime = CoverTransitionTime;
                            jump 1264;
                            default;
                        }
                    }
                    else
                    {
                        if (Outer.Pawn.bIsCrouched == false)
                        {
                            switch (Player.CoverAction);
                            case 9;
                            NewCameraMode = CoverPeekLeftStand;
                            TransitionTime = CoverTransitionTime;
                            jump 1406;
                            case 10;
                            NewCameraMode = CoverPeekRightStand;
                            TransitionTime = CoverTransitionTime;
                            jump 1406;
                            case 0;
                            NewCameraMode = CoverStand;
                            TransitionTime = CoverTransitionTime;
                            jump 1406;
                            default;
                        }
                        else
                        {
                            switch (Player.CoverAction);
                            case 9;
                            NewCameraMode = CoverPeekLeftCrouch;
                            TransitionTime = CoverTransitionTime;
                            jump 1518;
                            case 10;
                            NewCameraMode = CoverPeekRightCrouch;
                            TransitionTime = CoverTransitionTime;
                            jump 1518;
                            case 0;
                            NewCameraMode = CoverCrouch;
                            TransitionTime = CoverTransitionTime;
                            jump 1518;
                            default;
                        }
                    }
                }
                else
                {
                    if (Outer.bStorming)
                    {
                        NewCameraMode = CombatStormCam;
                        TransitionTime = SprintTransitionTime;
                    }
                    else
                    {
                        if (Outer.IsZoomed())
                        {
                            Weapon = SFXWeapon(Outer.Pawn.Weapon);
                            if (Weapon != None && Weapon.bUseSniperCam && Player.IsUsingPower() == false)
                            {
                                NewCameraMode = SniperZoomCam;
                            }
                            else
                            {
                                NewCameraMode = TightAimCam;
                                TransitionTime = DefaultAimTransitionTime;
                            }
                        }
                        else
                        {
                            NewCameraMode = CombatCam;
                            TransitionTime = DefaultCombatTransitionTime;
                        }
                        if (SFXCameraMode_Cover(OldCameraMode) != None)
                        {
                            TransitionTime = 0,6;
                        }
                        if (SFXCameraMode_TightAim(OldCameraMode) != None || SFXCameraMode_TightAimCover(OldCameraMode) != None)
                        {
                            TransitionTime = DefaultAimTransitionExit;
                        }
                    }
                }
            }
        }
    }
    if (Outer.AimAssist != None && Outer.AimAssist.LastZoomSnapTarget != None)
    {
        Transition = ZoomSnapTransition;
        ZoomSnapTransition.ZoomSnapTargetLocation = Outer.AimAssist.LastZoomSnapTarget.Location + Outer.AimAssist.ZoomSnapTarget;
    }
    if (OldCameraMode == CombatStormCam || NewCameraMode == CombatStormCam || OldCameraMode == ExploreStormCam || NewCameraMode == ExploreStormCam || OldCameraMode == ExploreCam || NewCameraMode == ExploreCam)
    {
        TransitionTime = SprintFastTransitionTime;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == ExploreCam)
    {
        TransitionTime = SprintFastTransitionTime;
    }
    if (OldCameraMode == ExploreCam && NewCameraMode == CombatCam)
    {
        TransitionTime = SprintFastTransitionTime;
    }
    if (OldCameraMode == ExploreStormCam && NewCameraMode == ExploreCam)
    {
        TransitionTime = SprintTransitionTime;
    }
    if (OldCameraMode == ExploreStormCam && NewCameraMode == CombatCam)
    {
        TransitionTime = SprintTransitionTime;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverPeekLeftStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverPeekRightStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverPeekLeftCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatCam && NewCameraMode == CoverPeekRightCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CoverPeekLeftStand && NewCameraMode == CombatCam)
    {
        TransitionTime = CoverSlowTransitionTime;
    }
    if (OldCameraMode == CoverPeekRightCrouch && NewCameraMode == CoverStand)
    {
        TransitionTime = 2;
    }
    if (OldCameraMode == TightAimCoverCam && NewCameraMode == TightAimCoverPopupCam)
    {
        TransitionTime = 0,5;
    }
    if (OldCameraMode == CoverPeekRightCrouch && NewCameraMode == CoverCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CoverPeekLeftCrouch && NewCameraMode == CoverCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == TightAimCoverCam && NewCameraMode == TightAimCover_AimBack)
    {
        TransitionTime = 0,8;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverPeekLeftStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverPeekRightStand)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverPeekLeftCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (OldCameraMode == CombatStormCam && NewCameraMode == CoverPeekRightCrouch)
    {
        TransitionTime = CoverEnter;
    }
    if (NewCameraMode == SniperZoomCam || NewCameraMode == SniperZoomCoverCam || NewCameraMode == SniperZoomCover_AimBack)
    {
        TransitionTime = SniperZoomTransitionTime;
    }
    else
    {
        if (OldCameraMode == SniperZoomCam || OldCameraMode == SniperZoomCoverCam || OldCameraMode == SniperZoomCover_AimBack)
        {
            TransitionTime = SniperZoomTransitionTime;
        }
    }
    return NewCameraMode;
    return 1392509036;
}

exec function TightAim()
{
    local BioPawn ChkPawn;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    ClearTimer('TurnOffTightAim');
    BioPlayerInput(Outer.PlayerInput).bWantsToZoom = 1;
    Outer.GenerateTutorialEvent(2);
    if (Outer.AimAssist != None)
    {
        Outer.AimAssist.ZoomSnap();
    }
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None)
    {
        ChkPawn.m_oBehavior.SetActionState(1);
        if (ChkPawn.IsUsingPower())
        {
            BioActivePower(ChkPawn.m_oBehavior.m_oCurrentModalActive).ClearPreviousCoverAction();
        }
    }
}

exec function StopTightAim()
{
    SetTimer(InputDelayTightAimExit, false, 'TurnOffTightAim');
}

function TurnOffTightAim()
{
    BioPlayerInput(Outer.PlayerInput).bWantsToZoom = 0;
}

exec function EnterPowerWheel()
{
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    Outer.GameModeManager2.EnableMode(1);
}

exec function EnterWeaponWheel()
{
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    Outer.GameModeManager2.EnableMode(2);
}

exec function EnterCommandMenu()
{
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    Outer.GameModeManager2.EnableMode(3);
}

exec function UseAbility(int Ability)
{
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    MassEffectGuiManager(Outer.GetScaleFormManager()).m_oSFPowerWheelHandler.doHotKey(Ability);
}

exec function bool TryExitCover(bool bForceExit)
{
    local float MoveStickMag;
    local float MoveStickAngle;
    local Rotator MoveStickRot;
    local bool bCanStormOut;
    local ECoverAction CoverAction;
    Outer.ComputeMovementStickAngle(MoveStickMag, MoveStickAngle, MoveStickRot);
    bCanStormOut = true;
    CoverAction = BioPawn(Outer.Pawn).CoverAction;
    if (CoverAction != 3 && CoverAction != 4 && CoverAction != 9 && CoverAction != 10)
    {
        bCanStormOut = false;
    }
    if (Outer.IsInCoverState() && bForceExit || MoveStickMag > 0 && bCanStormOut)
    {
        SFXWeapon(Outer.Pawn.Weapon).CancelReload();
        Outer.BreakFromCover();
        if (Outer.IsCameraAlignedWithCoverSlot())
        {
            Outer.m_bDoCoverExitAccel = bForceExit;
        }
        return true;
    }
    return false;
}

exec function TryReload()
{
    local SFXWeapon Weapon;
    local BioPawn ChkPawn;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None && ChkPawn.ActionState != 1)
    {
        ChkPawn.m_oBehavior.SetActionState(1);
        return;
    }
    if (Outer.Pawn != None)
    {
        Weapon = SFXWeapon(Outer.Pawn.Weapon);
        if (Weapon != None && Weapon.CanReload())
        {
            Weapon.TryReload();
        }
    }
}

exec function TryMelee()
{
    local SFXWeapon Weapon;
    local BioPlayerInput Input;
    if (Outer.Pawn != None && Outer.Pawn.Weapon != None && Outer.IsZoomed() == false && Outer.IsInCoverState() == false)
    {
        Input = BioPlayerInput(Outer.PlayerInput);
        if (Input != None)
        {
            Weapon = SFXWeapon(Outer.Pawn.Weapon);
            if (Weapon != None)
            {
                Weapon.CancelReload();
                if (Weapon.MeleePowerName != 'None' && Weapon.IsInState('WeaponEquipping') == false && Weapon.IsInState('WeaponPuttingDown') == false)
                {
                    if (Input.ActivatePower(Weapon.MeleePowerName))
                    {
                        Outer.HintSystem.HintEvent('MELEE', Weapon.MeleePowerName);
                    }
                }
            }
        }
    }
}

exec function TryHeavyMelee()
{
    local SFXWeapon Weapon;
    local BioPlayerInput Input;
    if (Outer.Pawn != None && Outer.Pawn.Weapon != None && Outer.IsZoomed() == false && Outer.IsInCoverState() == false)
    {
        Input = BioPlayerInput(Outer.PlayerInput);
        if (Input != None)
        {
            Weapon = SFXWeapon(Outer.Pawn.Weapon);
            if (Weapon != None)
            {
                Weapon.CancelReload();
                if (Weapon.MeleePowerName != 'None' && Weapon.IsInState('WeaponEquipping') == false && Weapon.IsInState('WeaponPuttingDown') == false)
                {
                    Input.ActivatePower('HeavyPunch');
                    Outer.HintSystem.HintEvent('MELEE', Weapon.MeleePowerName);
                }
            }
        }
    }
}

exec function TryHolster()
{
    local BioPawn ChkPawn;
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None && ChkPawn.IsReloading(true) == false)
    {
        if (ChkPawn.InCombat())
        {
            return;
        }
        if (ChkPawn.IsUsingPower() || ChkPawn.IsInAnimatedTransition())
        {
            return;
        }
        if (Outer.IsInCoverState())
        {
            Outer.BreakFromCover();
        }
        ChkPawn.m_oBehavior.SetActionState(0);
    }
}

exec function bool Used()
{
    local Actor Selection;
    local bool bUsed;
    local SFXSimpleUseModule UseModule;
    local BioActorBehavior targetBehavior;
    Selection = Outer.m_oPlayerSelection.m_oCurrentSelectionTarget;
    if (Selection == None)
    {
        return false;
    }
    if (VSize(Outer.Pawn.Location - Selection.Location) <= Outer.InteractDistance)
    {
        UseModule = Selection.GetModule(Class'SFXSimpleUseModule');
        if (UseModule != None)
        {
            UseModule.OnUsed(Outer.Pawn);
            bUsed = true;
        }
    }
    if (Selection.TriggerEventClass(Class'SeqEvent_Used', Outer.Pawn))
    {
        bUsed = true;
    }
    targetBehavior = BioActorBehavior(Selection.oBioComponent);
    if (targetBehavior != None)
    {
        if (Outer.IsCombatTargetable(Selection) == false && targetBehavior.IsWithinUseRange(Outer.Pawn.Location))
        {
            if (Pawn(Selection) != None && BioAiController(Pawn(Selection).Controller) != None)
            {
                bUsed = BioAiController(Pawn(Selection).Controller).PlayerActivate(Outer.Pawn);
            }
        }
    }
    if (bUsed)
    {
        SFXGame(Outer.WorldInfo.Game).PlayTransientSound(UseSucceeded, Outer.Pawn.Location);
        Outer.m_oPlayerSelection.SetSelectionIconMaterialParam('Select_ok', 1);
        ClearTimer('ResetSelectionMaterialParams', self);
        SetTimer(0,25, false, 'ResetSelectionMaterialParams', self);
    }
    else
    {
        SFXGame(Outer.WorldInfo.Game).PlayTransientSound(UseFailed, Outer.Pawn.Location);
        Outer.m_oPlayerSelection.SetSelectionIconMaterialParam('Select_nodice', 1);
        ClearTimer('ResetSelectionMaterialParams', self);
        SetTimer(0,25, false, 'ResetSelectionMaterialParams', self);
    }
    return bUsed;
}

function ResetSelectionMaterialParams()
{
    Outer.m_oPlayerSelection.SetSelectionIconMaterialParam('Select_ok', 0);
    Outer.m_oPlayerSelection.SetSelectionIconMaterialParam('Select_nodice', 0);
}

exec function TrySwapWeapon()
{
    local SFXPawn_Player ChkPawn;
    ChkPawn = SFXPawn_Player(Outer.Pawn);
    if (ChkPawn != None)
    {
        if (ChkPawn.SwitchToBackupWeapon(SFXWeapon(ChkPawn.WeaponOnDeck)))
        {
            Outer.GenerateTutorialEvent(4);
        }
    }
}

exec function PrevWeapon()
{
    local SFXWeapon Weapon;
    local BioPawn ChkPawn;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None && ChkPawn.ActionState != 1)
    {
        BioPawn(Outer.Pawn).m_oBehavior.SetActionState(1);
        return;
    }
    Weapon = SFXWeapon(Outer.Pawn.Weapon);
    if (Weapon != None)
    {
        if (Weapon.IsInState('WeaponEquipping') || Weapon.IsInState('WeaponPuttingDown'))
        {
            return;
        }
        if (Outer.Pawn.InvManager != None && ChkPawn != None && ChkPawn.IsInCoverLeaning() == false)
        {
            Outer.Pawn.InvManager.PrevWeapon();
        }
    }
}

exec function NextWeapon()
{
    local SFXWeapon Weapon;
    local BioPawn ChkPawn;
    if (BioPlayerInput(Outer.PlayerInput).IsCombatEnabled() == false)
    {
        return;
    }
    ChkPawn = BioPawn(Outer.Pawn);
    if (ChkPawn != None && ChkPawn.ActionState != 1)
    {
        BioPawn(Outer.Pawn).m_oBehavior.SetActionState(1);
        return;
    }
    Weapon = SFXWeapon(Outer.Pawn.Weapon);
    if (Weapon != None)
    {
        if (Weapon.IsInState('WeaponEquipping') || Weapon.IsInState('WeaponPuttingDown'))
        {
            return;
        }
        if (Outer.Pawn.InvManager != None && ChkPawn != None && ChkPawn.IsInCoverLeaning() == false)
        {
            Outer.Pawn.InvManager.NextWeapon();
        }
    }
}

exec function StormOn()
{
    local bool bCanStorm;
    local ECoverAction CoverAction;
    if (Outer.RemappedJoyUp > 0)
    {
        bCanStorm = true;
        if (Outer.IsInCoverState())
        {
            CoverAction = BioPawn(Outer.Pawn).CoverAction;
            if (CoverAction != 3 && CoverAction != 4 && CoverAction != 9 && CoverAction != 10)
            {
                bCanStorm = false;
            }
            if (bCanStorm)
            {
                Outer.BreakFromCover();
            }
        }
        if (bCanStorm)
        {
            Outer.bWantsToStorm = 1;
            ClearTimer('TurnStormOff');
            Outer.GenerateTutorialEvent(5);
        }
    }
}

exec function StormOff()
{
    SetTimer(InputDelayStormExit, false, 'TurnStormOff');
}

function TurnStormOff()
{
    Outer.bWantsToStorm = 0;
}

exec function TryUsePower(int Power)
{
    local BioPlayerInput Input;
    local Name PowerName;
    local SFXPawn_Player Player;
    local SFXWeapon Weapon;
    local SFXPower oPower;
    Input = BioPlayerInput(Outer.PlayerInput);
    if (Input == None || Input.IsCombatEnabled() == false)
    {
        return;
    }
    Player = SFXPawn_Player(Outer.Pawn);
    if (Player != None && Player.IsPerformingBlockingAction())
    {
        return;
    }
    Weapon = SFXWeapon(Player.Weapon);
    Weapon.CancelReload();
    switch (Power)
    {
        case 0:
            PowerName = Input.m_nmMappedPower;
            break;
        case 1:
            PowerName = Input.m_nmMappedPower2;
            break;
        case 2:
            PowerName = Input.m_nmMappedPower3;
            break;
    }
    oPower = Player.FindPower(PowerName);
    if (oPower != None)
    {
        Outer.SquadOrderUsePower(oPower.PowerName, Outer.Pawn, 0, false);
        Outer.ApplyTacticalOrders();
        Outer.HintSystem.HintEvent('UseMappedPower', oPower.Class.Name);
        Outer.GenerateTutorialEvent(3);
    }
}

exec function bool ShowAreaMap()
{
    local MassEffectGuiManager oManager;
    local SFXSFHandler_AreaMap oHandler;
    local bool bGotMap;
    oManager = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (oManager != None)
    {
        oManager.ShowAreaMap();
        oHandler = oManager.GetAreaMapHandler();
        if (oHandler != None)
        {
            bGotMap = oHandler.Initialize(false);
        }
    }
    if (bGotMap == false)
    {
        PulseRadarDisplay(RadarMapDisplayTime);
    }
    else
    {
        ClearTimer('TurnObjectiveRadarDisplayOn', self);
    }
    return bGotMap;
}

exec function SwitchToBackup()
{
    if (Outer.Pawn == None || Outer.Pawn.Weapon == None || SFXWeapon(Outer.Pawn.Weapon) == None)
    {
        return;
    }
    if (SFXWeapon(Outer.Pawn.Weapon).OutOfAmmo() == false)
    {
        return;
    }
    if (SFXGame(Outer.WorldInfo.Game).gameconfig.bOutOfAmmoWeaponSwap == false)
    {
        return;
    }
    SFXPawn_Player(Outer.Pawn).SwitchToBackupWeapon();
}

defaultproperties
{
    InputDelayStormExit=0,23
    InputDelayTightAimExit=0,1
    RadarMapDisplayTime=1
    CombatCam=SFXCameraMode_Combat'CombatCam0'
    ExploreCam=SFXCameraMode_Explore'ExploreCam0'
    CombatStormCam=SFXCameraMode_CombatStorm'CombatStormCam0'
    ExploreStormCam=SFXCameraMode_ExploreStorm'ExploreStormCam0'
    TightAimCam=SFXCameraMode_TightAim'TightAimCam0'
    SniperZoomCam=SFXCameraMode_SniperZoom'SniperZoomCam0'
    TightAimCoverCam=SFXCameraMode_TightAimCover'TightAimCoverCam0'
    TightAimCoverPopupCam=SFXCameraMode_TightAimCover'TightAimCoverPopupCam0'
    SniperZoomCoverCam=SFXCameraMode_SniperZoomCover'SniperZoomCoverCam0'
    AimBackCam=SFXCameraMode_Cover'AimBackCam0'
    CoverStand=SFXCameraMode_Cover'CoverStand0'
    CoverCrouch=SFXCameraMode_Cover'CoverCrouch0'
    CoverPeekLeftStand=SFXCameraMode_CoverFixed'CoverPeekLeftStand0'
    CoverPeekLeftCrouch=SFXCameraMode_CoverFixed'CoverPeekLeftCrouch0'
    CoverPeekRightStand=SFXCameraMode_CoverFixed'CoverPeekRightStand0'
    CoverPeekRightCrouch=SFXCameraMode_CoverFixed'CoverPeekRightCrouch0'
    SniperZoomCover_AimBack=SFXCameraMode_SniperZoomCover'SniperZoomCrouchAimBackCam0'
    TightAimCover_AimBack=SFXCameraMode_TightAimCover'TightAimCoverAimBackCam0'
    SprintTransitionTime=1
    SprintFastTransitionTime=0,5
    DefaultAimTransitionTime=0,08
    DefaultAimTransitionExit=0,15
    DefaultCombatTransitionTime=0,25
    CoverEnter=0,75
    CoverTransitionTime=0,2
    CoverSlowTransitionTime=1
    SniperZoomTransitionTime=0,1
    ZoomSnapTransition=SFXCameraTransition_ZoomSnap'ZoomSnapTransition0'
    ZoomSnapCurve=(Points=?,InterpMethod=?)
    UseSucceeded=WwiseEvent'Play_SkillGameIncorrectButton'
    UseFailed=WwiseEvent'Play_SkillGameIncorrectButton'
    Bindings=System.Byte[]
    bShowHUD=true
    bShowSelection=true
    bShowDamageIndicators=true
    bShowRadar=true
    bAllowRotationUpdate=true
    bAllowMovement=true
    bAllowCamera=true
    bAllowCameraMods=true
    bAllowSave=true
    bAllowPauseMenu=true
    bShowSubtitle=true
    bShowReticles=true
    bPlayVocalizations=true
    // child object CombatCam0 of type SFXCameraMode_Combat
    // child object CombatStormCam0 of type SFXCameraMode_CombatStorm
    // child object AimBackCam0 of type SFXCameraMode_Cover
    // child object CoverCrouch0 of type SFXCameraMode_Cover
    // child object CoverStand0 of type SFXCameraMode_Cover
    // child object CoverPeekLeftCrouch0 of type SFXCameraMode_CoverFixed
    // child object CoverPeekLeftStand0 of type SFXCameraMode_CoverFixed
    // child object CoverPeekRightCrouch0 of type SFXCameraMode_CoverFixed
    // child object CoverPeekRightStand0 of type SFXCameraMode_CoverFixed
    // child object ExploreCam0 of type SFXCameraMode_Explore
    // child object ExploreStormCam0 of type SFXCameraMode_ExploreStorm
    // child object SniperZoomCam0 of type SFXCameraMode_SniperZoom
    // child object SniperZoomCoverCam0 of type SFXCameraMode_SniperZoomCover
    // child object SniperZoomCrouchAimBackCam0 of type SFXCameraMode_SniperZoomCover
    // child object TightAimCam0 of type SFXCameraMode_TightAim
    // child object TightAimCoverAimBackCam0 of type SFXCameraMode_TightAimCover
    // child object TightAimCoverCam0 of type SFXCameraMode_TightAimCover
    // child object TightAimCoverPopupCam0 of type SFXCameraMode_TightAimCover
    // child object ZoomSnapTransition0 of type SFXCameraTransition_ZoomSnap
}
