﻿class SFXGameModeGUI extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var() /* 00000008 */ SFXCameraTransition_GalaxyMap InstantTransition;

var() /* 00000008 */ BioCameraBehaviorFlourish DeathCam;

var array<Name> StackedGuis;

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    Transition = InstantTransition;
    TransitionTime = 0;
    PreserveTarget = 0;
    if (Outer.Pawn != None && Outer.Pawn.IsDead())
    {
        return DeathCam;
    }
    return OldCameraMode;
}

function Activated()
{
    Activated();
    MassEffectGuiManager(Outer.GetScaleFormManager()).HideHint();
    PauseTimeDilationEffects();
}

function Deactivated()
{
    if (StackedGuis.Length == 0)
    {
        Deactivated();
        MassEffectGuiManager(Outer.GetScaleFormManager()).RestoreHint();
        UnpauseTimeDilationEffects();
    }
}

function ActivateSpecifier(Name ModeSpecifier)
{
    StackedGuis.AddItem(ModeSpecifier);
}

function DeactivateSpecifier(Name ModeSpecifier)
{
    StackedGuis.RemoveItem(ModeSpecifier);
}

exec function NextCerberusItem()
{
    local BioSFHandler_MainMenu Menu;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Menu = GuiMan.GetMainMenuHandler();
        if (Menu != None)
        {
            Menu.NextCerberusItem();
        }
    }
}

exec function PrevCerberusItem()
{
    local BioSFHandler_MainMenu Menu;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Menu = GuiMan.GetMainMenuHandler();
        if (Menu != None)
        {
            Menu.PrevCerberusItem();
        }
    }
}

exec function DecryptUp()
{
    local BioSkillGame_Decryption_Handler Handler;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Handler = GuiMan.GetDecryptionHandler();
        if (Handler != None)
        {
            Handler.onUpPressed();
        }
    }
}

exec function DecryptDown()
{
    local BioSkillGame_Decryption_Handler Handler;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Handler = GuiMan.GetDecryptionHandler();
        if (Handler != None)
        {
            Handler.onDownPressed();
        }
    }
}

exec function DecryptLeft()
{
    local BioSkillGame_Decryption_Handler Handler;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Handler = GuiMan.GetDecryptionHandler();
        if (Handler != None)
        {
            Handler.onLeftPressed();
        }
    }
}

exec function DecryptRight()
{
    local BioSkillGame_Decryption_Handler Handler;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Handler = GuiMan.GetDecryptionHandler();
        if (Handler != None)
        {
            Handler.onRightPressed();
        }
    }
}

exec function DecryptSelect()
{
    local BioSkillGame_Decryption_Handler Handler;
    local MassEffectGuiManager GuiMan;
    GuiMan = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (GuiMan != None)
    {
        Handler = GuiMan.GetDecryptionHandler();
        if (Handler != None)
        {
            Handler.onSelectPressed();
        }
    }
}

exec function bool HideAreaMap()
{
    local MassEffectGuiManager oManager;
    local SFXSFHandler_AreaMap oHandler;
    oManager = MassEffectGuiManager(Outer.GetScaleFormManager());
    if (oManager != None)
    {
        oHandler = oManager.GetAreaMapHandler();
        if (oHandler != None)
        {
            oHandler.BeginClose();
            return true;
        }
    }
    return false;
}

defaultproperties
{
    DeathCam=BioCameraBehaviorFlourish'DeathCam0'
    InstantTransition=SFXCameraTransition_GalaxyMap'InstantTransition0'
    Bindings=System.Byte[]
    bAllowSave=true
    bMergeNotifications=true
    bQueueAndSuppressNotifications=true
    Priority=ModePriority_Menus
    // child object DeathCam0 of type BioCameraBehaviorFlourish
    // child object InstantTransition0 of type SFXCameraTransition_GalaxyMap
}
