﻿class SFXGameModeGalaxy extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var float DeadZone;

var() /* 00000008 */ SFXCameraTransition_GalaxyMap InstantTransition;

var() /* 00000008 */ BioCameraBehaviorGalaxy GalaxyCam;

function Initialize()
{
    GalaxyCam.Input.m_bUseExplorationSensitivity = true;
    Initialize();
}

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    Transition = InstantTransition;
    TransitionTime = 0;
    PreserveTarget = 0;
    return GalaxyCam;
}

function SFXCameraMode HACK_GetCameraMode()
{
    return GalaxyCam;
}

function bool CanExit()
{
    return true;
}

function BeginExitGalaxyMap(bool resize);

exec function BuyProbes()
{
    local SFXInventoryManager oInventory;
    if (GalaxyCam.m_nCurrentState != 3 || GalaxyCam.m_pSelectedObject != GalaxyCam.m_pDepotObject)
    {
        return;
    }
    oInventory = SFXInventoryManager(Outer.Pawn.InvManager);
    if (oInventory.GetResource(8) < oInventory.GetMaxProbes() && oInventory.GetResource(0) > 100)
    {
        oInventory.AdjustResource(8, 5, false);
        oInventory.AdjustResource(0, -100, false);
        GalaxyCam.m_pAudioComponent.Play(GalaxyCam.m_pBuyProbeSound);
    }
}

exec function BuyFuel()
{
    local SFXInventoryManager oInventory;
    local float fPreviousFuel;
    if (GalaxyCam.m_nCurrentState != 3 || GalaxyCam.m_pSelectedObject != GalaxyCam.m_pDepotObject)
    {
        return;
    }
    oInventory = SFXInventoryManager(Outer.Pawn.InvManager);
    fPreviousFuel = oInventory.CurrentFuel;
    if (fPreviousFuel < oInventory.GetMaxFuel())
    {
        oInventory.CurrentFuel = FMin(oInventory.CurrentFuel + 25, oInventory.GetMaxFuel());
        if (oInventory.GetResource(0) > 0)
        {
            oInventory.AdjustResource(0, -25, false);
        }
        if (oInventory.CurrentFuel >= oInventory.GetMaxFuel())
        {
            GalaxyCam.m_pAudioComponent.Play(GalaxyCam.m_pBuyFuelSound_Full);
        }
        else
        {
            GalaxyCam.m_pAudioComponent.SetWwiseRTPC(GalaxyCam.m_sBuyFuelSound_PctFullRTPCName, oInventory.CurrentFuel / oInventory.GetMaxFuel());
        }
    }
}

exec function StartFuel()
{
    local SFXInventoryManager oInventory;
    oInventory = SFXInventoryManager(Outer.Pawn.InvManager);
    if (GalaxyCam.m_nCurrentState != 3 || GalaxyCam.m_pSelectedObject != GalaxyCam.m_pDepotObject)
    {
        return;
    }
    if (oInventory.CurrentFuel < oInventory.GetMaxFuel())
    {
        GalaxyCam.m_pAudioComponent.Play(GalaxyCam.m_pBuyFuelSound);
    }
}

exec function StopFuel()
{
    local SFXInventoryManager oInventory;
    oInventory = SFXInventoryManager(Outer.Pawn.InvManager);
    if (GalaxyCam.m_nCurrentState != 3 || GalaxyCam.m_pSelectedObject != GalaxyCam.m_pDepotObject)
    {
        return;
    }
    if (oInventory.CurrentFuel < oInventory.GetMaxFuel())
    {
        GalaxyCam.m_pAudioComponent.Play(GalaxyCam.m_pBuyFuelSoundStop);
    }
}

exec function TabRight()
{
    local BioSFPanel oPanel;
    local array<ASParams> lstParams;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    lstParams.Length = 0;
    oPanel = oWorldInfo.GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    oPanel.InvokeMethodArgs("tabRight", lstParams);
}

exec function TabLeft()
{
    local BioSFPanel oPanel;
    local array<ASParams> lstParams;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    lstParams.Length = 0;
    oPanel = oWorldInfo.GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    oPanel.InvokeMethodArgs("tabLeft", lstParams);
}

defaultproperties
{
    GalaxyCam=BioCameraBehaviorGalaxy'GalaxyCam0'
    InstantTransition=SFXCameraTransition_GalaxyMap'InstantTransition0'
    DeadZone=0,1
    Bindings=System.Byte[]
    bShowHUD=true
    bAllowSave=true
    bShowSubtitle=true
    Priority=ModePriority_Menus
    // child object GalaxyCam0 of type BioCameraBehaviorGalaxy
    // child object InstantTransition0 of type SFXCameraTransition_GalaxyMap
}
