﻿class SFXGameModeOrbital extends SFXGameModeGalaxy
    within BioPlayerController
    config(Input);

var /* 00000008 */ transient array<ParticleSystemComponent> TemporaryComponents;

var transient float fResourceTimer;

var /* 00000008 */ transient WwiseAudioComponent AudioComponent;

var transient float fResourceRetrievalFactor;

var float fSpectrographUpdateDelay;

var transient float fSpectrographUpdateTime;

var ScreenShakeStruct BigShake;

var ScreenShakeStruct Shake;

var ForceFeedbackWaveform ResourceFFWaveForm;

var float ImpactTimeMax;

var transient float ImpactTime;

var transient float fMaxRescaleTime;

var transient float fNewScale;

var transient float fInitialScale;

var transient float fRescaleTime;

var transient float Roll;

var transient float ReticleScale;

var transient Vector ProbeControlPtLocation;

var transient Vector ProbeTargetLocation;

var transient Vector ProbeLaunchLocation;

var transient bool bMouseLock;

var transient bool DrawProbeDebugLines;

var transient bool ImpactActive;

var transient bool bExiting;

var transient bool bRescaling;

var transient bool ProbeActive;

var /* 00000008 */ transient ParticleSystemComponent ProbeExplosionEffect;

var /* 00000008 */ transient ParticleSystemComponent LaunchReticleEffect;

var /* 00000008 */ transient ParticleSystemComponent ScanDirectionEffect;

var /* 00000008 */ transient ParticleSystemComponent ScanBlipEffect;

var /* 00000008 */ transient ParticleSystemComponent ScanWipeEffect;

var /* 00000008 */ transient ParticleSystemComponent ScanReticleEffect;

var /* 00000008 */ transient ParticleSystemComponent ReticleEffect;

var float ScanDist;

var float ProbeLaunchTimeMax;

var float ProbeLaunchTime;

var float ScannerRotateSpeed;

var bool Scanning;

var float ProbeControlTargetOffset;

var float ProbeControlAxisOffset;

var float MoveDist;

var config float ScanReticleMoveSpeed;

var config float ReticleMoveSpeed;

var config float ScanPlanetRotationSpeed;

var config float PlanetRotationSpeed;

var Rotator ReticleRotMinClamp;

var Rotator ReticleRotMaxClamp;

var Rotator ReticleRot;

function SFXCameraMode GetCameraMode(SFXCameraMode OldCameraMode, out int PreserveTarget, out float TransitionTime, out SFXCameraMode_Interpolate Transition)
{
    return Outer.GameModeManager2.GameModes[9].GetCameraMode(OldCameraMode, PreserveTarget, TransitionTime, Transition);
}

function Activated()
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local InterpActor oPlanet;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    oController.HintSystem.HintEvent('StartPlanetScanner');
    Activated();
    ProbeLaunchLocation = GetGameData().Probe.Location;
    if (AudioComponent == None)
    {
        AudioComponent = Class'WwiseAudioComponent'.CreateComponentFromScript(GetGameData().GetWorldInfo());
    }
    AudioComponent.SetGlobalRTPCFromScript("Music_Galaxy_Map_Type", 1);
    oPlanet = GetGameData().Planet;
    if (oPlanet.DrawScale3D.X != 5,5)
    {
        fInitialScale = oPlanet.DrawScale3D.X;
        fNewScale = 5,5;
        bRescaling = true;
    }
    if (ReticleEffect == None)
    {
        ReticleEffect = new(Class'ParticleSystemComponent');
        ReticleEffect.SetTemplate(GetGameData().Reticle);
        ReticleEffect.SetAbsolute(false, true, false);
        ReticleEffect.SetScale(ReticleScale);
        GetGameData().Planet.AttachComponent(ReticleEffect);
    }
    ReticleEffect.DeactivateSystem();
    if (ScanReticleEffect == None)
    {
        ScanReticleEffect = new(Class'ParticleSystemComponent');
        ScanReticleEffect.SetTemplate(GetGameData().ScanReticle);
        ScanReticleEffect.SetAbsolute(false, true, false);
        ScanReticleEffect.SetScale(ReticleScale);
        ScanReticleEffect.bAutoActivate = false;
        GetGameData().Planet.AttachComponent(ScanReticleEffect);
    }
    ScanReticleEffect.DeactivateSystem();
    if (LaunchReticleEffect == None)
    {
        LaunchReticleEffect = new(Class'ParticleSystemComponent');
        LaunchReticleEffect.SetTemplate(GetGameData().LaunchReticle);
        LaunchReticleEffect.SetAbsolute(false, true, false);
        LaunchReticleEffect.SetScale(ReticleScale);
        LaunchReticleEffect.bAutoActivate = false;
        GetGameData().Planet.AttachComponent(LaunchReticleEffect);
    }
    LaunchReticleEffect.DeactivateSystem();
    if (ScanWipeEffect == None && GetGameData().ScanWipe != None)
    {
        ScanWipeEffect = new(Class'ParticleSystemComponent');
        ScanWipeEffect.SetTemplate(GetGameData().ScanWipe);
        ScanWipeEffect.SetAbsolute(false, true, false);
        ScanWipeEffect.SetScale(ReticleScale);
        ScanWipeEffect.bAutoActivate = false;
        GetGameData().Planet.AttachComponent(ScanWipeEffect);
    }
    ScanWipeEffect.DeactivateSystem();
    if (ScanBlipEffect == None && GetGameData().ScanBlip != None)
    {
        ScanBlipEffect = new(Class'ParticleSystemComponent');
        ScanBlipEffect.SetTemplate(GetGameData().ScanBlip);
        ScanBlipEffect.SetAbsolute(false, false, false);
        ScanBlipEffect.SetScale(ReticleScale * 1,5);
        ScanBlipEffect.bAutoActivate = false;
        GetGameData().Planet.AttachComponent(ScanBlipEffect);
    }
    ScanBlipEffect.DeactivateSystem();
    if (ScanDirectionEffect == None && GetGameData().ScanDirection != None)
    {
        ScanDirectionEffect = new(Class'ParticleSystemComponent');
        ScanDirectionEffect.SetTemplate(GetGameData().ScanDirection);
        ScanDirectionEffect.SetAbsolute(false, true, false);
        ScanDirectionEffect.SetScale(ReticleScale);
        ScanDirectionEffect.bAutoActivate = false;
        GetGameData().Planet.AttachComponent(ScanDirectionEffect);
    }
    ScanDirectionEffect.DeactivateSystem();
    if (ProbeExplosionEffect != None)
    {
        ProbeExplosionEffect.DeactivateSystem();
    }
    UpdateReticle();
    oPanel = oWorldInfo.GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        oInventory = SFXInventoryManager(oController.Pawn.InvManager);
        stParam.Type = 2;
        stParam.sVar = SFXGame(oWorldInfo.Game).GetSimpleString(GetGameData().CurrentPlanet.DisplayName);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = oInventory.GetResource(4);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = oInventory.GetResource(5);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = oInventory.GetResource(7);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = oInventory.GetResource(6);
        lstParams.AddItem(stParam);
        stParam.Type = 0;
        stParam.nVar = oInventory.GetResource(8);
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("initializeInventory", lstParams);
    }
    SetLTriggerLabelVisible(true);
    ToggleMouseLock(true);
    bExiting = false;
}

function UpdatePlanetRichness()
{
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local BioWorldInfo oWorldInfo;
    local int nNumOver2000;
    local int nNumOver1500;
    local int nNumOver750;
    local int nNumOver350;
    local SFXPlanetFeature F;
    oWorldInfo = BioWorldInfo(GetGameData().GetWorldInfo());
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    foreach GetGameData().CurrentPlanet.Features(F)
    {
        if (F.FeatureType == 1)
        {
            if (F.ScaledAmount >= 2000)
            {
                nNumOver2000++;
            }
            if (F.ScaledAmount >= 1500)
            {
                nNumOver1500++;
            }
            if (F.ScaledAmount >= 750)
            {
                nNumOver750++;
            }
            if (F.ScaledAmount >= 350)
            {
                nNumOver350++;
            }
        }
    }
    if (nNumOver2000 >= 2)
    {
        nRichnessStrref = // unknown bytecode 4F ;
    }
}

function Deactivated()
{
    local int I;
    local BioPlayerController oController;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    oController.HintSystem.HintEvent('ClosePlanetScanner');
    Deactivated();
    ResetProbe();
    if (ReticleEffect != None)
    {
        ReticleEffect.DeactivateSystem();
    }
    if (ScanReticleEffect != None)
    {
        ScanReticleEffect.DeactivateSystem();
    }
    if (ProbeExplosionEffect != None)
    {
        ProbeExplosionEffect.DeactivateSystem();
    }
    if (LaunchReticleEffect != None)
    {
        LaunchReticleEffect.DeactivateSystem();
    }
    if (ScanWipeEffect != None)
    {
        ScanWipeEffect.DeactivateSystem();
    }
    if (ScanBlipEffect != None)
    {
        ScanBlipEffect.DeactivateSystem();
    }
    if (ScanDirectionEffect != None)
    {
        ScanDirectionEffect.DeactivateSystem();
    }
    Outer.ClientStopForceFeedbackWaveform(ResourceFFWaveForm);
    AudioComponent.SetGlobalRTPCFromScript("Music_Galaxy_Map_Type", 0);
    I = 0;
    while (I < GetGameData().MineralStopEvents.Length)
    {
        AudioComponent.Play(GetGameData().MineralStopEvents[I]);
        I++;
    }
    AudioComponent = None;
    I = 0;
    while (I < TemporaryComponents.Length)
    {
        TemporaryComponents[I].DeactivateSystem();
        GetGameData().Planet.DetachComponent(TemporaryComponents[I]);
        I++;
    }
    GetGameData().EndAction();
    SetRTriggerLabelVisible(false);
    SetLTriggerLabelVisible(false);
    ToggleMouseLock(false);
}

function BeginExitGalaxyMap(bool resize)
{
    ReticleEffect.DeactivateSystem();
    bExiting = true;
    if (fInitialScale > 0 && resize)
    {
        fNewScale = fInitialScale;
        fInitialScale = 5,5;
        bRescaling = true;
    }
}

function BioSeqAct_OrbitalGame GetGameData()
{
    local SeqAct_Latent SeqAct;
    foreach Outer.Pawn.LatentActions(SeqAct)
    {
        if (BioSeqAct_OrbitalGame(SeqAct) != None)
        {
            return BioSeqAct_OrbitalGame(SeqAct);
        }
    }
    return None;
}

event bool CanExit()
{
    return CanExit() && !ProbeActive && !Scanning && !ImpactActive && !bRescaling;
}

function ResetProbe()
{
    local InterpActor Probe;
    Probe = GetGameData().Probe;
    Probe.SetHidden(true);
    GetGameData().ProbeTrail.SetHidden(true);
    ProbeActive = false;
    Probe.SetLocation(ProbeLaunchLocation);
    GetGameData().ProbeTrail.ParticleSystemComponent.DeactivateSystem();
}

function UpdatePlanetScale(float DeltaTime)
{
    local InterpActor oPlanet;
    local Vector vNewScale;
    local Vector vNewRingScale;
    fRescaleTime += DeltaTime;
    fRescaleTime = FMin(fRescaleTime, fMaxRescaleTime);
    oPlanet = GetGameData().Planet;
    vNewScale.X = FInterpEaseIn(fInitialScale, fNewScale, fRescaleTime / fMaxRescaleTime, 2);
    vNewScale.Y = vNewScale.X;
    vNewScale.Z = vNewScale.X;
    oPlanet.SetDrawScale3D(vNewScale);
    if (GetGameData().Ring != None)
    {
        vNewRingScale = vNewScale * 6,855;
        GetGameData().Ring.SetDrawScale3D(vNewRingScale);
    }
    if (GetGameData().Clouds != None)
    {
        vNewScale.X *= 1,005;
        vNewScale.Z = vNewScale.X;
        vNewScale.Z = vNewScale.X;
        GetGameData().Clouds.SetDrawScale3D(vNewScale);
    }
    if (GetGameData().ScanSphere != None)
    {
        GetGameData().ScanSphere.SetDrawScale3D(vNewScale);
    }
    if (fRescaleTime >= fMaxRescaleTime)
    {
        bRescaling = false;
        fRescaleTime = 0;
    }
}

function Update(float DeltaTime)
{
    local Vector oldPos;
    local Vector NewPos;
    local InterpActor Probe;
    local float T;
    local BioSFPanel oPanel;
    local Rotator planetRot;
    Probe = GetGameData().Probe;
    if (bRescaling)
    {
        UpdatePlanetScale(DeltaTime);
        return;
    }
    if (!ReticleEffect.bIsActive)
    {
        ReticleEffect.ActivateSystem();
    }
    if (!ProbeActive && !Scanning && !ImpactActive)
    {
        planetRot = GetGameData().Planet.Rotation;
        planetRot.Yaw += GetGameData().CurrentPlanet.PlanetRotation * 182,0444 * DeltaTime;
        GetGameData().Planet.SetRotation(planetRot);
    }
    if (ProbeActive)
    {
        oldPos = Probe.Location;
        ProbeLaunchTime += DeltaTime;
        T = ProbeLaunchTime * ProbeLaunchTime / ProbeLaunchTimeMax * ProbeLaunchTimeMax;
        if (DrawProbeDebugLines)
        {
            Probe.DrawDebugLine(ProbeLaunchLocation, ProbeTargetLocation, 255, 0, 0);
            Probe.DrawDebugLine(ProbeLaunchLocation, ProbeControlPtLocation, 0, 255, 0);
            Probe.DrawDebugLine(ProbeControlPtLocation, ProbeTargetLocation, 0, 255, 0);
            Probe.DrawDebugLine(VLerp(ProbeLaunchLocation, ProbeControlPtLocation, T), VLerp(ProbeControlPtLocation, ProbeTargetLocation, T), 0, 0, 255);
        }
        NewPos = VLerp(VLerp(ProbeLaunchLocation, ProbeControlPtLocation, T), VLerp(ProbeControlPtLocation, ProbeTargetLocation, T), T);
        Probe.MoveSmooth(NewPos - Probe.Location);
        Probe.SetRotation(Probe.Location - oldPos);
        if (VSize(Probe.Location - ProbeTargetLocation) < 10 || ProbeLaunchTime >= ProbeLaunchTimeMax)
        {
            ResetProbe();
            ProbeImpact();
        }
    }
    if (ImpactActive)
    {
        ImpactTime += DeltaTime;
        if (ImpactTime >= ImpactTimeMax)
        {
            EndImpact();
        }
    }
    UpdateReticle();
    fSpectrographUpdateTime += DeltaTime;
    if (fSpectrographUpdateTime > fSpectrographUpdateDelay)
    {
        fSpectrographUpdateTime = 0;
        if (Scanning)
        {
            ScanResources(DeltaTime);
        }
        else
        {
            oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
            if (oPanel != None)
            {
                oPanel.InvokeMethod("flatlineScanner");
            }
        }
    }
}

function int ScannedResourceAmount(float fDistTo, int ResourceAmount)
{
    return Max(ScanDist - fDistTo / ScanDist * ResourceAmount * fResourceRetrievalFactor, 0);
}

function ScanResources(float DeltaTime)
{
    local InterpActor P;
    local SFXPlanetFeature F;
    local float fDist;
    local Vector pos;
    local Vector scanPos;
    local array<float> Resources;
    local BioSFPanel oPanel;
    local BioSFHandler_GalaxyMap oHandler;
    local BioWorldInfo WorldInfo;
    local int I;
    local Vector toLanding;
    local float distToLanding;
    distToLanding = -1;
    if (GetGameData().CurrentPlanet.PlanetLevelType != 1 && GetGameData().CurrentPlanet.PlanetLevelType != 6)
    {
        return;
    }
    WorldInfo = BioWorldInfo(GetGameData().GetWorldInfo());
    P = GetGameData().Planet;
    scanPos = GetRelativeReticlePosition();
    pos = scanPos / 5,5 << P.Rotation;
    // unknown bytecode 54 ;
}

function ShowHUDAnomalyIndicator()
{
    local BioSFPanel oPanel;
    local array<ASParams> lstParams;
    lstParams.Length = 0;
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        oPanel.InvokeMethodArgs("showAnomaly", lstParams);
    }
}

function UpdateAnomalyIndicator(Vector toLanding, float DeltaTime, bool flashIndicator)
{
    local Rotator Rot;
    local Vector Dir;
    local float Angle;
    local InterpActor P;
    local float lastRoll;
    local bool wrapped;
    P = GetGameData().Planet;
    wrapped = false;
    lastRoll = Roll;
    Roll += DeltaTime * ScannerRotateSpeed;
    if (Roll > 360)
    {
        wrapped = true;
        Roll -= 360;
    }
    Rot = ReticleRot;
    Rot.Roll = Roll * 182,0444;
    ScanWipeEffect.SetRotation(Rot);
    if (flashIndicator == false || ProbeActive == true || ImpactActive)
    {
        return;
    }
    if (VSize(toLanding) * 5,5 < ScanDist)
    {
        if (!ScanBlipEffect.bIsActive)
        {
            ScanBlipEffect.ActivateSystem();
        }
    }
    else
    {
        if (ScanBlipEffect.bIsActive)
        {
            ScanBlipEffect.DeactivateSystem();
        }
    }
    toLanding = toLanding >> P.Rotation;
    Dir = toLanding << ReticleRot;
    Dir.X = 0;
    Dir = Normal(Dir);
    Angle = Atan(-Dir.Z, Dir.Y) * 57,29578 + 90;
    if (Angle < 0)
    {
        Angle += 360;
    }
    if (Angle > lastRoll && Angle <= Roll || wrapped && Angle - 360 > lastRoll - 360 && Angle - 360 <= Roll || wrapped && Angle > lastRoll - 360 && Angle <= Roll && !P.IsTimerActive('AnomalyIndicator'))
    {
        P.SetTimer(0,75, false, 'AnomalyIndicator');
        Roll = Angle;
        ScanDirectionEffect.ActivateSystem();
        ShowHUDAnomalyIndicator();
        if (GetGameData().LandingSiteIndicator != None)
        {
            AudioComponent.Play(GetGameData().LandingSiteIndicator);
            AudioComponent.SetWwiseRTPC(GetGameData().LandingSiteIndicator_RTPCName, VSize(toLanding) / 100);
        }
        ScanDirectionEffect.SetRotation(Rot);
    }
}

function Vector GetRelativeReticlePosition()
{
    local Vector V;
    local float PlanetSize;
    if (GetGameData().CurrentPlanet != None)
    {
        PlanetSize = GetGameData().CurrentPlanet.GetPlanetSize();
    }
    else
    {
        PlanetSize = Class'BioPlanet'.Default.DefaultDisplaySize;
    }
    V = ReticleRot * PlanetSize;
    return V;
}

function StartFeatureSounds()
{
    local SFXPlanetFeature F;
    local BioWorldInfo WorldInfo;
    local bool LandingSite;
    WorldInfo = BioWorldInfo(GetGameData().GetWorldInfo());
    foreach GetGameData().CurrentPlanet.Features(F)
    {
        if (WorldInfo.CheckConditional(F.VisibleConditional, F.VisibleParameter))
        {
            if (F.FeatureType == 5)
            {
                LandingSite = true;
            }
            if (F.StartEvent != None && F.StopEvent != None)
            {
                AudioComponent.Play(F.StartEvent);
                AudioComponent.SetWwiseRTPC(F.RTPCName, 1);
            }
        }
    }
    if (LandingSite)
    {
        AudioComponent.Play(GetGameData().AnomalyStaticStart);
        WorldInfo.GetLocalPlayerController().HintSystem.HintEvent('PlanetScanAnomaly');
    }
}

function StopFeatureSounds()
{
    local SFXPlanetFeature F;
    foreach GetGameData().CurrentPlanet.Features(F)
    {
        if (F.StartEvent != None && F.StopEvent != None)
        {
            AudioComponent.Play(F.StopEvent);
        }
    }
}

exec function ToggleMouseLock(bool bNewMouseLock)
{
    local BioSFPanel oPanel;
    local BioSFHandler_GalaxyMap oHandler;
    bMouseLock = bNewMouseLock;
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        oHandler = BioSFHandler_GalaxyMap(oPanel.ScriptHandlers[0]);
        if (oHandler == None)
        {
            return;
        }
    }
    if (bMouseLock)
    {
        oHandler.SetMouseShown(false);
    }
    else
    {
        oHandler.SetMouseShown(true);
    }
}

function UpdateProbeHudElement(int nProbes)
{
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        stParam.Type = 0;
        stParam.nVar = nProbes;
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("updateProbeCount", lstParams);
    }
}

function SetRTriggerLabelVisible(bool bShow)
{
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        stParam.Type = 3;
        stParam.bVar = bShow;
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("setRTLabelVisible", lstParams);
    }
}

function SetLTriggerLabelVisible(bool bShow)
{
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        stParam.Type = 3;
        stParam.bVar = bShow;
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("setLTLabelVisible", lstParams);
    }
}

function SetButtonLabel(String sButton)
{
    local BioSFPanel oPanel;
    local ASParams stParam;
    local array<ASParams> lstParams;
    local BioWorldInfo oWorldInfo;
    oWorldInfo = BioWorldInfo(GetGameData().GetWorldInfo());
    oPanel = oWorldInfo.GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (oPanel != None)
    {
        stParam.Type = 2;
        stParam.sVar = sButton;
        lstParams.AddItem(stParam);
        stParam.Type = 2;
        stParam.sVar = SFXGame(oWorldInfo.Game).GetSimpleString(nText);
        lstParams.AddItem(stParam);
        oPanel.InvokeMethodArgs("updateControllerButton", lstParams);
    }
}

exec function StartScanning()
{
    local int I;
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    if (bRescaling || bExiting)
    {
        return;
    }
    if (GetGameData().CurrentPlanet.PlanetLevelType != 1 && GetGameData().CurrentPlanet.PlanetLevelType != 6)
    {
        return;
    }
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    oController.HintSystem.HintEvent('StartScanning');
    Scanning = true;
    if (!ProbeActive && !ImpactActive)
    {
        ScanReticleEffect.ActivateSystem();
        ScanWipeEffect.ActivateSystem();
    }
    SetLTriggerLabelVisible(false);
    SetRTriggerLabelVisible(true);
    Outer.ClientPlayForceFeedbackWaveform(ResourceFFWaveForm);
    ResourceFFWaveForm.Samples[0].LeftAmplitude = 0;
    ResourceFFWaveForm.Samples[0].RightAmplitude = 0;
    StartFeatureSounds();
    I = 0;
    while (I < GetGameData().MineralStartEvents.Length)
    {
        AudioComponent.Play(GetGameData().MineralStartEvents[I]);
        I++;
    }
    Class'BioTelemetry'.SendEventInt('PLANET_SCANNED', GetGameData().CurrentPlanet.ActiveWorld);
}

exec function StopScanning()
{
    local int I;
    local SFXPlanetFeature F;
    if (GetGameData().CurrentPlanet.PlanetLevelType != 1 && GetGameData().CurrentPlanet.PlanetLevelType != 6)
    {
        return;
    }
    Scanning = false;
    SetLTriggerLabelVisible(true);
    SetRTriggerLabelVisible(false);
    ScanReticleEffect.DeactivateSystem();
    ScanWipeEffect.DeactivateSystem();
    ScanBlipEffect.DeactivateSystem();
    ScanDirectionEffect.DeactivateSystem();
    StopFeatureSounds();
    Outer.ClientStopForceFeedbackWaveform(ResourceFFWaveForm);
    I = 0;
    while (I < GetGameData().MineralStopEvents.Length)
    {
        AudioComponent.Play(GetGameData().MineralStopEvents[I]);
        I++;
    }
    foreach GetGameData().CurrentPlanet.Features(F)
    {
        if (F.StartEvent != None && F.StopEvent != None)
        {
            AudioComponent.Play(F.StopEvent);
        }
    }
    AudioComponent.Play(GetGameData().AnomalyStaticStop);
}

function ProbeImpact()
{
    local Rotator Rot;
    local InterpActor Planet;
    Planet = GetGameData().Planet;
    if (GetGameData().ProbeImpact != None)
    {
        ImpactActive = true;
        if (ProbeExplosionEffect == None)
        {
            ProbeExplosionEffect = new(Class'ParticleSystemComponent');
        }
        Rot = ReticleRot;
        Rot.Pitch -= 90 * 182,0444;
        ProbeExplosionEffect.SetTranslation(100 * ReticleRot);
        ProbeExplosionEffect.SetRotation(Rot);
        ProbeExplosionEffect.SetScale(ReticleScale);
        ProbeExplosionEffect.SetAbsolute(false, true, false);
        Planet.AttachComponent(ProbeExplosionEffect);
        ProbeExplosionEffect.SetTemplate(GetGameData().ProbeImpact);
        ProbeExplosionEffect.ActivateSystem();
        AudioComponent.Play(GetGameData().ProbeImpactSound);
        GetGameData().SignalProbeImpact();
    }
}

function ShowProbeImpactVFX(BioPlanet PlanetData, Vector pos, InterpActor Planet)
{
    local ParticleSystemComponent Particle;
    if (GetGameData().ProbeLocationMarker != None)
    {
        Particle = new(Class'ParticleSystemComponent');
        Particle.SetTemplate(GetGameData().ProbeLocationMarker);
        Particle.SetAbsolute(false, false, false);
        Particle.SetTranslation(pos);
        Particle.SetRotation(pos);
        Particle.bAutoActivate = true;
        Planet.AttachComponent(Particle);
        TemporaryComponents.AddItem(Particle);
    }
    PlanetData.SaveProbeImpact(PlanetData.SphereToPlanePos(pos, 100));
}

function EndImpact()
{
    local SFXPlanetFeature F;
    local Vector pos;
    local InterpActor Planet;
    local float fDist;
    local int nRetrievedAmount;
    local int nLargestRetrievedAmount;
    local EMineralType RetrievedType;
    local BioWorldInfo WorldInfo;
    local bool bMiningSuccessful;
    local BioPlayerController PC;
    local bool RevealLandingSite;
    RevealLandingSite = false;
    WorldInfo = BioWorldInfo(GetGameData().GetWorldInfo());
    PC = WorldInfo.GetLocalPlayerController();
    Planet = GetGameData().Planet;
    if (Scanning)
    {
        ScanReticleEffect.ActivateSystem();
    }
    LaunchReticleEffect.DeactivateSystem();
    ImpactActive = false;
    ImpactTime = 0;
    pos = ProbeTargetLocation - Planet.Location / 5,5 << Planet.Rotation;
    RetrievedType = 4;
    bMiningSuccessful = false;
    if (GetGameData().CurrentPlanet != None)
    {
        foreach GetGameData().CurrentPlanet.Features(F)
        {
            fDist = VSize(F.Position - pos) * 5,5 - 50;
            if (fDist <= ScanDist && WorldInfo.CheckConditional(F.VisibleConditional, F.VisibleParameter))
            {
                WorldInfo.ExecuteStateTransition(F.FeatureTransition, F.FeatureTransitionParameter);
                if (F.FeatureType == 1 && F.ScaledAmount > 0)
                {
                    nRetrievedAmount = ScannedResourceAmount(fDist, F.ScaledAmount);
                    nRetrievedAmount = Min(nRetrievedAmount, F.ScaledAmount);
                    if (nRetrievedAmount > nLargestRetrievedAmount)
                    {
                        nLargestRetrievedAmount = nRetrievedAmount;
                        RetrievedType = F.MineralType;
                    }
                    PC.UnlockAchievement(41);
                    GiveResource(F.FeatureType, F.MineralType, nRetrievedAmount);
                    F.ScaledAmount -= nRetrievedAmount;
                    if (nRetrievedAmount > 0)
                    {
                        bMiningSuccessful = true;
                    }
                }
                else
                {
                    if (F.FeatureType == 5)
                    {
                        RevealLandingSite = true;
                        PC.HintSystem.HintEvent('PlanetRevealAnomaly');
                        if (F.ParticleComponent != None && GetGameData().LandingSiteMarker != None)
                        {
                            F.ParticleComponent.SetTemplate(GetGameData().LandingSiteMarker);
                            F.ParticleComponent.SetTranslation(F.Position);
                            F.ParticleComponent.ActivateSystem();
                        }
                        Class'BioTelemetry'.SendEventInt('ORBITAL_N7_DISCOVERED', GetGameData().CurrentPlanet.ActiveWorld);
                    }
                }
            }
        }
        ShowProbeImpactVFX(GetGameData().CurrentPlanet, pos, Planet);
    }
    if (nLargestRetrievedAmount == 0)
    {
        AudioComponent.Play(GetGameData().MineralRecoverySound_None);
    }
    else
    {
        if (nLargestRetrievedAmount > 750)
        {
            AudioComponent.Play(GetGameData().MineralRecoverySound_Large);
        }
        else
        {
            if (nLargestRetrievedAmount > 500)
            {
                AudioComponent.Play(GetGameData().MineralRecoverySound_Medium);
            }
            else
            {
                AudioComponent.Play(GetGameData().MineralRecoverySound_Small);
            }
        }
    }
    switch (RetrievedType)
    {
        case 0:
            GetGameData().GetGalaxyCamera().TriggerEvent('RetrievedEezo');
            break;
        case 1:
            GetGameData().GetGalaxyCamera().TriggerEvent('RetrievedIridium');
            break;
        case 2:
            GetGameData().GetGalaxyCamera().TriggerEvent('RetrievedPlatinum');
            break;
        case 3:
            GetGameData().GetGalaxyCamera().TriggerEvent('RetrievedPalladium');
            break;
    }
    UpdatePlanetRichness();
    if (bMiningSuccessful == true)
    {
        Class'BioTelemetry'.SendEventInt('ORBITAL_MINING_SUCCESS', GetGameData().CurrentPlanet.ActiveWorld);
    }
    else
    {
        Class'BioTelemetry'.SendEventInt('ORBITAL_MINING_FAILED', GetGameData().CurrentPlanet.ActiveWorld);
    }
    GetGameData().GetGalaxyCamera().m_bRefreshPlanetUsable = true;
    if (RevealLandingSite)
    {
        GetGameData().GetGalaxyCamera().HandleRevealLandingSite();
        GetGameData().EndAction();
    }
}

exec function LaunchProbe()
{
    local SFXInventoryManager oInventory;
    local Vector axisOffset;
    local Vector TargetOffset;
    local BioWorldInfo oWorldInfo;
    local BioPlayerController oController;
    oWorldInfo = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo());
    oController = oWorldInfo.GetLocalPlayerController();
    oInventory = SFXInventoryManager(Outer.Pawn.InvManager);
    if (Scanning && ProbeActive == false && ImpactActive == false && bRescaling == false && bExiting == false)
    {
        if (oInventory.GetResource(8) > 0)
        {
            oController.HintSystem.HintEvent('LaunchProbe');
            LaunchReticleEffect.ActivateSystem();
            ScanReticleEffect.DeactivateSystem();
            ScanWipeEffect.DeactivateSystem();
            ScanBlipEffect.DeactivateSystem();
            ScanDirectionEffect.DeactivateSystem();
            ProbeTargetLocation = GetRelativeReticlePosition() + GetGameData().Planet.Location;
            axisOffset = ProbeTargetLocation - ProjectOnTo(ProbeTargetLocation - GetGameData().Planet.Location, ProbeLaunchLocation - GetGameData().Planet.Location) + GetGameData().Planet.Location;
            axisOffset = Normal(axisOffset) * ProbeControlAxisOffset;
            TargetOffset = ClampLength(ProbeLaunchLocation - GetGameData().Planet.Location, ProbeControlTargetOffset);
            ProbeControlPtLocation = GetGameData().Planet.Location + TargetOffset + axisOffset;
            ProbeActive = true;
            ProbeLaunchTime = 0;
            GetGameData().Probe.SetHidden(false);
            GetGameData().ProbeTrail.SetHidden(false);
            GetGameData().ProbeTrail.ParticleSystemComponent.ActivateSystem();
            SFXPlayerCamera(Outer.PlayerCamera).AddScreenShake(Shake);
            SFXPlayerCamera(Outer.PlayerCamera).AddScreenShake(BigShake);
            oInventory.AdjustResource(8, -1, true);
            UpdateProbeHudElement(oInventory.GetResource(8));
            GetGameData().SignalProbeLaunch();
            AudioComponent.Play(GetGameData().ProbeLaunchedVO[Rand(GetGameData().ProbeLaunchedVO.Length)]);
        }
        else
        {
            MassEffectGuiManager(BioPlayerController(Outer.Pawn.Controller).GetScaleFormManager()).ShowPlatformSpecificHint(// unknown bytecode 4F ;
        }
    }
}

exec function PlanetLeftRight(float Axis)
{
    local InterpActor P;
    local Rotator Rot;
    if (ProbeActive || ImpactActive || GetGameData() == None)
    {
        return;
    }
    P = GetGameData().Planet;
    if (P != None)
    {
        Rot = P.Rotation;
        if (!Scanning)
        {
            Rot.Yaw += 182,0444 * Axis * PlanetRotationSpeed;
        }
        else
        {
            Rot.Yaw += 182,0444 * Axis * ScanPlanetRotationSpeed;
        }
        P.SetRotation(Rot);
    }
}

function UpdateReticle()
{
    local Rotator Rot;
    local Vector ReticlePos;
    ReticleRot.Pitch = Clamp(ReticleRot.Pitch, ReticleRotMinClamp.Pitch, ReticleRotMaxClamp.Pitch);
    Rot = ReticleRot;
    ReticlePos = 100 * ReticleRot;
    ReticleEffect.SetTranslation(ReticlePos);
    ScanReticleEffect.SetTranslation(ReticlePos);
    LaunchReticleEffect.SetTranslation(ReticlePos);
    ScanWipeEffect.SetTranslation(ReticlePos);
    ScanDirectionEffect.SetTranslation(ReticlePos);
    Rot.Pitch -= 90 * 182,0444;
    ReticleEffect.SetRotation(Rot);
    ScanReticleEffect.SetRotation(Rot);
    LaunchReticleEffect.SetRotation(Rot);
}

function float GetScannerSpeedUpgradeFactor()
{
    return SFXGame(GetGameData().Planet.WorldInfo.Game).BonusList.RchShipScannerCache;
}

function RingReticleLeftRight(float Axis)
{
    local Rotator Rot;
    if (ProbeActive || ImpactActive || GetGameData() == None)
    {
        return;
    }
    if (!Scanning)
    {
        ReticleRot.Yaw -= 182,0444 * Axis * ReticleMoveSpeed * GetScannerSpeedUpgradeFactor();
    }
    else
    {
        ReticleRot.Yaw -= 182,0444 * Axis * ScanReticleMoveSpeed * GetScannerSpeedUpgradeFactor();
    }
    Rot = ReticleRot;
    Rot.Yaw = Clamp(ReticleRot.Yaw, ReticleRotMinClamp.Yaw, ReticleRotMaxClamp.Yaw);
    if (Rot.Yaw < ReticleRot.Yaw || Rot.Yaw > ReticleRot.Yaw)
    {
        PlanetLeftRight(Axis);
    }
    ReticleRot = Rot;
}

function RingReticleUpDown(float Axis)
{
    if (ProbeActive || ImpactActive || GetGameData() == None)
    {
        return;
    }
    if (!Scanning)
    {
        ReticleRot.Pitch += 182,0444 * Axis * ReticleMoveSpeed * GetScannerSpeedUpgradeFactor();
    }
    else
    {
        ReticleRot.Pitch += 182,0444 * Axis * ScanReticleMoveSpeed * GetScannerSpeedUpgradeFactor();
    }
}

function GiveResource(EFeatureType FeatureType, EMineralType MineralType, int Amount)
{
    local BioPlayerController oController;
    local SFXInventoryManager oInventory;
    local int nCurrentAmount;
    local EInventoryResourceTypes InvType;
    local BioSFPanel oPanel;
    local BioSFHandler_GalaxyMap oHandler;
    switch (FeatureType);
    case 1;
    switch (MineralType);
    case 0;
    InvType = 4;
    jump 88;
    case 1;
    InvType = 5;
    jump 88;
    case 2;
    InvType = 7;
    jump 88;
    case 3;
    InvType = 6;
    jump 88;
    default;
    return;
    jump 96;
    default;
    return;
    oController = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController();
    oInventory = SFXInventoryManager(oController.Pawn.InvManager);
    oInventory.AdjustResource(InvType, Amount, false);
    oPanel = BioWorldInfo(GetGameData().GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager().GetPanelByTag('GalaxyMap');
    if (!oPanel != None) jump 389;
    oHandler = BioSFHandler_GalaxyMap(oPanel.ScriptHandlers[0]);
    if (!oHandler != None) jump 389;
    nCurrentAmount = oInventory.GetResource(InvType);
    oHandler.UpdateInventoryDisplay(MineralType, nCurrentAmount);
    return;
}

exec function SetScanDist(float A)
{
    ScanDist = A;
    GetGameData().Planet.DrawDebugSphere(GetGameData().Planet.Location + GetRelativeReticlePosition(), ScanDist, 16, 255, 255, 255, true);
}

exec function SetReticleRotMinClamp(float P, float Y, float R)
{
    ReticleRotMinClamp.Pitch = P;
    ReticleRotMinClamp.Yaw = Y;
    ReticleRotMinClamp.Roll = R;
}

exec function SetReticleRotMaxClamp(float P, float Y, float R)
{
    ReticleRotMaxClamp.Pitch = P;
    ReticleRotMaxClamp.Yaw = Y;
    ReticleRotMaxClamp.Roll = R;
}

exec function SetScanSpeed(float Speed)
{
    ScanReticleMoveSpeed = Speed;
}

exec function SetScanRotateSpeed(float Speed)
{
    ScanPlanetRotationSpeed = Speed;
}

exec function SetPlanetRotateSpeed(float Speed)
{
    PlanetRotationSpeed = Speed;
}

exec function SetReticleScale(float Scale)
{
    ReticleScale = Scale;
    ReticleEffect.SetScale(ReticleScale);
    ScanReticleEffect.SetScale(ReticleScale);
    LaunchReticleEffect.SetScale(ReticleScale);
    ScanWipeEffect.SetScale(ReticleScale);
    ScanBlipEffect.SetScale(ReticleScale);
    ScanDirectionEffect.SetScale(ReticleScale);
    ProbeExplosionEffect.SetScale(ReticleScale);
}

exec function SetProbeControl(float A, float T)
{
    ProbeControlAxisOffset = A;
    ProbeControlTargetOffset = T;
}

exec function SetProbeTime(float T)
{
    ProbeLaunchTimeMax = T;
}

exec function ToggleProbeDebug()
{
    DrawProbeDebugLines = !DrawProbeDebugLines;
}

exec function SetResourceRetrievalFactor(float F)
{
    fResourceRetrievalFactor = F;
}

exec function setshaket(float T)
{
    Shake.TimeDuration = T;
}

exec function setshakeramp(float X, float Y, float Z)
{
    Shake.RotAmplitude.X = X;
    Shake.RotAmplitude.Y = Y;
    Shake.RotAmplitude.Z = Z;
}

exec function setshakerfreq(float X, float Y, float Z)
{
    Shake.RotFrequency.X = X;
    Shake.RotFrequency.Y = Y;
    Shake.RotFrequency.Z = Z;
}

exec function setshakelamp(float X, float Y, float Z)
{
    Shake.LocAmplitude.X = X;
    Shake.LocAmplitude.Y = Y;
    Shake.LocAmplitude.Z = Z;
}

exec function setshakelfreq(float X, float Y, float Z)
{
    Shake.LocFrequency.X = X;
    Shake.LocFrequency.Y = Y;
    Shake.LocFrequency.Z = Z;
}

defaultproperties
{
    PlanetRotationSpeed=0,05
    ScanPlanetRotationSpeed=0,025
    ReticleMoveSpeed=0,12
    ScanReticleMoveSpeed=0,02
    MoveDist=2,5
    ProbeControlAxisOffset=500
    ProbeControlTargetOffset=600
    ScannerRotateSpeed=900
    ProbeLaunchTimeMax=2,5
    ScanDist=90
    ReticleScale=0,15
    fMaxRescaleTime=0,3
    ImpactTimeMax=1,2
    ResourceFFWaveForm=ForceFeedbackWaveform'ResourceFFWave'
    fSpectrographUpdateDelay=0,05
    fResourceRetrievalFactor=1,5
    GalaxyCam=BioCameraBehaviorGalaxy'GalaxyCam0'
    InstantTransition=SFXCameraTransition_GalaxyMap'InstantTransition0'
    DeadZone=0,2
    Bindings=System.Byte[]
    // child object GalaxyCam0 of type BioCameraBehaviorGalaxy
    // child object ResourceFFWave of type ForceFeedbackWaveform
    // child object InstantTransition0 of type SFXCameraTransition_GalaxyMap
}
