﻿class SFXGameModePowerWheel extends SFXGameModeBase
    within BioPlayerController
    config(Input);

var() config float DisableMoveTime;

function Activated()
{
    local SFXPRI PRI;
    Activated();
    Outer.SetZoomed(false);
    Outer.WorldInfo.bPlayersOnly = true;
    Outer.GetScaleFormManager().PlayGuiSound('ActivateSquadCommand');
    Outer.m_oPlayerSelection.m_eCurrentSelectionMode = 1;
    MassEffectGuiManager(Outer.GetScaleFormManager()).HideHint();
    if (Class'WorldInfo'.IsConsoleBuild())
    {
        PRI = SFXPRI(Outer.PlayerReplicationInfo);
        if (PRI != None)
        {
            if (PRI.StickConfig == 1)
            {
                Outer.GameModeManager2.Helper_SetStaticConsoleBinding('XboxTypeS_LeftX', "Axis aGuiTurn Speed=1.0 EventID=4");
                Outer.GameModeManager2.Helper_SetStaticConsoleBinding('XboxTypeS_LeftY', "Axis aGuiLookUp Speed=1.0 EventID=5");
                Outer.GameModeManager2.Helper_SetStaticConsoleBinding('XboxTypeS_RightX', "Axis aGuiStrafe Speed=1.0 EventID=2");
                Outer.GameModeManager2.Helper_SetStaticConsoleBinding('XboxTypeS_RightY', "Axis aGuiBaseY Speed=-1.0 EventID=3");
            }
        }
    }
}

function Deactivated()
{
    local SFXPRI PRI;
    Deactivated();
    Outer.WorldInfo.bPlayersOnly = false;
    if (BioPawn(Outer.Pawn).ActionState == 0)
    {
        BioPawn(Outer.Pawn).m_oBehavior.SetActionState(1);
    }
    else
    {
        Outer.ApplyTacticalOrders();
    }
    Outer.GetScaleFormManager().PlayGuiSound('DeactivateSquadCommand');
    MassEffectGuiManager(Outer.GetScaleFormManager()).RestoreHint();
    if (DisableMoveTime > 0 && Outer.IsInCoverState())
    {
        Outer.IgnoreMoveInput(true);
        SetTimer(DisableMoveTime, false, 'EnableMovement');
    }
    if (Class'WorldInfo'.IsConsoleBuild())
    {
        PRI = SFXPRI(Outer.PlayerReplicationInfo);
        if (PRI != None)
        {
            if (PRI.StickConfig == 1)
            {
                Outer.GameModeManager2.Helper_ResetStaticConsoleBindings();
            }
        }
    }
}

final function EnableMovement()
{
    Outer.IgnoreMoveInput(false);
}

exec function ExitPowerWheel()
{
    Outer.GameModeManager2.DisableMode(1);
}

exec function ShowMenu()
{
    ExitPowerWheel();
    ShowMenu();
}

defaultproperties
{
    bShowHUD=true
    bShowSelection=true
    bShowRadar=true
    bAllowCamera=true
    bAllowSave=true
    bAllowPauseMenu=true
    bShowSubtitle=true
    bShowReticles=true
}
