﻿class SFXModule_DamageParty extends SFXModule_Damage
    hidecategories(Object)
    config(Game)
    editinlinenew;

var transient float TimeLastHurt;

var config float HealthRegenTimeout;

var config float HealthRegenRate;

var config bool bHealthRegenerates;

function Tick(float DeltaTime)
{
    Tick(DeltaTime);
    Regen(DeltaTime);
}

simulated function Regen(float DeltaTime)
{
    local SFXShield_Base Shield;
    local SFXInventoryManager InvManager;
    if (CurrentHealth <= 0 || !bHealthRegenerates)
    {
        return;
    }
    if (BioPawn(Owner) == None || BioPawn(Owner).Squad == None || BioPlayerSquad(BioPawn(Owner).Squad) == None)
    {
        return;
    }
    InvManager = SFXInventoryManager(BioPawn(Owner).InvManager);
    if (InvManager == None)
    {
        return;
    }
    foreach InvManager.InventoryActors(Class'SFXShield_Base', Shield)
    {
        if (Shield.ShieldRegenTimer > 0)
        {
            return;
        }
    }
    CurrentHealth += MaxHealth.Value * HealthRegenRate * DeltaTime;
    CurrentHealth = FMin(MaxHealth.Value, CurrentHealth);
}

simulated function ApplyDamageToHealth(float Damage, Controller InstigatedBy, class<SFXDamageType> DamageType, out Vector HitLocation)
{
    TimeLastHurt = Pawn(Owner).WorldInfo.TimeSeconds;
    ApplyDamageToHealth(Damage, InstigatedBy, DamageType, HitLocation);
}

defaultproperties
{
    bHealthRegenerates=true
    HealthRegenRate=0,5
    bPartBasedDamageEnabled=false
}
