﻿class SFXModule_Locomotion extends SFXModule
    hidecategories(Object)
    config(Game)
    native;

enum ESFXLocomotionState
{
    eSFXLocomotionState_Inactive,
    eSFXLocomotionState_Moving,
    eSFXLocomotionState_Idle,
    eSFXLocomotionState_MoveStart,
    eSFXLocomotionState_MoveStop,
    eSFXLocomotionState_SkidTurn,
};

var transient bool MoveStartStopping;

var transient float MoveStartIdleTimer;

var transient float MoveStartLastYaw;

var transient float MoveStartRelYaw;

var transient Vector MoveStartInitialPos;

var transient float MoveStartInitialYaw;

var transient float MovingIncline;

var transient float MovingLean;

var transient float MovingLeanYaw[2];

var transient float StateSpeed;

var transient float StateTimer;

var config float PawnMoveStopRestartTimerThreshold;

var config float PawnMoveStopTimerThreshold;

var config float PawnMoveStandTurnRotRate;

var config float PawnMoveStandTurnDistanceThreshold;

var config float PawnMoveStartStopTimerThreshold;

var config float PawnMoveStartSidewayAccelerationTimer;

var config float PawnMoveStartFwdAccelerationTimer;

var config float PawnMoveStartFwdSpeed;

var config float PawnMoveStartFwdAngle;

var transient Vector PawnAcceleration;

var transient Rotator PawnDesiredRotation;

var transient int TickTag;

var transient int StateTag;

var transient ESFXLocomotionState CurrentState;

var transient AnimNode AnimNode;

var transient BioPawn Pawn;

native final function SetDesiredRotation(Rotator DesiredRotation);

native final function SetAcceleration(Vector Acceleration);

defaultproperties
{
    PawnMoveStartFwdAngle=120
    PawnMoveStartFwdAccelerationTimer=0,4
    PawnMoveStartSidewayAccelerationTimer=0,45
    PawnMoveStartStopTimerThreshold=0,1
    PawnMoveStandTurnDistanceThreshold=10
    PawnMoveStandTurnRotRate=180
    PawnMoveStopTimerThreshold=0,1
    PawnMoveStopRestartTimerThreshold=0,1
}
