﻿class SFXProfileSettings extends OnlineProfileSettings
    config(Game)
    native;

const BITS_PER_INT = 32;
enum EAchievementID
{
    ACHIEVEMENT_00_CERBERUS,
    ACHIEVEMENT_01_PRONOR_COMPLETE,
    ACHIEVEMENT_02_PROCER_COMPLETE,
    ACHIEVEMENT_03_JACKACQ,
    ACHIEVEMENT_04_GRUNTACQ,
    ACHIEVEMENT_05_GARRUSACQ,
    ACHIEVEMENT_06_MORDINACQ,
    ACHIEVEMENT_07_TALIACQ,
    ACHIEVEMENT_08_SAMARRAACQ,
    ACHIEVEMENT_09_THANEACQ,
    ACHIEVEMENT_10_CR1,
    ACHIEVEMENT_11_MIRANDALOYALTY,
    ACHIEVEMENT_12_JACOBLOYALTY,
    ACHIEVEMENT_13_JACKLOYALTY,
    ACHIEVEMENT_14_GRUNTLOYALTY,
    ACHIEVEMENT_15_GARRUSLOYALTY,
    ACHIEVEMENT_16_MORDINLOYALTY,
    ACHIEVEMENT_17_TALILOYALTY,
    ACHIEVEMENT_18_SAMARRALOYALTY,
    ACHIEVEMENT_19_THANELOYALTY,
    ACHIEVEMENT_20_LEGIONACQ,
    ACHIEVEMENT_21_LEGIONLOYALTY,
    ACHIEVEMENT_22_CR2,
    ACHIEVEMENT_23_ENDGAME,
    ACHIEVEMENT_24_COMPLETE,
    ACHIEVEMENT_25_COMPLETESURVIVE,
    ACHIEVEMENT_26_COMPLETEINSANITY,
    ACHIEVEMENT_27_COMPLETEFOLLOWER,
    ACHIEVEMENT_28_COMPLETEME1IMPORT,
    ACHIEVEMENT_29_ROMANCE,
    ACHIEVEMENT_30_HEADSHOT,
    ACHIEVEMENT_31_MELEECOMBO,
    ACHIEVEMENT_32_THRESHERMAW,
    ACHIEVEMENT_33_POWERCOMBO,
    ACHIEVEMENT_34_HEAVYWEAPON,
    ACHIEVEMENT_35_SCREAM,
    ACHIEVEMENT_36_DISRUPTSHIELDS,
    ACHIEVEMENT_37_BREAKBARRIERS,
    ACHIEVEMENT_38_BURNARMOUR,
    ACHIEVEMENT_39_N7MISSION,
    ACHIEVEMENT_40_MULTIN7MISSION,
    ACHIEVEMENT_41_MINERALS,
    ACHIEVEMENT_42_EXPLORATION,
    ACHIEVEMENT_43_POWERGAMER,
    ACHIEVEMENT_44_CODEX,
    ACHIEVEMENT_45_TECHUPGRADE,
    ACHIEVEMENT_46_WEAPONUPGRADE,
    ACHIEVEMENT_47_RESEARCH,
    ACHIEVEMENT_48_PERSONALIZE,
    ACHIEVEMENT_49_EVOLVEDPOWER,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
    ACHIEVEMENT_DLC,
};

enum EStickConfigOptions
{
    SCO_Default,
    SCO_SouthPaw,
};

enum ETriggerConfigOptions
{
    TCO_Default,
    TCO_SouthPaw,
};

enum EAimAssistOptions
{
    AAO_Low,
    AAO_Normal,
    AAO_High,
};

enum EDifficultyOptions
{
    DO_Level1,
    DO_Level2,
    DO_Level3,
    DO_Level4,
    DO_Level5,
    DO_Level6,
};

enum EAutoLevelOptions
{
    ALO_Off,
    ALO_Squad,
    ALO_All,
};

enum ETVType
{
    TVT_Default,
    TVT_Soft,
    TVT_Lucent,
    TVT_Vibrant,
};

enum EOptionYesNo
{
    OYN_Yes,
    OYN_No,
};

enum EOptionOnOff
{
    OOO_On,
    OOO_Off,
};

struct native AchievementReward
{
    var() Name Name;

    var() EAchievementID AchievementId;

    var() String Effect;

}

var array<GrinderAchievement> GrinderAchievementSettings;

var() config array<AchievementData> StaticAchievementData;

var() config array<AchievementReward> Rewards;

struct native AchievementData
{
    var() Name Name;

    var() EAchievementID AchievementId;

    var() int XboxAchievementID;

// Title: StringRefProperty[44]
// Incomplete: StringRefProperty[44]
// Complete: StringRefProperty[44]
    var() int Points;

    var() String Icon;

}

struct native GrinderAchievement
{
    var EAchievementID AchievementId;

    var int ProfileSettingId;

    var int Goal;

    var int Interval;

// Title: StringRefProperty[44]
// Description: StringRefProperty[44]
}

function bool GetAchievementData(EAchievementID AchievementId, out AchievementData AD)
{
    local int idx;
    local int I;
    I = 0;
    while (I < StaticAchievementData.Length)
    {
        if (StaticAchievementData[I].AchievementId == AchievementId)
        {
            idx = I;
            break;
        }
        I++;
    }
    if (idx >= 0)
    {
        AD = StaticAchievementData[idx];
        return true;
    }
    return false;
}

function bool GetGrinderAchievement(EAchievementID AchievementId, out GrinderAchievement G)
{
    local int I;
    I = 0;
    while (I < GrinderAchievementSettings.Length)
    {
        if (GrinderAchievementSettings[I].AchievementId == AchievementId)
        {
            G = GrinderAchievementSettings[I];
            return true;
        }
        I++;
    }
    return false;
}

function GrinderAchievementReset(EAchievementID AchievementId, BioPlayerController PC)
{
    local GrinderAchievement Settings;
    if (GetGrinderAchievement(AchievementId, Settings))
    {
        SetProfileSettingValueInt(Settings.ProfileSettingId, 0);
        PC.SaveProfile();
    }
}

function bool GrinderAchievementIncrement(EAchievementID AchievementId, BioPlayerController PC)
{
    local int Value;
    local String Title;
    local String Description;
    local GrinderAchievement Grinder;
    if (HasCompletedAchievement(AchievementId) == false && BioWorldInfo(PC.WorldInfo).GetGlobalVariables().GetBoolByName('IgnoreGrinderAchievements') == false)
    {
        if (GetGrinderAchievement(AchievementId, Grinder))
        {
            GetProfileSettingValueInt(Grinder.ProfileSettingId, Value);
            if (Value != Grinder.Goal)
            {
                Value += 1;
                SetProfileSettingValueInt(Grinder.ProfileSettingId, Value);
                if (Value >= Grinder.Goal)
                {
                    PC.UnlockAchievement(AchievementId);
                }
                else
                {
                    if (Value % Grinder.Interval == 0 || Value == 1)
                    {
                        Title = Class'SFXGame'.GetSimpleString(Grinder.Title);
                        ClearCustomTokens();
                        if (Grinder.Goal > 0)
                        {
                            SetCustomToken(0, Grinder.Goal);
                        }
                        Description = Class'SFXGame'.GetSimpleString(Grinder.Description, true);
                        PC.HintSystem.AddNotification_AchievementChange(Title, Value $ "/" $ Grinder.Goal, Description, Value, Grinder.Goal);
                    }
                }
                return true;
            }
        }
    }
    return false;
}

function UpdateHeavyWeaponKill(int WeaponID, BioPlayerController PC)
{
    local int KillFlags;
    local int WeaponFlag;
    if (!GetProfileSettingValueInt(60, KillFlags))
    {
        return;
    }
    WeaponFlag = 1 << WeaponID;
    if (WeaponID > 0)
    {
        if (KillFlags | WeaponFlag != KillFlags)
        {
            GrinderAchievementIncrement(34, PC);
            KillFlags = KillFlags | WeaponFlag;
            SetProfileSettingValueInt(60, KillFlags);
        }
    }
}

function bool GetControllerVibrationOption()
{
    local bool retval;
    local int Value;
    GetProfileSettingValueId(1, Value);
    switch (Value)
    {
        case 0:
            retval = false;
            break;
        case 3:
        default:
            retval = true;
            break;
    }
    return retval;
}

function bool GetInvertYOption()
{
    local bool retval;
    local int Value;
    GetProfileSettingValueId(2, Value);
    switch (Value)
    {
        case 0:
            retval = false;
            break;
        case 1:
        default:
            retval = true;
            break;
    }
    return retval;
}

function EProfileControllerSensitivityOptions GetControllerSensitivityValue()
{
    local EProfileControllerSensitivityOptions retval;
    local int Value;
    GetProfileSettingValueId(13, Value);
    switch (Value)
    {
        case 1:
            retval = 1;
            break;
        case 2:
            retval = 2;
            break;
        case 0:
        default:
            retval = 0;
            break;
    }
    return retval;
}

function EStickConfigOptions GetStickConfigOption()
{
    local EStickConfigOptions retval;
    local int Value;
    GetProfileSettingValueId(28, Value);
    switch (Value)
    {
        case 1:
            retval = 1;
            break;
        case 0:
        default:
            retval = 0;
            break;
    }
    return retval;
}

function ETriggerConfigOptions GetTriggerConfigOption()
{
    local ETriggerConfigOptions retval;
    local int Value;
    GetProfileSettingValueId(29, Value);
    switch (Value)
    {
        case 1:
            retval = 1;
            break;
        case 0:
        default:
            retval = 0;
            break;
    }
    return retval;
}

function bool GetSubtitleConfigOption()
{
    local int Value;
    GetProfileSettingValueId(30, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function EAimAssistOptions GetAimAssistValue()
{
    local int Value;
    GetProfileSettingValueId(31, Value);
    return Value;
}

function EDifficultyOptions GetDifficultyConfigOption()
{
    local int Value;
    GetProfileSettingValueId(32, Value);
    return Value;
}

function EAutoLevelOptions GetAutoLevelConfigOption()
{
    local int Value;
    GetProfileSettingValueId(33, Value);
    return Value;
}

function bool GetSquadPowerConfigOption()
{
    local int Value;
    GetProfileSettingValueId(34, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function bool GetAutoSaveConfigOption()
{
    local int Value;
    GetProfileSettingValueId(35, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function bool GetAutoLoginConfigOption()
{
    local int Value;
    GetProfileSettingValueId(44, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function bool IsTelemetryCollectionEnabled()
{
    local int Value;
    GetProfileSettingValueId(53, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function SetTelemetryCollection(bool bEnabled)
{
    local int Value;
    if (bEnabled)
    {
        Value = 0;
    }
    else
    {
        Value = 1;
    }
    SetProfileSettingValueId(53, Value);
}

function bool AreHintsEnabled()
{
    local int Value;
    GetProfileSettingValueId(69, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function SetShowHints(bool bEnabled)
{
    local int Value;
    if (bEnabled)
    {
        Value = 0;
    }
    else
    {
        Value = 1;
    }
    SetProfileSettingValueId(69, Value);
}

function float GetDisplayGamma()
{
    local float Value;
    GetProfileSettingValueFloat(55, Value);
    return Value;
}

event int GetMusicVolume()
{
    local int Value;
    GetProfileSettingValueInt(36, Value);
    return Value;
}

event int GetFXVolume()
{
    local int Value;
    GetProfileSettingValueInt(37, Value);
    return Value;
}

event int GetDialogVolume()
{
    local int Value;
    GetProfileSettingValueInt(38, Value);
    return Value;
}

function bool GetMotionBlurConfigOption()
{
    local int Value;
    GetProfileSettingValueId(39, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function bool GetFilmgrainConfigOption()
{
    local int Value;
    GetProfileSettingValueId(40, Value);
    if (Value == 1)
    {
        return false;
    }
    return true;
}

function int GetCurrentDeviceID()
{
    local int Value;
    if (GetProfileSettingValueInt(41, Value))
    {
        return Value;
    }
    return -1;
}

function SetCurrentDeviceID(int DeviceID, BioPlayerController PC)
{
    local int CurValue;
    GetProfileSettingValueInt(41, CurValue);
    if (CurValue != DeviceID)
    {
        SetProfileSettingValueInt(41, DeviceID);
        PC.SaveProfile();
    }
}

function String GetCurrentCareerName()
{
    local String Value;
    if (GetProfileSettingValue(42, Value))
    {
        return Value;
    }
    return "";
}

function SetCurrentCareerName(String CareerName)
{
    local String CurValue;
    GetProfileSettingValue(42, CurValue);
    if (CurValue != CareerName)
    {
        SetProfileSettingValue(42, CareerName);
    }
}

function int GetNumHeadshots()
{
    local int Value;
    if (GetProfileSettingValueInt(56, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumMeleeCombos()
{
    local int Value;
    if (GetProfileSettingValueInt(57, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumPowerCombos()
{
    local int Value;
    if (GetProfileSettingValueInt(59, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumScreams()
{
    local int Value;
    if (GetProfileSettingValueInt(61, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumShieldsDisrupted()
{
    local int Value;
    if (GetProfileSettingValueInt(62, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumBarriersWarped()
{
    local int Value;
    if (GetProfileSettingValueInt(63, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumArmourIncinerated()
{
    local int Value;
    if (GetProfileSettingValueInt(64, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumN7MissionsCompleted()
{
    local int Value;
    if (GetProfileSettingValueInt(65, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumCodex()
{
    local int Value;
    if (GetProfileSettingValueInt(66, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumTechUpgrades()
{
    local int Value;
    if (GetProfileSettingValueInt(67, Value))
    {
        return Value;
    }
    return -1;
}

function int GetNumGameCompletions()
{
    local int Value;
    if (GetProfileSettingValueInt(68, Value))
    {
        return Value;
    }
    return -1;
}

function String GetFinishedGameCareerName()
{
    local String Value;
    if (GetProfileSettingValue(76, Value))
    {
        return Value;
    }
    return "";
}

function int GetAchievementSettingField(EAchievementID AchievementId)
{
    local int ProfileId;
    ProfileId = 0;
    if (AchievementId < 32)
    {
        ProfileId = 50;
    }
    else
    {
        if (AchievementId < 32 * 2)
        {
            ProfileId = 51;
        }
        else
        {
            ProfileId = 52;
        }
    }
    return ProfileId;
}

function bool SetAchievementUncompleted(EAchievementID AchievementId, BioPlayerController PC, optional bool bSaveProfile = true)
{
    local int ProfileId;
    local int CompletionMask;
    if (HasCompletedAchievement(AchievementId) == true)
    {
        ProfileId = GetAchievementSettingField(AchievementId);
        GetProfileSettingValueInt(ProfileId, CompletionMask);
        SetProfileSettingValueInt(ProfileId, CompletionMask & ~1 << AchievementId % 32);
        if (bSaveProfile)
        {
            PC.SaveProfile();
        }
        return true;
    }
    return false;
}

function bool SetAchievementCompleted(EAchievementID AchievementId, BioPlayerController PC, optional bool bSaveProfile = true)
{
    local int ProfileId;
    local int CompletionMask;
    if (HasCompletedAchievement(AchievementId) == false)
    {
        ProfileId = GetAchievementSettingField(AchievementId);
        GetProfileSettingValueInt(ProfileId, CompletionMask);
        SetProfileSettingValueInt(ProfileId, CompletionMask | 1 << AchievementId % 32);
        UnlockReward(AchievementId, PC);
        if (bSaveProfile)
        {
            PC.SaveProfile();
        }
        return true;
    }
    return false;
}

function bool HasCompletedAchievement(EAchievementID AchievementId)
{
    local int ProfileId;
    local int CompletionMask;
    ProfileId = GetAchievementSettingField(AchievementId);
    if (GetProfileSettingValueInt(ProfileId, CompletionMask))
    {
        return CompletionMask & 1 << AchievementId % 32 != 0;
    }
    return false;
}

function int GetAchievementRequirement(EAchievementID AchievementId)
{
    local GrinderAchievement Settings;
    if (GetGrinderAchievement(AchievementId, Settings))
    {
        return Settings.Goal;
    }
    return 0;
}

function int GetAchievementStatus(EAchievementID AchievementId)
{
    local GrinderAchievement Settings;
    local int Value;
    if (GetGrinderAchievement(AchievementId, Settings))
    {
        GetProfileSettingValueInt(Settings.ProfileSettingId, Value);
        return Value;
    }
    return 0;
}

function bool UnlockReward(EAchievementID AchievementId, BioPlayerController PC)
{
    local int idx;
    local SFXModule_GameEffectManager GEManager;
    local class<SFXGameEffect> EffectClass;
    local SFXGameEffect Reward;
    idx = 0;
    while (idx < Rewards.Length)
    {
        if (AchievementId == Rewards[idx].AchievementId)
        {
            GEManager = PC.Pawn.GetModule(Class'SFXModule_GameEffectManager');
            if (GEManager != None)
            {
                EffectClass = Class<SFXGameEffect>(FindObject(Rewards[idx].Effect, Class'Class'));
                if (EffectClass != None)
                {
                    Reward = GEManager.CreateEffect(EffectClass, 'Achievement_Reward', 0, 0, 0);
                    if (Reward != None)
                    {
                        Reward.OnApplied();
                        return true;
                    }
                }
            }
        }
        idx++;
    }
    return false;
}

function UpdateAchievements(array<AchievementDetails> AchievementsList, BioPlayerController PC)
{
    local int idx;
    local int FoundIdx;
    local bool bSaveProfile;
    local AchievementDetails Achievement;
    idx = 0;
    while (idx < AchievementsList.Length)
    {
        Achievement = AchievementsList[idx];
        FoundIdx = StaticAchievementData.Find('XboxAchievementID', Achievement.Id);
        if (FoundIdx != -1)
        {
            if (Achievement.bWasAchievedOffline || Achievement.bWasAchievedOnline)
            {
                if (SetAchievementCompleted(StaticAchievementData[FoundIdx].AchievementId, PC, false))
                {
                    bSaveProfile = true;
                }
            }
            else
            {
                if (SetAchievementUncompleted(StaticAchievementData[FoundIdx].AchievementId, PC, false))
                {
                    bSaveProfile = true;
                }
            }
            jump 240;
        }
        idx++;
    }
    if (bSaveProfile)
    {
        PC.SaveProfile();
    }
    return;
}

function SetChoseMorinthNotSamara(bool ChoseMorinth)
{
    local int Value;
    if (ChoseMorinth)
    {
        Value = 0;
    }
    else
    {
        Value = 1;
    }
    SetProfileSettingValueId(74, Value);
}

function bool GetChoseMorinthNotSamara()
{
    local int Value;
    if (GetProfileSettingValueId(74, Value))
    {
        if (Value == 1)
        {
            return false;
        }
        return true;
    }
    return false;
}

native final function SetToDefaultsEx(const out array<EProfileSetting> lstProfileSettingsToReset);

enum EProfileSetting
{
    Setting_Unknown,
    Setting_ControllerVibration,
    Setting_YInversion,
    Setting_GamerCred,
    Setting_GamerRep,
    Setting_VoiceMuted,
    Setting_VoiceThruSpeakers,
    Setting_VoiceVolume,
    Setting_GamerPictureKey,
    Setting_GamerMotto,
    Setting_GamerTitlesPlayed,
    Setting_GamerAchievementsEarned,
    Setting_GameDifficulty,
    Setting_ControllerSensitivity,
    Setting_PreferredColor1,
    Setting_PreferredColor2,
    Setting_AutoAim,
    Setting_AutoCenter,
    Setting_MovementControl,
    Setting_RaceTransmission,
    Setting_RaceCameraLocation,
    Setting_RaceBrakeControl,
    Setting_RaceAcceleratorControl,
    Setting_GameCredEarned,
    Setting_GameAchievementsEarned,
    Setting_EndLiveIds,
    Setting_ProfileVersionNum,
    Setting_ProfileSaveCount,
    Setting_StickConfiguration,
    Setting_TriggerConfiguration,
    Setting_Subtitles,
    Setting_AimAssist,
    Setting_Difficulty,
    Setting_AutoLevel,
    Setting_SquadPowers,
    Setting_AutoSave,
    Setting_MusicVolume,
    Setting_FXVolume,
    Setting_DialogVolume,
    Setting_MotionBlur,
    Setting_FilmGrain,
    Setting_SelectedDeviceID,
    Setting_CurrentCareer,
    Setting_DaysSinceRegistration,
    Setting_AutoLogin,
    Setting_LoginInfo,
    Setting_PersonaID,
    Setting_NucleusRefused,
    Setting_NucleusSuccessful,
    Setting_CerberusRefused,
    Setting_Achievement_FieldA,
    Setting_Achievement_FieldB,
    Setting_Achievement_FieldC,
    Setting_TelemetryCollectionEnabled,
    Setting_KeyBindings,
    Setting_DisplayGamma,
    Setting_NumHeadshots,
    Setting_NumMeleeCombos,
    Setting_HeavyWeaponKillCount,
    Setting_NumPowerCombos,
    Setting_HeavyWeaponKillFlags,
    Setting_NumScreams,
    Setting_NumShieldsDisrupted,
    Setting_NumBarriersWarped,
    Setting_NumArmourIncinerated,
    Setting_NumN7MissionsCompleted,
    Setting_NumCodex,
    Setting_NumTechUpgrades,
    Setting_NumGameCompletions,
    Setting_ShowHints,
    Setting_NumTrainingVidsWatched,
    Setting_WatchedVid1,
    Setting_WatchedVid2,
    Setting_WatchedVid3,
    Setting_MorinthNotSamara,
    Setting_MaxWeaponUpgradeCount,
    Setting_LastFinishedCareer,
};

defaultproperties
{
    StaticAchievementData=System.Byte[]
    GrinderAchievementSettings=System.Byte[]
    VersionNumber=17
    ProfileSettingIds=None
}
