﻿class SFXSFHandler_AreaMap extends BioSFHandler
    transient
    native;

var bool m_bFromBrowserWheel;

var /* 00000008 */ transient DOFAndBloomEffect m_DOFEffect;

function OnPanelAdded()
{
    OnPanelAdded();
    oPanel.SetExternalInterface(self);
}

function PauseMenuAdditionalProcessing()
{
    Initialize(true);
}

function bool Initialize(bool bFromBrowserWheel)
{
    local SFXAreaMapData oMapData;
    m_bFromBrowserWheel = bFromBrowserWheel;
    oMapData = MassEffectGuiManager(oPanel.oParentManager).GetAreaMapData();
    if (oMapData != None)
    {
        SetMap(oMapData);
        ProcessPlayer(oMapData);
        PlayGuiSound('MapOpen');
        if (!m_bFromBrowserWheel)
        {
            PlayGuiSound('BrowserSelectMenu');
            AddDOFEffect(m_DOFEffect);
        }
        return true;
    }
    return false;
}

function SetMap(SFXAreaMapData oMapData)
{
    local array<ASParams> lstParams;
    lstParams.Length = 1;
    lstParams[0].Type = 0;
    lstParams[0].nVar = ScreenLayout;
    oPanel.InvokeMethodArgs("SetPlatformLayout", lstParams);
    lstParams[0].Type = 0;
    lstParams[0].nVar = oMapData.MapLayout;
    oPanel.InvokeMethodArgs("SetMapLayout", lstParams);
    if (oMapData != None)
    {
        if (oMapData.MapAsset != None)
        {
            SetExternalTextureOnPanel("MapHolder", oMapData.MapAsset);
        }
    }
}

function ProcessPlayer(SFXAreaMapData oMapData)
{
    local SFXPawn_Player pPlayer;
    local array<ASParams> lstParams;
    local float PxX;
    local float PxY;
    local BioPlayerController PC;
    if (oWorldInfo != None)
    {
        PC = BioWorldInfo(oWorldInfo).GetLocalPlayerController();
        pPlayer = SFXPawn_Player(PC.Pawn);
    }
    if (oMapData != None && oPanel != None && pPlayer != None)
    {
        if (pPlayer != None)
        {
            oMapData.GetPixelCoordinates(pPlayer.Location.X, pPlayer.Location.Y, PxX, PxY);
            lstParams.Length = 3;
            lstParams[0].Type = 0;
            lstParams[0].nVar = PxX;
            lstParams[1].Type = 0;
            lstParams[1].nVar = PxY;
            lstParams[2].Type = 0;
            lstParams[2].nVar = pPlayer.Rotation.Yaw * 0,005493164;
            oPanel.InvokeMethodArgs("SetPlayerLocRot", lstParams);
        }
    }
}

function BeginClose()
{
    if (oPanel != None)
    {
        oPanel.InvokeMethod("OnBeginClose");
    }
}

final private function Close()
{
    if (!m_bFromBrowserWheel)
    {
        RemoveDOFEffect();
        MassEffectGuiManager(oPanel.oParentManager).HideAreaMap();
    }
    else
    {
        MassEffectGuiManager(oPanel.oParentManager).ReturnToBrowserWheel(oPanel);
    }
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    switch (Event)
    {
        case 13:
        case 15:
        case 20:
            Close();
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

native function AddDOFEffect(DOFAndBloomEffect i_DOFEffect);

native function RemoveDOFEffect();

defaultproperties
{
    m_DOFEffect=DOFAndBloomEffect'oDOFEffect'
    // child object oDOFEffect of type DOFAndBloomEffect
}
