﻿class SFXSFHandler_EANetworking extends BioSFHandler
    config(UI)
    transient
    native;

enum EAGUI_CerberusIntroResult
{
    EAG_CI_REDEEM_CODE,
    EAG_CI_BUY_CODE,
    EAG_CI_CANCEL,
};

native function ShowIntroPage();

native function ShowNucleusLogin(String Email, String Password, int eScreenState);

native function ShowMessageBox(String sTitle, String sMessage, optional String sButton1Text, optional String sButton2Text, optional String sButton3Text);

native function ShowCreateNucleusAccount(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bRegisterProduct, bool bBioWareProducts, bool bUnderage);

native function ShowTermsOfService(String i_sTermsOfService, optional bool bTOSChanged);

native function ShowNucleusWelcomeMessage();

native function ShowCerberusIntro();

native function ShowRedeemCode();

native function ShowCerberusWelcomeMessage();

native function ShowCreateNucleusAccountEx(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bBioWareProducts, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode, array<String> m_CountryCodeList, array<String> m_CountryDisplayList);

native function ShowEmailPasswordMismatch(String Email, String Password);

native function ShowAccountDemographics(array<String> m_CountryCodeList, array<String> m_CountryDisplayList);

native function ShowParentEmail();

delegate GuiCallback_SubmitIntroPage(bool bContinue);

delegate GuiCallback_SubmitNucleusLogin(String Email, String Password, EAGUI_NucleusLoginResult eReturnCode);

delegate GuiCallback_SubmitMessageBox(EAGUI_MsgBoxResult eReturnEnum);

delegate GuiCallback_SubmitCreateNucleusAccount(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bRegisterProduct, bool bBioWareProducts, bool bSubmit);

delegate GuiCallback_SubmitTermsOfService(bool bAccept);

delegate GuiCallback_SubmitNucleusWelcomeMessage();

delegate GuiCallback_SubmitCerberusIntro(EAGUI_CerberusIntroResult eReturnCode);

delegate GuiCallback_SubmitRedeemCode(bool bContinue, String i_sCode);

delegate GuiCallback_SubmitCerberusWelcomeMessage();

delegate GuiCallback_SubmitCreateNucleusAccountEx(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bBioWareProducts, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode, bool bSubmit);

delegate GuiCallback_SubmitEmailPasswordMismatch(String Email, String Password, EAGUI_EmailPswdMismatchResult eReturnCode);

delegate GuiCallback_SubmitAccountDemographics(bool bContinue, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode);

delegate GuiCallback_SubmitParentEmail(bool bContinue, String ParentEmail);

var config int m_nMaxCerberusCodeLength;

var config int m_nMaxPasswordLength;

var config int m_nMaxEmailLength;

// m_srCerberusCodeTitle: StringRefProperty[44]
// m_srKeyboardPasswordTitle: StringRefProperty[44]
// m_srKeyboardEmailTitle: StringRefProperty[44]
var transient BioSFHandler_Keyboard m_oKeyboard;

enum EAGUI_MsgBoxResult
{
    EAG_MSGBOX_BTN,
    EAG_MSGBOX_BTN,
    EAG_MSGBOX_BTN,
};

enum EAGUI_NucleusLoginResult
{
    EAG_NL_LOGIN,
    EAG_NL_CREATE,
    EAG_NL_CANCEL,
};

enum EAGUI_EmailPswdMismatchResult
{
    EAG_EPM_SUBMIT,
    EAG_EPM_EMAIL_PSWD,
    EAG_EPM_CANCEL,
};

function SubmitIntroPage(bool bContinue)
{
    if (__GuiCallback_SubmitIntroPage__Delegate != None)
    {
        GuiCallback_SubmitIntroPage(bContinue);
    }
}

function SubmitNucleusLogin(String Email, String Password, EAGUI_NucleusLoginResult eReturnCode)
{
    if (__GuiCallback_SubmitNucleusLogin__Delegate != None)
    {
        GuiCallback_SubmitNucleusLogin(Email, Password, eReturnCode);
    }
}

function SubmitMessageBox(EAGUI_MsgBoxResult eReturnEnum)
{
    if (__GuiCallback_SubmitMessageBox__Delegate != None)
    {
        GuiCallback_SubmitMessageBox(eReturnEnum);
    }
}

function SubmitEmailPasswordMismatch(String Email, String Password, EAGUI_EmailPswdMismatchResult eReturnCode)
{
    if (__GuiCallback_SubmitEmailPasswordMismatch__Delegate != None)
    {
        GuiCallback_SubmitEmailPasswordMismatch(Email, Password, eReturnCode);
    }
}

function SubmitCreateNucleusAccount(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bRegisterProduct, bool bBioWareProducts, bool bSubmit)
{
    if (__GuiCallback_SubmitCreateNucleusAccount__Delegate != None)
    {
        GuiCallback_SubmitCreateNucleusAccount(sEmail, sPassword, bEAProducts, bThirdParty, bRegisterProduct, bBioWareProducts, bSubmit);
    }
}

function SubmitTermsOfService(bool bAccept)
{
    if (__GuiCallback_SubmitTermsOfService__Delegate != None)
    {
        GuiCallback_SubmitTermsOfService(bAccept);
    }
}

function SubmitNucleusWelcomeMessage()
{
    if (__GuiCallback_SubmitNucleusWelcomeMessage__Delegate != None)
    {
        GuiCallback_SubmitNucleusWelcomeMessage();
    }
}

function SubmitCerberusIntro(EAGUI_CerberusIntroResult eReturnCode)
{
    if (__GuiCallback_SubmitCerberusIntro__Delegate != None)
    {
        GuiCallback_SubmitCerberusIntro(eReturnCode);
    }
}

function SubmitRedeemCode(bool bContinue, String i_sCode)
{
    if (__GuiCallback_SubmitRedeemCode__Delegate != None)
    {
        GuiCallback_SubmitRedeemCode(bContinue, i_sCode);
    }
}

function SubmitAccountDemographics(bool bContinue, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode)
{
    if (__GuiCallback_SubmitAccountDemographics__Delegate != None)
    {
        GuiCallback_SubmitAccountDemographics(bContinue, i_sCountryCode, BirthDay, BirthMonth, BirthYear, i_sLanguageCode);
    }
}

function SubmitParentEmail(bool bContinue, String ParentEmail)
{
    if (__GuiCallback_SubmitParentEmail__Delegate != None)
    {
        GuiCallback_SubmitParentEmail(bContinue, ParentEmail);
    }
}

function SubmitCerberusWelcomeMessage()
{
    if (__GuiCallback_SubmitCerberusWelcomeMessage__Delegate != None)
    {
        GuiCallback_SubmitCerberusWelcomeMessage();
    }
}

function SubmitCreateNucleusAccountEx(String sEmail, String sPassword, bool bEAProducts, bool bThirdParty, bool bBioWareProducts, String i_sCountryCode, int BirthDay, int BirthMonth, int BirthYear, String i_sLanguageCode, bool bSubmit)
{
    if (__GuiCallback_SubmitCreateNucleusAccountEx__Delegate != None)
    {
        GuiCallback_SubmitCreateNucleusAccountEx(sEmail, sPassword, bEAProducts, bThirdParty, bBioWareProducts, i_sCountryCode, BirthDay, BirthMonth, BirthYear, i_sLanguageCode, bSubmit);
    }
}

function ClearDelegates()
{
    __GuiCallback_SubmitIntroPage__Delegate = None;
    __GuiCallback_SubmitNucleusLogin__Delegate = None;
    __GuiCallback_SubmitMessageBox__Delegate = None;
    __GuiCallback_SubmitEmailPasswordMismatch__Delegate = None;
    __GuiCallback_SubmitCreateNucleusAccount__Delegate = None;
    __GuiCallback_SubmitTermsOfService__Delegate = None;
    __GuiCallback_SubmitNucleusWelcomeMessage__Delegate = None;
    __GuiCallback_SubmitCerberusIntro__Delegate = None;
    __GuiCallback_SubmitRedeemCode__Delegate = None;
    __GuiCallback_SubmitAccountDemographics__Delegate = None;
    __GuiCallback_SubmitParentEmail__Delegate = None;
    __GuiCallback_SubmitCerberusWelcomeMessage__Delegate = None;
    __GuiCallback_SubmitCreateNucleusAccountEx__Delegate = None;
}

function onExternalInitialize()
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    stParam.Type = 1;
    stParam.fVar = ScreenLayout;
    lstParams.AddItem(stParam);
    stParam.Type = 1;
    stParam.fVar = m_nMaxPasswordLength;
    lstParams.AddItem(stParam);
    stParam.Type = 1;
    stParam.fVar = m_nMaxEmailLength;
    lstParams.AddItem(stParam);
    oPanel.InvokeMethodArgs("onGameSideInit", lstParams);
}

function HandleInputEvent(BioGuiEvents Event, optional float fValue = 1)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    switch (Event)
    {
        case 5:
            if (Abs(fValue) >= 0,25)
            {
                stParam.Type = 1;
                stParam.fVar = fValue;
                lstParams.AddItem(stParam);
                oPanel.InvokeMethodArgs("ScrollControl", lstParams);
            }
            break;
        case 2:
            if (fValue >= 0,25)
            {
                oPanel.InvokeMethod("OnInputRight");
            }
            else
            {
                if (fValue <= -0,25)
                {
                    oPanel.InvokeMethod("OnInputLeft");
                }
            }
            break;
        case 12:
            oPanel.InvokeMethod("ExecuteControl");
            break;
        case 8:
            oPanel.InvokeMethod("NextControl");
            break;
        case 9:
            oPanel.InvokeMethod("OnInputLeft");
            break;
        case 10:
            oPanel.InvokeMethod("OnInputRight");
            break;
        case 11:
            oPanel.InvokeMethod("PreviousControl");
            break;
        default:
            HandleInputEvent(Event, fValue);
    }
}

event OnPanelAdded()
{
    OnPanelAdded();
    oPanel.SetExternalInterface(self);
}

event OnPanelRemoved()
{
    ClearDelegates();
}

function EnterEmail(String sDefault)
{
    if (m_oKeyboard == None)
    {
        m_oKeyboard = BioSFHandler_Keyboard(oPanel.AttachHandler(Class'BioSFHandler_Keyboard'));
    }
    m_oKeyboard.DisplayKeyboard(m_srKeyboardEmailTitle// unknown bytecode 4F ;
}

function EnterPassword(String sDefault)
{
    if (m_oKeyboard == None)
    {
        m_oKeyboard = BioSFHandler_Keyboard(oPanel.AttachHandler(Class'BioSFHandler_Keyboard'));
    }
    m_oKeyboard.DisplayKeyboard(m_srKeyboardPasswordTitle// unknown bytecode 4F ;
}

function EnterCode(String sDefault)
{
    if (m_oKeyboard == None)
    {
        m_oKeyboard = BioSFHandler_Keyboard(oPanel.AttachHandler(Class'BioSFHandler_Keyboard'));
    }
    m_oKeyboard.DisplayKeyboard(m_srCerberusCodeTitle// unknown bytecode 4F ;
}

function Update(float fDeltaT)
{
    local ASParams stParam;
    local array<ASParams> lstParams;
    if (m_oKeyboard != None && m_oKeyboard.bKeyboardVisible == false)
    {
        if (m_oKeyboard.bKeyboardEntrySucceeded)
        {
            stParam.Type = 2;
            stParam.sVar = m_oKeyboard.sInputValue;
            lstParams.AddItem(stParam);
            oPanel.InvokeMethodArgs("SetActiveInputField", lstParams);
        }
        oPanel.RemoveScriptHandler(m_oKeyboard);
        m_oKeyboard = None;
    }
}

defaultproperties
{
    m_srKeyboardEmailTitle=System.Byte[]
    m_srKeyboardPasswordTitle=System.Byte[]
    m_srCerberusCodeTitle=System.Byte[]
    m_nMaxEmailLength=100
    m_nMaxPasswordLength=16
    m_nMaxCerberusCodeLength=16
}
