﻿class SFXSFHandler_HUD extends BioSFHandler
    config(UI)
    transient
    native;

const STATUS_Barrier = 1;
const STATUS_Bleedout = 2;
const STATUS_HardenedShields = 4;
const STATUS_HeavyArmour = 8;
const STATUS_MinimalDamage = 16;
const STATUS_ActivePower = 32;
const STATUS_SuperRegen = 64;
const SF_9SLICE_SCALE_ERROR = 0.05336;
struct native SFXHudDmgIndicatorPaths
{
    var String _alpha;

    var String _visible;

}

struct native SFXHUDResistances
{
    var bool bHasShield;

    var bool bHasArmour;

    var bool bHasBiotic;

    var bool bHasHealth;

    var float fHealthPct;

    var float fArmourPct;

    var float fBioticPct;

    var float fShieldPct;

}

struct native SFXHUDSquadMemberInfo
{
    var String sPath;

    var String sIconImagePath;

    var BioPawn pPawn;

    var Texture2D pIcon;

    var SFXHUDResistances Resistances;

    var SFXHUDResistances DisplayedResistances;

    var float fCooldown;

    var bool bCooldownVisible;

    var String sShieldPath;

    var String sBioticPath;

    var String sArmourPath;

    var String sHealthPath;

    var String sPowerPath;

    var bool bShieldVisible;

    var bool bBioticVisible;

    var bool bArmourVisible;

    var bool bHealthVisible;

    var bool bShieldDamage;

    var bool bBioticDamage;

    var bool bArmourDamage;

    var bool bHealthDamage;

    var bool bInvalidated;

    var bool bVisible;

    var bool bUpdateResistance;

    var bool bUpdateHealth;

    var bool bUpdatePower;

    var bool bUpdateIcon;

    var bool bDisplayVisible;

    var float fElapsedFullResistTime;

}

struct native SFXHUDTargetInfo
{
    var SFXHUDResistances Resistances;

    var String sName;

    var String sStatus;

    var bool bInteractive;

    var bool bHostile;

    var bool bInRange;

    var int nStatusFlags;

}

var int m_nNotificationFlourishId;

var float m_fNotificationElapsedTime;

var float m_fNotificationDisplayTime;

// m_srAmmoFull: StringRefProperty[44]
// m_srOverheat: StringRefProperty[44]
// m_srHealth: StringRefProperty[44]
// m_srBarrier: StringRefProperty[44]
// m_srArmour: StringRefProperty[44]
// m_srShields: StringRefProperty[44]
// m_srStatusSuperRegenText: StringRefProperty[44]
// m_srStatusMinimalDamageText: StringRefProperty[44]
// m_srStatusHeavyArmourText: StringRefProperty[44]
// m_srStatusHardenedShieldsText: StringRefProperty[44]
// m_srStatusBleedoutText: StringRefProperty[44]
// m_srStatusBarrierText: StringRefProperty[44]
var String m_sOverheat;

var String m_sHealth;

var String m_sBarrier;

var String m_sArmour;

var String m_sShields;

var String m_sPlayerPowerPath2;

var String m_sPlayerPowerPath1;

var String m_sOverheatIndicatorTextFieldPath;

var String m_sOverheatIndicatorTextPath;

var String m_sOverheatIndicatorPath;

var String m_sCenterStatusPath;

var String m_smcNotificationPath;

var String m_sResistBarOutlinePath;

var String m_sShieldBarPath;

var String m_sBioticBarPath;

var String m_sArmourBarPath;

var String m_sHealthBarPath;

var String m_sTargetBackgroundPath;

var String m_sButtonAPath;

var String m_sTargetStatusPath;

var String m_sTargetNamePath;

var String m_sWeaponClipAmmoPath;

var String m_sWeaponAmmoPath;

var String m_sWeaponIconPath;

var config float m_fFullStatFadeTime;

var config float m_fBarAnimRate;

var config float m_fWeaponUpdateInterval;

var config float m_fLowHealthWarning;

var config float m_fDamageIndicatorAlphaUpdateDelta;

var config float m_fHealthShieldUpdateDelta;

var config float m_fSuperRegenThreshold;

var String m_sTeamStatusStartFrame;

var float m_fButtonAHeight;

var float m_fButtonAInitialY;

var float m_fStatusTextHeight;

var float m_fStatusInitialY;

var float m_fShieldBarCenterY;

var float m_fBioticBarCenterY;

var float m_fArmourBarCenterY;

var float m_fHealthBarCenterY;

var float m_fCurrentOverheatValue;

var float m_fSFWidth;

var Actor m_pCurrentDisplayTarget;

var float m_fTimeSinceLastWeaponUpdate;

var int m_nCurrentClipAmmo;

var int m_nCurrentWeaponSpareAmmo;

var String m_nCurrentWeaponResource;

var int m_nCurrentWeaponIcon;

var float m_fEffectivelyZero;

var SFXHUDSquadMemberInfo m_oHench2Info;

var SFXHUDSquadMemberInfo m_oHench1Info;

var SFXHUDSquadMemberInfo m_oShepardInfo;

var array<float> m_aDamageIndicatorAlphas;

var array<SFXHudDmgIndicatorPaths> m_aDamageIndicatorPaths;

var BioPlayerSquad m_pPlayerSquad;

var BioPlayerController m_pPlayerController;

var bool m_bNotificationVisible;

var bool m_bHealthDisplayVisible;

var bool m_bWeaponOverheatBarVisible;

var bool m_bWeaponVisible;

var bool m_bInSquadCommandMode;

var bool m_bTargetStatusVisible;

var bool m_bInRange;

var bool m_bInteractive;

var String m_sStatusText;

var float m_fCurrentBarBackgroundX;

var int m_nCurrentBarCount;

var SFXHUDResistances m_ResistanceBarDisplayValues;

var SFXHUDResistances m_CurrentResistances;

var Actor m_pCurrentTarget;

delegate OnNotificationCompleted();

native function ShowNotification(float nDisplayTime, int nNumRemainingNotifications, int nPriority, String sTitle, String sSubtitle, String sBody, Texture oImage, Name nmAdditonalSound, optional int nFlourishID);

native function ClearNotification();

native function OnNotificationOpenAnimComplete();

event OnPanelRemoved()
{
    CleanupReferences();
    OnPanelRemoved();
}

function CleanupReferences()
{
    m_pPlayerController = None;
    m_pPlayerSquad = None;
    m_oShepardInfo.pPawn = None;
    m_oHench1Info.pPawn = None;
    m_oHench2Info.pPawn = None;
    m_oShepardInfo.pIcon = None;
    m_oHench1Info.pIcon = None;
    m_oHench2Info.pIcon = None;
    m_pCurrentDisplayTarget = None;
    m_pCurrentTarget = None;
    __OnNotificationCompleted__Delegate = None;
}

function GameSessionEnded()
{
    CleanupReferences();
    GameSessionEnded();
}

event OnAspectRatioChanged()
{
    UpdateCachedPositionData();
}

event InitDisplay()
{
    Class'SFXSFHandler_PowerWheel'.HideWeaponIcon(oPanel, m_sWeaponIconPath);
    oPanel.GotoLabelAndStop(m_oShepardInfo.sPath, m_sTeamStatusStartFrame);
    oPanel.GotoLabelAndStop(m_oHench1Info.sPath, m_sTeamStatusStartFrame);
    oPanel.GotoLabelAndStop(m_oHench2Info.sPath, m_sTeamStatusStartFrame);
    m_sShields = m_srShields;
    m_sArmour = m_srArmour;
    m_sBarrier = m_srBarrier;
    m_sHealth = m_srHealth;
    m_sOverheat = m_srOverheat;
    SetOverheat(0, true);
    UpdateWeaponDisplay(false, None);
    UpdateCachedPositionData();
}

event UpdateCachedPositionData()
{
    m_fHealthBarCenterY = oPanel.GetVariableFloat(m_sHealthBarPath $ "._y") - oPanel.GetVariableFloat(m_sHealthBarPath $ "._height") * 0,5;
    m_fArmourBarCenterY = oPanel.GetVariableFloat(m_sArmourBarPath $ "._y") - oPanel.GetVariableFloat(m_sArmourBarPath $ "._height") * 0,5;
    m_fBioticBarCenterY = oPanel.GetVariableFloat(m_sBioticBarPath $ "._y") - oPanel.GetVariableFloat(m_sBioticBarPath $ "._height") * 0,5;
    m_fShieldBarCenterY = oPanel.GetVariableFloat(m_sShieldBarPath $ "._y") - oPanel.GetVariableFloat(m_sShieldBarPath $ "._height") * 0,5;
    m_fStatusInitialY = oPanel.GetVariableFloat(m_sTargetStatusPath $ "._y");
    m_fStatusTextHeight = oPanel.GetVariableFloat(m_sTargetStatusPath $ "._height");
    m_fButtonAInitialY = oPanel.GetVariableFloat(m_sButtonAPath $ "._y");
    m_fButtonAHeight = oPanel.GetVariableFloat(m_sButtonAPath $ "._height");
}

static event GetResistances(Actor pTarget, out SFXHUDResistances oResistances)
{
    local BioPawn pBioPawnTarget;
    local SFXShield_Base pShield;
    local SFXModule_Damage pDamageMod;
    local float FMax;
    local float fCurrent;
    local float fShieldMax;
    local float fBioticMax;
    local float fArmourMax;
    local float fShieldCurrent;
    local float fBioticCurrent;
    local float fArmourCurrent;
    pBioPawnTarget = BioPawn(pTarget);
    oResistances.fShieldPct = 0;
    oResistances.fBioticPct = 0;
    oResistances.fArmourPct = 0;
    oResistances.fHealthPct = 0;
    oResistances.bHasShield = false;
    oResistances.bHasBiotic = false;
    oResistances.bHasArmour = false;
    oResistances.bHasHealth = false;
    if (pTarget == None)
    {
        return;
    }
    if (pBioPawnTarget != None && pBioPawnTarget.InvManager != None)
    {
        foreach pBioPawnTarget.InvManager.InventoryActors(Class'SFXShield_Base', pShield)
        {
            switch (pShield.Resistance)
            {
                case 0:
                    fShieldMax += pShield.MaxShields.Value;
                    fShieldCurrent += Min(pShield.CurrentShields, pShield.MaxShields.Value);
                    oResistances.bHasShield = true;
                    break;
                case 2:
                    fBioticMax += pShield.MaxShields.Value;
                    fBioticCurrent += Min(pShield.CurrentShields, pShield.MaxShields.Value);
                    oResistances.bHasBiotic = true;
                    break;
                case 1:
                    fArmourMax += pShield.MaxShields.Value;
                    fArmourCurrent += Min(pShield.CurrentShields, pShield.MaxShields.Value);
                    oResistances.bHasArmour = true;
                    break;
            }
        }
    }
    oResistances.fShieldPct = fShieldMax > 0 ? fShieldCurrent / fShieldMax : 0;
    oResistances.fBioticPct = fBioticMax > 0 ? fBioticCurrent / fBioticMax : 0;
    oResistances.fArmourPct = fArmourMax > 0 ? fArmourCurrent / fArmourMax : 0;
    pDamageMod = pTarget.GetModule(Class'SFXModule_Damage');
    if (pDamageMod != None)
    {
        FMax = pDamageMod.MaxHealth.Value;
        fCurrent = Min(pDamageMod.CurrentHealth, FMax);
        if (FMax > 1)
        {
            oResistances.fHealthPct = fCurrent / FMax;
            oResistances.bHasHealth = true;
        }
        else
        {
            oResistances.fHealthPct = 0;
        }
    }
    if (oResistances.fHealthPct <= 0,009)
    {
        oResistances.fHealthPct = 0;
    }
    else
    {
        if (oResistances.fHealthPct >= 0,99)
        {
            oResistances.fHealthPct = 1;
        }
    }
    if (oResistances.fArmourPct <= 0,009)
    {
        oResistances.fArmourPct = 0;
    }
    else
    {
        if (oResistances.fArmourPct >= 0,99)
        {
            oResistances.fArmourPct = 1;
        }
    }
    if (oResistances.fBioticPct <= 0,009)
    {
        oResistances.fBioticPct = 0;
    }
    else
    {
        if (oResistances.fBioticPct >= 0,99)
        {
            oResistances.fBioticPct = 1;
        }
    }
    if (oResistances.fShieldPct <= 0,009)
    {
        oResistances.fShieldPct = 0;
    }
    else
    {
        if (oResistances.fShieldPct >= 0,99)
        {
            oResistances.fShieldPct = 1;
        }
    }
}

event GetTargetHealthAndShields(Actor pTarget, out float fHealthPct, out float fShieldsPct)
{
    local SFXModule_Damage pDamageMod;
    local SFXShield_Base pShieldObj;
    local float fShieldCurrent;
    local float fShieldMax;
    local BioPawn pBioPawnTarget;
    fHealthPct = 0;
    fShieldsPct = 0;
    if (pTarget == None)
    {
        return;
    }
    pDamageMod = pTarget.GetModule(Class'SFXModule_Damage');
    if (pDamageMod == None)
    {
        return;
    }
    if (pDamageMod.MaxHealth.Value > 0)
    {
        fHealthPct = pDamageMod.CurrentHealth / pDamageMod.MaxHealth.Value;
    }
    else
    {
        fHealthPct = 1;
    }
    pBioPawnTarget = BioPawn(pTarget);
    if (pBioPawnTarget != None)
    {
        if (pBioPawnTarget.InvManager != None)
        {
            fShieldCurrent = 0;
            fShieldMax = 0;
            foreach pBioPawnTarget.InvManager.InventoryActors(Class'SFXShield_Base', pShieldObj)
            {
                fShieldCurrent += pShieldObj.CurrentShields;
                fShieldMax += pShieldObj.MaxShields.Value;
            }
            if (fShieldMax <= 0)
            {
                fShieldsPct = 0;
            }
            else
            {
                fShieldsPct = fShieldCurrent / fShieldMax;
            }
        }
    }
}

static event int GetTargetStatusFlags(Actor pTarget)
{
    local BioPawn pBioPawnTarget;
    local SFXShield_Base pShieldObj;
    local BioEpicPawnBehavior pEPBehavior;
    local bool bShieldBoosted;
    local bool bShieldHardened;
    local String sPowerText;
    local int nStatusFlags;
    pBioPawnTarget = BioPawn(pTarget);
    if (pBioPawnTarget != None)
    {
        if (pBioPawnTarget.InvManager != None)
        {
            bShieldBoosted = false;
            bShieldHardened = false;
            foreach pBioPawnTarget.InvManager.InventoryActors(Class'SFXShield_Base', pShieldObj)
            {
                if (pShieldObj.BoostedShieldMax > 0)
                {
                    bShieldBoosted = true;
                }
                if (pShieldObj.bHardened)
                {
                    bShieldHardened = true;
                }
            }
            if (bShieldBoosted)
            {
                nStatusFlags = nStatusFlags | 1;
            }
            if (bShieldHardened)
            {
                nStatusFlags = nStatusFlags | 4;
            }
        }
        if (pBioPawnTarget.GetRegenRate() > Default.m_fSuperRegenThreshold)
        {
            nStatusFlags = nStatusFlags | 64;
        }
        if (pBioPawnTarget.IsArmorFortified() != false)
        {
            nStatusFlags = nStatusFlags | 8;
        }
    }
    pEPBehavior = BioEpicPawnBehavior(pTarget.oBioComponent);
    if (pEPBehavior != None && pEPBehavior.GetPowerText(sPowerText) != false)
    {
        nStatusFlags = nStatusFlags | 32;
    }
    return nStatusFlags;
}

static event String GetStatusText(BioPawn pTarget, int nStatusFlags)
{
    local String sStatus;
    local BioEpicPawnBehavior pEPBehavior;
    if (nStatusFlags & 32 != 0)
    {
        pEPBehavior = BioEpicPawnBehavior(pTarget.oBioComponent);
        if (pEPBehavior != None && pEPBehavior.GetPowerText(sStatus) != false)
        {
            return sStatus;
        }
    }
    if (nStatusFlags & 4 != 0)
    {
        sStatus = Default.m_srStatusHardenedShieldsText;
    }
    else
    {
        if (nStatusFlags & 8 != 0)
        {
            sStatus = Default.m_srStatusHeavyArmourText;
        }
        else
        {
            if (nStatusFlags & 64 != 0)
            {
                sStatus = Default.m_srStatusSuperRegenText;
            }
            else
            {
                if (nStatusFlags & 16 != 0)
                {
                    sStatus = Default.m_srStatusMinimalDamageText;
                }
                else
                {
                    if (nStatusFlags & 2 != 0)
                    {
                        sStatus = Default.m_srStatusBleedoutText;
                    }
                }
            }
        }
    }
    return sStatus;
}

function SetCenterStatus(String sText)
{
    if (sText != "")
    {
        oPanel.SetClipVisibility(m_sCenterStatusPath, true);
        oPanel.SetTextFieldText(m_sCenterStatusPath $ ".CenterStatusText.text", sText);
    }
    else
    {
        oPanel.SetClipVisibility(m_sCenterStatusPath, false);
    }
}

function SetOverheat(float fOverheatPct, optional bool bForce = false)
{
    if (Abs(fOverheatPct - m_fCurrentOverheatValue) > 0,01 || bForce != false)
    {
        if (fOverheatPct > 0)
        {
            SetCenterStatus(m_sOverheat);
            oPanel.SetTextFieldText(m_sOverheatIndicatorTextFieldPath, m_sOverheat);
            oPanel.SetClipVisibility(m_sOverheatIndicatorTextPath, true);
            oPanel.SetVariableFloat(m_sOverheatIndicatorTextPath $ "._alpha", 100 * Lerp(0,2, 1, fOverheatPct));
        }
        else
        {
            SetCenterStatus("");
            oPanel.SetTextFieldText(m_sOverheatIndicatorTextFieldPath, "");
            oPanel.SetClipVisibility(m_sOverheatIndicatorTextPath, false);
        }
        m_fCurrentOverheatValue = fOverheatPct;
    }
}

function SetTargetName(String sTargetName, optional bool bHostile = false)
{
    local array<ASParams> aArgs;
    if (sTargetName != "")
    {
        aArgs.Length = 2;
        aArgs[0].Type = 2;
        aArgs[0].sVar = sTargetName;
        aArgs[1].Type = 3;
        aArgs[1].bVar = bHostile;
        oPanel.InvokeMethodArgs("SetTargetName", aArgs);
        oPanel.SetClipVisibility(m_sTargetNamePath, true);
    }
    else
    {
        oPanel.SetClipVisibility(m_sTargetNamePath, false);
    }
}

function SetTargetStatus(String sStatus, optional bool bInteractive = false, optional bool bInRange = true)
{
    local array<ASParams> aArgs;
    if (sStatus != "")
    {
        aArgs.Length = 3;
        aArgs[0].Type = 2;
        aArgs[0].sVar = sStatus;
        aArgs[1].Type = 3;
        aArgs[1].bVar = bInteractive;
        aArgs[2].Type = 3;
        aArgs[2].bVar = bInRange;
        oPanel.InvokeMethodArgs("SetTargetStatus", aArgs);
        oPanel.SetClipVisibility(m_sTargetStatusPath, true);
    }
    else
    {
        oPanel.SetClipVisibility(m_sTargetStatusPath, false);
        oPanel.SetClipVisibility(m_sButtonAPath, false);
    }
}

function UpdateTargetStatusVisibility(const out SFXHUDTargetInfo oTargetInfo)
{
    local bool bHaveHealth;
    local bool bHaveText;
    if (oTargetInfo.Resistances.fHealthPct >= m_fEffectivelyZero || oTargetInfo.Resistances.fArmourPct >= m_fEffectivelyZero || oTargetInfo.Resistances.fBioticPct >= m_fEffectivelyZero || oTargetInfo.Resistances.fShieldPct >= m_fEffectivelyZero)
    {
        bHaveHealth = true;
    }
    if (oTargetInfo.sName != "" || oTargetInfo.sStatus != "")
    {
        bHaveText = true;
    }
    if (m_pCurrentTarget == None)
    {
        bHaveHealth = false;
        bHaveText = false;
    }
    if (bHaveHealth == false && bHaveText == false)
    {
        if (m_bTargetStatusVisible != false)
        {
            SetTargetName("");
            SetTargetStatus("");
            oPanel.SetClipVisibility(m_sTargetBackgroundPath, false);
            m_bTargetStatusVisible = false;
        }
    }
    else
    {
        if (m_bTargetStatusVisible == false && m_pCurrentTarget != None)
        {
            oPanel.SetClipVisibility(m_sTargetBackgroundPath, true);
            m_bTargetStatusVisible = true;
        }
    }
}

function UpdateResistanceBarDisplay(float fResistPercent, String sBarClipPath)
{
    local int nFrame;
    if (fResistPercent > 0)
    {
        nFrame = 1 - fResistPercent * 100;
        if (nFrame == 0)
        {
            nFrame = 1;
        }
        oPanel.SetClipVisibility(sBarClipPath, true);
        oPanel.GotoFrameAndStop(sBarClipPath, nFrame);
    }
    else
    {
        oPanel.SetClipVisibility(sBarClipPath, false);
    }
}

event UpdateTargetStatusDisplay(const out SFXHUDTargetInfo oTargetInfo)
{
    local bool bBarsVisible;
    if (oTargetInfo.Resistances.fHealthPct > m_fEffectivelyZero || oTargetInfo.Resistances.fArmourPct > m_fEffectivelyZero || oTargetInfo.Resistances.fBioticPct > m_fEffectivelyZero || oTargetInfo.Resistances.fShieldPct > m_fEffectivelyZero)
    {
        bBarsVisible = true;
    }
    UpdateTargetStatusVisibility(oTargetInfo);
    SetTargetName(oTargetInfo.sName, oTargetInfo.bHostile);
    SetTargetStatus(oTargetInfo.sStatus, oTargetInfo.bInteractive, bBarsVisible || oTargetInfo.bInRange);
    m_ResistanceBarDisplayValues = oTargetInfo.Resistances;
    UpdateResistanceDisplay(oTargetInfo.Resistances);
}

event UpdateResistanceDisplay(SFXHUDResistances oResistValues)
{
    local bool bBarsVisible;
    if (oResistValues.fHealthPct > m_fEffectivelyZero || oResistValues.fArmourPct > m_fEffectivelyZero || oResistValues.fBioticPct > m_fEffectivelyZero || oResistValues.fShieldPct > m_fEffectivelyZero)
    {
        bBarsVisible = true;
    }
    if (bBarsVisible != false)
    {
        UpdateResistanceBarDisplay(oResistValues.fHealthPct, m_sHealthBarPath);
        UpdateResistanceBarDisplay(oResistValues.fArmourPct, m_sArmourBarPath);
        UpdateResistanceBarDisplay(oResistValues.fBioticPct, m_sBioticBarPath);
        UpdateResistanceBarDisplay(oResistValues.fShieldPct, m_sShieldBarPath);
        m_ResistanceBarDisplayValues = oResistValues;
    }
    else
    {
        oPanel.SetClipVisibility(m_sHealthBarPath, false);
        oPanel.SetClipVisibility(m_sArmourBarPath, false);
        oPanel.SetClipVisibility(m_sBioticBarPath, false);
        oPanel.SetClipVisibility(m_sShieldBarPath, false);
    }
    oPanel.InvokeMethod("UpdateTargetDisplay");
}

event UpdateWeaponDisplay(bool bVisible, Weapon pWeap)
{
    local bool bCheckWeaponOverheat;
    local SFXWeapon pSFXWeap;
    local int nAmmoInMagazine;
    local int nAmmoSpare;
    local int nOverheatPercent;
    local float fOverheatPct;
    local bool bShowOverheat;
    local bool bShowOverheatText;
    local bool bDisplayInvalidated;
    pSFXWeap = SFXWeapon(pWeap);
    if (pSFXWeap == None)
    {
        bVisible = false;
    }
    bShowOverheat = bVisible;
    if (m_bWeaponVisible != bVisible)
    {
        oPanel.SetClipVisibility(m_sWeaponIconPath, bVisible);
        oPanel.SetClipVisibility(m_sWeaponAmmoPath, bVisible);
        oPanel.SetClipVisibility(m_sWeaponClipAmmoPath, bVisible);
        m_bWeaponVisible = bVisible;
        if (bVisible == true)
        {
            bDisplayInvalidated = true;
        }
    }
    if (bShowOverheat != m_bWeaponOverheatBarVisible || bDisplayInvalidated != false)
    {
        oPanel.SetClipVisibility(m_sOverheatIndicatorPath, bShowOverheat);
        m_bWeaponOverheatBarVisible = bShowOverheat;
        if (bVisible == false)
        {
            SetOverheat(0);
        }
    }
    if (bVisible == false)
    {
        return;
    }
    bShowOverheatText = true;
    if (pSFXWeap.GetMagazineSize() <= pSFXWeap.AmmoPerShot)
    {
        bShowOverheatText = false;
    }
    nAmmoInMagazine = pSFXWeap.GetAmmoCountInMagazine();
    nAmmoSpare = pSFXWeap.GetCurrentSpareAmmo();
    if (nAmmoSpare != m_nCurrentWeaponSpareAmmo || bDisplayInvalidated != false)
    {
        oPanel.SetTextFieldText(m_sWeaponAmmoPath, nAmmoSpare);
        bCheckWeaponOverheat = true;
        m_nCurrentWeaponSpareAmmo = nAmmoSpare;
    }
    if (nAmmoInMagazine != m_nCurrentClipAmmo || bDisplayInvalidated != false)
    {
        oPanel.SetTextFieldText(m_sWeaponClipAmmoPath, nAmmoInMagazine);
        bCheckWeaponOverheat = true;
        m_nCurrentClipAmmo = nAmmoInMagazine;
    }
    if (bCheckWeaponOverheat != false && bShowOverheat != false)
    {
        if (nAmmoInMagazine <= pSFXWeap.LowAmmoSoundThreshold)
        {
            if (pSFXWeap.LowAmmoSoundThreshold > 0)
            {
                fOverheatPct = 1 - nAmmoInMagazine / pSFXWeap.LowAmmoSoundThreshold;
            }
            else
            {
                if (nAmmoInMagazine == 0)
                {
                    fOverheatPct = 1;
                }
                else
                {
                    fOverheatPct = 0;
                }
            }
        }
        else
        {
            fOverheatPct = 0;
        }
        if (fOverheatPct == 0 || fOverheatPct > 0 && bShowOverheatText != false)
        {
            SetOverheat(fOverheatPct);
        }
        nOverheatPercent = Max(1, nAmmoInMagazine / pSFXWeap.GetMagazineSize() * 100);
        oPanel.GotoFrameAndStop(m_sOverheatIndicatorPath, 101 - nOverheatPercent);
    }
    if (pSFXWeap.IconRef != m_nCurrentWeaponIcon || PathName(pSFXWeap.IconResource) != m_nCurrentWeaponResource || bDisplayInvalidated != false)
    {
        Class'SFXSFHandler_PowerWheel'.SetWeaponTypeDisplay(oPanel, m_sWeaponIconPath, PathName(pSFXWeap.IconResource), pSFXWeap.IconRef);
        m_nCurrentWeaponIcon = pSFXWeap.IconRef;
        m_nCurrentWeaponResource = PathName(pSFXWeap.IconResource);
    }
}

event bool ShouldDisplayWeaponIcon()
{
    local bool bDisplayWeaponIcon;
    local BioPawn pPawn;
    pPawn = BioPawn(m_pPlayerController.Pawn);
    if (pPawn == None)
    {
        return false;
    }
    bDisplayWeaponIcon = true;
    if (SFXHeavyWeapon(pPawn.Weapon) != None)
    {
        bDisplayWeaponIcon = false;
    }
    bDisplayWeaponIcon = bDisplayWeaponIcon && m_bInSquadCommandMode == false;
    return bDisplayWeaponIcon;
}

function OnNotificationComplete()
{
    if (__OnNotificationCompleted__Delegate != None)
    {
        OnNotificationCompleted();
        __OnNotificationCompleted__Delegate = None;
    }
}

function PulseFullAmmoMessage()
{
    oPanel.SetClipVisibility("DPad.DPadText", false);
    oPanel.SetTextFieldText("DPad.DPadText.Text", "");
    oPanel.SetTextFieldText("DPad.ammo.text", "");
    oPanel.SetClipVisibility("DPad.ammo", true);
    PlayGuiSound('FullAmmo');
    PulseMessage();
}

function PulseTextMessage(String sMessage)
{
    oPanel.SetClipVisibility("DPad.ammo", false);
    oPanel.SetTextFieldText("DPad.DPadText.Text", sMessage);
    oPanel.SetClipVisibility("DPad.DPadText", true);
    PulseMessage();
}

function PulseMessage()
{
    oPanel.SetClipVisibility("DPad", true);
    oPanel.GotoLabelAndPlay("DPad", "show");
}

defaultproperties
{
    m_nCurrentBarCount=-1
    m_fEffectivelyZero=0,01
    m_sTeamStatusStartFrame="Console"
    m_fSuperRegenThreshold=5
    m_fHealthShieldUpdateDelta=0,005
    m_fDamageIndicatorAlphaUpdateDelta=1
    m_fLowHealthWarning=0,1
    m_fWeaponUpdateInterval=0,1
    m_fBarAnimRate=10
    m_fFullStatFadeTime=1,5
    m_sWeaponIconPath="Weapon"
    m_sWeaponAmmoPath="SpareAmmo"
    m_sWeaponClipAmmoPath="MagazineAmmo"
    m_sTargetNamePath="TargetName"
    m_sTargetStatusPath="TargetStatus"
    m_sButtonAPath="ButtonA"
    m_sTargetBackgroundPath="TargetBackground"
    m_sHealthBarPath="targetHealth"
    m_sArmourBarPath="targetArmour"
    m_sBioticBarPath="targetBarrier"
    m_sShieldBarPath="targetShield"
    m_sResistBarOutlinePath="targetBarOutline"
    m_smcNotificationPath="_root.mcNotification"
    m_sCenterStatusPath="CenterStatus"
    m_sOverheatIndicatorPath="WeaponOverheat"
    m_sOverheatIndicatorTextPath="WeaponOverheat.TextAnim"
    m_sOverheatIndicatorTextFieldPath="WeaponOverheat.TextAnim.text.text"
    m_sPlayerPowerPath1="PlayerPower1"
    m_sPlayerPowerPath2="PlayerPower2"
    m_srStatusBarrierText=System.Byte[]
    m_srStatusBleedoutText=System.Byte[]
    m_srStatusHardenedShieldsText=System.Byte[]
    m_srStatusHeavyArmourText=System.Byte[]
    m_srStatusMinimalDamageText=System.Byte[]
    m_srStatusSuperRegenText=System.Byte[]
    m_srShields=System.Byte[]
    m_srArmour=System.Byte[]
    m_srBarrier=System.Byte[]
    m_srHealth=System.Byte[]
    m_srOverheat=System.Byte[]
    m_srAmmoFull=System.Byte[]
    bSetGameMode=false
}
