﻿class SFXSFHandler_PCPowerWheel extends SFXSFHandler_PowerWheel
    config(UI)
    transient
    native;

const NUM_KEYBOARD_QUICKSLOTS = 8;
var config float m_fDragStartThreshold;

// m_srMinimizeText: StringRefProperty[44]
// m_srMaximizeText: StringRefProperty[44]
var SFXPowerWheelIconPower m_oDragSlotIcon;

var SFXPowerWheelIconPower m_oDragPowerIcon;

var int m_nCurrentQuickSlot;

var SFXPowerWheelIconPower m_aQuickSlotIcons[8];

var float m_fQuickslotIconUpdateInterval;

var int m_nCurrentDropTarget;

var Vector2D m_vDragOffsets;

var Vector2D m_vMouseDownPos;

var int m_nDraggingIcon;

var SFXPowerWheelIconWeapon m_oHench2WeaponIcon;

var SFXPowerWheelIconWeapon m_oHench1WeaponIcon;

var SFXPowerWheelIconWeapon m_oCenterWeaponIcon;

var bool m_bEvalQuickSlotPowers;

var bool m_bQuickSlotVisible;

var bool m_bQuickSlotExpanded;

var bool m_bDoingDrag;

var bool m_bDraggingKey;

var bool m_bDraggingPower;

var bool m_bDashboardWeaponsOpen;

native function NewSetQuickSlotPower(int nSlot, int nDraggingIconID, bool bDraggingPower, bool bSilently);

native function RemoveHenchman(BioPawn pPawn);

function CleanupReferences()
{
    local int nIcon;
    CleanupReferences();
    nIcon = 0;
    while (nIcon < 8)
    {
        m_aQuickSlotIcons[nIcon].pPower = None;
        m_aQuickSlotIcons[nIcon].pPawn = None;
        ++nIcon;
    }
    m_oDragPowerIcon.pPower = None;
    m_oDragPowerIcon.pPawn = None;
    m_oDragSlotIcon.pPower = None;
    m_oDragSlotIcon.pPawn = None;
}

function OnAllowCameraRotation(bool i_bValue)
{
    if (i_bValue)
    {
        jump 12;
    }
    return;
}

event InitDisplay()
{
    InitDisplay();
    HideWeaponIcon(oPanel, m_oCenterWeaponIcon.sPath);
    m_bQuickSlotExpanded = false;
    SetQuickSlotState(true, true);
}

event WheelVisibilityChanged(bool bVisible)
{
    local int nIcon;
    SetMouseShown(bVisible);
    WheelVisibilityChanged(bVisible);
    if (bVisible == false)
    {
        oPanel.GotoFrameAndStop("Wheel.Wheel.Player", 1);
        m_bDashboardWeaponsOpen = false;
        nIcon = 0;
        while (nIcon < 8)
        {
            m_aQuickSlotIcons[nIcon].bDragHover = false;
            SetQuickSlotIconSelected(nIcon, false);
            UpdateQuickSlotDisplay(nIcon);
            ++nIcon;
        }
    }
    oPanel.SetClipVisibility("QuickSlots.Control", bVisible);
    oPanel.SetClipVisibility(m_oCenterWeaponIcon.sPath, bVisible);
}

event SetUseText(String sText);

event SetMapText(String sText1, SFXPowerWheelMapButtonIcon eIcon1, optional String sText2 = "", optional SFXPowerWheelMapButtonIcon eIcon2 = 0);

function SortWeapons(BioPawn pPawn, out array<SFXWeapon> aWeapons)
{
    local int nWeap;
    local SFXWeapon pSwapWeap;
    if (pPawn == m_pShepardPawn)
    {
        SortWeapons(pPawn, aWeapons);
        return;
    }
    nWeap = 0;
    while (nWeap < aWeapons.Length)
    {
        if (aWeapons[nWeap] == pPawn.Weapon)
        {
            if (nWeap != 0)
            {
                pSwapWeap = aWeapons[0];
                aWeapons[0] = aWeapons[nWeap];
                aWeapons[nWeap] = pSwapWeap;
            }
        }
        ++nWeap;
    }
}

event SetWeaponState(int nWeapIndex, SFXPowerWheelWeaponState eNewWeapState)
{
    if (nWeapIndex < 0 || nWeapIndex >= m_aWeaponIcons.Length)
    {
        return;
    }
    if (m_oWeaponIndices.aPlayer.Find(nWeapIndex) == -1)
    {
        if (eNewWeapState == 3)
        {
            eNewWeapState = 0;
        }
    }
    SetWeaponState(nWeapIndex, eNewWeapState);
}

function SelectWeapon(int nWeaponIndex)
{
    if (nWeaponIndex < 0 || nWeaponIndex >= m_aWeaponIcons.Length)
    {
        return;
    }
    if (m_oWeaponIndices.aPlayer.Find(nWeaponIndex) != -1)
    {
        SelectWeapon(nWeaponIndex);
        SetWeaponTypeDisplay(oPanel, "Wheel.Wheel.Player.WeaponCenter", m_aWeaponIcons[nWeaponIndex].sIconResource, m_aWeaponIcons[nWeaponIndex].nWeaponIcon);
        UpdateWeaponIconDisplay(m_aWeaponIcons[nWeaponIndex], "Wheel.Wheel.Player.WeaponCenter");
        m_oCenterWeaponIcon.nWeaponIcon = m_aWeaponIcons[nWeaponIndex].nWeaponIcon;
        ClosePlayerWeapons();
    }
}

function ClosePlayerWeapons()
{
    if (m_bDashboardWeaponsOpen == true)
    {
        m_bDashboardWeaponsOpen = false;
        oPanel.GotoLabelAndPlay("Wheel.Wheel.Player", "close");
    }
}

function ExpandPlayerWeapons()
{
    if (m_bDashboardWeaponsOpen == false)
    {
        m_bDashboardWeaponsOpen = true;
        oPanel.GotoLabelAndPlay("Wheel.Wheel.Player", "open");
    }
}

function SwapHenchmanWeapon(BioPawn pHench)
{
    local SFXInventoryManager pInvManager;
    local SFXWeapon pWeapon;
    local int nIcon;
    local SFXPowerWheelIconWeapon oWeaponIcon;
    local bool bSwitched;
    if (pHench == None)
    {
        PlayGuiSound('GuiError');
        return;
    }
    if (pHench == m_pHench1Pawn)
    {
        nIcon = m_oWeaponIndices.aHench1[0];
    }
    else
    {
        if (pHench == m_pHench2Pawn)
        {
            nIcon = m_oWeaponIndices.aHench2[0];
        }
    }
    pInvManager = SFXInventoryManager(pHench.InvManager);
    oWeaponIcon = m_aWeaponIcons[nIcon];
    if (pInvManager != None)
    {
        foreach pInvManager.InventoryActors(Class'SFXWeapon', pWeapon)
        {
            if (pWeapon.Class != oWeaponIcon.oWeaponClass)
            {
                pInvManager.CurrentWeaponSelection = pWeapon.Class;
                m_pPlayerController.OrderWeaponSwitch(pHench, pWeapon);
                PlayGuiSound('HUDPowerWheelQueueingHighlightedPowerForActivation');
                SetWeaponIcon(pWeapon, nIcon, pHench);
                HoverWeaponIcon(nIcon, true);
                bSwitched = true;
                break;
            }
        }
    }
    if (bSwitched == false)
    {
        PlayGuiSound('GuiError');
    }
}

function SetQuickSlotState(bool bExpand, bool bSkipTransition)
{
    local int nIcon;
    if (m_bQuickSlotExpanded == bExpand)
    {
        return;
    }
    if (bExpand != false)
    {
        SetupQuickSlotKeys();
        if (bSkipTransition == false)
        {
            oPanel.GotoLabelAndPlay("QuickSlots", "maximize");
        }
        else
        {
            oPanel.GotoLabelAndStop("QuickSlots", "maximized");
        }
        oPanel.SetTextFieldText("QuickSlots.Control.controlMC.txtMinMax", m_srMinimizeText);
        oPanel.GotoLabelAndStop("QuickSlots.Control.controlMC.Button", "minimize");
        nIcon = 0;
        while (nIcon < 8)
        {
            SetQuickSlotIconSelected(nIcon, false);
            UpdateQuickSlotDisplay(nIcon);
            ++nIcon;
        }
    }
    else
    {
        if (bSkipTransition == false)
        {
            oPanel.GotoLabelAndPlay("QuickSlots", "minimize");
        }
        else
        {
            oPanel.GotoLabelAndStop("QuickSlots", "minimized");
        }
        oPanel.SetTextFieldText("QuickSlots.Control.controlMC.txtMinMax", m_srMaximizeText);
        oPanel.GotoLabelAndStop("QuickSlots.Control.controlMC.Button", "maximize");
    }
    m_bQuickSlotExpanded = bExpand;
}

native function SetupQuickSlotKeys();

native function SetupQuickSlotPowers();

function SFXPowerWheelMode FindIconIndexFromPath(String sIconID, out int nFoundIcon)
{
    local int nIcon;
    nFoundIcon = -1;
    nIcon = 0;
    while (nIcon < m_aPowerIcons.Length)
    {
        if (m_aPowerIcons[nIcon].sID == sIconID)
        {
            nFoundIcon = nIcon;
            return 1;
        }
        ++nIcon;
    }
    nIcon = 0;
    while (nIcon < m_aWeaponIcons.Length)
    {
        if (m_aWeaponIcons[nIcon].sID == sIconID)
        {
            nFoundIcon = nIcon;
            return 2;
        }
        ++nIcon;
    }
    return 0;
}

function ExInt_IconRollOver(String sIconID)
{
    local int nIcon;
    local SFXPowerWheelMode eMode;
    local bool bIsPlayerID;
    local BioPawn pPawn;
    if (IsMouseShown() == false)
    {
        return;
    }
    eMode = FindIconIndexFromPath(sIconID, nIcon);
    if (nIcon == -1 || eMode == 0)
    {
        if (sIconID == "WeaponCenter")
        {
            ExpandPlayerWeapons();
        }
        else
        {
            if (HandleQuickSlotRollOver(sIconID) != false)
            {
                return;
            }
        }
        return;
    }
    if (eMode == 1)
    {
        if (m_oPowerIndices.aPlayer.Find(nIcon) >= 0)
        {
            pPawn = m_pShepardPawn;
        }
        else
        {
            if (m_oPowerIndices.aHench1.Find(nIcon) >= 0)
            {
                pPawn = m_pHench1Pawn;
            }
            else
            {
                if (m_oPowerIndices.aHench2.Find(nIcon) >= 0)
                {
                    pPawn = m_pHench2Pawn;
                }
            }
        }
        ClosePlayerWeapons();
        if (IsPawnBlocked(pPawn) == false)
        {
            HoverPowerIcon(nIcon, false);
        }
    }
    else
    {
        if (eMode == 2)
        {
            if (m_oWeaponIndices.aPlayer.Find(nIcon) >= 0)
            {
                pPawn = m_pShepardPawn;
            }
            else
            {
                if (m_oWeaponIndices.aHench1.Find(nIcon) >= 0)
                {
                    pPawn = m_pHench1Pawn;
                }
                else
                {
                    if (m_oWeaponIndices.aHench2.Find(nIcon) >= 0)
                    {
                        pPawn = m_pHench2Pawn;
                    }
                }
            }
            if (IsPawnBlocked(pPawn) != false)
            {
                return;
            }
            if (m_oWeaponIndices.aPlayer.Find(nIcon) != -1)
            {
                bIsPlayerID = true;
            }
            if (m_bDashboardWeaponsOpen == bIsPlayerID)
            {
                HoverWeaponIcon(nIcon);
            }
        }
    }
}

function bool HandleQuickSlotRollOver(String sIconID)
{
    local int nSlot;
    if (sIconID == "QuickslotControl")
    {
        oPanel.GotoLabelAndPlay("QuickSlots.Control", "startselect");
        return true;
    }
    nSlot = 0;
    while (nSlot < 8)
    {
        if (m_aQuickSlotIcons[nSlot].sID == sIconID)
        {
            HoverQuickSlot(nSlot);
            return true;
        }
        ++nSlot;
    }
    return false;
}

function ExInt_IconRollOut(String sIconID)
{
    local int nIcon;
    local SFXPowerWheelMode eMode;
    local bool bIsPlayerID;
    if (IsMouseShown() == false)
    {
        return;
    }
    eMode = FindIconIndexFromPath(sIconID, nIcon);
    if (nIcon == -1 || eMode == 0)
    {
        HandleQuickSlotRollOut(sIconID);
        return;
    }
    if (eMode == 1)
    {
        LeavePowerIcon(nIcon, false);
    }
    else
    {
        if (eMode == 2)
        {
            if (m_oWeaponIndices.aPlayer.Find(nIcon) != -1)
            {
                bIsPlayerID = true;
            }
            if (m_bDashboardWeaponsOpen == bIsPlayerID)
            {
                LeaveWeaponIcon(nIcon);
            }
        }
    }
}

function bool HandleQuickSlotRollOut(String sIconID)
{
    local int nSlot;
    if (sIconID == "QuickslotControl")
    {
        oPanel.GotoFrameAndStop("QuickSlots.Control", 1);
        return true;
    }
    nSlot = 0;
    while (nSlot < 8)
    {
        if (m_aQuickSlotIcons[nSlot].sID == sIconID)
        {
            LeaveQuickSlot(nSlot);
            return true;
        }
        ++nSlot;
    }
    return false;
}

function ExInt_IconMouseUp(String sIconID)
{
    local int nIcon;
    local SFXPowerWheelMode eMode;
    if (IsMouseShown() == false)
    {
        return;
    }
    eMode = FindIconIndexFromPath(sIconID, nIcon);
    if (nIcon == -1 || eMode == 0)
    {
        HandleQuickSlotMouseUp(sIconID);
        return;
    }
    if (m_nDraggingIcon == nIcon && m_bDoingDrag != false)
    {
        m_nDraggingIcon = -1;
        return;
    }
    if (eMode == 1 && m_nCurrentPowerIconIndex == nIcon)
    {
        SelectCurrentWheelItem(1);
    }
    else
    {
        if (eMode == 2 && m_nCurrentWeaponIconIndex == nIcon)
        {
            if (m_oWeaponIndices.aPlayer.Find(nIcon) != -1)
            {
                SelectCurrentWheelItem(2);
            }
            else
            {
                if (m_oWeaponIndices.aHench1.Find(nIcon) != -1)
                {
                    SwapHenchmanWeapon(m_pHench1Pawn);
                }
                else
                {
                    if (m_oWeaponIndices.aHench2.Find(nIcon) != -1)
                    {
                        SwapHenchmanWeapon(m_pHench2Pawn);
                    }
                }
            }
        }
    }
    m_nDraggingIcon = -1;
}

function bool HandleQuickSlotMouseUp(String sIconID)
{
    local int nSlot;
    if (sIconID == "QuickslotControl")
    {
        SetQuickSlotState(!m_bQuickSlotExpanded, false);
        return true;
    }
    if (m_bDoingDrag == false)
    {
        nSlot = 0;
        while (nSlot < 8)
        {
            if (m_aQuickSlotIcons[nSlot].sID == sIconID)
            {
                doHotKey(nSlot);
                return true;
            }
            ++nSlot;
        }
    }
    return false;
}

function ExInt_IconMouseDown(String sIconID)
{
    local int nIcon;
    local SFXPowerWheelMode eMode;
    if (IsMouseShown() == false)
    {
        return;
    }
    m_bDraggingPower = false;
    eMode = FindIconIndexFromPath(sIconID, nIcon);
    if (nIcon == -1 || eMode == 0)
    {
        HandleQuickSlotMouseDown(sIconID);
        return;
    }
    if (eMode == 1)
    {
        if (m_aPowerIcons[nIcon].eState != 5 && m_aPowerIcons[nIcon].eState != 6)
        {
            m_bDraggingPower = true;
        }
    }
    m_nDraggingIcon = nIcon;
}

function bool HandleQuickSlotMouseDown(String sIconID)
{
    local int nSlot;
    nSlot = 0;
    while (nSlot < 8)
    {
        if (m_aQuickSlotIcons[nSlot].sID == sIconID)
        {
            if (m_aQuickSlotIcons[nSlot].eState != 5 && m_aQuickSlotIcons[nSlot].eState != 6)
            {
                m_bDraggingKey = true;
                m_nDraggingIcon = nSlot;
                return true;
            }
        }
        ++nSlot;
    }
    return false;
}

native function UpdateQuickSlotDisplay(int nIcon);

function HoverQuickSlot(int nSlotID)
{
    if (nSlotID < 0 || nSlotID >= 8)
    {
        return;
    }
    if (m_nCurrentQuickSlot != nSlotID)
    {
        LeaveQuickSlot(m_nCurrentQuickSlot);
        if (m_bDraggingPower != false)
        {
            m_aQuickSlotIcons[nSlotID].bDragHover = true;
        }
        SetQuickSlotIconSelected(nSlotID, true);
        m_nCurrentQuickSlot = nSlotID;
        UpdatePowerInformationText(m_aQuickSlotIcons[nSlotID]);
        PlayGuiSound('HUDPowerWheelChangeHighlightedPower');
    }
}

function LeaveQuickSlot(int nSlotID)
{
    if (nSlotID < 0 || nSlotID >= 8)
    {
        return;
    }
    m_aQuickSlotIcons[nSlotID].bDragHover = false;
    SetQuickSlotIconSelected(nSlotID, false);
    m_nCurrentQuickSlot = -1;
    SetInformationText("", "");
}

native function doHotKey(int nIndex);

native function SetQuickSlotIconSelected(int nIconIndex, bool bSelected);

function ExInt_CollapsePlayerWeapons()
{
    ClosePlayerWeapons();
}

defaultproperties
{
    m_nDraggingIcon=-1
    m_nCurrentDropTarget=-1
    m_fQuickslotIconUpdateInterval=0,1
    m_srMaximizeText=System.Byte[]
    m_srMinimizeText=System.Byte[]
    m_fDragStartThreshold=3
    m_bCanMapPlayerPowers=false
    m_aPowerIcons=System.Byte[]
    m_aWeaponIcons=System.Byte[]
    m_sShepardBlockerPath="Wheel.Wheel.BlockerShepard"
    m_sHench1BlockerPath="Wheel.Wheel.BlockerTeam1"
    m_sHench2BlockerPath="Wheel.Wheel.BlockerTeam2"
    m_sTeam1StatusTextPath="Wheel.Wheel.txtTeam1Status"
    m_sTeam1PowerTextPath="Wheel.Wheel.txtTeam1Power"
    m_sTeam2StatusTextPath="Wheel.Wheel.txtTeam2Status"
    m_sTeam2PowerTextPath="Wheel.Wheel.txtTeam2Power"
    ScreenLayout=System.Byte[]
}
