﻿class SFXSeqAct_GivePlotWeapon extends SeqAct_Latent
    hidecategories(Object);

var SFX_MB_TextAlign m_TextAlign;

var SFX_MB_Skin m_Skin;

// srSquadListTokens: StringRefProperty[44]
// ShepardName: StringRefProperty[44]
// srNoSquadMembers: StringRefProperty[44]
// srAButton: StringRefProperty[44]
// srText: StringRefProperty[44]
var bool m_bWasPaused;

var bool m_bFinished;

var() bool bShowPopup;

var() bool bAutoEquip;

var() class<SFXWeapon> WeaponClass;

function Activated()
{
    local SFXPawn oPawn;
    local SFXPawn oPlayerPawn;
    local int idx;
    local int HIdx;
    local int GroupIdx;
    local int EntryIdx;
    local SFXEngine Engine;
    m_bFinished = false;
    OutputLinks[0].bHasImpulse = false;
    OutputLinks[1].bHasImpulse = false;
    OutputLinks[2].bHasImpulse = false;
    m_bWasPaused = GetWorldInfo().bPlayersOnly;
    GetWorldInfo().bPlayersOnly = true;
    oPlayerPawn = SFXPawn(BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetLocalPlayerController().Pawn);
    Engine = SFXEngine(BioPlayerController(oPlayerPawn.Controller).Player.Outer);
    Class'SFXPlayerSquadLoadoutData'.GetWeaponCategory(WeaponClass, GroupIdx, EntryIdx);
    if (GroupIdx != -1)
    {
        if (Class'SFXPlayerSquadLoadoutData'.CanPlayerUseWeaponClass(WeaponClass))
        {
            Engine.PlayerLoadoutWeapons[GroupIdx] = PathName(WeaponClass);
        }
        idx = 0;
        while (idx < Engine.HenchmanRecords.Length)
        {
            HIdx = 0;
            while (HIdx < Class'SFXPawn_Henchman'.Default.HenchmenInfo.Length)
            {
                if (Class'SFXPawn_Henchman'.Default.HenchmenInfo[HIdx].Tag == Engine.HenchmanRecords[idx].Tag)
                {
                    if (Class'SFXPlayerSquadLoadoutData'.CanHenchmanUseWeaponClass(Class'SFXPawn_Henchman'.Default.HenchmenInfo[HIdx].Tag, WeaponClass))
                    {
                        Engine.HenchmanRecords[idx].LoadoutWeapons[GroupIdx] = PathName(WeaponClass);
                    }
                }
                HIdx++;
            }
            idx++;
        }
    }
    idx = 0;
    while (idx < oPlayerPawn.Squad.GetSquadSize())
    {
        oPawn = SFXPawn(oPlayerPawn.Squad.GetMember(idx));
        if (oPawn.CanUseWeapon(WeaponClass))
        {
            oPawn.CreateWeapon(WeaponClass, bAutoEquip);
        }
        idx++;
    }
    if (bShowPopup)
    {
        DisplayMessageBox();
    }
    else
    {
        OutputLinks[0].bHasImpulse = true;
        m_bFinished = true;
        GetWorldInfo().bPlayersOnly = m_bWasPaused;
    }
}

function DisplayMessageBox()
{
    local BioSFHandler_MessageBox oMsgBox;
    local BioMessageBoxOptionalParams stParams;
    local String WeaponName;
    local String SquadList;
    oMsgBox = MassEffectGuiManager(BioWorldInfo(GetWorldInfo()).GetLocalPlayerController().GetScaleFormManager()).CreateMessageBox();
    oMsgBox.SetInputDelegate(MessageInputPressed);
    stParams.srAText = // unknown bytecode 4F ;
}

function String BuildSquadMemberList(class<SFXWeapon> WClass)
{
    local BioGlobalVariableTable VarTable;
    local bool bWeaponIsUsed;
    local int TokenIndex;
    local int Index;
    local HenchmanInfoStruct HenchInfo;
    VarTable = BioWorldInfo(Class'Engine'.GetCurrentWorldInfo()).GetGlobalVariables();
    ClearCustomTokens();
    if (Class'SFXPlayerSquadLoadoutData'.CanPlayerUseWeaponClass(WClass))
    {
        bWeaponIsUsed = true;
        SetCustomToken(TokenIndex++, ShepardName);
    }
    foreach Class'SFXPawn_Henchman'.Default.HenchmenInfo(HenchInfo)
    {
        if (VarTable.GetBool(HenchInfo.HenchAcquiredPlotID))
        {
            if (Class'SFXPlayerSquadLoadoutData'.CanHenchmanUseWeaponClass(HenchInfo.Tag, WClass))
            {
                bWeaponIsUsed = true;
                if (HenchInfo.AlternateHenchNamePlotFlag != 'None' && VarTable.GetBoolByName(HenchInfo.AlternateHenchNamePlotFlag))
                {
                    SetCustomToken(TokenIndex++, HenchInfo.AlternatePrettyName);
                }
                else
                {
                    SetCustomToken(TokenIndex++, HenchInfo.PrettyName);
                }
            }
        }
    }
    if (!bWeaponIsUsed)
    {
        SetCustomToken(TokenIndex++, srNoSquadMembers);
    }
    Index = TokenIndex;
    while (Index < 14)
    {
        SetCustomToken(Index, "");
        Index++;
    }
    return Class'SFXGame'.GetSimpleString(srSquadListTokens, true);
}

event bool Update(float DeltaTime)
{
    if (m_bFinished)
    {
        OutputLinks[0].bHasImpulse = true;
        return false;
    }
    return true;
}

final function MessageInputPressed(bool bAPressed, int nContext)
{
    m_bFinished = true;
    GetWorldInfo().bPlayersOnly = m_bWasPaused;
}

defaultproperties
{
    bAutoEquip=true
    bShowPopup=true
    srText=System.Byte[]
    srAButton=System.Byte[]
    srNoSquadMembers=System.Byte[]
    ShepardName=System.Byte[]
    srSquadListTokens=System.Byte[]
    m_Skin=SFX_MB_Skin_Shepard
    bCallHandler=false
    bManualHandleOutputs=true
    VariableLinks=None
}
