﻿class SFXSeqAct_LegacyDataCallback extends BioSequenceLatentAction
    hidecategories(Object)
    native;

var() float m_fTimeOut;

var int m_nAutoDeviceID;

var bool m_bLoginUIOpenedOnce;

var bool m_bLoginUIActive;

var bool m_bLegacyDataReady;

var transient BioWorldInfo BWI;

var transient SFXLegacyData ImportDataManager;

// XenonInterface: InterfaceProperty[48]
var transient OnlineSubsystem OnlineSubsystem;

event Activated()
{
    Activated();
    DetermineParams();
    BWI = BioWorldInfo(GetWorldInfo());
    if (BWI != None && BWI.CurrentGame != None)
    {
        ImportDataManager = BWI.CurrentGame.ImportedDataManager;
    }
    OnlineSubsystem = Class'GameEngine'.GetOnlineSubsystem();
    if (OnlineSubsystem != None)
    {
        XenonInterface = OnlineSubsystem.PlayerInterface;
    }
}

native final function DetermineParams();

event bool UpdateOp(float DeltaTime)
{
    local LocalPlayer LocPlayer;
    local int ControllerId;
    local bool bIsXbox;
    local SFXEngine Engine;
    bIsXbox = BWI.IsConsoleBuild(1);
    LocPlayer = LocalPlayer(BWI.GetLocalPlayerController().Player);
    Engine = SFXEngine(LocPlayer.Outer);
    if (Engine != None && Engine.ME2ImportSaveGame != None)
    {
        ME2ImportPlotState();
        Class'BioTelemetry'.SendEvent('NEW_CHARACTER');
        OutputLinks[1].bHasImpulse = true;
        return true;
    }
    if (bIsXbox)
    {
        if (!m_bLegacyDataReady)
        {
            ApplyCanonPlotStates();
            OutputLinks[0].bHasImpulse = true;
            Class'BioTelemetry'.SendEvent('NEW_CHARACTER');
            return true;
        }
        if (ImportDataManager == None)
        {
            OutputLinks[2].bHasImpulse = true;
            return true;
        }
        if (ImportDataManager.m_bImportStartPausedForMissingDevice)
        {
            OutputLinks[4].bHasImpulse = true;
            ImportDataManager.m_bImportStartPausedForMissingDevice = false;
            return true;
        }
        if (ImportDataManager.m_bImportAllowed == false)
        {
            ImportDataManager.m_bImportedData = false;
            ApplyCanonPlotStates();
            OutputLinks[0].bHasImpulse = true;
            Class'BioTelemetry'.SendEvent('NEW_CHARACTER');
            return true;
        }
    }
    else
    {
        if (ImportDataManager == None)
        {
            OutputLinks[0].bHasImpulse = true;
            return true;
        }
        else
        {
            if (ImportDataManager.m_bImportedData)
            {
                ImportDataManager.ApplyME1PlotStates();
                OutputLinks[1].bHasImpulse = true;
                Class'BioTelemetry'.SendEvent('IMPORT_ME1_CHARACTER');
                return true;
            }
            else
            {
                ApplyCanonPlotStates();
                OutputLinks[0].bHasImpulse = true;
                Class'BioTelemetry'.SendEvent('NEW_CHARACTER');
                return true;
            }
        }
    }
    if (ImportDataManager.m_bImportedData)
    {
        ImportDataManager.ApplyME1PlotStates();
        OutputLinks[1].bHasImpulse = true;
        Class'BioTelemetry'.SendEvent('IMPORT_ME1_CHARACTER');
        if (bIsXbox && m_nAutoDeviceID > 0 && m_nAutoDeviceID < 5 && BWI.GetLocalPlayerController() != None)
        {
            BWI.GetLocalPlayerController().SetDeviceID(m_nAutoDeviceID);
        }
        return true;
    }
    if (!m_bLoginUIActive)
    {
        if (m_fTimeOut < 0)
        {
            OutputLinks[3].bHasImpulse = true;
            return true;
        }
        m_fTimeOut -= DeltaTime;
    }
    ControllerId = 0;
    if (LocPlayer != None)
    {
        ControllerId = LocPlayer.ControllerId;
    }
    if (NotEqual_InterfaceInterface(XenonInterface, OnlinePlayerInterface(None)))
    {
        if (XenonInterface.GetLoginStatus(ControllerId) == 0)
        {
            if (!m_bLoginUIOpenedOnce)
            {
                XenonInterface.ShowLoginUI(false);
                m_bLoginUIActive = true;
                m_bLoginUIOpenedOnce = true;
                return false;
            }
        }
        else
        {
            if (m_bLoginUIActive == true)
            {
                m_bLoginUIActive = false;
            }
        }
    }
    if (bIsXbox)
    {
        PingBlazeReconnect();
    }
    return TryImport();
}

final function ME2ImportPlotState()
{
    local LocalPlayer LocPlayer;
    local SFXEngine Engine;
    local BioGlobalVariableTable VarTable;
    local BioSaveGame SaveGame;
    LocPlayer = LocalPlayer(BWI.GetLocalPlayerController().Player);
    Engine = SFXEngine(LocPlayer.Outer);
    VarTable = BWI.GetGlobalVariables();
    VarTable.SetBool(4135, true);
    if (Engine != None && Engine.ME2ImportSaveGame != None)
    {
        if (VarTable != None)
        {
            VarTable.BoolVariables = Engine.ME2ImportSaveGame.PlotRecord.BoolVariables;
            VarTable.IntVariables = Engine.ME2ImportSaveGame.PlotRecord.IntVariables;
            VarTable.FloatVariables = Engine.ME2ImportSaveGame.PlotRecord.FloatVariables;
        }
        SaveGame = BWI.CurrentGame;
        if (Engine.ME2ImportSaveGame.ME1PlotRecord.BoolVariables.Length + Engine.ME2ImportSaveGame.ME1PlotRecord.IntVariables.Length + Engine.ME2ImportSaveGame.ME1PlotRecord.FloatVariables.Length > 0)
        {
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.BoolVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.BoolVariables;
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.IntVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.IntVariables;
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.FloatVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.FloatVariables;
            Engine.CurrentSaveGame.ME1PlotRecord.BoolVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.BoolVariables;
            Engine.CurrentSaveGame.ME1PlotRecord.IntVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.IntVariables;
            Engine.CurrentSaveGame.ME1PlotRecord.FloatVariables = Engine.ME2ImportSaveGame.ME1PlotRecord.FloatVariables;
            SFXGame(BWI.Game).SetNGPlusPlotStates();
            SaveGame.ImportedDataManager.ApplyME1PlotStates();
        }
        else
        {
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.BoolVariables.Length = 0;
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.IntVariables.Length = 0;
            SaveGame.ImportedDataManager.m_oImportedGlobalVariables.FloatVariables.Length = 0;
            Engine.CurrentSaveGame.ME1PlotRecord.BoolVariables.Length = 0;
            Engine.CurrentSaveGame.ME1PlotRecord.IntVariables.Length = 0;
            Engine.CurrentSaveGame.ME1PlotRecord.FloatVariables.Length = 0;
            SFXGame(BWI.Game).SetNGPlusPlotStates();
            ApplyCanonPlotStates();
        }
    }
}

native final function bool TryImport();

final function PingBlazeReconnect()
{
    local SFXGame oGame;
    local SFXOnlineSubsystem oOnline;
    local SFXOnlineComponentBlazeLogin oLogin;
    if (BWI != None)
    {
        oGame = SFXGame(BWI.Game);
        if (oGame != None)
        {
            oOnline = oGame.SFXOnlineSubsystem;
            if (oOnline != None)
            {
                oLogin = oOnline.GetComponentLogin();
                if (oLogin != None)
                {
                    oLogin.Connect(3);
                }
            }
        }
    }
}

final function ApplyCanonPlotStates()
{
    local BioGlobalVariableTable VarTable;
    if (BWI == None)
    {
        return;
    }
    VarTable = BWI.GetGlobalVariables();
    VarTable.SetBool(3752, true);
    VarTable.SetBool(1862, true);
    if (BWI.CurrentGame.bNewPlayer == true && BWI.CurrentGame.NewPlayer.bIsFemale == true)
    {
        VarTable.SetBool(1540, true);
    }
    else
    {
        if (BWI.CurrentGame.bNewPlayer == false && BWI.CurrentGame.DefaultPlayer.bIsFemale == true)
        {
            VarTable.SetBool(1540, true);
        }
        else
        {
            VarTable.SetBool(1541, true);
        }
    }
    VarTable.SetBool(1553, true);
    VarTable.SetBool(1555, true);
    VarTable.SetBool(1926, true);
    VarTable.SetBool(2659, true);
    VarTable.SetBool(2400, true);
    VarTable.SetBool(3753, true);
    VarTable.SetBool(2278, true);
}

defaultproperties
{
    m_fTimeOut=10000
    bHasTargets=false
    bManualHandleOutputs=true
    InputLinks=None
}
