﻿class SFXSystem extends SFXGalaxyMapObject
    hidecategories(Object)
    native;

var(Appearance) LinearColor FlareTint;

var(Appearance) LinearColor StarColor;

var(Appearance) LinearColor SunColor;

var(Appearance) bool m_bShowNebula;

var() bool m_bHasMassRelay;

var transient Bio2DA m_pPlanetTable;

var transient Bio2DA m_pSystemTable;

var array<BioPlanet> Planets;

native function bool LoadFrom2DA();

function SFXGalaxyMapObject AddChild()
{
    local BioPlanet newPlanet;
    newPlanet = new(self,Class'BioPlanet');
    Planets.AddItem(newPlanet);
    newPlanet.NameText = "new Planet";
    return newPlanet;
}

function GetChildren(out array<SFXGalaxyMapObject> Children)
{
    Children = Planets;
}

function RemoveChild(SFXGalaxyMapObject Child)
{
    local int Index;
    Index = Planets.Find(BioPlanet(Child));
    if (Index >= 0)
    {
        Planets[Index] = None;
    }
}

defaultproperties
{
    m_pSystemTable=Bio2DA'Default2DA'
    m_pPlanetTable=Bio2DA'Default2DA'
    SunColor=(R=0,G=0,B=0,A=1)
    StarColor=(R=0,G=0,B=0,A=1)
    FlareTint=(R=0,G=0,B=0,A=1)
    Tag="System"
}
