﻿class SFXVocalizationBank extends Object
    native;

struct native SFXVocalizationLine
{
    var WwiseEvent Sound;

    var() array<ESFXVocalizationVariationType> SpecificType;

    var() array<int> SpecificValue;

}

struct native SFXVocalizationVariation
{
    var() array<SFXVocalizationLine> Variations;

}

struct native SFXVocalizationRole
{
    var() array<SFXVocalizationVariation> Roles;

}

var array<SFXVocalizationEventV2> VocalizationsV2;

var array<SFXVocalizationRole> Vocalizations;

struct native SFXVocalizationParam
{
    var() array<ESFXVocalizationVariationType> SpecificType;

    var() array<int> SpecificValue;

}

struct native SFXVocalizationLineV2
{
    var SFXVocalizationParam Instigator;

    var SFXVocalizationParam Recipient;

    var SFXVocalizationParam ThirdParam;

    var WwiseEvent Sound;

    var String DebugText;

}

struct native SFXVocalizationEventV2
{
    var array<SFXVocalizationLineV2> Lines;

}

function EnsureArrays(int I, int J)
{
    if (Vocalizations.Length <= I)
    {
        // unknown bytecode 54 ;
    }
}

function ImportBadOldType(out Name Type, out Name Variation)
{
    local String Suffix;
    if (Type == 'SpecificType_Character')
    {
        Type = 'SpecificType_CharacterName';
    }
    else
    {
        if (Type == 'SpecificType_Race' || Type == 'SpecificType_EnemyType')
        {
            Type = 'SpecificType_CharacterType';
            Suffix = Right(Variation, Len(Variation) - InStr(Variation, "_", true));
            if (Suffix == "_Mech")
            {
                Suffix = "_LightMech";
                Variation = "CharacterType" $ Suffix;
            }
            else
            {
                if (Suffix == "_Geth")
                {
                    Suffix = "_GethInfantry";
                    Variation = "CharacterType" $ Suffix;
                }
                else
                {
                    if (Suffix == "_Merc")
                    {
                        Type = 'SpecificType_Group';
                        Suffix = "_GenericMerc";
                        Variation = "GroupType" $ Suffix;
                    }
                    else
                    {
                        Variation = "CharacterType" $ Suffix;
                    }
                }
            }
        }
    }
}

event MakeEntry(Name Role, Name Event, Name Type, Name Variation, WwiseEvent Sound)
{
    local int EventIndex;
    local int RoleIndex;
    local int TypeIndex;
    local int VariationIndex;
    local Object Obj;
    ImportBadOldType(Type, Variation);
    EventIndex = GetEnumIndex(Enum'ESFXVocalizationEventID', "SFXVocalizationEvent_" $ Event);
    RoleIndex = GetEnumIndex(Enum'ESFXVocalizationRole', "SFXVocalizationRole_" $ Role);
    TypeIndex = GetEnumIndex(Enum'ESFXVocalizationVariationType', "SFXVocalization" $ Type);
    if (TypeIndex == 0)
    {
        VariationIndex = 0;
    }
    else
    {
        Obj = Class'SFXVocalizationTypes'.Default.EnumForType[TypeIndex];
        if (TypeIndex == 3 || TypeIndex == 4 || TypeIndex == 7)
        {
            VariationIndex = GetEnumIndex(Obj, Variation);
        }
        else
        {
            VariationIndex = GetEnumIndex(Obj, "SFXVocalization" $ Variation);
        }
    }
    if (VariationIndex == -1 || TypeIndex == -1)
    {
        VariationIndex = 0;
        TypeIndex = 0;
    }
    EnsureArrays(EventIndex, RoleIndex);
    // unknown bytecode 54 ;
}

defaultproperties
{
}
