﻿class SFXVocalizationManager extends SFXVocalizationManagerNativeBase
    hidecategories(Navigation)
    config(Game);

enum ESFXVocalizationEventID
{
    SFXVocalizationEvent_None,
    SFXVocalizationEvent_EnteredCombat,
    SFXVocalizationEvent_ReceivedOrder_Attack,
    SFXVocalizationEvent_ReceivedOrder_Attack_TargetValid,
    SFXVocalizationEvent_ReceivedOrder_Attack_MovingFirst,
    SFXVocalizationEvent_ReceivedOrder_Attack_KilledTarget,
    SFXVocalizationEvent_ReceivedOrder_ChangeWeapon,
    SFXVocalizationEvent_ReceivedOrder_Move,
    SFXVocalizationEvent_ReceivedOrder_Follow,
    SFXVocalizationEvent_ReceivedOrder_TakeCover,
    SFXVocalizationEvent_ReceivedOrder_Hold,
    SFXVocalizationEvent_CancellingHoldOrder,
    SFXVocalizationEvent_FailedMoveOrder,
    SFXVocalizationEvent_Attacking,
    SFXVocalizationEvent_Attacking_Henchman,
    SFXVocalizationEvent_KilledTarget_Henchman,
    SFXVocalizationEvent_LostSight,
    SFXVocalizationEvent_EnemySighted,
    SFXVocalizationEvent_MovingToCover,
    SFXVocalizationEvent_UsingPower,
    SFXVocalizationEvent_ChangingWeapon,
    SFXVocalizationEvent_Death,
    SFXVocalizationEvent_Death_NonTrivial,
    SFXVocalizationEvent_Death_Henchman,
    SFXVocalizationEvent_ReceivedDamage,
    SFXVocalizationEvent_ReceivedDamage_LowHealth,
    SFXVocalizationEvent_ReceivedDamage_ExtremelyLowHealth,
    SFXVocalizationEvent_RequireHealing,
    SFXVocalizationEvent_ShieldsDown,
    SFXVocalizationEvent_OneEnemyRemaining,
    SFXVocalizationEvent_ZeroEnemiesRemaining,
    SFXVocalizationEvent_Agitation_High,
    SFXVocalizationEvent_Agitation_Medium,
    SFXVocalizationEvent_DamageReaction_GreatPain,
    SFXVocalizationEvent_DamageReaction_OnFire,
    SFXVocalizationEvent_DamageReaction_KnockedBack,
    SFXVocalizationEvent_Falling,
    SFXVocalizationEvent_Tossed,
    SFXVocalizationEvent_Brainwashed,
    SFXVocalizationEvent_Taunt,
    SFXVocalizationEvent_Ambient,
    SFXVocalizationEvent_Power_Failed_ShieldsUp,
    SFXVocalizationEvent_Power_Failed_BarrierUp,
    SFXVocalizationEvent_Power_Failed_ArmorUp,
    SFXVocalizationEvent_Power_EnergyDrain,
    SFXVocalizationEvent_Power_Reave,
    SFXVocalizationEvent_Power_ShockWave,
    SFXVocalizationEvent_Power_Crush,
    SFXVocalizationEvent_Power_CombatDrone,
    SFXVocalizationEvent_Power_Incinerate,
    SFXVocalizationEvent_Power_Lift,
    SFXVocalizationEvent_Power_Pull,
    SFXVocalizationEvent_Power_Singularity,
    SFXVocalizationEvent_Power_Stasis,
    SFXVocalizationEvent_Power_Throw,
    SFXVocalizationEvent_Power_Warp,
    SFXVocalizationEvent_Power_Biotic_Misc,
    SFXVocalizationEvent_Power_AIHack,
    SFXVocalizationEvent_Power_Fissure,
    SFXVocalizationEvent_Power_Flashbang,
    SFXVocalizationEvent_Power_NeuralShock,
    SFXVocalizationEvent_Power_Overload,
    SFXVocalizationEvent_Power_Sabotage,
    SFXVocalizationEvent_Power_Tech_Misc,
    SFXVocalizationEvent_Power_Ammo,
    SFXVocalizationEvent_Power_Explosion,
    SFXVocalizationEvent_Power_Melee,
    SFXVocalizationEvent_Power_Projectile,
    SFXVocalizationEvent_Power_Combat_Misc,
    SFXVocalizationEvent_Power_Buff,
    SFXVocalizationEvent_Power_Cloak,
    SFXVocalizationEvent_Power_Regeneration,
    SFXVocalizationEvent_Power_Resurrection,
    SFXVocalizationEvent_Power_KroganCharge,
    SFXVocalizationEvent_Power_KroganResurrection,
    SFXVocalizationEvent_MultipleAttackers,
    SFXVocalizationEvent_ViolenceAwe,
    SFXVocalizationEvent_Bored,
    SFXVocalizationEvent_DrewWeapon_OutOfCombat,
    SFXVocalizationEvent_StaredAt,
    SFXVocalizationEvent_Bumped,
    SFXVocalizationEvent_FriendlyFire,
    SFXVocalizationEvent_Headshot,
    SFXVocalizationEvent_ShootDeadBody,
    SFXVocalizationEvent_UsedNuclearWeapon,
    SFXVocalizationEvent_CoverCrateExplosion,
    SFXVocalizationEvent_HeavyMechGoingToExplode,
    SFXVocalizationEvent_Flanked,
    SFXVocalizationEvent_UnCloaked,
    SFXVocalizationEvent_ChargeFailed,
    SFXVocalizationEvent_BlockedPower,
    SFXVocalizationEvent_PowerStillOnCooldown,
    SFXVocalizationEvent_Varren_Charge,
    SFXVocalizationEvent_Husk_Charge,
    SFXVocalizationEvent_DamageReaction_PlayerStagger,
    SFXVocalizationEvent_DamageReaction_PlayerMeleed,
    SFXVocalizationEvent_DamageReaction_PlayerMeleedII,
    SFXVocalizationEvent_DamageReaction_PlayerMeleedNoRotate,
    SFXVocalizationEvent_DamageReaction_PlayerStandardImpact,
    SFXVocalizationEvent_DamageReaction_PlayerKnockback,
    SFXVocalizationEvent_DamageReaction_BloodyPlayerStandardImpact,
    SFXVocalizationEvent_DamageReaction_PlayerOnFire,
    SFXVocalizationEvent_CollectorPossession,
    SFXVocalizationEvent_VorchaBloodlust,
    SFXVocalizationEvent_CausedDamage,
    SFXVocalizationEvent_LowAmmo,
    SFXVocalizationEvent_OutOfAmmo,
    SFXVocalizationEvent_Loot_AmmoFound,
    SFXVocalizationEvent_Loot_AmmoFull,
    SFXVocalizationEvent_Loot_TreasureFound,
    SFXVocalizationEvent_Saw_HeavyMech,
    SFXVocalizationEvent_CollectorGeneral_ReceivedDamage,
    SFXVocalizationEvent_Aggressive_Flank,
    SFXVocalizationEvent_PraetorianImmune_ReceivedDamage,
    SFXVocalizationEvent_Krogan_ReceivedDamage,
    SFXVocalizationEvent_CollectorPossessed,
};

struct VocEventLog
{
    var Pawn Speaker;

    var Pawn ReferredTo;

    var ESFXVocalizationEventID Id;

    var float Time;

}

var transient array<VocEventLog> PastEvents;

event PostBeginPlay()
{
    EventProperties.Length = 116;
}

final function TriggerVocalizationEvent(ESFXVocalizationEventID Id, BioPawn InInstigator, optional BioPawn Recipient, optional BioPawn ReferringTo, optional float DelaySec, optional float fChanceToPlayModifier = 1)
{
    local SFXVocalizationEventProperties EventProps;
    local SFXVocalizationEvent NewEvent;
    local BioWorldInfo TheWorldInfo;
    local BioPlayerController PC;
    if (InInstigator != None)
    {
        TheWorldInfo = BioWorldInfo(InInstigator.WorldInfo);
        if (TheWorldInfo != None)
        {
            PC = TheWorldInfo.GetLocalPlayerController();
        }
    }
    if (Role == 3)
    {
        if (PC == None || PC.GameModeManager2 == None || PC.GameModeManager2.ShouldPlayVocalizations() == false)
        {
            return;
        }
        if (Id != 0)
        {
            EventProps = EventProperties[Id];
            if (FRand() <= EventProps.ChanceToPlay * fChanceToPlayModifier)
            {
                NewEvent.Instigator = InInstigator;
                NewEvent.Recipient = Recipient;
                NewEvent.Id = Id;
                NewEvent.DelayTimeRemainingSec = DelaySec;
                NewEvent.DebugIndex = DebugCounter++;
                if (Id == 34 || Id == 36)
                {
                    if (PC != None)
                    {
                        PC.UpdateAchievementProgression(35, InInstigator);
                    }
                }
                QueuedEvents.AddItem(NewEvent);
                jump 433;
            }
        }
    }
    return;
}

simulated protected event bool PlaySFXVocalizationSLineInternal(const out SFXVocalizationEvent E, const out SFXVocalizationLine LineToPlay, BioPawn Speaker, optional float DelaySec)
{
    local VocEventLog vlog;
    vlog.Id = E.Id;
    vlog.ReferredTo = E.Instigator;
    vlog.Speaker = Speaker;
    vlog.Time = WorldInfo.TimeSeconds;
    PastEvents.AddItem(vlog);
    return PlaySFXVocalizationSLineInternal(E, LineToPlay, Speaker, DelaySec);
}

simulated event TickEvents(float DeltaTime)
{
    local int idx;
    local int SoundsThisFrame;
    local bool bPlayedVocEvent;
    local bool bHandledVocEvent;
    local VocEventLog vlog;
    local SFXVocalizationEvent CurrentEvent;
    SoundsThisFrame = 0;
    idx = 0;
    while (idx < QueuedEvents.Length)
    {
        if (QueuedEvents[idx].DelayTimeRemainingSec <= 0)
        {
            if (WorldInfo.TimeSeconds - EventProperties[QueuedEvents[idx].Id].TimeLastPlayed > EventProperties[QueuedEvents[idx].Id].MinTimeBetweenSec || bAlwaysPlay)
            {
                if (SoundsThisFrame < 1)
                {
                    CurrentEvent = QueuedEvents[idx];
                    bPlayedVocEvent = HandleSFXVocalizationEvent(CurrentEvent);
                    bHandledVocEvent = true;
                }
                SoundsThisFrame++;
                jump 240;
            }
            if (!bHandledVocEvent && EventProperties[QueuedEvents[idx].Id].bQueueIfBlocked)
            {
            }
            else
            {
                if (!bPlayedVocEvent)
                {
                    vlog.Id = QueuedEvents[idx].Id;
                    vlog.ReferredTo = QueuedEvents[idx].Instigator;
                    vlog.Speaker = None;
                    vlog.Time = WorldInfo.TimeSeconds;
                    PastEvents.AddItem(vlog);
                }
                QueuedEvents.Remove(idx, 1);
                --idx;
            }
        }
        else
        {
            QueuedEvents[idx].DelayTimeRemainingSec -= DeltaTime;
        }
        ++idx;
    }
    return;
}

function DebugDraw(BioHUD H)
{
    local array<Actor> Done;
    local Actor A;
    local int idx;
    idx = PastEvents.Length - 1;
    while (idx >= 0)
    {
        if (TimeSince(PastEvents[idx].Time) > 2)
        {
            PastEvents.Remove(idx, 1);
        }
        idx--;
    }
    idx = PastEvents.Length - 1;
    while (idx >= 0)
    {
        if (PastEvents[idx].Speaker != None)
        {
            A = PastEvents[idx].Speaker;
        }
        else
        {
            A = PastEvents[idx].ReferredTo;
        }
        if (Done.Find(A) == -1)
        {
            DrawActorLog(A, H);
            Done.AddItem(A);
        }
        idx--;
    }
}

function DrawActorLog(Actor oActor, BioHUD H)
{
    local Vector ScreenCoords;
    local float X;
    local float Y;
    local float YL;
    local Vector CamLoc;
    local Rotator CamRot;
    local int idx;
    if (WorldInfo == None || WorldInfo.bShowDebugText == false)
    {
        return;
    }
    H.PlayerOwner.GetPlayerViewPoint(CamLoc, CamRot);
    if (oActor != None && TimeSince(oActor.LastRenderTime) < 1 && oActor.Location - CamLoc Dot CamRot > 0)
    {
        X = H.Canvas.CurX;
        Y = H.Canvas.CurY;
        YL = H.Canvas.CurYL;
        ScreenCoords = H.Canvas.Project(oActor.Location);
        H.Canvas.CurX = ScreenCoords.X;
        H.Canvas.CurY = ScreenCoords.Y;
        idx = PastEvents.Length - 1;
        while (idx >= 0)
        {
            if (PastEvents[idx].Speaker == None && PastEvents[idx].ReferredTo == oActor)
            {
                H.Canvas.SetDrawColor(255, 0, 0);
                H.Canvas.DrawText(PastEvents[idx].Id);
                H.Canvas.CurY += 15;
            }
            else
            {
                if (PastEvents[idx].Speaker == oActor)
                {
                    H.Canvas.SetDrawColor(0, 255, 0);
                    H.Canvas.DrawText(PastEvents[idx].Id);
                    H.Canvas.CurY += 15;
                }
            }
            idx--;
        }
        H.Canvas.CurX = X;
        H.Canvas.CurY = Y;
        H.Canvas.CurYL = YL;
    }
}

defaultproperties
{
    EventProperties=System.Byte[]
}
