﻿class SFXWeapon_AssaultRifle_Base extends SFXWeapon
    hidecategories(Navigation)
    config(Weapon)
    abstract;

simulated function float CalculateStaticBonus()
{
    local float Bonus;
    Bonus = CalculateStaticBonus();
    if (Pawn(Owner) != None && Pawn(Owner).InPlayerParty())
    {
        Bonus *= SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAssaultRifleCache;
        SFXPRI(Instigator.PlayerReplicationInfo).LastDamageCalculation.AchievementBonusDamage = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAssaultRifleCache;
    }
    return Bonus;
}

function ScaleWeapon(int Level)
{
    local float AccuracyBonus;
    if (Pawn(Owner) != None && Pawn(Owner).InPlayerParty())
    {
        AccuracyBonus = SFXGame(Pawn(Owner).WorldInfo.Game).BonusList.RchAssaultRifleAccuracyCache;
        MinAimError.StaticBonus = AccuracyBonus;
        MaxAimError.StaticBonus = AccuracyBonus;
        MinZoomAimError.StaticBonus = AccuracyBonus;
        MaxZoomAimError.StaticBonus = AccuracyBonus;
        CrosshairRange.X = Default.CrosshairRange.X * AccuracyBonus;
        CrosshairRange.Y = Default.CrosshairRange.Y * AccuracyBonus;
        ZoomCrosshairRange.X = Default.ZoomCrosshairRange.X * AccuracyBonus;
        ZoomCrosshairRange.Y = Default.ZoomCrosshairRange.Y * AccuracyBonus;
        AccFirePenalty = Default.AccFirePenalty * AccuracyBonus;
        AccFireInterpSpeed = Default.AccFireInterpSpeed * AccuracyBonus;
        AI_AccCone_Min.X = Default.AI_AccCone_Min.X * 2 / 1 + AccuracyBonus;
        AI_AccCone_Min.Y = Default.AI_AccCone_Min.Y * 2 / 1 + AccuracyBonus;
        AI_AccCone_Max.X = Default.AI_AccCone_Max.X * 2 / 1 + AccuracyBonus;
        AI_AccCone_Max.Y = Default.AI_AccCone_Max.Y * 2 / 1 + AccuracyBonus;
    }
    ScaleWeapon(Level);
}

defaultproperties
{
    WeaponFireWaveForm=ForceFeedbackWaveform'ForceFeedbackWaveformBase'
    PSC_ReloadVent=ParticleSystemComponent'ReloadVent0'
    AmmoPowerPSCO=ParticleSystemComponent'AmmoPowerHologram'
    AmmoPowerIconPSCO=ParticleSystemComponent'AmmoPowerIconHologram'
    VocalizationType=SFXVocalizationWeapon_AssaultRifle
    // child object ForceFeedbackWaveformBase of type ForceFeedbackWaveform
    // child object AmmoPowerHologram of type ParticleSystemComponent
    // child object AmmoPowerIconHologram of type ParticleSystemComponent
    // child object ReloadVent0 of type ParticleSystemComponent
    // child object WeaponMesh of type SkeletalMeshComponent
}
